/*******************************************************************************
*   atrbt_concat    (see manual, Command Ref., User Functions)  <fc>           *
*           Description:  Concatenates all attributes for                      *
*			all objects in specified set.                                      *
*                                                                              *
*			Parameters:  long s;   set number                                  *
*                                                                              *
*           Globals/files changed:  job_stats[13], attributes & objects files. *
*                                                                              *
*           Returns zero upon normal end-of-job (EOJ).                         *
*                   J.Dabritz, 1/2/89                                          *
*******************************************************************************/

#include <string.h>
#include "../../incl/globals.h"
#include "../../incl/in.h"


long atrbt_concat( s )
	long s;
{
	OBJECTS object;
	ATTRIBUTES atrbt;

	char string[256];

	long new_atrbts;
	long i,n;
	long otype;
	long concat;


		/**************** check for map ********************************/
	if(!job_stats[0])
	{	message("You must CREATE or ACQUIRE a map befor concatonating attributes.");
		return(1);
	}

		/**************** check for assembly/objects *******************/
	if(!job_stats[10])
	{	message("You must ASSEMBLE the map befor concatonating attributes.");
		return(1);
	}

		/**************** check for attributes *************************/
	if(job_stats[13] < 2)
	{	message("You must assign attributes befor concatonating them.");
		return(1);
	}



		/**************** check all objects & concatonate attributes ***/
	new_atrbts = 0;
	for(i=0; i<job_stats[10]; i++)
	{		/**************** get object *******************************/
		if(get_objects(&object,i))
		{	message("aborting atrbt_concat, location 1.");
			return(1);
		}

			/**************** inform user ******************************/
		if(!(i % 100))
		{	sprintf(string,"checking objects for attribute concatonation, object %d.",i);
			message(string);
		}

			/**************** check set ********************************/
		if(s == 0)        /** all map type objects ***/
		{	if(object.i12[0] < 8)        /** node **/
				otype = 1;
			else if(object.i12[0] < 14)  /** segment **/
				otype = 2;
			else
				otype = 4;
			concat = otype & map_type;
		}
		else
			concat = object.i12[4] & (1 << s);

		if(concat && object.i12[2])
		{	/**************** read through all attributes concatonating */
			*string = 0;
			atrbt.next = object.i12[2];
			for(n=0;  atrbt.next;  n++)
			{	if(get_attr(&atrbt,atrbt.next))
				{	message("aborting atrbt_concat, location 2.");
					return(1);
				}
				strncat(string,atrbt.string,30);
				string[30] = 0;
			}

			/**************** store attribute if there are changes *****/
			if(n > 1)
			{	if(asgn_atrbt(i,0,string))
				{	message("aborting atrbt_concat, location 3.");
					return(1);
				}
				new_atrbts++;
			}
		}
	}

		/**************** pack attributes ******************************/
	if(new_atrbts)
	{	if(pack_atrbts())
		{	message("aborting atrbt_concat, location 4.");
			return(1);
		}
	}
	

		/**************** return ***************************************/
	return(0);
}
