/*******************************************************************************
*	atrbt_contur	(see manual, Command Ref., User Function)	<fc>   *
*			Sets the grahpics input mode to attribute contours.    *
*			If the context (flag) is 1, then set the context_elev  *
*			flag global to 1, otherwise set the flag to 0 and set  *
*			both the elev_above and elev_below globals.            *
*           checks the contour_interval item of the header structure           *
*           and sets the contour_interval global (or rejects command.)         *
*                                                                              *
*           Globals modified:       long   context_elev;                       *
*                                   long   elev_above, elev_below;             *
*                                   long   contour_interval;                   *
*                                                                              *
*		Returns zero upon normal end-of-job (EOJ).                     *
*******************************************************************************/

#include "../../incl/globals.h"
#include "../../incl/in.h"

long atrbt_contur(action,elevation,context)
	long action; 	/*   attribute action code  */
	long elevation, context;
{
	char string[STRLIST];
	char *ptr;

		/************ check for map ************************************/
	if(!job_stats[0])
	{	message("You must acquire a map befor attributing contour lines.");
		return(1);
	}

		/****** check attribute action code ********************/
	if((action <0)  ||  (action > atrbt_action_limit))
	{	sprintf(string,"Action code must be in range 0 - %d.  no action taken.",atrbt_action_limit);
		message(string);
		return(1);
	}

		/************ check for segments *******************************/
	if(!(job_stats[5]  ||  job_stats[6]))
	{	message("You must have ASSEMBLED segments befor contour attributing.");
		return(1);
	}
	
		/************ check & set contour_interval *********************/
	get_cont_int();

		/************ check & set contour_context flag/ or elevations **/
	if(context)
		context_elev = 1;
	else
	{	context_elev = 0;
		elev_above = elevation;
		elev_below = elevation;
	}

		/************ change atrbt_action global ***********************/
	atrbt_action = action;

		/************ change mode settings *****************************/
	change_mode(1,0);

		/************ return *******************************************/
	return(0);
}
