/*******************************************************************************
*	atrbt_dig	(see manual, Command Ref., User Function)	<fc>   *
*			Sets the grahpics input mode to digitize attributes.   *
*			Sets the object type, attribute action type, and       *
*			string to be used as an attribute.                     *
*                                                                              *
*			sets atrbt_string                                      *
*                                                                              *
*			Returns zero upon normal end-of-job (EOJ).             *
*           J.Dabritz 8/9/89                                                   *
*******************************************************************************/

#include "../../incl/globals.h"
#include "../../incl/in.h"

long atrbt_dig(otype,action,string)
	long otype;	/*   object type code to attribute: 0=node, 1=seg,
				2=polygon                                  */
	long action; 	/*   attribute action code  */
	char *string;	/*   attribute string.                              */
{
	if((otype <0)  ||  (otype > 2))
	{	message("Object type must be in range 0 - 2.  no action taken.");
		return(1);
	}

		/****** check attribute action code ********************/
	if((action <0)  ||  (action > atrbt_action_limit))
	{	sprintf(string,"Action code must be in range 0 - %d.  no action taken.",atrbt_action_limit);
		message(string);
		return(1);
	}
	
	atrbt_otype = otype;
	atrbt_action = action;
	sprintf(atrbt_string,"%s",string);
	atrbt_string[30] = 0;

	change_mode(2,0);
	
	return(0);
}
