/*******************************************************************************
*	atrbt_edit	(see manual, Command Ref., User Functions)	<fc>   *
*			Description:  Invokes an ascii editor for viewing and  *
*			editing the attributes assigned to objects.            *
*			Parameters:  long set_no                               *
*									       *
*			Returns zero upon normal end-of-job (EOJ).             *
*           J.Dabritz    8/12/89                                               *
*******************************************************************************/

#include <string.h>
#include "../../incl/globals.h"
#include "../../incl/in.h"

long atrbt_edit( set_no )
	long set_no;
{
	char tmp_name[L_tmpnam];		/*  Holds temp file name  */
	char string[256];
	char *ptr;
	char file[256];
	char part1[256], part2[256];
	
	long obj_no;
	long x,y;

	int fd;
	
		/************** check for a current map & objects ***********/
	if(!job_stats[0])
	{	message("No map current acquired.  nothing to edit.");
		return(1);
	}

		/************** check parameters ****************************/
	if(set_no < 0   ||  set_no > 31)
	{	message("Illegal set number, atrbt_edit aborted.");
		return(1);
	}

		/************** print attributes to file ********************/
	tmpnam( tmp_name );
	sprintf(file,"%s",tmp_name);
	if(atrbt_print(set_no,2,file))
	{	message(" atrbt_edit aborted.");
		return(1);
	}

		/************** allow user to edit the file *****************/
	edit_ltp(file);

	if(!batch_mode)
	{	if(!answerisyes(231,1))
		{	purgef(file);
			return(1);  
		}
	}

		/************** open file **************************/
	if((fd = openf( file, READ )) == -1) 
	{	sprintf(string, "  Cannot open file %s, atrbt_edit aborted.", file);
		message(string);
		purgef(file);
		return(1);
	}

		/************** re-interpret file and store attributes ******/
	obj_no = -1;
	for(; reada(string,255,fd); )
	{	if(*(trim(string)))
		{	strsplit(string, '=', part1, part2);
			trim(part1);
			trim(part2);
			if(strstr(string, "="))        /*** line may have object number ***/
			{
					/**** break string at first blank ***/
				for(ptr = part1; *ptr && (*ptr!= '\t') && (*ptr != ' '); ptr++);
				*ptr = 0;

					/**** get object record number ****/
				if(*part1)
				{	if(strchr("0123456789",*part1))
						obj_no = strtol(part1, (char **)NULL, 10);
					else
						obj_no = -1;
				}

					/**** store attribute ****/
				if(obj_no >= 0)
				{	asgn_atrbt(obj_no,7,(char *) 0);
					if(*part2) 
					{	part2[30] = 0;      /** clip at 30 characters **/
						asgn_atrbt(obj_no,6,part2);
					}
				}
			}
			else if(obj_no >= 0)     /***  no '=', just another attribute ******/
			{		/**** check for blank line ***/
				if(*part1 )
				{		/**** store attribute ****/
					part1[30] = 0;      /** clip at 30 characters **/
					asgn_atrbt(obj_no,6,part1);
				}
			}
		}
	}

		/************** close file **********************************/
	closef(fd);

		/************** purge file **********************************/
	purgef(file);

		/************** pack attributes file ************************/
	if(pack_atrbts())
		return(1);

		/*** redisplay the map ****/
		/************* call set30_check to flag objects for plotting **/
	if((disp_hglight | disp_normal) & (3 << 26))
	{		/************* call dispgraphics to re-display data *********/
		x = (rwindowxmin + rwindowxmax) / 2;
		y = (rwindowymin + rwindowymax) / 2;
		if(dispgraphics(x,y,resolution_code))
			return(1);
	}

		/************** return **************************************/
	return(0);
}
