/*******************************************************************************
*      atrbt_line      (see manual, Command Ref., User Function)      <fc>     *
*                  Sets the grahpics input mode to digitize line attributes.   *
*                  Sets the object type to line, attribute action type,        *
*                  string to be used as an attribute, and mile post.           *
*                                                                              *
*        Parameters:  long action;   attribute action (0-7)                    *
*                     float mp;      beginning mile post                       *
*                     char string;   attribute string to be assigned.          *
*                                                                              *
*        Globals changed:  atrbt_string, mile_post, atrbt_action               *
*                                                                              *
*                  Returns zero upon normal end-of-job (EOJ).                  *
*           J.Dabritz 6/26/90                                                  *
*******************************************************************************/

#include "../../incl/globals.h"
#include "../../incl/in.h"

long atrbt_line(action,mp,string)
	long action;
	float mp;
	char *string;
{
		/****** check attribute action code ********************/
	if((action <0)  ||  (action > atrbt_action_limit))
	{	sprintf(string,"Action code must be in range 0 - %d.  no action taken.",atrbt_action_limit);
		message(string);
		return(1);
	}

	
	atrbt_action = action;
	sprintf(atrbt_string,"%s",string);
	atrbt_string[30] = 0;
	mile_post = mp;

	change_mode(29,0);
	
	return(0);
}
