/*******************************************************************************
*   atrbt_rec       (see manual, Command Ref., User Functions)  <fc>           *
*           Description:  attributes 1 object as specified by the parameters   *
*                                                                              *
*        Parameters:  long record;   object record number                      *
*			             long action;   attribute action code:                    *
*                                       see ../in/asgn_atrbt                   *
*                     char *string;  pointer to attribute string               *
*                                                                              *
*           Globals/files changed:  job_stats[13], attributes & objects files. *
*                                                                              *
*           Returns zero upon normal end-of-job (EOJ).                         *
*                   J.Dabritz,   1/3/89                                        *
*******************************************************************************/

#include <string.h>
#include "../../incl/globals.h"
#include "../../incl/in.h"


long atrbt_rec(record,action, string )
	long record,action;
	char *string;
{

		/**************** check for map ********************************/
	if(!job_stats[0])
	{	message("You must CREATE or ACQUIRE a map befor assigning attributes.");
		return(1);
	}

		/**************** check for assembly/objects *******************/
	if(!job_stats[10])
	{	message("You must ASSEMBLE the map befor thinning attributes.");
		return(1);
	}

		/**************** check parameters **********************/
	if((record < 0)  ||  (record >= job_stats[10]))
	{	message("Illegal record number, no attribute assigned.");
		return(1);
	}
		/****** check attribute action code ********************/
	if((action <0)  ||  (action > atrbt_action_limit))
	{	sprintf(string,"Action code must be in range 0 - %d.  no action taken.",atrbt_action_limit);
		message(string);
		return(1);
	}
	string[30] = 0;

		/**************** assign attribute **********************/
	if(asgn_atrbt(record,action,string))
		return(1);

		/**************** return ***************************************/
	return(0);
}
