/*******************************************************************************
*   atrbt_set       (see manual, Command Ref., User Functions)  <fc>           *
*           Description:  attributes 1 object as specified by the parameters   *
*                                                                              *
*        Parameters:  long set;      set number                                *
*			             long action;   attribute action code:                    *
*                                       see ../in/asgn_atrbt                   *
*                     char *string;  pointer to attribute string               *
*                                                                              *
*           Globals/files changed:  job_stats[13], attributes & objects files. *
*                                                                              *
*           Returns zero upon normal end-of-job (EOJ).                         *
*                   J.Dabritz,   1/3/89                                        *
*******************************************************************************/

#include <string.h>
#include "../../incl/globals.h"
#include "../../incl/in.h"


long atrbt_set(set,action, string )
	long set,action;
	char *string;
{
	OBJECTS object;

	long i;

		/**************** check for map ********************************/
	if(!job_stats[0])
	{	message("You must CREATE or ACQUIRE a map befor assigning attributes.");
		return(1);
	}

		/**************** check for assembly/objects *******************/
	if(!job_stats[10])
	{	message("You must ASSEMBLE the map befor thinning attributes.");
		return(1);
	}

		/**************** check parameters **********************/
	if((set < 0)  ||  (set >= 32))
	{	message("Illegal set number, no attribute assigned.");
		return(1);
	}
		/****** check attribute action code ********************/
	if((action <0)  ||  (action > atrbt_action_limit))
	{	sprintf(string,"Action code must be in range 0 - %d.  no action taken.",atrbt_action_limit);
		message(string);
		return(1);
	}
	string[30] = 0;

		/**************** assign attribute **********************/
	for(i=0; i<job_stats[10]; i++)
	{	if(get_objects(&object,i))
		{	message("Error, no attribute assigned.");
			return(1);
		}
		if(object.i12[4] & (1 << set))
		{	if(asgn_atrbt(i,action,string))
			{	message("error when assigning attributes, command aborted.");
				return(1);
			}
		}
	}

		/**************** return ***************************************/
	return(0);
}
