/*******************************************************************************
*   brstr_create    (see manual, Command Ref., User Functions)  <fc>           *
*        Copies the temp/raster to temp/rasterb                                *
*                                                                              *
*        Parameters:  - none -                                                 *
*                                                                              *
*        Globals/files changed:  rasterb file created or replaced.             *
*                                job_stats[76] is set.                         *
*                                                                              *
*        Values returned:  0=copy done, 1=copy filed.                          *
*                   J.Dabritz,   2/8/90                                        *
*******************************************************************************/
/* Modified 5/92 by DBS@CWU for ULTRIX support */

#include "../../incl/globals.h"
#include "../../incl/in.h"


long brstr_create()
{
	char command[256];


		/**************** check for map ********************************/
	if(!job_stats[0])
	{	message("You must CREATE or ACQUIRE a map befor creating a rasterb.");
		return(1);
	}

		/**************** inform user **********************************/
	message("creating a duplicate copy (braster) of the current scan/raster . . . ");

		/**************** copy raster **********************************/

/* #if (ULTRIX || SUNOS) */
	sprintf(command,"%s %s/raster %s/rasterb",COPY_CMD, temp_map_path,temp_map_path);

	if(system_ltp(command))
	{	message("Copy of temp raster to temp rasterb failed.");
		return(1);
	}

		/**************** put rasterb size in job_stats ****************/
	job_stats[76] = ((job_stats[1] + 1) * (job_stats[2] + 1)) / 8;

		/**************** inform user  *********************************/
	append_msg("done.");

		/**************** make diary entry *****************************/
	sprintf(command,"rasterb created.");
	put_diary(command);

		/**************** return ***************************************/
	return(0);
}
