/*******************************************************************************
*   brstr_delete    (see manual, Command Ref., User Functions)  <fc>           *
*        Deletes the temp/rasterb file.                                        *
*                                                                              *
*        Parameters:  - none -                                                 *
*                                                                              *
*        Globals/files changed:  rasterb file is deleted.                      *
*                                job_stats[76] is set.                         *
*                                                                              *
*        Values returned:  0=delete done, 1=delete failed.                     *
*                   J.Dabritz,   2/8/90                                        *
*******************************************************************************/

#include "../../incl/globals.h"
#include "../../incl/in.h"


long brstr_delete()
{
	char command[256];


		/**************** check for map ********************************/
	if(!job_stats[0])
	{	message("You must CREATE or ACQUIRE a map befor deleting a rasterb.");
		return(1);
	}

		/**************** copy raster **********************************/
	sprintf(command,"rm %s/rasterb",temp_map_path);
	if(system_ltp(command))
	{	message("Deletion of temp raster failed.");
		return(1);
	}

		/**************** set rasterb size in job_stats to 0 ***********/
	job_stats[76] = 0;

		/**************** make diary entry *****************************/
	sprintf(command,"rasterb deleted.");
	put_diary(command);

		/**************** return ***************************************/
	return(0);
}
