/*******************************************************************************
*	ckeys_get	(see manual, Command Ref., User Functions)	<fc>   *
*      This program causes a cursor keys file to be loaded into the            *
*    cursor_keys global array.  This remaps the cursor/mouse buttons to        *
*    whatever strings are indicated in the file.                               *
*                                                                              *
*    Parameters:    char fname[]     name of file in the cursor_keys directory *
*                                                                              *
*    Globals changed:    char cursor_keys[][STRLIST]                           *
*                                                                              *
*    Values returned:    0 = cursor keys file loaded,  1 = failure.            *
*    J.Dabritz    9/28/89                                                      *
*******************************************************************************/
/* Modified 7/92 by DBS@CWU for multi user support */

#include "../../incl/globals.h"
#include "../../incl/in.h"

long ckeys_get( fname )
	char *fname;
{
	char path[256];

#ifdef MULTIUSER
	sprintf(path,"%s/.ltp/cursor_keys/%s",home_path,fname);
	if (file_exists(path,"")) {
	    if (get_ckeys(path)) {
		message("cursor keys file not be loaded.");
		message("please check for proper directory & permissions.");
		return(1);
	   }
	}
	else {
	    sprintf(path,"%s/cursor_keys/%s",ltp_path,fname);
	    if(get_ckeys(path)) {
		message("cursor keys file not be loaded.");
		message("please check for proper directory & permissions.");
		return(1);
	   }
	}
#else
	sprintf(path,"%s/cursor_keys/%s",ltp_path,fname);
	if(get_ckeys(path))
	{	message("cursor keys file not be loaded.");
		message("please check for proper directory & permissions.");
		return(1);
	}
#endif

	return(0);
}
