/*******************************************************************************
*	config_ltp    (see manual, Command Ref., User Functions)	<fc>   *
*			Description: Modifies config.h information             *
*			according to item,arg values passed from               *
*			configM.                                               *
*			Parameters:  Two strings: the item and the             *
*			arg to which it should be changed in config.h.         *
*                                                                              *
*			Returns zero upon normal end-of-job (EOJ).             *
*******************************************************************************/

#include <string.h>
#include "../../incl/globals.h"
#include "../../incl/in.h"

long config_ltp(print_flag,part1,part2)
long print_flag;
char *part1;
char *part2;
{	
	char path[512];



		/********************* check for header change & make change ****/
	if(*part1)
	{		/*  match part1 with config item  */
		if(!(strcmp(part1,"prtr_adr")))
			strcpy(config.prtr_adr,part2); 
		else if(!(strcmp(part1,"prtr_type")))
			strcpy(config.prtr_type,part2); 
		else if(!(strcmp(part1,"crt_adr")))
			strcpy(config.crt_adr,part2); 
		else if(!(strcmp(part1,"crt_type")))
			strcpy(config.crt_type,part2); 
		else if(!(strcmp(part1,"bkup11")))
			strcpy(config.bkup11,part2); 
		else if(!(strcmp(part1,"bkup12")))
			strcpy(config.bkup12,part2); 
		else if(!(strcmp(part1,"bkup21")))
			strcpy(config.bkup21,part2); 
		else if(!(strcmp(part1,"bkup22")))
			strcpy(config.bkup22,part2); 
		else if(!(strcmp(part1,"print1")))
			strcpy(config.print1,part2); 
		else if(!(strcmp(part1,"print2")))
			strcpy(config.print2,part2); 
		else if(!(strcmp(part1,"edit1")))
			strcpy(config.edit1,part2); 
		else if(!(strcmp(part1,"edit2")))
			strcpy(config.edit2,part2); 
		else if(!(strcmp(part1,"cursor_file")))
			strcpy(config.cursor_file,part2); 
		else if(!(strcmp(part1,"mouse_adr")))
			strcpy(config.mouse_adr,part2); 
		else if(!(strcmp(part1,"mouse_type")))
			strcpy(config.mouse_type,part2); 
		else if(!(strcmp(part1,"dig1_adr")))
			strcpy(config.dig1_adr,part2); 
		else if(!(strcmp(part1,"dig1_type")))
			strcpy(config.dig1_type,part2); 
		else if(!(strcmp(part1,"dig2_adr")))
			strcpy(config.dig2_adr,part2); 
		else if(!(strcmp(part1,"dig2_type")))
			strcpy(config.dig2_type,part2); 
		else if(!(strcmp(part1,"plt1_adr")))
			strcpy(config.plt1_adr,part2); 
		else if(!(strcmp(part1,"plt1_type")))
			strcpy(config.plt1_type,part2); 
		else if(!(strcmp(part1,"plt2_adr")))
			strcpy(config.plt2_adr,part2); 
		else if(!(strcmp(part1,"plt2_type")))
			strcpy(config.plt2_type,part2); 
		else if(!(strcmp(part1,"maps_path")))
			strcpy(config.maps_path,part2); 
		else if(!(strcmp(part1,"bkup_path")))
			strcpy(config.bkup_path,part2); 
		else if(!(strcmp(part1,"data3_path")))
			strcpy(config.data3_path,part2); 
		else if(!(strcmp(part1,"data4_path")))
			strcpy(config.data4_path,part2); 
		else if(!(strcmp(part1,"export_path")))
			strcpy(config.export_path,part2); 
		else if(!(strcmp(part1,"import_path")))
			strcpy(config.import_path,part2); 
		else if(!(strcmp(part1,"malloc")))
			strcpy(config.malloc,part2); 
		else if(!(strcmp(part1,"menuset")))
			strcpy(config.menuset,part2); 
		else if(!(strcmp(part1,"ginput")))
			strcpy(config.ginput,part2); 
		else if(!(strcmp(part1,"rasterh")))
			strcpy(config.rasterh,part2); 
		else if(!(strcmp(part1,"rasterw")))
			strcpy(config.rasterw,part2); 
		else if(!(strcmp(part1,"pen0")))
			strcpy(config.pen0,part2); 
		else if(!(strcmp(part1,"pen1")))
			strcpy(config.pen1,part2); 
		else if(!(strcmp(part1,"pen2")))
			strcpy(config.pen2,part2); 
		else if(!(strcmp(part1,"pen3")))
			strcpy(config.pen3,part2); 
		else if(!(strcmp(part1,"pen4")))
			strcpy(config.pen4,part2); 
		else if(!(strcmp(part1,"pen5")))
			strcpy(config.pen5,part2); 
		else if(!(strcmp(part1,"pen6")))
			strcpy(config.pen6,part2); 
		else if(!(strcmp(part1,"pen7")))
			strcpy(config.pen7,part2); 
		else if(!(strcmp(part1,"pen8")))
			strcpy(config.pen8,part2); 
		else if(!(strcmp(part1,"tile1")))
			strcpy(config.tile1,part2); 
		else if(!(strcmp(part1,"tile2")))
			strcpy(config.tile2,part2); 
		else if(!(strcmp(part1,"tile3")))
			strcpy(config.tile3,part2); 
		else if(!(strcmp(part1,"tile4")))
			strcpy(config.tile4,part2); 
		else if(!(strcmp(part1,"tile5")))
			strcpy(config.tile5,part2); 
		else if(!(strcmp(part1,"tile6")))
			strcpy(config.tile6,part2); 
		else if(!(strcmp(part1,"tile7")))
			strcpy(config.tile7,part2); 
		else if(!(strcmp(part1,"tile8")))
			strcpy(config.tile8,part2); 
		else if(!(strcmp(part1,"tile9")))
			strcpy(config.tile9,part2); 
		else if(!(strcmp(part1,"tile10")))
			strcpy(config.tile10,part2); 
		else if(!(strcmp(part1,"tile11")))
			strcpy(config.tile11,part2); 
		else
		{	message("no match of config item to:  ");
			append_msg(part1);
			append_msg(".   No change made to config file.");
			return(0);
		}


			/*    store config file     */              
#ifdef MULTIUSER
                sprintf(path,"%s/.ltp/config",home_path);
                if(!file_exists(path, "config")) {
                  char orig_path[512];
                  sprintf(orig_path, "%s/config", ltp_path);
                  copy_file(orig_path, "config", path);
                }
		strcat(path,"/config");
#else
		sprintf(path,"%s/config/config",ltp_path);
#endif
		if(put_config())
		{	message("unable to store config values in:  ");
			append_msg(path);
			message("No change made.");
			return(0);
		}


			/*    retrieve config to update changed variables  */
		sync();
		if(get_config())
		{	message("unable to retrieve config file from:  ");
			append_msg(path);
			message("you may have a corrupt config file.");
			return(0);
		}
	}


		/********************* check for print & print ******************/
	if(print_flag) {	
#ifdef MULTIUSER
		sprintf(path,"%s/.ltp/config/config",home_path);
		if (!file_exists(path,""))
			sprintf(path,"%s/config/config",ltp_path);
#else
		sprintf(path,"%s/config/config",ltp_path);
#endif
		print_file(path);
	}


	return(1);
}
