/*******************************************************************************
*	coord_type	(see manual, Command Ref., User Function)	<fc>   *
*			Sets the coordinate type to be used for input          *
*                       & display                                              *
*                                                                              *
*			Returns zero upon normal end-of-job (EOJ).             *
*******************************************************************************/

#include "../../incl/globals.h"
#include "../../incl/in.h"

long coord_type(type)
	long type;  /* the code for the coordinate type to be used for display
			and input.                                         */
{
	if(!job_stats[0])
	{	message("You must acquire a map to display different coordinate types.");
		return(1);
	}

	if(!(registered(type)))
	{	message("The current map is not registered in this coordinate type.");
		return(1);
	}

		/******* set coord type *******************/
	disp_coord_type = type;

		/******** re-display coordinates **********/
	cursor(ginfo.scoord[0]+1,ginfo.scoord[1]);
	cursor(ginfo.scoord[0],ginfo.scoord[1]);
	cursor(ginfo.scoord[0],ginfo.scoord[1]);
	cursor(ginfo.scoord[0],ginfo.scoord[1]);
	cursor(ginfo.scoord[0],ginfo.scoord[1]);
	cursor(ginfo.scoord[0],ginfo.scoord[1]);

	return(0);
}
