/*******************************************************************************
*     crit_arange     (see manual, Command Ref., User Functions)      <fc>     *
*                                                                              *
*         Sets set selection criteria for attributes.  Two strings are         *
*         stored which must bracket an attribute of an object in lexical       *
*         order.                                                               *
*                                                                              *
*         Parameters:    char *s1;  string <= attribute                        *
*                        char *s2;  string >= attribute                        *
*                                                                              *
*         globals changed:  set_criteria[1], critarange[][]                    *
*                                                                              *
*         Returns 0 upon normal execution, else                                *
*         returns -1 upon error.                                               *
*             J.Dabritz  1/10/90                                               *
*******************************************************************************/

#include <string.h>
#include "../../incl/globals.h"
#include "../../incl/in.h"


long crit_arange(s1,s2)
	char *s1, *s2;
{
		/******************* check for map ***************************/
	if(!job_stats[0])
	{	message("Cannot build criteria untill a map is created or acquired.");
		return(1);
	}

		/******************* check input parameters ******************/
	if((s1 == (char *) 0)  ||  (s2 == (char *) 0))
		return(1);

		/******************* check for enough parameter storage ******/
	if(set_criteria[1] > 9)
	{	message("There are already 10 crit_arange criteria.  New criteria not accepted.");
		return(1);
	}
	if(set_criteria[1] < 0)
		set_criteria[1] = 0;

		/******************* store parameter *************************/
	strncpy(critarange[set_criteria[1]][0],s1,95);
	strncpy(critarange[set_criteria[1]][1],s2,95);
	set_criteria[1]++;
	
		/******************* return **********************************/
	return(0);
}
