/*******************************************************************************
*     crit_area       (see manual, Command Ref., User Functions)      <fc>     *
*                                                                              *
*         Sets set selection criteria for area of polygons to the limist       *
*         set by the parameters.                                               *
*                                                                              *
*         Parameters:    long i:    code for area units                        *
*                        double a1,a2;  limits of area, lower, upper           *
*                                                                              *
*         globals changed:  set_criteria[2], critarea[][]                      *
*                                                                              *
*         Returns 0 upon normal execution, else                                *
*         returns -1 upon error.                                               *
*             J.Dabritz  1/10/90                                               *
*******************************************************************************/

#include "../../incl/globals.h"
#include "../../incl/in.h"


long crit_area(i,a1,a2)
	long i;
	double a1,a2;
{
	double a3;


		/******************* check for map ***************************/
	if(!job_stats[0])
	{	message("Cannot build criteria untill a map is created or acquired.");
		return(1);
	}

		/******************* check input parameters ******************/
	if(i < 0  ||  i > 6)
		return(1);
	if(a1 > a2)
	{	a3 = a2;
		a2 = a1;
		a1 = a3;
	}

		/******************* check for enough parameter storage ******/
	if(set_criteria[2] > 9)
	{	message("There are already 10 crit_area criteria.  New criteria not accepted.");
		return(1);
	}
	if(set_criteria[2] < 0)
		set_criteria[2] = 0;

		/******************* store parameter *************************/
	critarea[set_criteria[2]][0] = a1;
	critarea[set_criteria[2]][1] = a2;
	critarea[set_criteria[2]][2] = (double) i;
	set_criteria[2]++;
	
		/******************* return **********************************/
	return(0);
}
