/*******************************************************************************
*     crit_astrg      (see manual, Command Ref., User Functions)      <fc>     *
*                                                                              *
*         Sets set selection criteria for attribute string template            *
*                                                                              *
*         Parameters:    char *s   template string                             *
*                                                                              *
*         globals changed:  set_criteria[3], critastrg[][]                     *
*                                                                              *
*         Returns 0 upon normal execution, else                                *
*         returns -1 upon error.                                               *
*             J.Dabritz  1/10/90                                               *
*******************************************************************************/

#include <string.h>
#include "../../incl/globals.h"
#include "../../incl/in.h"


long crit_astrg( s )
	char *s;
{
		/******************* check for map ***************************/
	if(!job_stats[0])
	{	message("Cannot build criteria untill a map is created or acquired.");
		return(1);
	}

		/******************* check input parameters ******************/
	if(!( *s))
		return(1);

		/******************* check for enough parameter storage ******/
	if(set_criteria[3] > 9)
	{	message("There are already 10 crit_astrg criteria.  New criteria not accepted.");
		return(1);
	}
	if(set_criteria[3] < 0)
		set_criteria[3] = 0;

		/******************* store parameter *************************/
	strncpy(critastrg[set_criteria[3]],s,95);
	set_criteria[3]++;
	
		/******************* return **********************************/
	return(0);
}
