/*******************************************************************************
*     crit_psides     (see manual, Command Ref., User Functions)      <fc>     *
*                                                                              *
*         Sets set selection criteria for number of polygon sides to be        *
*         within the specified range.                                          *
*                                                                              *
*         Parameters:    long s1, s2;    limits on number of sides             *
*                                                                              *
*         globals changed:  set_criteria[6], critpsides[]                      *
*                                                                              *
*         Returns 0 upon normal execution, else                                *
*         returns -1 upon error.                                               *
*             J.Dabritz  1/10/90                                               *
*******************************************************************************/

#include "../../incl/globals.h"
#include "../../incl/in.h"


long crit_psides( s1, s2 )
	long s1, s2;
{
	long s3;


		/******************* check for map ***************************/
	if(!job_stats[0])
	{	message("Cannot build criteria untill a map is created or acquired.");
		return(1);
	}

		/******************* check input parameters ******************/
	if(s1 < 0  ||  s2 < 0 )
		return(1);
	if(s1 > s2)
	{	s3 = s2;
		s2 = s1;
		s1 = s3;
	}

		/******************* check for enough parameter storage ******/
	if(set_criteria[6] > 9)
	{	message("There are already 10 crit_psides criteria.  New criteria not accepted.");
		return(1);
	}
	if(set_criteria[6] < 0)
		set_criteria[6] = 0;

		/******************* store parameter *************************/
	critpsides[set_criteria[6]][0] = s1;
	critpsides[set_criteria[6]][1] = s2;
	set_criteria[6]++;
	
		/******************* return **********************************/
	return(0);
}
