/*******************************************************************************
*     crit_slen       (see manual, Command Ref., User Functions)      <fc>     *
*                                                                              *
*         Sets set selection criteria for attribute string length of an object.*
*         must be within the specified range.                                  *
*                                                                              *
*         Parameters:    long s1, s2;    limits on number                      *
*                                                                              *
*         globals changed:  set_criteria[9], critslen[]                        *
*                                                                              *
*         Returns 0 upon normal execution, else                                *
*         returns -1 upon error.                                               *
*             J.Dabritz  1/10/90                                               *
*******************************************************************************/

#include "../../incl/globals.h"
#include "../../incl/in.h"


long crit_slen( s1, s2 )
	long s1, s2;
{
	long s3;


		/******************* check for map ***************************/
	if(!job_stats[0])
	{	message("Cannot build criteria untill a map is created or acquired.");
		return(1);
	}

		/******************* check input parameters ******************/
	if(s1 < 0  ||  s2 < 0 )
		return(1);
	if(s1 > s2)
	{	s3 = s2;
		s2 = s1;
		s1 = s3;
	}

		/******************* check for enough parameter storage ******/
	if(set_criteria[9] > 9)
	{	message("There are already 10 crit_slen criteria.  New criteria not accepted.");
		return(1);
	}
	if(set_criteria[9] < 0)
		set_criteria[9] = 0;

		/******************* store parameter *************************/
	critslen[set_criteria[9]][0] = s1;
	critslen[set_criteria[9]][1] = s2;
	set_criteria[9]++;
	
		/******************* return **********************************/
	return(0);
}
