/*******************************************************************************
*     crit_subel      (see manual, Command Ref., User Functions)      <fc>     *
*                                                                              *
*         Sets set selection criteria for subelements of menbers of a          *
*         specified set.                                                       *
*                                                                              *
*         Parameters:    long s;   number of set                               *
*                                                                              *
*         globals changed:  set_criteria[10], critsubel[]                      *
*                                                                              *
*         Returns 0 upon normal execution, else                                *
*         returns -1 upon error.                                               *
*             J.Dabritz  1/10/90                                               *
*******************************************************************************/

#include "../../incl/globals.h"
#include "../../incl/in.h"


long crit_subel( s )
	long s;
{

		/******************* check for map ***************************/
	if(!job_stats[0])
	{	message("Cannot build criteria untill a map is created or acquired.");
		return(1);
	}

		/******************* check input parameters ******************/
	if(s < 0  ||  s > 31)
		return(1);

		/******************* check for enough parameter storage ******/
	if(set_criteria[10] > 9)
	{	message("There are already 10 crit_subel criteria.  New criteria not accepted.");
		return(1);
	}
	if(set_criteria[10] < 0)
		set_criteria[10] = 0;

		/******************* store parameter *************************/
	critsubel[set_criteria[10]] = s;
	set_criteria[10]++;

		/******************* return **********************************/
	return(0);
}
