/*******************************************************************************
*     crit_superel    (see manual, Command Ref., User Functions)      <fc>     *
*                                                                              *
*         Sets set selection criteria for superelements of menbers of a        *
*         specified set.                                                       *
*                                                                              *
*         Parameters:    long s;   number of set                               *
*                                                                              *
*         globals changed:  set_criteria[11], critsuperel[]                    *
*                                                                              *
*         Returns 0 upon normal execution, else                                *
*         returns -1 upon error.                                               *
*             J.Dabritz  1/10/90                                               *
*******************************************************************************/

#include "../../incl/globals.h"
#include "../../incl/in.h"


long crit_superel( s )
	long s;
{
		/******************* check for map ***************************/
	if(!job_stats[0])
	{	message("Cannot build criteria untill a map is created or acquired.");
		return(1);
	}

		/******************* check input parameters ******************/
	if(s < 0  ||  s > 31)
		return(1);

		/******************* check for enough parameter storage ******/
	if(set_criteria[11] > 9)
	{	message("There are already 10 crit_superel criteria.  New criteria not accepted.");
		return(1);
	}
	if(set_criteria[11] < 0)
		set_criteria[11] = 0;

		/******************* store parameter *************************/
	critsuperel[set_criteria[11]] = s;
	set_criteria[11]++;
	
		/******************* return **********************************/
	return(0);
}
