/*******************************************************************************
*     crit_type       (see manual, Command Ref., User Functions)      <fc>     *
*                                                                              *
*         Sets set selection criteria for object type.                         *
*                                                                              *
*         Parameters:    long s;   object type                                 *
*                                                                              *
*         globals changed:  set_criteria[12], crittype[]                       *
*                                                                              *
*         Returns 0 upon normal execution, else                                *
*         returns -1 upon error.                                               *
*             J.Dabritz  1/10/90                                               *
*******************************************************************************/

#include "../../incl/globals.h"
#include "../../incl/in.h"


long crit_type( s )
	long s;
{
		/******************* check for map ***************************/
	if(!job_stats[0])
	{	message("Cannot build criteria untill a map is created or acquired.");
		return(1);
	}

		/******************* check input parameters ******************/
	if(s < 0  ||  s > 16)
		return(1);

		/******************* check for enough parameter storage ******/
	if(set_criteria[12] > 9)
	{	message("There are already 10 crit_type criteria.  New criteria not accepted.");
		return(1);
	}
	if(set_criteria[12] < 0)
		set_criteria[12] = 0;

		/******************* store parameter *************************/
	crittype[set_criteria[12]] = s;
	set_criteria[12]++;
	
		/******************* return **********************************/
	return(0);
}
