/*******************************************************************************
*	decrement	(see manual, Command Ref., User Function)	<fc>   *
*			Note:  decrement works exactly like 'continue' except  *
*			when the grahics input mode is 'atrbt_contur'.  When   *
*			the mode is 'atrbt_contur' it continues by decrementing*
*			object attribute elevations along the profile to the   *
*			current position.                                      *
*                                                                              *
*			files modified:  objects, attributes                   *
*			globals modified:  elev_above, elev_below, context_elev           *
*                                                                             *
*			Returns 0 if ok, 1 on failure.                         *
*		    J.Dabritz  8/15/89                                         *
*******************************************************************************/

#include "../../incl/globals.h"
#include "../../incl/in.h"

long decrement(x,y)
	long x,y;  /*  raster coordinates to which to continue     */
{
	char string[256];

		/***************** take action according to mode *************/
	if(input_mode != 1)
	{	sprintf(raw_buf,"continue %d %d",x,y);
		fj();
		return(1);
	}

		/******************* check for map loaded **********************/
	if(!job_stats[0])
		return(1);

		/***************** attribute a profile ************************/
	if(!first_point)
	{	if(atrbt_profil(last_raster_x,last_raster_y,x,y,-1))
			return(1);
		set_undo(1,0,0,last_raster_x,last_raster_y,x,y);
	}
	else
	{	cursor_mode = 1;     /* rubber line  */
		first_point = 0;
	}
	anchorx = x;
	anchory = y;

		/***************** update last_raster_x,y ********************/
	last_raster_x = x;
	last_raster_y = y;

		/***************** return ************************************/
	return(0);
}
