/*******************************************************************************
*	default_head	(see manual, Command Ref., User Functions)	<fc>   *
*			Description:  Update/display the default header file on the    *
*			specified device.                                      *
*			Parameters:  Print flag, item to update paired with    *
*				     change.                                   *
*									       *
*			Returns one upon success, 0 on failure.                *
*           J.Dabritz  6/8/89                                                  *
*******************************************************************************/
/* Modified 6/92 by DBS@CWU for multi user support */

#include <string.h>
#include "../../incl/globals.h"
#include "../../incl/in.h"

long default_head(print_flag,part1,part2)
long print_flag;
char *part1;
char *part2;
{	
	HEADER dhead;
	long orig_stplzn = 0;
	char path[512];

		/********************* get default header file ******************/
#ifdef MULTIUSER
	sprintf(path,"%s/.ltp/config/header",home_path);
	if(!file_exists(path,""))
		sprintf(path,"%s/config/header",ltp_path);
#else
	sprintf(path,"%s/config/header",ltp_path);
#endif
	get_header(path,&dhead,0);


		/********************* check for header change & make change ****/
	if(*part1)
	{		/*  match part1 with header item  */
		if(!(strcmp(part1,"comments"))) 
			strcpy(dhead.comments, part2);
		else if(!(strcmp(part1,"compress"))) 
			strcpy(dhead.compress, part2);
		else if(!(strcmp(part1,"contour_interval"))) 
			strcpy(dhead.contour_interval, part2);
		else if(!(strcmp(part1,"datum"))) 
			strcpy(dhead.datum, part2);
		else if(!(strcmp(part1,"dictionary"))) 
			strcpy(dhead.dictionary, part2);
		else if(!(strcmp(part1,"edgematch"))) 
			strcpy(dhead.edgematch, part2);
		else if(!(strcmp(part1,"edge_e"))) 
			strcpy(dhead.edge_e, part2);
		else if(!(strcmp(part1,"edge_n"))) 
			strcpy(dhead.edge_n, part2);
		else if(!(strcmp(part1,"edge_s"))) 
			strcpy(dhead.edge_s, part2);
		else if(!(strcmp(part1,"edge_w"))) 
			strcpy(dhead.edge_w, part2);
		else if(!(strcmp(part1,"head1"))) 
			strcpy(dhead.head1, part2);
		else if(!(strcmp(part1,"head2"))) 
			strcpy(dhead.head2, part2);
		else if(!(strcmp(part1,"layer_name"))) 
			strcpy(dhead.layer_name, part2);
		else if(!(strcmp(part1,"map_ht"))) 
			strcpy(dhead.map_ht, part2);
		else if(!(strcmp(part1,"map_wd"))) 
			strcpy(dhead.map_wd, part2);
		else if(!(strcmp(part1,"maptype"))) 
			strcpy(dhead.maptype, part2);
		else if(!(strcmp(part1,"menu_set"))) 
			strcpy(dhead.menu_set, part2);
		else if(!(strcmp(part1,"org"))) 
			strcpy(dhead.org, part2);
		else if(!(strcmp(part1,"quad_unit"))) 
			strcpy(dhead.quad_unit, part2);
		else if(!(strcmp(part1,"revision_yr"))) 
			strcpy(dhead.revision_yr, part2);
		else if(!(strcmp(part1,"scale"))) 
			strcpy(dhead.scale, part2);
		else if(!(strcmp(part1,"search_rad"))) 
			strcpy(dhead.search_rad, part2);
		else if(!(strcmp(part1,"source_yr"))) 
			strcpy(dhead.source_yr, part2);
		else if(!(strcmp(part1,"state"))) 
			strcpy(dhead.state, part2);
		else if(!(strcmp(part1,"stplzn"))) 
			strcpy(dhead.stplzn, part2);
		else if(!(strcmp(part1,"template1"))) 
			strcpy(dhead.template1, part2);
		else if(!(strcmp(part1,"template2"))) 
			strcpy(dhead.template2, part2);
		else if(!(strcmp(part1,"template3"))) 
			strcpy(dhead.template3, part2);
		else if(!(strcmp(part1,"udrn"))) 
			strcpy(dhead.udrn, part2);
		else if(!(strcmp(part1,"utmln"))) 
			strcpy(dhead.utmln, part2);
		else if(!(strcmp(part1,"utmlt"))) 
			strcpy(dhead.utmlt, part2);
		else
		{	message("no match of header item to:  ");
			append_msg(part1);
			append_msg(".   No change made to default header.");
			return(0);
		}

/*** New code as of 12/11/89   ***/
		/************ set the stpln_params globals *****************/
		/*  & the stateplane corners in the corner global          */
	if(dhead.stplzn)
	{	orig_stplzn = state_plane_zone;
		state_plane_zone = 0;
		if(sscanf(dhead.stplzn,"%d",&state_plane_zone))
		{
/*** NOTE:  The call to stpln_data will also update the global stpl data ***/
/*** It is necessary to store the original stplzn and use it to update   ***/
/*** the header if necessary.                                            ***/

			if(stpln_data(state_plane_zone))
				state_plane_zone = 0;      /* none */
			else
				strcpy(dhead.stplzn, header.stplzn);

		/*** Restore header and stplzn global data to original setting ***/
			if( orig_stplzn )
				stpln_data(orig_stplzn);
			else
				header.stplzn[0] = (char)NULL;
		}
	}
/*** End of New Code 12/11/89  ***/

			/*    store header in default header file */
#ifdef MULTIUSER
		sprintf(path,"%s/.ltp/config/header",home_path);
#else
		sprintf(path,"%s/config/header",ltp_path);
#endif
		if(put_header(path, &dhead))
		{	message("unable to store header in:  ");
			append_msg(path);
			message("No change made.");
			return(0);
		}

	}


		/********************* check for print & print ******************/
	if(print_flag) {	
#ifdef MULTIUSER
	    sprintf(path,"%s/.ltp/config/header",home_path);
	    if (!file_exists(path,""))
		sprintf(path,"%s/config/header",ltp_path);
#else
		sprintf(path,"%s/config/header",ltp_path);
#endif
		print_file(path);
	}

	return(1);
}
