/*******************************************************************************
*	dict_print	(see manual, Command Ref., User Functions)	<fc>   *
*			Description:  Prints or displays data dictionary       *
*			on specified device.                                   *
*			Parameters:  Device code, dictionary name and optional *
*				     file name (if device code = 3).           *
*									       *
*			Returns zero upon normal end-of-job (EOJ).             *
*			J.Dabritz  2/1/90						       *
*******************************************************************************/
/* Modified 6/92 by DBS@CWU for multi user support */

#include "../../incl/globals.h"
#include "../../incl/in.h"

long dict_print( dev , file)
	long dev;
	char *file;
{
	char path[256];
	
		/************** check parameters ****************************/
	if(dev < 0   ||  dev > 1)
	{	message("Illegal device code, dict_print aborted.");
		return(1);
	}

		/************** set path of dictionary file *****************/
	if(*file != '/')
#ifdef MULTIUSER
	    sprintf(path,"%s/.ltp/dictionaries/%s",home_path,file);
	    if(!file_exists(path,""))
		sprintf(path,"%s/dictionaries/%s",ltp_path,file);
#else
		sprintf(path,"%s/dictionaries/%s",ltp_path,file);
#endif
	else
		sprintf(path,"%s",file);


		/************** display or print file if necessary **********/
	if(dev == 0)   /** display on screen **/
		more(path);
	else
		print_file(path);

		/************** return **************************************/
	return(0);
}
