/*******************************************************************************
*   disprstr_ers    (see manual, Command Ref., User Functions)  <fc>           *
*        Erases the current displayed raster.                                  *
*                                                                              *
*        Parameters:  - none -                                                 *
*                                                                              *
*        Globals/files changed:  the displayed raster (global) is changed.     *
*                                job_stats[40], job_stats[45]                  *
*                                                                              *
*        Values returned:  0=done, 1=failed.                                   *
*                   J.Dabritz,   2/8/90                                        *
*******************************************************************************/

#include "../../incl/globals.h"
#include "../../incl/in.h"


long disprstr_ers()
{
	char string[STRLIST];

	long *ptr, *endptr;


		/**************** check for map ********************************/
	if(!job_stats[0])
	{	message("You must CREATE or ACQUIRE a map befor erasing the raster.");
		return(1);
	}

		/************* check for VIEW ONLY raster **********************/
	if(job_stats[78])
	{	message("You CANNOT do ANYTHING to the VIEW ONLY ORIGINAL SCAN.");
		return(1);
	}

		/*******   erase displayed raster *********/
	endptr = (long *) lraster[job_stats[2]] + raster_wincrement;
	for(ptr = (long *) lraster[0]; ptr < endptr; ptr++)
		*ptr = 0;

		/**************** re-display on screen *************************/
		/******** re-build map display ************/
	redisp_map();
	dispgraphics(job_stats[1] / 2, job_stats[2] / 2, (long) 0);

		/**************** set edited flag  *****************************/
	if(job_stats[40] < job_stats[45])
	{	job_stats[45]++;
		job_stats[40] = job_stats[45];
	}

		/**************** make diary entry *****************************/
	sprintf(string,"raster display erased.");
	put_diary(string);

		/**************** return ***************************************/
	return(0);
}

