/*******************************************************************************
*   disprstr_get    (see manual, Command Ref., User Functions)  <fc>           *
*        Copies the disprstr to the display                                    *
*                                                                              *
*        Parameters:  long rasterb;   0=get from raster                        *
*                                     1=get from rasterb, VIEW ONLY            *
*                                     2=get from rasterb, REPLACE raster       *
*                     long redisp;    1=redisplay map, 0=don't redisplay map   *
*                                                                              *
*        Globals/files changed:  - none -                                      *
*                                                                              *
*        Values returned:  0=copy done, 1=copy filed.                          *
*                   J.Dabritz,   2/8/90                                        *
*******************************************************************************/

#include "../../incl/globals.h"
#include "../../incl/in.h"


long disprstr_get(rasterb,redisp)
long rasterb,redisp;
{
	char path[256];

	long h,w,raster_size;

	int filefd;

		/**************** check for map ********************************/
	if(!job_stats[0])
	{	message("You must CREATE or ACQUIRE a map befor recalling the temp raster.");
		return(1);
	}


		/***** if getting original raster for viewing only, save disprstr **/
	if((rasterb == 1) && !job_stats[78]) /* braster not currently being viewed */
	{	if(disprstr_put())
			return(1);
	}

		/********** load raster *****************************/
		/***********  calculate sizes **************/
	h = job_stats[2] + 1;             /* height of raster in rows  */
	w = (job_stats[1] + 1) / 8;       /* width of raster in bytes  */
	raster_size = h*w;                /* size of raster in bytes   */
	
		/***********  read raster from file *********************/
	if(rasterb)
	{	if(israsterb())
			sprintf(path,"%s/rasterb",temp_map_path);
		else
		{	message("There is no b-raster or the b-raster is the wrong size.  Cannot get it.");
			return(1);
		}
	}
	else
		sprintf(path,"%s/raster",temp_map_path);

	filefd = openf(path,READ);
	if(0 > filefd)
	{	if(rasterb)
			message("  <<  cannot open map rasterb (original scan) file.");
		else
			message("  <<  cannot open map raster file.");
		return(1);
	}
	if(0 >= readb(rasterm.rec0,raster_size,1,filefd))
	{	message("  <<  cannot read raster map file.");
		closef(filefd);
		return(1);
	}
	closef(filefd);

		/**************** re-display on screen *************************/
		/******** re-build map display ************/
	if(redisp)
	{	redisp_map();
		dispgraphics(job_stats[1] / 2, job_stats[2] / 2, (long) 0);
	}


		/**************** make diary entry *****************************/
	job_stats[78] = 0;   /** default, ok to store over edited raster **/
	if(rasterb)
	{	if(rasterb == 1)
		{	sprintf(path,"dispraster_get, from original scan raster VIEW ONLY.");
			job_stats[78] = 1;   /*** flag for no store ***/
			if(((input_mode >= 3) && (input_mode <= 26) && (input_mode != 13))
			   || (input_mode == 28) || (input_mode == 30) || (input_mode == 32))
				change_mode(0,0);
		}
		else
			sprintf(path,"dispraster_get, from original scan raster REPLACE EDITABLE RASTER.");
	}
	else
		sprintf(path,"dispraster_get, from editable raster.");
	put_diary(path);

		/**************** return ***************************************/
	return(0);
}
