/*******************************************************************************
*   disprstr_mrg    (see manual, Command Ref., User Functions)  <fc>           *
*        Merges the current displayed raster and the temp/raster.              *
*                                                                              *
*        Parameters:  - none -                                                 *
*                                                                              *
*        Globals/files changed:  the displayed raster (global) is changed.     *
*                                job_stats[40], job_stats[45]                  *
*                                                                              *
*        Values returned:  0=done, 1=failed.                                   *
*                   J.Dabritz,   2/8/90                                        *
*******************************************************************************/

#include "../../incl/globals.h"
#include "../../incl/in.h"


long disprstr_mrg()
{
	char path[256];

	long *ptr, *endptr;
	long word;

	int filefd;


		/**************** check for map ********************************/
	if(!job_stats[0])
	{	message("You must CREATE or ACQUIRE a map befor merging the display & temp rasters.");
		return(1);
	}

		/************* check for VIEW ONLY *****************************/
	if(job_stats[78])
	{	message("You CANNOT do ANYTHING to the VIEW ONLY ORIGINAL SCAN.");
		return(1);
	}

		/**************** open raster file *****************************/
	sprintf(path,"%s/raster",temp_map_path);
	filefd = openf(path,READ);
	if(0 > filefd)
	{	message("  <<  cannot open raster map file.");
		return(1);
	}

		/**************** read & mearge files **************************/
	endptr = (long *) lraster[job_stats[2]] + raster_wincrement;
	for(ptr = (long *) lraster[0]; ptr < endptr; ptr++)
	{	if((readb((char *) &word ,4,1,filefd)) == 0)
		{	message("  <<  cannot read all of raster map file, continuing.");
			break;
		}
		*ptr |= word;
	}
	closef(filefd);

		/**************** re-display on screen *************************/
		/******** re-build map display ************/
	redisp_map();
	dispgraphics(job_stats[1] / 2, job_stats[2] / 2, (long) 0);

		/**************** set edited flag  *****************************/
	if(job_stats[40] < job_stats[45])
	{	job_stats[45]++;
		job_stats[40] = job_stats[45];
	}

		/**************** make diary entry *****************************/
	sprintf(path,"raster display merged with temp raster.");
	put_diary(path);

		/**************** return ***************************************/
	return(0);
}

