/*******************************************************************************
*   disprstr_put    (see manual, Command Ref., User Functions)  <fc>           *
*        Copies the display raster to the temp raster file                     *
*                                                                              *
*        Parameters:  - none -                                                 *
*                                                                              *
*        Globals/files changed:  the temp/raster file is overwritten.          *
*                                                                              *
*        Values returned:  0=copy done, 1=copy filed.                          *
*                   J.Dabritz,   2/8/90                                        *
*******************************************************************************/

#include "../../incl/globals.h"
#include "../../incl/in.h"


long disprstr_put()
{
	int fd;

	long size;
	long last_mode, last_snap;

	char path[512];


		/**************** check for map ********************************/
	if(!job_stats[0])
	{	message("You must CREATE or ACQUIRE a map befor storing the raster.");
		return(1);
	}

		/************* check for VIEW ONLY raster **********************/
	if(job_stats[78])
	{	message("You CANNOT do ANYTHING to the VIEW ONLY ORIGINAL SCAN.");
		return(1);
	}
		/**************** save current input mode **********************/
	last_mode = input_mode;
	last_snap = snap_input;
	change_mode(0,0);         /** eliminate current mode **/

		/*******   write raster to temp file  *****/
		/*  open file   */
	sprintf(path,"%s/raster",temp_map_path);
	if((fd = openf(path,WRITE)) <= 0)
	{	message("Cannot open raster temp file.  Aborting.");
		return(1);
	}
		/*  write all records  */
	size = (job_stats[1]+1)  *  (job_stats[2]+1)  /  8;
	if(0 > writeb(rasterm.rec0, size , 1, fd))
	{	message("Cannot write all raster recs to temp file.  Aborting.");
		closef(fd);
		return(1);
	}
		/*  close file  */
	closef(fd);

		/**************** write mini-raster to temp file ****************/
		/*  open file   */
	sprintf(path,"%s/mini_raster",temp_map_path);
	if((fd = openf(path,WRITE)) <= 0)
	{	message("Cannot open mini_raster temp file.  Aborting.");
		return(1);
	}
		/*  write all records  */
	size = 400 * 50;
	if(0 > writeb(mini_raster[0], size , 1, fd))
	{	message("Cannot write all mini_raster recs to temp file.  Aborting.");
		closef(fd);
		return(1);
	}
		/*  close file  */
	closef(fd);

		/**************** reset current input mode **********************/
	change_mode(last_mode,last_snap);

		/*** make sure that all writes are scheduled **/
	sync();

		/**************** make diary entry *****************************/
	sprintf(path,"temp raster replaced by displayed raster.");
	put_diary(path);

		/**************** return ***************************************/
	return(0);
}

