/*******************************************************************************
*   erase_obj          (see manual, Command Ref., User Function)        <fc>   *
*           Sets the graphic input mode to erase_obj for the specified         *
*           object type.                                                       *
*                                                                              *
*           Parameters:   long otype;  0=node, 1=segment, 2=polygon;           *
*                                                                              *
*           Globals changed:   sets  atrbt_otype                               *
*                                                                              *
*           Returns long (0)                                                   *
*           J.Dabritz 8/13/89                                                  *
*******************************************************************************/

#include "../../incl/globals.h"
#include "../../incl/in.h"

long erase_obj(otype)
long otype;
{
		/************* check for VIEW ONLY raster **********************/
	if(job_stats[78])
	{	message("You CANNOT do ANYTHING to the VIEW ONLY ORIGINAL SCAN.");
		return(1);
	}

		/**** check input parameter ***/
	if((otype <0)  ||  (otype > 2))
	{	message("Object type must be 0-2.  no action taken.");
		return(1);
	}
	
		/*** set object type global for erase_obj  **/
	atrbt_otype = otype;

		/*** change mode ***/
	change_mode(30,0);
	
	return(0);
}
