/*******************************************************************************
*	execute_ltp   (see manual, Command Ref, User Functions)             <fc>   *
*                                                                              *
*           Passes the command found in parm to the operating system  for      *
*           invokation.  The parm is not checked to determine if it is a       *
*           valid UNIX/XENIX command.  If no parm is found, execute shell.     *
*                                                                              *
*           Returns 1 upon normal execution, else returns 0.                   *
*******************************************************************************/

#include "../../incl/globals.h"

long execute_ltp(parm)
	char *parm;
{
	long ret_code = 0;

/*** If parm is empty, execute the shell command, else use 'system' call ***/
	if( strlen(parm) == 0 )
	{	if( !batch_mode )
			shell();
	}
	else
	{	graphics_off();
		kb_reset();

		ret_code = system_ltp(parm);

		if( !batch_mode )
		{	printf("\nPress [RETURN] to return to LTPlus.  ");
			fflush(stdin);
			getchar();
		}

		graphics_on();
		kb_setup();
	}
	
	return(ret_code);
}
