/*******************************************************************************
*	graphics	(see manual, Command Ref., User Function)	<fc>   *
*			Changes the type of graphics being displayed and       *
*			the area in which they are diplayed.                   *
*                                                                              *
*			Modifies the displayed graphics screen and values in   *
*			the graphics.h header file                             *
*                                                                              *
*			Returns zero upon normal end-of-job (EOJ).             *
*           J.Dabritz 8/13/89                                                  *
*******************************************************************************/

#include "../../incl/globals.h"
#include "../../incl/in.h"
#include <string.h>


long graphics(full_width,raster_disp,normal_v,normal_i1,normal_i2,highlight_v,highlight_i1,highlight_i2,centroid_disp)
long full_width;
long raster_disp;
long normal_v;
long normal_i1;
long normal_i2;
long highlight_v;
long highlight_i1;
long highlight_i2;
long centroid_disp;
{
	long x,y;
	long i;
	char string[256];

		/************* set global display control variables *********/
	disp_raster = raster_disp;
	disp_normal = normal_v;
	disp_i1normal = normal_i1;
	disp_i2normal = normal_i2;
	disp_hglight = highlight_v;
	disp_i1hglight = highlight_i1;
	disp_i2hglight = highlight_i2;
	disp_centroid = centroid_disp;

		/************* evaluate full_width & change as necessary ****/
	if(full_width != full_width_disp)
	{	full_width_disp = full_width;
		if(full_width)
		{	windowxmin = 0;
			scrn_display();

				/*   display map name *****************************/
			strcpy(string,map_name);
			string[14] = 0;
			for(i=2; i<4; i++)
			{	swplane(i);
				bar_off(528,416,639,431);
				disptext(26,66,string);
			}

				/****** display menu name *********************/
			for(i = 2;  i < 4;  i++)
			{	swplane(i);
				bar_off(528,432,639,447);
				disptext(27,66,menu_name[current_menu]);
			}

				/*** display input mode ****/
			for(i = 2;  i < 4;  i++)
			{	swplane(i);
				bar_off(528,448,639,463);
				disptext(28,66,input_modes[input_mode]);
			}

				/***************** display snap on/off ***********************/
			for(i=1; i<4; i++)
			{	swplane(i);
				bar_off(528,464,639,479);
			}
			if(snap_input)
			{	for(i = 2;  i < 4;  i++)
				{	swplane(i);
					disptext(29,66,"** SNAP ON **");
				}
			}
			else
			{	swplane(1);
				disptext(29,66,"  snap off");
			}
		}
		else 
		{	windowxmin = 224;
			scrn_display();
				/*** erase map/menu/mode/snap in lower right corner **/
			for(i=1; i<4; i++)
			{	swplane(i);
				bar_off(528,416,639,479);
			}
				
			i = current_menu;
			disp_menuset();
			disp_menu(i);
				/*** redisp input mode ****/
			for(i = 2;  i < 4;  i++)
			{	swplane(i);
				bar_off(0,47,111,32);
				disptext(2,0,input_modes[input_mode]);
			}

				/*** redisp snap mode ***/
			/***************** display snap on/off ***********************/
			for(i=1; i<4; i++)
			{	swplane(i);
				bar_off(0,62,111,48);
			}
			if(snap_input)
			{	for(i = 2;  i < 4;  i++)
				{	swplane(i);
					disptext(3,0,"** SNAP ON **");
				}
			}
			else
			{	swplane(1);
				disptext(3,0,"  snap off");
			}

				/*** redisp map name ****/
				/*   display map name in upper left block, line 2 */
			strcpy(string,map_name);
			string[14] = 0;
			swplane(2);
			bar_off(0,16,111,31);
			disptext(1,0,string);
			swplane(3);
			bar_off(0,16,111,31);
			disptext(1,0,string);
		}
	}

		/************* call dispgraphics to re-display data *********/
	x = (rwindowxmin + rwindowxmax) / 2;
	y = (rwindowymin + rwindowymax) / 2;
	if(dispgraphics(x,y,resolution_code))
		return(1);

		/************* return ***************************************/
	return(0);
}
