/*******************************************************************************
*	header_ltp	(see manual, Command Ref., User Functions)	<fc>   *
*			Description:  Update/display the header file on the    *
*			specified device.                                      *
*			Parameters:  Print flag, item to update paired with    *
*				     change.                                   *
*									       *
*			Returns one upon success, 0 on failure.                *
*           J.Dabritz  6/8/89                                                  *
*******************************************************************************/

#include <string.h>
#include "../../incl/globals.h"
#include "../../incl/in.h"

long header_ltp(print_flag,part1,part2)
long print_flag;
char *part1;
char *part2;
{	
	char path[512];
	long x,y;

		/********************* check for loaded map *********************/
	if(!job_stats[0]  ||  !*temp_map_path)
	{	message("there is no map currently loaded. cannot change header");
		return(0);
	}


		/********************* check for header change & make change ****/
	if(*part1)
	{		/*  match part1 with header item  */
		if(!(strcmp(part1,"comments"))) 
			strcpy(header.comments, part2);
		else if(!(strcmp(part1,"compress"))) 
			strcpy(header.compress, part2);
		else if(!(strcmp(part1,"contour_interval"))) 
			strcpy(header.contour_interval, part2);
		else if(!(strcmp(part1,"datum"))) 
			strcpy(header.datum, part2);
		else if(!(strcmp(part1,"dictionary"))) 
			strcpy(header.dictionary, part2);
		else if(!(strcmp(part1,"edgematch"))) 
			strcpy(header.edgematch, part2);
		else if(!(strcmp(part1,"edge_e"))) 
			strcpy(header.edge_e, part2);
		else if(!(strcmp(part1,"edge_n"))) 
			strcpy(header.edge_n, part2);
		else if(!(strcmp(part1,"edge_s"))) 
			strcpy(header.edge_s, part2);
		else if(!(strcmp(part1,"edge_w"))) 
			strcpy(header.edge_w, part2);
		else if(!(strcmp(part1,"head1"))) 
			strcpy(header.head1, part2);
		else if(!(strcmp(part1,"head2"))) 
			strcpy(header.head2, part2);
		else if(!(strcmp(part1,"layer_name"))) 
			strcpy(header.layer_name, part2);
		else if(!(strcmp(part1,"map_ht"))) 
			strcpy(header.map_ht, part2);
		else if(!(strcmp(part1,"map_wd"))) 
			strcpy(header.map_wd, part2);
		else if(!(strcmp(part1,"maptype"))) 
			strcpy(header.maptype, part2);
		else if(!(strcmp(part1,"menu_set"))) 
			strcpy(header.menu_set, part2);
		else if(!(strcmp(part1,"org"))) 
			strcpy(header.org, part2);
		else if(!(strcmp(part1,"quad_unit"))) 
			strcpy(header.quad_unit, part2);
		else if(!(strcmp(part1,"revision_yr"))) 
			strcpy(header.revision_yr, part2);
		else if(!(strcmp(part1,"scale"))) 
			strcpy(header.scale, part2);
		else if(!(strcmp(part1,"search_rad"))) 
			strcpy(header.search_rad, part2);
		else if(!(strcmp(part1,"source_yr"))) 
			strcpy(header.source_yr, part2);
		else if(!(strcmp(part1,"state"))) 
			strcpy(header.state, part2);
		else if(!(strcmp(part1,"stplzn"))) 
			strcpy(header.stplzn, part2);
		else if(!(strcmp(part1,"udrn"))) 
			strcpy(header.udrn, part2);
		else if(!(strcmp(part1,"template1"))) 
			strcpy(header.template1, part2);
		else if(!(strcmp(part1,"template2"))) 
			strcpy(header.template2, part2);
		else if(!(strcmp(part1,"template3"))) 
			strcpy(header.template3, part2);
		else if(!(strcmp(part1,"utmln"))) 
			strcpy(header.utmln, part2);
		else if(!(strcmp(part1,"utmlt"))) 
			strcpy(header.utmlt, part2);
		else
		{	message("no match of header item to:  ");
			append_msg(part1);
			append_msg(".   No change made to header.");
			return(0);
		}
			/*    store header in temp map file      */
		sprintf(path,"%s/header",temp_map_path);
		if(put_header(path,&header))
		{	message("unable to store header in:  ");
			append_msg(path);
			message("No change made.");
			return(0);
		}

			/*    retrieve header to update changed variables  */
		sync();
		if(get_header(path,&header,1))
		{	message("unable to retrieve header from:  ");
			append_msg(path);
			message("you may have a corrupt temporary map file.");
			return(0);
		}

	}


		/********************* check for print & print ******************/
	if(print_flag)
	{	sprintf(path,"%s/header",temp_map_path);
		print_file(path);
	}


		/************* check last map_type against current  *********/
	if(job_stats[9] != map_type)
		default_sets();

		/************* call dispgraphics to re-display data *********/
	if(disp_hglight | disp_normal)
	{	if(!(strcmp(part1,"maptype"))) 
		{	x = (rwindowxmin + rwindowxmax) / 2;
			y = (rwindowymin + rwindowymax) / 2;
			if(dispgraphics(x,y,resolution_code))
				return(0);
		}
	}

	return(1);
}
