/*******************************************************************************
*    level_icopy   (see manual, Command Ref., User Functions)    <fc>          *
*            This program sets the mode to icopy, individual copy of import    *
*       level objects.                                                         *
*                                                                              *
*       parameters:    long level;    number of level from which to copy       *
*                                                                              *
*       files/globals changed:  input_mode                                     *
*                                                                              *
*       values returned:  long 0= ok,  1=failure                               *
*                                                                              *
*            J.Dabritz   8/16/90                                               *
*******************************************************************************/

#include "../../incl/globals.h"
#include "../../incl/in.h"

long level_icopy(level)
long level;
{
		/************* check for VIEW ONLY raster **********************/
	if(job_stats[78])
	{	message("You CANNOT do ANYTHING to the VIEW ONLY ORIGINAL SCAN.");
		return(1);
	}

		/**** check input parameter ***/
	if((level <32)  ||  (level > 95))
	{	message("Level must be in range 32-95.  no action taken.");
		return(1);
	}
	
		/*** change mode ***/
	entry_level = level;
	change_mode(32,0);
	
	return(0);
}
