/*******************************************************************************
*       macro_begin    (see manual, Command Ref., User Functions)       <fc>   *
*                       Description:  Activates the macro collection mode.     *
*                       Parameters:  Macro name and macro descriptor.          *
*                                                                              *
*                       Returns zero upon normal end-of-job (EOJ).             *
*                       J.Dabritz   2/1/90                                     *
*******************************************************************************/
/* Last modified 5/3/92 by DBS@CWU for multiuser support */

#include "../../incl/globals.h"
#include "../../incl/in.h"

long macro_begin( mac_name, descript )
	char *mac_name;
	char *descript;
{
	char fname[256];
	char string[256];


	/************* create file ***************************************/
#ifdef MULTIUSER
	sprintf(fname,"%s/.ltp/macros/%s",home_path,mac_name);
#else
	sprintf(fname,"%s/%s",macros_path,mac_name);
#endif
	if(1 > creatf(fname))
		return(1);

	/************* open file *****************************************/
	macro_file = openf(fname,WRITE);
	if(macro_file <= 0)
	{	purgef(fname);
		return(1);
	}

	/************* store description as a comment ********************/
	sprintf(string,"#  %s\n",descript);
	writea(string, macro_file);


	/************* store a blank line ********************************/
	writea("\n",macro_file);

	/************* set macro collection mode to 'begin' **************/
	collecting_macro = -1;

	/************* return ********************************************/
	return(0);
}
