/*******************************************************************************
*        macro_end        (see manual, Command Ref., User Functions)    <fc>   *
*                        Description:  Exits from the macro collection mode.   *
*                        Parameters:  None.                                    *
*                                                                              *
*                        Returns zero upon normal end-of-job (EOJ).            *
*                        J.Dabritz   2/1/90                                    *
*******************************************************************************/

#include "../../incl/globals.h"
#include "../../incl/in.h"

long macro_end( )
{

	/************* check for macro collection ************************/
	if(!collecting_macro)
	{	message("There is no macro currently being collected.");
		return(1);
	}

	/************* close file ****************************************/
	closef(macro_file);
	macro_file = -1;

	/************* set macro collection mode to off ******************/
	collecting_macro = 0;

	/************* inform user ***************************************/
	message(" --------- macro collection finished. ------------");

	/************* return ********************************************/
	return(0);
}
