/*******************************************************************************
*        menuset_get    (see manual, Internal Functions)                <fc>   *
*                       This program reads the menu file specified by the      *
*                       parameter and loads the menus into the common block    *
*                       and displays them on the screen.                       *
*                                                                              *
*                       Only the menu_set.h common block is changed.           *
*                                                                              *
*                       Returns zero upon normal end-of-job (EOJ).             *
*******************************************************************************/
/* modified 4/92 by DBS@CWU for multiuser support */
#include <string.h>

#include "../../incl/globals.h"    /*  <stdio.h> & all LTP defines & globals  */
#include "../../incl/in.h"             /*  <in> function definitions        */


long menuset_get(filename)
	char *filename;
{
	int file;
	char line[STRLIST];
	char part1[STRLIST], part2[STRLIST];
	char filepath[2 * STRLIST];
	char delim;
	char n,m;
	int bytes;
	long menu_no;       /*   menu number as in the file, beginning with 0 */
	long item_no;       /*   item number for item within a menu (begin=0) */
	long i,j;
	long menuname;
	long max_elements;
	long perm_item_no;  /*   item number of permanent menu item           */



		/*    open the menu file                               */
#ifdef MULTIUSER
	sprintf(filepath, "%s/.ltp/menus/%s", home_path, filename);
	if( (file = openf(filepath, READ)) == -1 ) {
	  sprintf(filepath, "%s/%s", menus_path, filename);
	  if( (file = openf(filepath, READ)) == -1 )
	    return(1);
	}
#else
	sprintf(filepath, "%s/%s", menus_path, filename);
	if( (file = openf(filepath, READ)) == -1 )
		return(1);
#endif

		/*    initialize the menu strings to NULL                */
	for(i=0; i<MENUS; i++)          /*   for each menu in the set of 19  */
	{	menu_name[i][0] = (char) NULL;   /* set the menu name to NULL */
		menu_help[i][0] = (char) NULL;
		for(j=0; j<MENU_ITEMS; j++)      /*  for each entry in menu  */
			menu_item[i][j][0] = (char) NULL;
	}
	for(i=0; i<6; i++)
		*perm_item[i] = 0;      /*  set to null */


		/*    read the menu file 1 record at a time and        */
		/*    place in appropirate menu. element.              */
	bytes = STRLIST-1;
	max_elements = 2;
	n = STRLIST;
	m = MENU_DISPLEN;
	perm_item_no = 0;
	for(menuname=1, menu_no=0 ; reada(line, bytes, file) && menu_no<MENUS ;)
	{	
		line[STRLIST-1] = 0;    /*  append a null  */
		trim(line);    
		if(line[0])
		{	if(strsplit(line,'\173',part1,part2))   /* begin a new menu       */
			{       /*   end perm menu input   */
				perm_item_no = 6;
					/*   first check to see if there is text befor bracket  */
				if(strlen(trim(part1)))
				{	strcpy( menu_name[menu_no], part1);
					strcpy( menu_help[menu_no], part1);
				}

					/*   next reset item_no, and menuname flag         */
				menuname = 0;
				item_no = 0;

					/*   next check for text following closing bracket     */
				if(strlen(trim(part2)))
					strcpy( menu_item[menu_no][item_no++],part2);
			}

			else if(strsplit(line,'\175',part1,part2))     /* end a menu     */
			{       /*   end perm menu input   */
				perm_item_no = 6;
					/* check to see if there is text befor closing bracket  */
				if(strlen(trim(part1)))
					strcpy( menu_item[menu_no][item_no++],part1);

				  /*     increment menu_no, and set menuname flag     */
				menu_no++;
				menuname = 1;  
			}

			else                               /* add a menu name or menu line*/
			{	if(perm_item_no < 6)
					strcpy( perm_item[perm_item_no++], line);
				else if(menuname)
				{	strcpy( menu_name[menu_no], line);
					strcpy( menu_help[menu_no], line);
				}
				else if( item_no < MENU_ITEMS)
					strcpy( menu_item[menu_no][item_no++], line);
			}
		}
		else                     /* increment item number   */
			item_no++;
	}
	closef(file);
	
	strcpy(menuset_name,filename);

	disp_menuset();

	return 0;
}
