/*******************************************************************************
*    merge_fill    (see manual, Command Ref., User Function)          <fc>     *
*         This function combines the raster display with parts of the          *
*      raster (temp file) as strored on disc.  Each pixel is examined.         *
*      If a pixel is off, and has 0 or 1 adjacent pixel on, then the pixel     *
*      is recalled from disc.                                                  *
*                                                                              *
*      Parameters:   - none -                                                  *
*                                                                              *
*      Files changed:  the displayed raster                                    *
*                                                                              *
*      Values returned:   0 = successful, 1=failure                            *
*      J.Dabritz   2/9/90                                                      *
*******************************************************************************/

#include "../../incl/globals.h"
#include "../../incl/in.h"

long merge_fill()
{
	char string[STRLIST];

	long last_mode, last_snap;
	long locale;
	long word, bit;
	long *lptr;
	long wordmax;
	long i,j,n;
	long x,y;

message("Not implemented yet.");
return(1);

		/**************** check for map ********************************/
	if(!job_stats[0])
	{	message("You must CREATE or ACQUIRE a map befor doing a merge_fill.");
		return(1);
	}

/*	turn graphics and keyboard trap off   */
graphics_off();
kb_reset();

		/************ save last input mode & snap mode ****************/
	last_mode = input_mode;
	last_snap = snap_input;

		/************ set input mode to recall pt *********************/
	change_mode(18,0);         /** recall pt mode         **/

		/************ check all xy pts for off pixel ******************/
	wordmax = (job_stats[1] + 1) >> 5;
printf("Merge/fill, wordmax = %d\n",wordmax);
	for(y=0, lptr=(long *)&lraster[0][0]; y<= job_stats[2]; y++)
	{	if(!(y % 25))
		{	sprintf(string,"merge/filling, at row %d.",y);
			message(string);
		}
		for(x=0, word = 0; word < wordmax; word++, lptr++)
		{
			for(i=0; i<32; i++, x++) 
			{		/************ if pixel off, check locale **************/
				bit = (7 & ~x) | (x & 24);
				if(!(*lptr & (1 << bit)))
				{	locale = locale_xy(x,y);
					/************ if 1 or less pts on, the recall pt ******/
					for(n=0,j=0; (n<8)  &&  (j<2); n++)
						j += (locale > n) & 1;
					if(j<2)
						continue_ltp(x,y);
				}
			}
		}
	}

/*  reset the graphics and keyboard trap  */
graphics_on();
kb_setup();


		/************ reset input mode & snap mode ********************/
	change_mode(last_mode,last_snap);

		/**************** make diary entry *****************************/
	sprintf(string,"merge_fill command executed.");
	put_diary(string);


		/************ return ******************************************/
	return(1);
}
