/*******************************************************************************
*       mlist_exec    (see manual, Command Ref., User Function)       <fc>     *
*                     Executes another LTP function/macro on a list of maps.   *
*                     Parameters:  long save_flag;  1=save map after procesing *
*                                  char maplist[];  name of maplist file.      *
*                                  char action[];   string to be exectued      *
*                     Makes no file changes itself.                            *
*                     Values returned:  long (0)  exectued, 1=aborted.         *
*                     J.Dabritz  2/7/90                                        *
*******************************************************************************/
/* Modified 6/92 by DBS@CWU for multi user support */

#include "../../incl/globals.h"
#include "../../incl/in.h"

long mlist_exec(save_flag,maplist, action)
	long save_flag;
	char *maplist;
	char *action;
{
	char  tmp_name[L_tmpnam];                /* used for tmpnam()      */
	char  path[256];
	char  string[256];
	char  command[256];
	char  parsed[20][STRLIST];
	
	int fd;
	int fd_temp;

	long n,j;


		/************* check action parameter ***************************/
	trim(action);
	if(!(*action))
	{	message("You must specify an action to be taken on the maplist.");
		return(1);
	}

		/************* create temp file *********************************/
	tmp_name[0] = (char) 0;
	tmpnam( tmp_name );		/* Arg must be L_tmpnam in length */
	if(creatf(tmp_name) < 0)
	{	message("Cannot open temp map_list file.  aborting command.");
		return(1);
	}

		/************* open temp    file ********************************/
	fd_temp = openf(tmp_name,WRITE);
	if(fd_temp < 0)
	{	message("Cannot open temp file.  aborting command.");
		return(1);
	}

		/************* open maplist file ********************************/
#ifdef MULTIUSER
	sprintf(path,"%s/.ltp/map_lists/%s",home_path,maplist);
	if (!file_exists(path,""))
		sprintf(path,"%s/map_lists/%s",ltp_path,maplist);
#else
	sprintf(path,"%s/map_lists/%s",ltp_path,maplist);
#endif
	fd = openf(path,READ);
	if(fd < 0)
	{	message("Cannot open maplist file ");
		append_msg(path);
		append_msg(".  aborting command.");
		closef(fd_temp);
		return(1);
	}

		/************* read & expand maplist file into temp file ********/
		/*** first do unexpanded strings ***/
	for(;reada(string,255,fd) != (char *) 0; )
	{	trim(string);
		if((strstr(string,"*") == (char *) 0) && (strstr(string,"?") == (char *) 0))
		{	n = strlen(string);
			string[n] = 10;
			string[n + 1] = 0;
			writea(string,fd_temp);
		}
	}
	closef(fd_temp);

		/*** next do expanded strings ***/
	closef(fd);
	fd = openf(path,READ);
	if(fd < 0)
	{	message("Cannot open maplist file.  aborting command.");
		return(1);
	}
	for(;reada(string,255,fd) != (char *) 0; )
	{	trim(string);
		if(((strstr(string,"*") != (char *) 0) || (strstr(string,"?") != (char *) 0)))
		{	sprintf(command,"ls -d %s/%s >> %s",maps_path,string,tmp_name);
			system_ltp(command);
		}
	}

		/************* close map_list file ******************************/
	closef(fd);

		/************* open  temp file **********************************/
	fd = openf(tmp_name,READ);
	if(fd < 0)
	{	message("Cannot open temp map_list file.  aborting command.");
		closef(fd);
		return(1);
	}

		/************* read temp file 1 name at a time & execute action */
	trim(action);
	for( ; reada(string,STRLIST,fd); )
	{	trim(string);
		if(*string)
		{	j = parse(string,"/",parsed[0],20);
			if((j > 0) && (j <= 20))
			{	sprintf(string,"%s",parsed[j - 1]);
				sprintf(raw_buf,"acquire  %s",string);
				fj();
				sprintf(raw_buf,"%s",action);
				fj();
				if(changes() && save_flag)
				{	sprintf(raw_buf,"save");
					fj();
				}
			}
		}

			/************* check for abort **********************************/
		*raw_buf = (char) 0;
		if(abort_cmd())
		{	message("User terminated mlist exec.");
			break;
		}
	}
	
		/************* close temp file **********************************/
	closef(fd);

		/************* return *******************************************/
	return(0);
}
