/*******************************************************************************
*             more_ltp (see manual, Command Ref., User Functions)        <fc>  *
*                       Displays the contents of the specified file (fname), in*
*                       paged format, on the full screen tile.                 *
*                                                                              *
*            parameters:  long n;         file type, see editM.c               *
*                         char *fname;    file name to be displayed            *
*                         long columns;   number of screen columns to use(1-80)*
*                                                                              *
*                        Returns zero upon normal end-of-job (EOJ).            *
*                      j.dabritz  12/3/90                                      *
*******************************************************************************/
/* Modified 4/92 by DBS@CWU for multi user support */

#include "../../incl/globals.h"
#include "../../incl/in.h"


long more_ltp(n,fname,columns)
	long n;
	char fname[];
	long columns;
{
	char path[256];
	char file[256];
	char name[256];

		/********************** check for map loaded if neces **************/
	if(!job_stats[0]  && ((n == 4)  ||  (n == 9)))
	{	message("You must Create or Acquire a map befor viewing map files.");
		return(1);
	}

		/********************** check for legitimate parameters ************/
	if(n<1 || n>16)
	{	message("Illegal file type. Edit aborted.");
		return(1);
	}
	
		/********************** construct full file name *******************/
	sprintf(name,fname);
	switch(n) {
	case 1: 	/* config */
		sprintf(name,"config");
#ifdef MULTIUSER
		sprintf(path,"%s/.ltp/config", home_path);
		if (!file_exists(path,name))
		  sprintf(path,"%s/config",ltp_path);
#else
		sprintf(path,"%s/config",ltp_path);
#endif
		break;
	case 3:  /* default_head */
		sprintf(name,"header");
#ifdef MULTIUSER
		sprintf(path,"%s/.ltp/config", home_path);
		if (!file_exists(path,name))
		  sprintf(path,"%s/config",ltp_path);
#else
		sprintf(path,"%s/config",ltp_path);
#endif
		break;
	case 4:  /* diary  */
		if(!job_stats[0])
		{	message("You must Create or Acquire a map befor viewing map files.");
			return(1);
		}
		sprintf(name,"diary");
		sprintf(path,"%s",temp_map_path);
		break;
	case 9:  /* header */
		if(!job_stats[0])
		{	message("You must Create or Acquire a map befor viewing map files.");
			return(1);
		}
		sprintf(name,"header");
		sprintf(path,"%s",temp_map_path);
		break;
	case 16: /* tolerance */
		sprintf(name,"tolerance");
#ifdef MULTIUSER
		sprintf(path,"%s/.ltp/config", home_path);
		if (!file_exists(path,name))
		  sprintf(path,"%s/config",ltp_path);
#else
		sprintf(path,"%s/config",ltp_path);
#endif
		break;
	case 2:  /*	"cursor_key", 				/*   2 */
#ifdef MULTIUSER
		sprintf(path,"%s/.ltp/cursor_keys", home_path);
		if (!file_exists(path,name))
		  sprintf(path,"%s/cursor_keys",ltp_path);
#else
		sprintf(path,"%s/cursor_keys",ltp_path);
#endif
		break;
	case 5:	/* "dictionary", 				/*   5 */
#ifdef MULTIUSER
		sprintf(path,"%s/.ltp/dictionaries", home_path);
		if (!file_exists(path,name))
		  sprintf(path,"%s/dictionaries",ltp_path);
#else
		sprintf(path,"%s/dictionaries",ltp_path);
#endif
		break;
	case 6:	/* "digmenu   ", 				/*   6 */
#ifdef MULTIUSER
		sprintf(path,"%s/.ltp/digmenus", home_path);
		if (!file_exists(path,name))
		  sprintf(path,"%s/digmenus",ltp_path);
#else
		sprintf(path,"%s/digmenus",ltp_path);
#endif
		break;
	case 7:	/* "digitizer",					/*   7 */
#ifdef MULTIUSER
		sprintf(path,"%s/.ltp/digitizers", home_path);
		if (!file_exists(path,name))
		  sprintf(path,"%s/digitizers",ltp_path);
#else
		sprintf(path,"%s/digitizers",ltp_path);
#endif
		break;
	case 8:	/* "export", 					/*   8 */
		sprintf(path,"%s",config.export_path);
		break;
	case 10:	/* "import", 				/*  10 */
		sprintf(path,"%s",config.import_path);
		break;
	case 11:	/* "macro",				/*  11 */
#ifdef MULTIUSER
		sprintf(path,"%s/.ltp/macros", home_path);
		if (!file_exists(path,name))
		  sprintf(path,"%s/macros",ltp_path);
#else
		sprintf(path,"%s/macros",ltp_path);
#endif
		break;
	case 12:	/* "map_list", 				/*  12 */
#ifdef MULTIUSER
		sprintf(path,"%s/.ltp/map_lists", home_path);
		if (!file_exists(path,name))
		  sprintf(path,"%s/map_lists",ltp_path);
#else
		sprintf(path,"%s/map_lists",ltp_path);
#endif
		break;
	case 13:	/* "menu_set, 				/*  13 */
#ifdef MULTIUSER
		sprintf(path,"%s/.ltp/menus", home_path);
		if (!file_exists(path,name))
		  sprintf(path,"%s/menus",ltp_path);
#else
		sprintf(path,"%s/menus",ltp_path);
#endif
		break;
	case 14:	/* "other", 				/*  14 */
		sprintf(path,"");
		break;
	case 15:	/* "pens    , 				/*  15 */
#ifdef MULTIUSER
		sprintf(path,"%s/.ltp/pens", home_path);
		if (!file_exists(path,name))
		  sprintf(path,"%s/pens",ltp_path);
#else
		sprintf(path,"%s/pens",ltp_path);
#endif
		break;
	}
	trim(path);

		/********************** create directory if it doesn't exist *******/
		/********************** add file name to the path   ****************/
	if(n == 14)
		sprintf(file,"%s",name);
	else
	{	makedir(path);
		sprintf(file,"%s/%s",path,name);
	}

		/********************** allow user to more the file ****************/
	moref(file,columns);

		/********************** return *************************************/
	return(0);
}
