/*******************************************************************************
*	negative_img (see manual, Command Ref., User Function)	<fc>   *
*			Reverses the raster pixels  on <> off                  *
*                                                                              *
*           parameters:  none                                                  *
*                                                                              *
*           files/globals changed:  Raster, mini-raster files                  *
*                                                                              *
*			Returns zero upon normal end-of-job (EOJ).             *
*******************************************************************************/

#include "../../incl/globals.h"
#include "../../incl/in.h"

long negative_img()
{
	long *ptr, *end_ptr;
	long size;

	if(!job_stats[0])
	{	message("You must acquire a map befor taking a negative image.");
		return(1);
	}

		/************* check for VIEW ONLY raster **********************/
	if(job_stats[78])
	{	message("You CANNOT do ANYTHING to the VIEW ONLY ORIGINAL SCAN.");
		return(1);
	}
		/******* reverse raster pixels ************/
	message("making a negative image of the raster . . . ");
	size = ((job_stats[1] >> 5) + 1)   *   (job_stats[2] + 1);
	end_ptr = (long *) (lraster[0] + size);
	for( ptr = (long *) lraster[0]; ptr < end_ptr; ptr++ )
	    *ptr ^= (long) -1;
	append_msg(" done.");

		/******** re-build map display ************/
	redisp_map();

	dispgraphics(job_stats[1] / 2, job_stats[2] / 2, (long) 0);

		/********** set the edited flag ****************/
	if(job_stats[40] < job_stats[45])
	{	job_stats[45]++;
		job_stats[40] = job_stats[45];
	}

	return(0);
}
