/*******************************************************************************
*       pause           (see manual, User Functions)                    <fc>   *
*			Displays the input message on the control portion of the screen    *
*           and pauses LTPlus execution for the input number of seconds.       *
*                                                                              *
*           Parameters:    long seconds      number of seconds to pause (>=0)  *
*                          char string       text string to be displayed.      *
*                                                                              *
*           Files/globals changed:  none                                       *
*                                                                              *
*			Returns zero upon normal end-of-job (EOJ).             *
*                      j.dabritz  10/30/89                                     *
*******************************************************************************/
/* Modified 6/92 by DBS@CWU for X11 support */

#include "../../incl/globals.h"
#include "../../incl/in.h"
#ifdef LTP_X11
#include "../../incl/x11.h"
#endif

long pause_ltp(seconds, string)
	long seconds;
	char string[];
{	
	long i,n;

	char saveit[3][5120];
	char *ptr1;


		/** check for batch mode **/
	if(batch_mode)
		return(0);

		/** check for no display text string **/
	trim(string);
	if(*string == (char) 0)
	{	sleep(seconds);
		return(0);
	}

		/** save 3 layers for re-display later **/
	ptr1 = vga_plane + BITPLN_WIDTH * 416;     
	for(i=0; i<3 ; i++)
	{	swplane(i+1);
#ifndef LTP_X11
		bitmap(5120,1,1,1,ptr1,saveit[i]);
#else
                bitmap4x(WIDTH,64,0,415,xmainwin,0,415,xmainpix);
#endif
	}
	
		/** erase white text **/
	swplane(0);
	bar_off(0,479,639,416);

		/** lay a lt_read background **/
	swplane(1);
	bar_off(0,464,639,479);
	swplane(2);
	bar_on(0,463,639,416);
	bar_off(0,464,639,479);
	swplane(3);
	bar_on(0,463,639,416);
	bar_off(0,464,639,479);

		/** diplay message in black  **/
	n = strlen(string);
	if(n > 80)
	{	string[80] = 0;
		n = 80;
	}
	i = (80 - n) / 2;
	if( i < 0)
		i = 0;
	disptext(27,i,string);

#ifdef LTP_X11
	XFlush(xdisplay);
#endif

		/** wait for alloted time **/
	if(seconds > 0)
		sleep(seconds);

		/** redisplay 3 layers **/
	ptr1 = vga_plane + BITPLN_WIDTH * 416;     
	for(i=0; i<3 ; i++)
	{	swplane(i+1);
#ifndef LTP_X11
		bitmap(5120,1,1,1,saveit[i],ptr1);
#else
                bitmap4x(WIDTH,64,0,415,xmainpix,0,415,xmainwin);
#endif
	}
	
	
	return(0);
}
