/*******************************************************************************
*       plot_ascii      (see manual, Command Ref., User Functions)	<fc>   *
*                                                                              *
*                       Generates a plot to the plotter spedified by fd_plot   *
*                       of the ascii file identified by fname.                 *
*                       Parameters:   char * - pathname of file to plot        *
*                       Globals Modified:  fd_plot                             *
*                                                                              *
*			Returns 0 upon normal execution, else returns -1.      *
*			C. Jonson  9/22/89                                     *
*******************************************************************************/
#include "../../incl/globals.h"
#include "../../incl/in.h"

#define BYTES 4096
#define BYTESB 5000

long plot_ascii( fname )
	char *fname;
{
	int    fd;
	char   p_cmd[STRLIST];
	char   pstring[BYTESB];
	char   *ptr, *ptr2;
	
	long bytes;
	

/*** Open the file  ***/
	if( (fd = openf(fname, RDWR)) == -1)
	{	sprintf(p_cmd, "plot_ascii:  Cannot open %s.  Bye.", fname);
		message(p_cmd);
		return(-1);
	}

		/********** read file & send to plotter *****************/
	ptr = pstring;
	ptr[BYTES] = (char) 0;
	while( bytes = readb(ptr,BYTES,1,fd) )
	{		/*** read BYTES bytes & find last ';' *************/
		if(bytes == BYTES)
		{	for(ptr2 = ptr + BYTES - 1; ptr2 >= ptr; ptr2--)
			{	if(*ptr2 == ';')
					break;
			}
		}
		else
			ptr2 = ptr + bytes - 1;

			/***** check for no ';' found 512 bytes read *********/
		if(((ptr + bytes - 512) > ptr2)  ||  (ptr > ptr2))
		{	message("No full plot command in BYTES bytes read, aborting.");
			break;
		}

			/****** send string (up to ';') to plotter  **********/
		if(writeb(pstring,ptr2-pstring + 1,1,fd_plot) == -1)
		{	message("Cannot write string to plotter, aborting.");
			break;
		}
		
			/****** copy remainning string to front of variable & set ptr ****/
		strcpy(pstring,ptr2 + 1);
		ptr = pstring + strlen(pstring);
		ptr[BYTES] = (char) 0;

			/****** check for user abort ***********************/
		if(abort_cmd())
			break;
	}

	closef(fd);
	closef(fd_plot);
	fd_plot = -1;

	return(0);
}
