/*******************************************************************************
*     plus_plus        (see manual, Command Ref., User Function)        <fc>   *
*                       sets the plus_plus value for the next use of the       *
*                       $++ attribute variable.                                *
*                                                                              *
*                       parameters:  long n;    new value for next $++.        *
*                                               (-1 = do not set)              *
*                                    long l;    new string length for $++.     *
*                                               (-1 = do not set)              *
*                                                                              *
*                       Globals changed:  plus_plus;                           *
*                                                                              *
*                       Returns zero upon normal end-of-job (EOJ).             *
*           J.Dabritz 7/10/90                                                  *
*******************************************************************************/

#include "../../incl/globals.h"

long plus_plus_ltp(n,l)
	long n,l;
{
		/********** check for legal n value ************/
	if(n > 2000000000)
	{	message("Illegal n= value.  No action taken.");
		return(1);
	}

		/********** check for legal l value ************/
	if(l > 30)
	{	message("Illegal l= value.  No action taken.");
		return(1);
	}

		/********** change plus_plus value *********************/
	if(n >= 0)
		plus_plus = n;

		/********** change plus_plus value *********************/
	if(l >= 0)
		plus_length = l;

		/********** return *************************************/
	return(0);
}
