/*******************************************************************************
*	save		(see manual, Command Ref., User Functions)	<fc>   *
*                                                                              *
*			Saves the files associated with the active map.        *
*                                                                              *
*        Arguments:  char[] fname  null = save under current active map name   *
*                                  non-null = save under specified name        *
*                                                                              *
*			Returns 1 on success, 0 on failure.                    *
*           J.Dabritz, 6/9/89                                                  *
*           modified J.Dabritz, 5/21/90                                        *
*******************************************************************************/

#include "../../incl/globals.h"
#include "../../incl/in.h"

long save(fname)
	char fname[];
{
	char file_name[512];
	char new_temp[512];
	char string[512];
	long i;

        /******************** check to see if a map is acquired ***********/
	if(!job_stats[0])
	{	append_msg("no current map to save.");
		return(0);
	}

        /******************** set file name *******************************/
	if(fname[0])
		sprintf(file_name,"%s",fname);
	else
		sprintf(file_name,"%s",map_name);

        /******************** inform user *********************************/
	sprintf(string,"saving map file as  %s . . . ",file_name);
	message(string);


        /******************** write all malloc'd records to temp **********/
	if(update_temp())
	{	message(" Uanable to update temporary disc file.  Save failed.");
		return(0);
	}
	
message("update done");
        /******************** create a new_temp directory *****************/
	i=0;
	sprintf(new_temp,"%s/temp%d",maps_path,i);
	for(;makedir(new_temp) && i<100;i++)    /* make temporary directory   */
		sprintf(new_temp,"%s/temp%d",maps_path,i);
	if(i >= 100)
	{	message(" Unable to create new temporary directory. Aborting Save.");
		message(" (new dir = ");
		append_msg(new_temp);

		return(0);
	}

message("new directory created.");
        /******************** copy temp to new_temp ***********************/
	if(copy_dir(temp_map_path,new_temp))
	{	append_msg("  <<  cannot copy map to temp. space");
		return(0);
	}

message("temp map copied to new directory.");
        /******************** move new_temp onto origional map directory **/
	sprintf(string,"%s/%s",maps_path,file_name);
	if(purgef(string))
	{
		pause_ltp(3," . Cannot remove old map file");
		sprintf(string,"updated map stored under path:  %s",new_temp);
		if(!batch_mode)
			wait_ltp(string);
		return(1);
	}
message("old file (if any) purged.");

	sprintf(string,"mv %s %s/%s",new_temp,maps_path,file_name);
	if(system_ltp(string))
	{	message("Cannot move new data onto old map.");
		sprintf(string,"updated map stored under path:  %s",new_temp);
		message(string);
		strcpy(file_name,new_temp);
	}
	else
	{	sprintf(string,"new data stored as map  %s",file_name);
		message(string);
		sprintf(string,"%s/%s",maps_path,file_name);
		sprintf(file_name,"%s",string);
	}


        /******************** compress data if wanted *********************/
	if((header.compress[0] != 'n')  && (header.compress[0] != 'N'))
	{	message("compressing some map files . . . ");
			/*** compress diary, errors files ***/
		sprintf(string,"%s %s/d\* %s/e\*",GENERAL_PACK, file_name,file_name);
		system_ltp(string);
			/*** compress history, index_array, index_list files ***/
		sprintf(string,"%s %s/hi\* %s/i\*",GENERAL_PACK, file_name,file_name);
		system_ltp(string);
			/*** compress level_names, v_...  files ***/
		sprintf(string,"%s %s/l\* %s/v\*",GENERAL_PACK, file_name,file_name);
		system_ltp(string);
			/** pack mini-raster, raster, rasterb files */
		sprintf(string,"%s %s/m\* %s/ra\*",RASTER_PACK, file_name,file_name);
		system_ltp(string);
		append_msg("done.");
	}

        /******************** inform user *********************************/
	sprintf(string,"map saved in directory  %s",file_name);
	if(put_diary(string))
		return(1);

message("diary written.");


        /******************** return **************************************/
    return(1);
}

