/*******************************************************************************
*     set_dig         (see manual, Command Ref., User Functions)      <fc>     *
*                                                                              *
*         Changes the input mode to dig_set.                                   *
*                                                                              *
*         Parameters:    long s;    set to be added to/removed from            *
*                        long otype; object type to be added 0=n,1=s,2=p       *
*                        char descr[];   set name/description                  *
*                                                                              *
*         globals changed:  input mode,  entry_level, atrbt_otype              *
*                                                                              *
*         Returns 0 upon normal execution, 1 otherwise                         *
*             J.Dabritz  7/17/90                                               *
*******************************************************************************/

#include "../../incl/globals.h"


long set_dig(s,otype,descr)
	long s,otype;
	char descr[];
{	
	long i;
	long x,y;

		/*********** check input parameters ****************************/
	if(!s  ||  (s < -24)  ||  (s > 24))
	{	message("The set to be digitized must be in the range (+-) 1-24.");
		return(1);
	}
	if(descr <= (char *) 0)
	{	message("Illegal string pointer.  set_union aboring.");
		return(1);
	}
	descr[79] = (char) 0;
	
	if((otype < 0) || (otype > 2))
	{	message("The object type must be in range 0-2.");
		return(1);
	}


		/*********** set entry_level (set number), atrbt_otype *********/
	entry_level = s;
	atrbt_otype = otype;

		/*********** change level name *********************************/
	if(*descr)
	{	i = (s > 0) ?  s: -s;
		descr[79] = (char) 0;
		sprintf(level_names[i],"%s",descr);
	}

		/*********** change input mode *********************************/
	change_mode(33,0);
	
		/*********** change display to highlight created set only ******/
	i = (s > 0) ?  s: -s;
	disp_hglight = (1 << i);
	disp_centroid = 1;

		/*********** re-display map ************************************/
	x = (rwindowxmin + rwindowxmax) / 2;
	y = (rwindowymin + rwindowymax) / 2;
	if(dispgraphics(x,y,resolution_code))
		return(1);

		/*********** return *********************************************/
	return(0);
}
