/*******************************************************************************
*   set_erase          (see manual, Command Ref., User Function)        <fc>   *
*           Erases the raster under a set of objects.                          *
*                                                                              *
*           Parameters:   long set;    set number:  0-31                       *
*                                                                              *
*           Globals changed:   - none -                                        *
*                                                                              *
*           Returns long 0=successful, 1=error                                 *
*           J.Dabritz 8/13/89                                                  *
*******************************************************************************/

#include "../../incl/globals.h"
#include "../../incl/in.h"

long set_erase(set)
long set;
{
	OBJECTS object;

	long i;
	long save_imode;
	long save_snap;


		/************* check for VIEW ONLY raster **********************/
	if(job_stats[78])
	{	message("You CANNOT do ANYTHING to the VIEW ONLY ORIGINAL SCAN.");
		return(1);
	}
		/**** check input parameter ***/
	if((set <0)  ||  (set > 31))
	{	message("Set number must be 0-31.  no action taken.");
		return(1);
	}
	
	save_imode = input_mode;
	save_snap = snap_input;

		/*** examine all objects & erase raster under those in set ***/
	for(i=0; i< job_stats[10]; i++)
	{		/*********** get object record ****************************/
		if(get_objects(&object,i))
		{	message("cannot retrieve object.   Set_erase aborting.");
			change_mode(save_imode,save_snap);
			return(1);
		}

			/*********** check for user abort *************************/
		if(abort_cmd())
			break;

			/*********** check set & erase ****************************/
		if(object.i12[4] & (1 << set))
		{	if(erase_mapobj(i))
			{	message("Cannot erase object.  Set_erase aborting.");
				change_mode(save_imode,save_snap);
				return(1);
			}
		}
	}

		/*** reset cursor     ****************************************/
	change_mode(save_imode,save_snap);

	
		/*** return **************************************************/
	return(0);
}
