/*******************************************************************************
*       shell           (see manual, User Functions)                    <fc>   *
*			Puts the user into Cshell under line trace.  They will *
*           return to line trace after pressing control d               *
*                                                                              *
*			Returns zero upon normal end-of-job (EOJ).             *
*                      j.dabritz  3/7/89 - 5/8/89                              *
*******************************************************************************/
/* Modified 7/92 by DBS@CWU for X11 support */

#include "../../incl/globals.h"
#include "../../incl/in.h"
#include <errno.h>

long shell()
{	
	long i;
	extern int errno;
	char string[256];

	/*  check for batch mode   */
	if(batch_mode)
		return(0);

	/*	turn graphics and keyboard trap off   */
	graphics_off();
	kb_reset();

	/*  flush the standard input */
	fflush(stdin);
#ifdef LTP_X11
	/* print this message to cut down on confusion */
	printf("\n\nTO RETURN TO LTPlus TYPE: exit\n\n");
	fflush(stdout);
#endif

	/*  load and exec the string (more) by the operating system  */
	if(i = system_ltp("/bin/csh"))
	{	sprintf(string,"  (System call to shell returned %d  UNIX errno = %d)",
					i, errno);
		append_msg(string);
	}

	/*  reset the graphics and keyboard trap  */
	graphics_on();
	kb_setup();

	return 0;
}
