/*******************************************************************************
*	step		(see manual, Command Ref., User Function)	<fc>   *
*			Changes the graphics being displayed to an area        *
*			adjacent to the current one.                           *
*                                                                              *
*			Modifies the displayed graphics screen and cursor      *
*			position and last cursor position variables in the     *
*			input.h include variables.                             *
*                                                                              *
*			Returns zero upon normal end-of-job (EOJ). (1 = failure)           *
*                                                                              *
*           J.Dabritz   8/8/89                                                 *
*******************************************************************************/

#include "../../incl/globals.h"
#include "../../incl/in.h"

long step(d)
	long d;  /* direction code:  'l'=left, 'r'=right, 'u'=up, 'd'=down    */
{
	long x,y;
	long dx,dy;
char string[256];

		/************* check for map **********************************/
	if(!job_stats[0])
		return(0);

		/************* check for legal direction **********************/
	if((d != 'l') && (d != 'r') && (d != 'u') && (d != 'd'))
		return(1);

		/************* check for batch mode ***************************/
	if(batch_mode)
		return(1);

		/************* check for veiw smaller than map ****************/
	if(!resolution_code)
		return(0);

	dx = rwindowxmax - rwindowxmin;
	dy = rwindowymax - rwindowymin;

		/************* calc move or wrap as necessary *****************/
	x = (rwindowxmin + rwindowxmax + 1) / 2;
	y = (rwindowymin + rwindowymax + 1) / 2;
	switch(d)  {
	case 'l':           /*  left  */
		if(rwindowxmin == 0)           /** try to wrap up **/
		{	if(rwindowymax >= job_stats[2])
			{	message(" You are already at the top left corner.");
				return(1);
			}
			y = rwindowymax + dy * 0.3;
			x = job_stats[1];
		}
		else                           /** move left **/
			x = rwindowxmin - dx * 0.3;
		break;

	case 'r':           /*  right  */
		if(rwindowxmax >= job_stats[1])           /** try to wrap down **/
		{	if(rwindowymin == 0 )
			{	message(" You are already at the bottom right corner.");
				return(1);
			}
			y = rwindowymin - dy * 0.3;
			x = 0;
		}
		else                           /** move right **/
			x = rwindowxmax + dx * 0.3;
		break;

	case 'u':           /*  up  */
		if(rwindowymax >= job_stats[2])           /** try to wrap left **/
		{	if(rwindowxmin == 0 )
			{	message(" You are already at the top left corner.");
				return(1);
			}
			y = 0;
			x = rwindowxmin - dx * 0.3;
		}
		else                           /** move up **/
			y = rwindowymax + dy * 0.3;
		break;

	case 'd':           /*  down  */
		if(rwindowymin == 0)           /** try to wrap right **/
		{	if(rwindowxmax >= job_stats[1] )
			{	message(" You are already at the bottom right corner.");
				return(1);
			}
			y = job_stats[2];
			x = rwindowxmax + dx * 0.3;
		}
		else                           /** move up **/
			y = rwindowymin - dy * 0.3;
		break;

	}

		/************* call dispgraphics to do the display work *******/
	dispgraphics(x,y,resolution_code);

		/************* return *****************************************/
	return(0);
}
