/*******************************************************************************
*	view_ltp     (see manual, Command Ref., User Function)	<fc>   *
*			Changes the resolution of the grahpics being displayed.*
*                                                                              *
*			Moves the displayed area & resolution to the ones      *
*			specified by the input parameters.                     *
*                                                                              *
*			Returns zero for ok, 1 for failure.                    *
*           J.Dabritz  6/22/89                                                 *
*******************************************************************************/

#include "../../incl/globals.h"
#include "../../incl/in.h"

long view_ltp(x, y, res_code)
	long x,y;        /* raster coords around which to center view   */
	long res_code;   /* 0=map, 1=block, 2=full, 3=zoom, 4=last res  */
{
	long r_code;

		/****************** check for map present ************************/
	if(!job_stats[0])
		return(1);

		/****************** check res_code, x & y ************************/
	if(res_code<0 || res_code>4) 
		return(1);

		/****************** check res_code, get last res_code if needed **/
	if(res_code == 4)
		r_code = last_res_code;
	else
		r_code = res_code;

		/****************** place x & y within map ***********************/
	x = (x < 0) ?  0 : x;
	x = (x > job_stats[1]) ?  job_stats[1] : x;
	y = (y < 0) ?  0 : y;
	y = (y > job_stats[2]) ?  job_stats[2] : y;

		/****************** redisplay map at new res, center x,y *********/
	if(dispgraphics(x, y, r_code))
		return(1);

		/****************** return ***************************************/
	return(0);
}
