/*******************************************************************************
*       wait           (see manual, User Functions)                    <fc>   *
*			Displays the input message on the control portion of the screen    *
*           and waits for a [RETURN] to continue LTPlus execution.            *
*                                                                              *
*           Parameters:    char string       text string to be displayed.      *
*                                                                              *
*           Files/globals changed:  none                                       *
*                                                                              *
*			Returns zero upon normal end-of-job (EOJ).             *
*                      j.dabritz  10/30/89                                     *
*******************************************************************************/
/* Modified 6/92 by DBS@CWU for X11 support */

#include "../../incl/globals.h"
#include "../../incl/in.h"
#ifdef LTP_X11
#include "../../incl/x11.h"
#endif

long wait_ltp(string)
	char string[];
{	
	char dummy[256];
	char saveit[3][5120];
	char *ptr1;

	long i,n;



		/** check for batch mode **/
	if(batch_mode)
		return(0);

		/** save 3 layers for re-display later **/
	ptr1 = vga_plane + BITPLN_WIDTH * 416;     
	for(i=0; i<3 ; i++)
	{	swplane(i+1);
#ifndef LTP_X11
		bitmap(5120,1,1,1,ptr1,saveit[i]);
#else
                bitmap4x(WIDTH,64,0,415,xmainwin,0,415,xmainpix);
#endif
	}
	

		/** erase white text **/
	swplane(0);
	bar_off(0,479,639,416);

		/** lay a lt_read background **/
	swplane(1);
	bar_off(0,464,639,479);
	swplane(2);
	bar_on(0,463,639,416);
	bar_off(0,464,639,479);
	swplane(3);
	bar_on(0,463,639,416);
	bar_off(0,464,639,479);
	disptext(29,0,"          - - - Press [RETURN/ENTER] when you want to continue - - -            ");

		/** diplay message in black  **/
	n = strlen(string);
	if(n > 80)
	{	string[80] = 0;
		n = 80;
	}
	i = (80 - n) / 2;
	if( i < 0)
		i = 0;
	disptext(27,i,string);

		/** wait for return **/
	get_string(dummy);


		/** redisplay 3 layers **/
	ptr1 = vga_plane + BITPLN_WIDTH * 416;     
	for(i=0; i<3 ; i++)
	{	swplane(i+1);
#ifndef LTP_X11
		bitmap(5120,1,1,1,saveit[i],ptr1);
#else
                bitmap4x(WIDTH,64,0,415,xmainpix,0,415,xmainwin);
#endif
	}
	
	
	return(0);
}
