/*******************************************************************************
*	acquireM	(see manual, Command Ref, Function Mgr)		<fm>   *
*                                                                              *
*			Either calls the acquire function or writes the        *
*			acquire command to a macro file.                       *
*                                                                              *
*                    	Calls parser to extract  mapdir from  rawrem passed    *
*			from function junction (fj) and passes that name       *
*			to the acquire function for processing.  If no         *
*			argument was found, or the argument is not a valid     *
*			string representing a file or directory name,          *
*			acquireM calls the catalog function to acquire         *
*			a list of map names to pass when calling the           *
*			mlt_choice function to query the user for a valid      *
*			map name.  This function will also check to insure     *
*			that the file exists (cannot be a new file) prior      *
*			to passing the  mapdir name to acquire.                *
*                                                                              *
*			Returns 1 upon completion, 0 upon abort.               *
*******************************************************************************/
 
#include <string.h>
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
#include <malloc.h>
#define LISTLENGTH 500
 
 
acquireM(map)
char *map;
{	
	char path[512];
	int fd;
	char list[1024][STRLIST];
	long n;


		/*  check to see if current map has been saved/if user wants saved */
	if(!collecting_macro)
	{	path[0] = (char) 0;
		if(changes())
		{	if(!batch_mode)
			{	if(answerisyes(210,1))
					save(path);
			}
		}
	}


 		/*  see if map is there /offer user choice of existing maps        */
	trim(map);
	if(!map[0])
	{	if(!(choose_map(map)[0]))
			return(0);
	}
	sprintf(path,"%s/%s/job_stats",maps_path,map);
	if(0 > (fd = openf(path,READ)))
	{		/*  check name length  */
		if(strlen(map) > 14)
		{	append_msg("  <<  map name is too long (>14 characters).");
			return(0);
		}
			/*    check to see if map exists.   */
		n = dir_list(maps_path,list[0],1024);
		if(!list_find(list[0],map,n))
		{	if(batch_mode)
			{	sprintf(raw_buf,"create %s",map);
				fj();
			}
			else if(answerisyes(219,1))    /*  see if they want it created  */
			{	sprintf(raw_buf,"create %s",map);
				fj();
			}
		}
		else   /*   tell user that job_stats file cannot be opened. */
			message(" Cannot open job_stats file.  Possible privilage or file corruption problem.");

		return(0);
	}
	closef(fd);

		/*   reset path to map directory  */
	sprintf(path,"%s/%s",maps_path,map);

	if(!collecting_macro)
	{	if(!acquire(path))
		{	message(" ... acquire failed.  There is no current map loaded.");
			return(0);
		}
		next_step((char *) 0);
	}
		
		/*  set command string for history & return                        */
	sprintf(raw_buf,"acquire %s",map);
    return(1);
}
