/*******************************************************************************
*	atrbt_conturM	(see manual, Command Ref., Function Manager)	<fm>   *
*	 		Checks optional parameter (if any) to see if it is a   *
*			real elevation.  If not real (or absent) then calls    *
*			atrbt_contur with context flag set to 1 (otherwise 0). *
*                                                                              *
*			Either calls atrbt_contur() or writes atrbt_contur     *
*			command line to the macro being built.                 *
*                                                                              *
*			Returns one  upon normal end-of-job (EOJ).             *
*                                                                              *
*           J.Dabritz   8/15/89                                                *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
long atrbt_contuM(parameters)
char *parameters;
{
	long action;
	long context;
	long elevation;
	long no_params;

	char answer[STRLIST];
	char parsed[2][STRLIST];

		/**************** set default values *************************/
	action = -1;
	context = 1;
	elevation = 0;

		/**************** parse parameter string *********************/
	trim(parameters);
	no_params = parse(trim(parameters),delim_buf,parsed,2);

		/**************** check for action and elevation parameters **/
	if(no_params)
	{	if((*parsed[0] >= '0')  &&  (*parsed[0] <= '9'))
			action = strtol(parsed[0], (char **)NULL, 10);
		if(no_params > 1)
		{	if((*parsed[1] >= '0')  &&  (*parsed[1] <= '9'))
			{	elevation = strtol(parsed[1], (char **)NULL, 10);
				context = 0;
			}
			else
			{		/*** prompt for elevation or context **/
				message(prompt[2]);
				get_string(answer);
				trim(answer);
				if((*answer >= '0')  &&  (*answer <= '9'))
				{	elevation = strtol(answer, (char **)NULL, 10);
					context = 0;
				}
				else
				{	elevation = 0;
					context = 1;
				}
			}
		}
	}

		/**************** if action parameter not present query for both */
	if((action < 0) || (action > atrbt_action_limit))
	{	if(batch_mode)
			return(0);

			/*** prompt for action ***/
		action = list_choice(atrbt_actions,atrbt_action_limit+1,3);

			/*** prompt for elevation or context **/
		message(prompt[2]);
		get_string(answer);
		trim(answer);
		if((*answer >= '0')  &&  (*answer <= '9'))
		{	elevation = strtol(answer, (char **)NULL, 10);
			context = 0;
		}
		else
		{	elevation = 0;
			context = 1;
		}
	}

		/**************** call function ******************************/
	if(!collecting_macro)
	{	if(atrbt_contur(action,elevation,context))
			return(0);
	}

		/**************** set command string *************************/
	if(context)
		sprintf(raw_buf,"atrbt_contur %d",action);
	else
		sprintf(raw_buf,"atrbt_contur  %d  %d",action,elevation);

		/**************** return *************************************/
    return(1);
}
