/*******************************************************************************
*	atrbt_copyM	(see manual, Command Ref., Function Manager)	<fm>   *
*			Function manager for the atrbt_copy function.           *
*                                                                              *
*			Queries for all parameters not present.                *
*                                                                              *
*			Calls function or writes command to macro being built  *
*                 							       *
*			Returns zero upon normal end-of-job (EOJ).             *
*******************************************************************************/
 
#include <string.h>
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
long atrbt_copyM(parameters)
char *parameters;
{
	long totype,fotype,action;
	long no_params;
	long promptem;
	long level, ot10;

	char answer[256];
	char parsed[4][STRLIST];


		/*********** get otype & action parameters if present **********/
	no_params = parse(trim(parameters),delim_buf,parsed,4);
	promptem = 0;

		/****** check for parameter 1, from object type    *****************/
		/*** set input or default from object type if possible. ***/
	if(*parsed[0])
		sscanf(parsed[0],"%d",&fotype);
	else
		fotype = -1;       /** flag for multiple map type **/

		/*** check & query for object type if necessary ***/
	ot10 = fotype % 10;
	if((fotype < 0)  ||  (fotype > 952) || (ot10 < 0) || (ot10 > 2))
	{	if(batch_mode)
			return(0);
		else
		{	message(prompt[357]);
			get_string(answer);
			trim(answer);
			if((*answer < '0')  ||  (*answer > '2'))
				return(0);
			fotype = *answer - '0';
		}
			/*** check to see if user wants to query an import level ***/
		if(answerisyes(342,0))
		{	if(!batch_mode)
				level = choose_level(32,95,246);
			else
				return(0);
			fotype += level * 10;
		}
	}
	ot10 = fotype % 10;
	if((fotype < 0)  ||  (fotype > 952) || (ot10 < 0) || (ot10 > 2))
		return(0);

		/****** check for parameter 1, to object type    *****************/
	totype = -1;
	if(get_long(parsed[1],&totype,&promptem,358,0,2))
		return(0);

	/***** next get action parameter ******************/
	if(no_params > 1)
		action = *parsed[2] - '0';
	else
		action = -1;

	if(promptem  ||  no_params < 2  || action<0  ||  action >atrbt_action_limit)
		action = list_choice(atrbt_actions,atrbt_action_limit+1,3);

	if(action<0  ||  action>atrbt_action_limit)
		return(0);

		/*********** execute function *********************************/
	if(!collecting_macro)
	{	if(atrbt_copy(fotype,totype,action))
		{	*raw_buf = 0;
			return(0);
		}
	}

		/*********** generate command string **************************/
	sprintf(raw_buf,"atrbt_copy  %d  %d  %d",fotype,totype,action);

		/*********** return *******************************************/
    return(1);
}
