/*******************************************************************************
*     atrbt_lineM    (see manual, Command Ref., Function Manager)       <fm>   *
*                  Sets up the atrbt_line input mode.  Prompts for attribute   *
*                  string and beginning mile_post value (if needed)            *
*                                                                              *
*                  Either calls atrbt_line() or writes atrbt_line              *
*                  command line to the macro being built.                      *
*                                                                              *
*                  Returns one  upon normal end-of-job (EOJ).                  *
*                                                                              *
*           J.Dabritz   6/25/90                                                *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
#include <string.h>
 
 
long atrbt_lineM(parameters)
char *parameters;
{
	char answer[STRLIST];
	char parsed[4][STRLIST];
	char attribute[STRLIST];
	char *ptr;

	long promptem;
	long action;
	long no_params;
	long atrbt;

	float mp;


		/**************** set default values *************************/
	action = -1;

		/**************** parse parameter string *********************/
	trim(parameters);
	promptem = 0;
	no_params = parse(trim(parameters),delim_buf,parsed,4);

		/***** get action, mp, and attribute parameters if present */
	mp = 0.0;
	*attribute = (char) 0;
	if(no_params)
	{		/*** get attribute action **/
		if((*parsed[0] >= '0')  &&  (*parsed[0] <= '9'))
			action = strtol(parsed[0], (char **)NULL, 10);

			/*** get mp parameter ***/
		atrbt = 1;
		if(no_params > 1)
		{	if(strstr(parsed[1],"mp=") == (char *) parsed[1])
			{	ptr = &parsed[1][3];
				if((*ptr >= '.') && (*ptr <= '9'))
				{	if((sscanf(ptr,"%f",&mp)) > 0)
						atrbt = 2;
					else
						promptem = 1;
				}
				else
					promptem = 1;
			}
			


					/***** get string attribute ***/
			if((no_params > atrbt) && !promptem)
			{	for(ptr=parameters; atrbt;)
				{ 	if(*ptr < 33)
					{	atrbt--;
						trim(ptr);
					}
					else
						ptr++;
				}
				strcpy(attribute,ptr);
			}
		}
	}
	else
		promptem = 1;

		/**************** if action parameter not present prompt for it **/
	if((action < 0) || (action > atrbt_action_limit))
	{	if(batch_mode)
			return(0);

			/*** prompt for action ***/
		promptem = 1;
		action = list_choice(atrbt_actions,atrbt_action_limit+1,3);
	}

			/*** prompt for attribute ***/
	if(*attribute == 0  &&  action != 7)
	{	promptem = 1;
		if(batch_mode)
			return(0);
		message(prompt[4]);
		get_string(attribute);
		trim(attribute);
		if(!*attribute)
			return(0);
	}

			/*** if attribute contains $mp & no mile_post set, prompt for it **/
	if(action != 7)
	{	if(promptem && mp==0.0 && (strstr(attribute,"$mp") != (char *) 0))
		{	if(batch_mode)
				mp = 0.0;
			message(prompt[333]);
			get_string(answer);
			trim(answer);
			if((*answer >= '.') && (*answer <= '9'))
				sscanf(answer,"%f",&mp);
		}
	}

	if(mp < 0.0)
		return(0);

		/**************** call function ******************************/
	if(!collecting_macro)
	{	if(atrbt_line(action,mp,attribute))
			return(0);
	}

		/**************** set command string *************************/
	if(strstr(attribute,"$mp") != (char *) 0)
		sprintf(raw_buf,"atrbt_line  %d  mp=%.2f  %s",action,mp,attribute);
	else
		sprintf(raw_buf,"atrbt_line  %d  %s",action,attribute);

		/**************** return *************************************/
    return(1);
}
