/*******************************************************************************
*	atrbt_listM	(see manual, Command Ref., Function Manager)	<fm>   *
*			Function manager for the atrbt_list function.           *
*                                                                              *
*			Queries for all parameters not present.                *
*                                                                              *
*			Calls function or writes command to macro being built  *
*                 							       *
*			Returns zero upon normal end-of-job (EOJ).             *
*******************************************************************************/
/* Modified 6/92 by DBS@CWU for multi user support */
 
#include <string.h>
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
long atrbt_listM(parameters)
char *parameters;
{
	long otype,action;
	long no_params;
	long promptem;
	long count;
	long n;

	char path[256];
	char fname[256];
	char parsed[4][STRLIST];
	char list[256][STRLIST];


		/*********** get otype & action parameters if present **********/
	no_params = parse(trim(parameters),delim_buf,parsed,3);
	promptem = 0;


		/****** check for parameter 1, object type    *****************/
	if(get_long(parsed[0],&otype,&promptem,53,0,2))
		return(0);

	/***** next get action parameter ******************/
	if(no_params > 1)
		action = *parsed[1] - '0';
	else
		action = -1;

	if(promptem  ||  no_params < 2  || action<0  ||  action >atrbt_action_limit)
	{	action = list_choice(atrbt_actions[0],atrbt_action_limit+1,3);
		promptem = 1;
	}

	if(action<0  ||  action>atrbt_action_limit)
		return(0);

		/*********** set fname ******************/
	if((no_params >= 3)  &&  (!promptem))
		sprintf(fname,"%s",parsed[2]);
	else {	
#ifdef MULTIUSER  /***** first ask from .ltp directory *****/
		sprintf(path,"%s/.ltp/dictionaries",home_path);
		count = dir_list(path,list[3],254);
		if(count >= 0) {
		    count += 3;
		    sprintf(list[0]," - none, escape -");
		    sprintf(list[1]," - enter name from keyboard");
		    sprintf(list[2]," - select from system list");
		    n = list_choice(list[0],count,355);
		    if(n <= 0)
			    return(0);
		    if(n == 1) {
			message(prompt[356]);
			get_string(fname);
			trim(fname);
			if(!(*fname))
			    return(0);
		    }
                    sprintf(fname,"%s/.ltp/dictionaries/%s",home_path,list[n]);
		}
		if (n = 2) {  /* allow choice from system directory */
		    sprintf(path,"%s/dictionaries",ltp_path);
		    count = dir_list(path,list[2],254);
		    if(count < 0)
			return(0);
		    count += 2;
		    sprintf(list[0]," - none, escape -");
		    sprintf(list[1]," - enter name from keyboard");
		    n = list_choice(list[0],count,355);
		    if(n <= 0)
			return(0);
		    if(n == 1)
		    {	message(prompt[356]);
			get_string(fname);
			trim(fname);
			if(!(*fname))
				return(0);
		    }
		    else
		       sprintf(fname,"%s/dictionaries/%s",ltp_path,list[n]);
		}
#else  /***** original code *****/
		sprintf(path,"%s/dictionaries",ltp_path);
		count = dir_list(path,list[2],254);
		if(count < 0)
			return(0);
		count += 2;
		sprintf(list[0]," - none, escape -");
		sprintf(list[1]," - enter name from keyboard");
		n = list_choice(list[0],count,355);
		if(n <= 0)
			return(0);
		if(n == 1)
		{	message(prompt[356]);
			get_string(fname);
			trim(fname);
			if(!(*fname))
				return(0);
		}
		else
		   sprintf(fname,"%s/dictionaries/%s",ltp_path,list[n]);
#endif
	}

		/*********** execute function *********************************/
	if(!collecting_macro)
	{	if(atrbt_list(otype,action,fname))
		{	*raw_buf = 0;
			return(0);
		}
	}

		/*********** generate command string **************************/
	sprintf(raw_buf,"atrbt_list  %d  %d  %s",otype,action,fname);

		/*********** return *******************************************/
    return(1);
}
