/*******************************************************************************
*	atrbt_printM	(see manual, Command Ref., Function Manager)	<fm>   *
*			Description:  Parses string parameter and checks       *
*			arguments for their presence and validity.             *
*			Parameters:  A string containing the function          *
*			arguments.  The following values are searched for:     *
*			arg1:  Set number                                      *
*			arg2:  Device type code				       *
*			arg3:  Ascii file name (required only when arg2=3)     *
*									       *
*			Returns zero upon normal end-of-job (EOJ).             *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
long atrbt_printM(parameters)
char *parameters;
{
	char answer[STRLIST];
	char parsed[3][STRLIST];
	char file[256];
	static char print_choice[3][STRLIST] = { "screen print", "hardcopy print"
				, "print to file" };
	long print_dev, s;
	long i;
	long no_params;

		/************** break up parameters ***************************/
	no_params = parse(lowerc(trim(parameters)),delim_buf,parsed,3);
	for(i=0; i < no_params; i++)
		trim(lowerc(parsed[i]));

		/************** check & get first parameter (set number) ******/
	s = -1;
	if(no_params)
	{	s = strtol(parsed[0], (char **)NULL, 10);
		s = (s) ?  -1 : s;
	}
	
	if(s<0  ||  s>31)
	{	if(batch_mode)
			return(0);
		s = list_choice(level_names[0],32,202);
	}

		/************** check & get second (printer choice) ***********/
	print_dev = -1;
	if(no_params > 1)
		print_dev = strtol(parsed[1], (char **)NULL, 10);
	
	if(print_dev<0  ||  print_dev>2)
	{	if(batch_mode)
			return(0);
		print_dev = list_choice(print_choice[0],3,230);
	}

		/************** check & get file name if needed  **************/
	if(print_dev == 2)      /** write to a file **/
	{	strcpy(file,trim(parsed[2]));
		if(!*file)
		{	if(batch_mode)
				return(0);
			message(prompt[111]);
			get_string(file);
			if(!*(trim(file)))
			{	message("file string is null, no action taken.");
				return(0);
			}
		}
	}
	else
		file[0] = 0;

		/************** execute attribute print  **********************/
	if(!collecting_macro)
		i = atrbt_print(s,print_dev,file);
	else
		i = 0;
	i = (i+1) & 1;

		/************** set file to null if not a file print *********/
	if(print_dev != 2)
		file[0] = 0;

		/************** build string **********************************/
	if(i)
		sprintf(raw_buf,"atrbt_print  %d  %d  %s",s,print_dev,file);
	
		/************** return ****************************************/
    return(i);
}
