/*******************************************************************************
*	atrbt_recM	(see manual, Command Ref., Function Manager)	<fm>   *
*			Function manager for the atrbt_rec function.           *
*                                                                              *
*			Queries for all parameters not present.                *
*                                                                              *
*			Calls function or writes command to macro being built  *
*                 							       *
*			Returns zero upon normal end-of-job (EOJ).             *
*******************************************************************************/
 
#include <string.h>
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
long atrbt_recM(parameters)
char *parameters;
{
	long i;
	long record,action;
	long no_params;
	long promptem;
	char *ptr, *attribute, answer[STRLIST];
	char parsed[4][STRLIST];


		/*********** get action & record number parameters if present **********/
	no_params = parse(trim(parameters),delim_buf,parsed,3);
	promptem = 0;


		/****** check for parameter 0, record number  *****************/
	if(get_long(parsed[0],&record,&promptem,298,0,999999999))
		return(0);

	/***** next get action parameter ******************/
	if(no_params > 1)
		action = *parsed[1] - '0';
	else
		action = -1;

	if(promptem  ||  no_params < 2  || action<0  ||  action >atrbt_action_limit )
		action = list_choice(atrbt_actions,atrbt_action_limit+1,3);

	if(action<0  ||  action>atrbt_action_limit)
		return(0);

		/*********** set attribute string if present ******************/
	if(no_params > 2)
	{	for(i=0, ptr = parameters + 1; i<2; ptr++)
		{	if((*ptr < 33)  &&  (*(ptr-1) > 32))
				i++;
		}
		trim(ptr);
		attribute = ptr;
	}
	else
		attribute = parameters + strlen(parameters);

	if(*attribute == 0  &&  action != 7)
	{	if(batch_mode)
			return(0);
		message(prompt[4]);
		get_string(answer);
		trim(answer);
		if(!*answer)
			return(0);
		attribute = answer;
	}

		/**** trim attribute to 30 characters of data or less **/
	attribute[30] = 0;

		/*********** execute function *********************************/
	if(!collecting_macro)
	{	if(atrbt_rec(record,action,attribute))
		{	*raw_buf = 0;
			return(0);
		}
	}

		/*********** generate command string **************************/
	sprintf(raw_buf,"atrbt_rec  %d  %d  %s",record,action,attribute);

		/*********** return *******************************************/
    return(1);
}
