/*******************************************************************************
*	b_editM		(see manual, Command Ref., Function Manager)	<fm>   *
*			Function manager for the b_edit function.              *
*			Queries for user input if all parameters not specified *
*                                                                              *
*			Calls function or writes command to macro being built  *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
long b_editM(parameters)
char *parameters;
{
	char parsed[30][STRLIST];
	char ifl[STRLIST], ofl[STRLIST];
	unsigned char ichar[264],dchar[264],jchar[264];
	char string[STRLIST];
	unsigned char replchr[256];
	char part[2][STRLIST];
	char *ptr;

	long no_params;
	long promptem;
	long cflag, eflag;
	long k, m;
	long a, b, c, f, g, i, l, n, s, t;
	long dcount,icount,jcount,rcount;


		/*********** parse parameter string  ************************/
	no_params = parse(parameters,delim_buf,parsed[0],30);
	promptem = 0;

		/*********** check for first parameter, input file **********/
	if(get_dirfname(parsed[0],ifl,config.import_path,&promptem))
		return(0);

		/*********** check for second param, output file (optional) */
	*ofl = (char) 0;
	n=1;
	if((no_params > 1) && !promptem)
	{		/*** check for  '-' and '=' characters *****/
		for(ptr = parsed[1]; *ptr; ptr++)
		{	if((*ptr == '-') || (*ptr == '='))
				break;
		}
		if(!(*ptr))
		{	sprintf(ofl,"%s",parsed[1]);
			n++;
		}
	}
	if(promptem || (no_params < 2))
	{	message(prompt[319]);
		get_string(ofl);
		trim(ofl);
	}

		/****** initialize parameters ***/
		/** check for subsequent params: -c -e a= b= c= d= g= f= i= j= l= s= t= */
	cflag = eflag = 0;
	a=b=c=g=f=l=s=t=0;
	dchar[0] = 0;
	dcount = 0;
	ichar[0] = 0;
	icount = 0;
	jchar[0] = 0;
	jcount = 0;
	for(k=0; k<256; k++)
		replchr[k] = k;
	rcount = 0;
	for(; n<no_params; n++)
	{	if(parsed[n][0] == '-')
		{	switch(parsed[n][1]) {
			case 'c':       /******* delete all Control characters ****/
			case 'C':
				cflag = 1;
				break;
			case 'e':       /******* delete all Extention characters **/
			case 'E':
				eflag = 1;
				break;
			}
		}
		else if(2 == parse(parsed[n],"=",part[0],2))
		{	ptr = part[1];
			switch(part[0][0]) {
			case 'a':       /******* Add LF at xx characters         **/
			case 'A':
				a = 0;
				sscanf(ptr,"%ld",&a);
				if(a < 0)
					a = 0;
				break;
			case 'b':       /******* number of lines to delete from  **/
			case 'B':       /*******    Beginning of file *************/
				b = 0;
				sscanf(ptr,"%ld",&b);
				if(b < 0)
					b = 0;
				break;
			case 'c':       /******* number of Chars to delete from  **/
			case 'C':       /*******     of each line *****************/
				c = 0;
				sscanf(ptr,"%ld",&c);
				if(c < 0)
					c = 0;
				break;
			case 'd':       /******* delete specified column from    **/
			case 'D':       /*******        each line *****************/
				i = 0;
				sscanf(ptr,"%ld",&i);
				if((i > 0) && (i < 256))
				{	dchar[dcount] = (unsigned char) i;
					dcount++;
				}
				break;
			case 'f':       /******* Fill to xx characters befor LF  **/
			case 'F':
				f = 0;
				sscanf(ptr,"%ld",&f);
				if(f < 0)
					f = 0;
				break;
			case 'g':       /******* number of lines to Group *********/
			case 'G':
				g = 0;
				sscanf(ptr,"%ld",&g);
				if(g < 1)
					g = 0;
				break;
			case 'i':       /******* character to delete **************/
			case 'I':       /*******  (all occurrances) ***************/
				i = 0;
				sscanf(ptr,"%ld",&i);
				if((i > 0) && (i < 256))
				{	ichar[icount] = (unsigned char) i;
					icount++;
				}
				break;
			case 'j':       /******* insert new col at specified     **/
			case 'J':       /*******        location  *****************/
				i = 0;
				sscanf(ptr,"%ld",&i);
				if((i > 0) && (i < 256))
				{	jchar[jcount] = (unsigned char) i;
					jcount++;
				}
				break;
			case 'l':       /******* min line Length of lines to ******/
			case 'L':       /*******    be retained. ******************/
				l = 0;
				sscanf(ptr,"%ld",&l);
				if(l < 0)
					l = 0;
				break;
			case 's':       /******* Substitute xx preceding char for */
			case 'S':       /*******    all blanks written to ofl *****/
				s = 0;
				sscanf(ptr,"%ld",&s);
				if(s < 0)
					s = 0;
				break;
			case 't':       /******* Trim lines to xx characters long */
			case 'T':
				t = 0;
				sscanf(ptr,"%ld",&t);
				if(t < 0)
					t = 0;
				break;
					/******** check for xx=yy character replacement *****/
			case '0': case '1': case '2': case '3': case '4':
			case '5': case '6': case '7': case '8': case '9':
				k = -1;
				if(1 == sscanf(part[0],"%ld",&k))
				{	if(1 == sscanf(part[1],"%ld",&m))
					{	if((k>=0) && (k<=255) && (m>=0) && (m<=255))
						{	replchr[k] = m;
							rcount++;
						}
					}
				}
				break;
			}
		}
	}

		/*********** prompt for subsequent params: -c -e b= c= i= l= */
	if(promptem || !(cflag + eflag + a + b + c + dcount + f + g + icount + jcount + l + s + t + rcount) )
	{		/************** prompt for -c **********************/
		if(cflag==0)
		{	if(answerisyes(321,0))
				cflag = 1;
			else
				cflag = 0;
		}

			/************** prompt for -e **********************/
		if(eflag==0)
		{	if(answerisyes(320,0))
				eflag = 1;
			else
				eflag = 0;
		}

			/************** prompt for a= **********************/
		if( a == 0)
		{	message(prompt[327]);
			get_string(string);
			sscanf(string,"%ld",&a);
			if(a < 0)
				return(0);
		}

			/************** prompt for b= **********************/
		if( b == 0)
		{	message(prompt[322]);
			get_string(string);
			sscanf(string,"%ld",&b);
			if(b < 0)
				return(0);
		}

			/************** prompt for l= **********************/
		if( l == 0)
		{	message(prompt[324]);
			get_string(string);
			sscanf(string,"%ld",&l);
			if(l < 0)
				return(0);
		}

			/************** prompt for c= **********************/
		if( c == 0)
		{	message(prompt[323]);
			get_string(string);
			sscanf(string,"%ld",&c);
			if(c < 0)
				return(0);
		}

			/************** prompt for i= **********************/
		for(;;)
		{	message(prompt[326]);
			get_string(string);
			i = 0;
			sscanf(string,"%ld",&i);
			if((i < 0) || (i > 255))
				return(0);
			if(i == 0)
				break;
			ichar[icount] = (char) i;
			icount++;
			if(icount > 255)
				break;
		}

			/************** prompt for d= **********************/
		for(;;)
		{	message(prompt[364]);
			get_string(string);
			i = 0;
			sscanf(string,"%ld",&i);
			if((i < 0) || (i > 255))
				return(0);
			if(i == 0)
				break;
			dchar[dcount] = (char) i;
			dcount++;
			if(dcount > 255)
				break;
		}

			/************** prompt for j= **********************/
		for(;;)
		{	message(prompt[365]);
			get_string(string);
			i = 0;
			sscanf(string,"%ld",&i);
			if((i < 0) || (i > 255))
				return(0);
			if(i == 0)
				break;
			jchar[jcount] = (char) i;
			jcount++;
			if(jcount > 255)
				break;
		}

			/************** prompt for f= **********************/
		if( f == 0)
		{	message(prompt[328]);
			get_string(string);
			sscanf(string,"%ld",&f);
			if(f < 0)
				return(0);
		}

			/************** prompt for s= **********************/
		if( s == 0)
		{	message(prompt[329]);
			get_string(string);
			sscanf(string,"%ld",&s);
			if(s < 0)
				return(0);
		}

			/************** prompt for t= **********************/
		if( t == 0)
		{	message(prompt[330]);
			get_string(string);
			sscanf(string,"%ld",&t);
			if(t < 0)
				return(0);
		}

			/************** prompt for g= **********************/
		if( g == 0)
		{	message(prompt[325]);
			get_string(string);
			sscanf(string,"%ld",&g);
			if(g < 0)
				return(0);
		}

			/************** prompt for xx= **********************/
		for(;;)
		{	message(prompt[368]);
			get_string(string);
			k = -1;
			sscanf(string,"%ld",&k);
			if((k >= 0) && (k <= 255))
			{	message(prompt[369]);
				get_string(string);
				m = -1;
				sscanf(string,"%ld",&m);
				if((m >= 0) && (m <= 255))
				{	replchr[k] = m;
					rcount++;
				}
				else
					break;
			}
			else 
				break;
		}
	}

		/*********** check for null effect & abort ******************/
	if(!(cflag + eflag + a + b + c + dcount + f + g + icount + jcount + l + s + t + rcount) )
	{	message("b_edit command specified has no effect.");
		return(0);
	}

		/*********** add null to end of ichar ***********************/
	dchar[dcount] = (char) 0;
	ichar[icount] = (char) 0;
	jchar[jcount] = (char) 0;

		/*********** call function **********************************/
	if(!collecting_macro)
	{	if(b_edit(ifl,ofl,cflag,eflag,a,b,l,c,ichar,dchar,jchar,f,s,t,g,replchr))
		{	*raw_buf = 0;
			return(0);
		}
	}

		/*********** write command string *****************************/
	sprintf(raw_buf,"b_edit %s",ifl);
		/*** add ofl ************************/
	if(ofl[0])
	{	strcat(raw_buf," ");
		strcat(raw_buf,ofl);
	}

		/*** add -c *************************/
	if(cflag)
		strcat(raw_buf," -c");

		/*** add -e *************************/
	if(eflag)
		strcat(raw_buf," -e");

		/*** add a= *************************/
	if(a)
	{	sprintf(string," a=%d",a);
		strcat(raw_buf,string);
	}

		/*** add b= *************************/
	if(b)
	{	sprintf(string," b=%d",b);
		strcat(raw_buf,string);
	}

		/*** add l= *************************/
	if(l)
	{	sprintf(string," l=%d",l);
		strcat(raw_buf,string);
	}

		/*** add c= *************************/
	if(c)
	{	sprintf(string," c=%d",c);
		strcat(raw_buf,string);
	}

		/*** add i= *************************/
	for(n=0; (n<icount) && (90 > strlen(raw_buf)); n++)
	{	sprintf(string," i=%d",(unsigned) ichar[n]);
		strcat(raw_buf,string);
	}

		/*** add d= *************************/
	for(n=0; (n<dcount) && (90 > strlen(raw_buf)); n++)
	{	sprintf(string," d=%d",(unsigned) dchar[n]);
		strcat(raw_buf,string);
	}

		/*** add j= *************************/
	for(n=0; (n<jcount) && (90 > strlen(raw_buf)); n++)
	{	sprintf(string," j=%d",(unsigned) jchar[n]);
		strcat(raw_buf,string);
	}

		/*** add f= *************************/
	if(f)
	{	sprintf(string," f=%d",f);
		strcat(raw_buf,string);
	}

		/*** add s= *************************/
	if(s)
	{	sprintf(string," s=%d",s);
		strcat(raw_buf,string);
	}

		/*** add t= *************************/
	if(t)
	{	sprintf(string," t=%d",t);
		strcat(raw_buf,string);
	}

		/*** add g= *************************/
	if(g)
	{	sprintf(string," g=%d",g);
		strcat(raw_buf,string);
	}

		/*** add xx= ************************/
	for(k=0; (k < 256) && (87 > strlen(raw_buf)); k++)
	{	if(replchr[k] != k)
		{	sprintf(string," %d=%d", k, replchr[k]);
			strcat(raw_buf,string);
		}
	}

		/*********** return *******************************************/
	return(1);

}
