/*******************************************************************************
*	ckeys_getM	(see manual, Command Ref., Function Manager)	<fm>   *
*			Description:  Parses string parameter and checks       *
*			arguments for their presence and validity.             *
*			Parameters:  A string containing the function name     *
*			and its arguments.  The following values are           *
*			searched for:                                          *
*			arg1:  cursor function file name.                      *
*                                                                              *
*			Returns zero upon normal end-of-job (EOJ).             *
*******************************************************************************/
/* Modified 6/92 by DBS@CWU for multi user support */
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 

#define LCOUNT 256

 
long ckeys_getM(parameters)
char *parameters;
{
	char file[STRLIST];
	char path[256];
	char ckeys_list[LCOUNT][STRLIST];
	long no_items;
	long i, found;
	long file_no;

	sprintf(ckeys_list[0]," - none - (escape form singsing) ");
		/*       parse out name of ckeys_file from paramaters string          */
	parsen(parameters, " \t", file, 0);
	

		/*      see if ckeys file named does, in fact exist.     */
#ifdef MULTIUSER
	sprintf(path,"%s/.ltp/cursor_keys",home_path);
	if (file_exists(path,"")) {
	    no_items = dir_list(path, ckeys_list[1], LCOUNT);
	}
	else no_items = 0;

	if(no_items > 0) 
	    found = list_find(ckeys_list[1], file, no_items);
	else
	    found = 0;
	if (!found) {
	    sprintf(path,"%s/cursor_keys",ltp_path);
	    no_items = dir_list(path, ckeys_list[1], LCOUNT);
	    if(no_items <= 0)
	    {	message("cannot locate cursor_keys directory.  Aborting.");
		return(0);
	    }
	    found = list_find(ckeys_list[1], file, no_items);
	}

	/*if file is not found, & prompting is allowed, ask user for filename */
	if(!found) {
		if(batch_mode)
			return 0;
		file_no = 0;
		sprintf(ckeys_list[0]," - none - (next list)");
		sprintf(path,"%s/.ltp/cursor_keys",home_path);
		if (file_exists(path,"")) {
		    no_items = dir_list(path, ckeys_list[1], LCOUNT);
		}
		else no_items = 0;

		if(no_items > 0) 
		    file_no = list_choice(ckeys_list[0], no_items + 1, 249);
		if (file_no != 0) 
			sprintf(file,"%s/%s", path, ckeys_list[file_no]);
		else {
			sprintf(ckeys_list[0]," - none - ");
			sprintf(path,"%s/cursor_keys",ltp_path);
			no_items = dir_list(path, ckeys_list[1], LCOUNT);
			file_no = list_choice(ckeys_list[0], no_items + 1, 249);
			if(file_no == 0)
				return(1);
			sprintf(file,"%s/%s", path, ckeys_list[file_no]);
		}
	}
#else
	sprintf(path,"%s/cursor_keys",ltp_path);
	no_items = dir_list(path, ckeys_list[1], LCOUNT);
	if(no_items <= 0)
	{	message("cannot locate cursor_keys directory.  Aborting.");
		return(0);
	}
	found = list_find(ckeys_list[1], file, no_items);

		/*if file is not found, & prompting is allowed, ask user for filename */
	if(!found)
	{   if(batch_mode)
			return 0;
		file_no = list_choice(ckeys_list[0], no_items + 1, 249);
		if(file_no == 0)
			return(1);
		strcpy(file,ckeys_list[file_no]);
	}
#endif

	if(!collecting_macro)
	{	if(ckeys_get(file))
			return(0);
	}
	sprintf(raw_buf, "ckeys_get %s",file);
	return(1);

}
