/*******************************************************************************
*	configM		(see manual, Command Ref., Function Manager)	<fm>   *
*			Description:  Parses string param (rawrem) and         *
*			checks arguments for their presence and validity.      *
*			Parameters:  A string containing item name(s),         *
*			= symbol(s), and argument(s).                          *
*			Each item is checked for validity and passed to        *
*			config.c for modification.                             *
*                                                                              *
*			Returns zero upon normal end-of-job (EOJ).             *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
long configM(parameters)
char *parameters;
{

	char print_config[STRLIST];
	char string[STRLIST];
	char part1[STRLIST], part2[STRLIST];
	char list[80][STRLIST];
	long print_flag;
	long ret_code;
	long i,n;


	*part1 = 0;
	*part2 = 0;

		/*************** if parameters, check for -p & item=string ******/
	if(*trim(parameters))
	{         /*   first check for -p  */
		if(strstr(parameters,"-p") == parameters)
		{	sprintf(print_config,"-p");
			parameters[0] = ' ';
			parameters[1] = ' ';
			trim(parameters);
		}
		else
			*print_config = 0;

			/*   next check for item=string   (must have part1 ) */
		if(strsplit(parameters,'=',part1,part2) )
		{	if(!*trim(part1) )
			{	*part1 = 0;
				*part2 = 0;
			}
			else
				trim(part2);
		}
		else
		{	*part1 = 0;
			*part2 = 0;
		}
	}
	else
	{	*print_config = 0;                      /*  set to null   */
		*part1 = 0;                             /*  set to null   */
		*part2 = 0;                             /*  set to null   */
	}

		/*************** else querry for print, item=string *************/
	if(!batch_mode)
	{	if(!*print_config  && !*part1)
		{
				/*   querry for item    */
			sprintf(list[0]," - none -");
			sprintf(list[1],"prtr_adr = %s", config.prtr_adr);
			sprintf(list[2],"prtr_type = %s", config.prtr_type);
			sprintf(list[3],"crt_adr = %s", config.crt_adr);
			sprintf(list[4],"crt_type = %s", config.crt_type);
			sprintf(list[5],"bkup11 = %s", config.bkup11);
			sprintf(list[6],"bkup12 = %s", config.bkup12);
			sprintf(list[7],"bkup21 = %s", config.bkup21);
			sprintf(list[8],"bkup22 = %s", config.bkup22);
			sprintf(list[9],"print1 = %s", config.print1);
			sprintf(list[10],"print2 = %s", config.print2);
			sprintf(list[11],"edit1 = %s", config.edit1);
			sprintf(list[12],"edit2 = %s", config.edit2);
			sprintf(list[13],"cursor_file = %s", config.cursor_file);
			sprintf(list[14],"mouse_adr = %s", config.mouse_adr);
			sprintf(list[15],"mouse_type = %s", config.mouse_type);
			sprintf(list[16],"dig1_adr = %s", config.dig1_adr);
			sprintf(list[17],"dig1_type = %s", config.dig1_type);
			sprintf(list[18],"dig2_adr = %s", config.dig2_adr);
			sprintf(list[19],"dig2_type = %s", config.dig2_type);
			sprintf(list[20],"plt1_adr = %s", config.plt1_adr);
			sprintf(list[21],"plt1_type = %s", config.plt1_type);
			sprintf(list[22],"plt2_adr = %s", config.plt2_adr);
			sprintf(list[23],"plt2_type = %s", config.plt2_type);
			sprintf(list[24],"maps_path = %s", config.maps_path);
			sprintf(list[25],"bkup_path = %s", config.bkup_path);
			sprintf(list[26],"data3_path = %s", config.data3_path);
			sprintf(list[27],"data4_path = %s", config.data4_path);
			sprintf(list[28],"export_path = %s", config.export_path);
			sprintf(list[29],"import_path = %s", config.import_path);
			sprintf(list[30],"malloc = %s", config.malloc);
			sprintf(list[31],"menuset = %s", config.menuset);
			sprintf(list[32],"ginput = %s", config.ginput);
			sprintf(list[33],"rasterh = %s", config.rasterh);
			sprintf(list[34],"rasterw = %s", config.rasterw);
			sprintf(list[35],"pen0 = %s", config.pen0);
			sprintf(list[36],"pen1 = %s", config.pen1);
			sprintf(list[37],"pen2 = %s", config.pen2);
			sprintf(list[38],"pen3 = %s", config.pen3);
			sprintf(list[39],"pen4 = %s", config.pen4);
			sprintf(list[40],"pen5 = %s", config.pen5);
			sprintf(list[41],"pen6 = %s", config.pen6);
			sprintf(list[42],"pen7 = %s", config.pen7);
			sprintf(list[43],"pen8 = %s", config.pen8);
			sprintf(list[44],"tile1 = %s", config.tile1);
			sprintf(list[45],"tile2 = %s", config.tile2);
			sprintf(list[46],"tile3 = %s", config.tile3);
			sprintf(list[47],"tile4 = %s", config.tile4);
			sprintf(list[48],"tile5 = %s", config.tile5);
			sprintf(list[49],"tile6 = %s", config.tile6);
			sprintf(list[50],"tile7 = %s", config.tile7);
			sprintf(list[51],"tile8 = %s", config.tile8);
			sprintf(list[52],"tile9 = %s", config.tile9);
			sprintf(list[53],"tile10 = %s", config.tile10);
			sprintf(list[54],"tile11 = %s", config.tile11);


				/*   get users choice    */
			n = list_choice(list[0],55,262);
			
					/*   if item, then querry for string  */
			if(n)
			{	message("old item:  ");
				append_msg(list[n]);
				message(prompt[6]);
				trim(get_string(string));
					/*   set part1 & part2  strings      */
				strcpy(part2,string);                /* set part2  */
				for(i=0; list[n][i] != '=' ; i++)    /* set part1  */
					part1[i] = list[n][i];
				part1[i] = 0;
				trim(part1);
			}
			else
			{	*part1 = 0;
				*part2 = 0;
			}
		}
	}

		/*************** check to see if there is anything to do ********/
	if(!*print_config && !*part1)
	{	message(" no print flag or config item.  No action taken.");
		return(0);
	}

		/*************** execute change & print *************************/
	if(!collecting_macro)
	{	if(*print_config)
			print_flag = 1;
		else
			print_flag = 0;
		ret_code = config_ltp(print_flag,part1,part2);
	}

		/*************** set command string & return ********************/
	if(*part1)
		sprintf(raw_buf,"config %s %s = %s",print_config,part1,part2);
	else
		sprintf(raw_buf,"config %s",print_config);

    return(ret_code);
}
