/*******************************************************************************
*	continueM	(see manual, Command Ref., Function Manager)	<fm>   *
*			Function manager for the continue function.            *
*                                                                              *
*			Queries for x,y position if not present.               *
*                                                                              *
*			Calls function or writes command to macro being built  *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
long continueM(parameters)
char *parameters;
{
	char parsed[2][STRLIST];

	long no_params;
	long x,y;
	long no_xy;

		/******************* check for map loaded **********************/
	if(!job_stats[0] && !collecting_macro)
	{	*raw_buf = 0;
		return(0);
	}

		/******************* clip parameters into separate strings *****/
	no_params = parse(trim(parameters),delim_buf,parsed,2);


		/******************* check for legal x & y *********************/
	x = 0;
	y = 0;
	if(no_params == 2)    /*   x and y value may be present  */
	{	if((!sscanf(parsed[0],"%d",&x))  ||  (!sscanf(parsed[1],"%d",&y)) )
			no_xy = 1;
		else
			no_xy = 0;
	}
	else
		no_xy = 1;

	if(no_xy  &&  !batch_mode)
		get_position(&x, &y);


		/******************* execute command ***************************/
	if(!collecting_macro)
	{	if(continue_ltp(x,y))
		{	*raw_buf = 0;
			return(0);
		}
	}

		/******************* set raw_buf string ************************/
	sprintf(raw_buf,"continue %d %d",x,y);

		/******************* return ************************************/
    return(1);
}
