/*******************************************************************************
*	crit_execM	(see manual, Command Ref., Function Manager)	<fm>   *
*                                                                              *
*			Either calls the crit_end function or writes the       *
*			crit_end command to a macro file.                      *
*                                                                              *
*			No arguments permitted.  Sole purpose is to call       *
*			crit_end function.                                     *
*                                                                              *
*			Returns zero upon normal execution.                    *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
long crit_execM(parameters)
char *parameters;
{
	char parsed[3][STRLIST];
	char descr[STRLIST];
	char *ptr;

	long s;
	long no_params;
	long promptem;


		/************* break up parameters *****************************/
	no_params = parse(trim(parameters),delim_buf,parsed,3);

		/************** initialize promptem flag **********************/
	promptem = 0;  /* set to 1 if & when prompting is necessary */

		/************* check parameter 0 , set number ******************/
	if(!no_params)
		promptem = 1;
	s = get_set(parsed[0],&promptem,1,24,288);
	if(s < 1)
		return(0);

		/************* check parameter 1 , set number ******************/
	if((no_params > 1)  &&  !promptem)
	{	for(ptr=parameters; *ptr > 32; ptr++);
		trim(ptr);
		strcpy(descr,ptr);
	}
	else if(!batch_mode)
	{	message(prompt[287]);
		get_string(descr);
	}
	else
		*descr = (char) 0;


		/************* call function ***********************************/
	if(!collecting_macro)
	{	if(crit_exec(s,descr))
			return(0);
	}

		/************* write command line ******************************/
	sprintf(raw_buf,"crit_exec  %d  %s",s,descr);

		/************* return ******************************************/
    return(1);
}
