/*******************************************************************************
*      crit_lengthM     (see manual, Command Ref., Function Manager)    <fm>   *
*                                                                              *
*                  Either calls the appropriate function or writes the comand  *
*                  to the macro file.                                          *
*                                                                              *
*                  collects user input as needed.                              *
*                                                                              *
*                  Returns one  upon normal execution.                         *
*                  J.Dabritz   1/11/90                                         *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
#ifdef SV32
#include <limits.h>
#else
#include <values.h>
#endif
 
long crit_lengthM(parameters)
char *parameters;
{
	char parsed[3][STRLIST];

	long promptem;
	long i;

	double a1,a2;

		/************* break up parameters *****************************/
	parse(trim(parameters),delim_buf,parsed,3);

		/************** initialize promptem flag **********************/
	promptem = 0;  /* set to 1 if & when prompting is necessary */

		/************* check parameter 0 , length units code *************/
	if(get_long(parsed[0],&i,&promptem,51,0,6))
		return(0);

		/************* check parameter 1 , lower bound of length *********/
#ifdef SV32
	if(get_double(parsed[1],&a1,&promptem,276,(double) 0.0,(double) DBL_MAX))
		return(0);
#else
	if(get_double(parsed[1],&a1,&promptem,276,(double) 0.0,(double) MAXDOUBLE))
		return(0);
#endif

		/************* check parameter 2 , upper bound of length *********/
#ifdef SV32
	if(get_double(parsed[2],&a2,&promptem,277,(double) 0.0,(double) DBL_MAX))
		return(0);
#else
	if(get_double(parsed[2],&a2,&promptem,277,(double) 0.0,(double) MAXDOUBLE))
		return(0);
#endif

		/************* call function ***********************************/
	if(!collecting_macro)
	{	if(crit_length(i,a1,a2))
			return(0);
	}

		/************* write command line ******************************/
	sprintf(raw_buf,"crit_length  %d  %f  %f",i,a1,a2);

		/************* return ******************************************/
    return(1);
}
