/*******************************************************************************
*	crit_reportM	(see manual, Command Ref., Function Manager)	<fm>   *
*			Description:  Parses string parameter and checks       *
*			arguments for their presence and validity.             *
*			Parameters:  A string containing the function          *
*			arguments.  The following values are searched for:     *
*			arg1:  Device type code				       *
*			arg2:  Ascii file name (required only when arg1=2)     *
*									       *
*			Returns zero upon normal end-of-job (EOJ).             *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
long crit_reportM(parameters)
char *parameters;
{
	char parsed[3][STRLIST];
	char file[256];
	static char print_choice[3][STRLIST] = { "screen print", "hardcopy print"
				, "print to file" };
	long print_dev;
	long i;
	long no_params;

		/************** break up parameters ***************************/
	no_params = parse(lowerc(trim(parameters)),delim_buf,parsed,3);
	for(i=0; i < no_params; i++)
		trim(lowerc(parsed[i]));

		/************** check & get first (printer choice) ***********/
	print_dev = -1;
	if(no_params >= 1)
		print_dev = (long) (parsed[0][0] - '0');
	
	if(print_dev<0  ||  print_dev>2)
	{	if(batch_mode)
			return(0);
		print_dev = list_choice(print_choice[0],3,230);
	}

		/************** check & get file name if needed  **************/
	if(print_dev == 2)      /** write to a file **/
	{	strcpy(file,trim(parsed[1]));
		if(!*file)
		{	if(batch_mode)
				return(0);
			message(prompt[111]);
			get_string(file);
			if(!*(trim(file)))
			{	message("file string is null, no action taken.");
				return(0);
			}
		}
	}
	else
		file[0] = 0;

		/************** execute attribute print  **********************/
	if(!collecting_macro)
	{	if(crit_report(print_dev,file))
			return(0);
	}

		/************** build string **********************************/
	sprintf(raw_buf,"crit_report  %d  %s",print_dev,file);
	
		/************** return ****************************************/
    return(1);
}
