/*******************************************************************************
*      crit_typeM       (see manual, Command Ref., Function Manager)    <fm>   *
*                                                                              *
*                  Either calls the appropriate function or writes the comand  *
*                  to the macro file.                                          *
*                                                                              *
*                  collects user input as needed.                              *
*                                                                              *
*                  Returns one  upon normal execution.                         *
*                  J.Dabritz   1/11/90                                         *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
long crit_typeM(parameters)
char *parameters;
{
	static char list[18][STRLIST] = {
		/*    0  */    "any node",
		/*    1  */    "any segment",
		/*    2  */    "any polygon",
		/*    3  */    "node with 0 branches, an isolated point",
		/*    4  */    "node with 1 branch, a spur endpoint",
		/*    5  */    "node with 2 branches, a simple island node",
		/*    6  */    "node with 3 branches, a junction node",
		/*    7  */    "node with 4 branches, a junction node",
		/*    8  */    "segment with 2 free ends, free floating segment",
		/*    9  */    "segment with 1 free end, a spur",
		/*   10  */    "segment with no free ends",
		/*   11  */    "segment which is a single link to an island, a lollypop stick.",
		/*   12  */    "segment between 2 polygons which have the same attribute",
		/*   13  */    "segment which has a possible contour attribute error",
		/*   14  */    "interior polygon",
		/*   15  */    "exterior polygon",
		/*   16  */    "map border polygon",
		/*   17  */    " unused "    };
		

	long otype;


		/************* break up parameters *****************************/
	trim(parameters);

		/************* check parameter 0 , type ************************/
	otype = -1;
	if(*parameters)
		sscanf(parameters,"%d",&otype);

	if((otype < 0)  ||  (otype > 16))
	{	if(batch_mode)
			return(1);
		otype = list_choice(list, 17, 286);
		if(otype < 0)
			return(0);
	}
	
		/************* check parameter 1 , none ************************/
		/************* check parameter 2 , none ************************/
		/************* call function ***********************************/
	if(!collecting_macro)
	{	if(crit_type(otype))
			return(0);
	}

		/************* write command line ******************************/
	sprintf(raw_buf,"crit_type  %d",otype);

		/************* return ******************************************/
    return(1);
}
