/*******************************************************************************
*	default_headM.c	(see manual, Command Ref., Function Manager)	<fm>   *
*			Description:  Parses string parameter and checks       *
*			arguments for their presence and validity.             *
*			Parameters:  A string containing the function name     *
*			and its arguments.  The following values are           *
*			searched for:                                          *
*			arg1:  print flag (-p=print default header on default printer) *
*			arg2:  array of character strings containing item-actio*
*                                                                              *
*			Returns zero upon normal end-of-job (EOJ).             *
*******************************************************************************/
/* Modified 6/92 by DBS@CWU for multi user support */
 
#include <string.h>
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
long default_headM(parameters)
	char *parameters;
{	
	HEADER dhead;

	char path[256];
	char print_header[STRLIST];
	char string[STRLIST];
	char part1[STRLIST], part2[STRLIST];
	char list[50][STRLIST];

	long print_flag;
	long ret_code;
	long i,n;


	*part1 = 0;
	*part2 = 0;

		/*************** if parameters, check for -p & item=string ******/
	if(*trim(parameters))
	{         /*   first check for -p  */
		if(strstr(parameters,"-p") == parameters)
		{	sprintf(print_header,"-p");
			parameters[0] = ' ';
			parameters[1] = ' ';
			trim(parameters);
		}
		else
			*print_header = 0;

			/*   next check for item=string   (must have part1 ) */
		if(strsplit(parameters,'=',part1,part2) )
		{	if(!*trim(part1) )
			{	*part1 = 0;
				*part2 = 0;
			}
			else
				trim(part2);
		}
		else
		{	*part1 = 0;
			*part2 = 0;
		}
	}
	else
	{	*print_header = 0;                      /*  set to null   */
		*part1 = 0;                             /*  set to null   */
		*part2 = 0;                             /*  set to null   */
	}

		/*************** else querry for print, item=string *************/
	if(!batch_mode)
	{	if(!*print_header  && !*part1)
		{
				/*   get default header */
#ifdef MULTIUSER
			sprintf(path,"%s/./ltp/config/header",home_path);
			if (!file_exists(path,""))
				sprintf(path,"%s/config/header",ltp_path);
#else
			sprintf(path,"%s/config/header",ltp_path);
#endif
			if(get_header(path,&dhead,0))
				return(0);

				/*   querry for item    */
			sprintf(list[0]," - none -");
			sprintf(list[1],"comments = %s", dhead.comments);
			sprintf(list[2],"compress = %s" , dhead.compress);
			sprintf(list[3],"contour_interval = %s" , dhead.contour_interval);
			sprintf(list[4],"datum = %s", dhead.datum);
			sprintf(list[5],"dictionary = %s" , dhead.dictionary);
			sprintf(list[6],"edgematch = %s" , dhead.edgematch);
			sprintf(list[7],"edge_e = %s" , dhead.edge_e);
			sprintf(list[8],"edge_n = %s" , dhead.edge_n);
			sprintf(list[9],"edge_s = %s" , dhead.edge_s);
			sprintf(list[10],"edge_w = %s", dhead.edge_w);
			sprintf(list[11],"head1 = %s", dhead.head1);
			sprintf(list[12],"head2 = %s", dhead.head2);
			sprintf(list[13],"layer_name = %s" , dhead.layer_name);
			sprintf(list[14],"map_ht = %s" , dhead.map_ht);
			sprintf(list[15],"map_wd = %s" , dhead.map_wd);
			sprintf(list[16],"maptype = %s" , dhead.maptype);
			sprintf(list[17],"menu_set = %s" , dhead.menu_set);
			sprintf(list[18],"org = %s" , dhead.org);
			sprintf(list[19],"quad_unit = %s", dhead.quad_unit);
			sprintf(list[20],"revision_yr = %s" , dhead.revision_yr);
			sprintf(list[21],"scale = %s" , dhead.scale);
			sprintf(list[22],"search_rad = %s" , dhead.search_rad);
			sprintf(list[23],"source_yr = %s" , dhead.source_yr);
			sprintf(list[24],"state = %s" , dhead.state);
			sprintf(list[25],"stplzn = %s", dhead.stplzn);
			sprintf(list[26],"template1 = %s", dhead.template1);
			sprintf(list[27],"template2 = %s", dhead.template2);
			sprintf(list[28],"template3 = %s", dhead.template3);
			sprintf(list[29],"udrn = %s" , dhead.udrn);
			sprintf(list[30],"utmln = %s" , dhead.utmln);
			sprintf(list[31],"utmlt = %s", dhead.utmlt);


				/*   get users choice    */
			n = list_choice(list[0],32,217);

			
					/*   if item, then querry for string  */
			if(n)
			{	message("old item:  ");
				append_msg(list[n]);
				message(prompt[218]);
				trim(get_string(string));
					/*   set part1 & part2  strings      */
				strcpy(part2,string);                /* set part2  */
				for(i=0; list[n][i] != '=' ; i++)    /* set part1  */
					part1[i] = list[n][i];
				part1[i] = 0;
				trim(part1);
			}
			else
			{	*part1 = 0;
				*part2 = 0;
			}
		}
	}

		/*************** check to see if there is anything to do ********/
	if(!*print_header && !*part1)
	{	message(" no print flag or header item.  No action taken.");
		return(0);
	}

		/*************** execute change & print *************************/
	if(!collecting_macro)
	{	if(*print_header)
			print_flag = 1;
		else
			print_flag = 0;
		ret_code = default_head(print_flag,part1,part2);
	}

		/*************** set command string & return ********************/
	if(*part1)
		sprintf(raw_buf,"default_head %s %s = %s",print_header,part1,part2);
	else
		sprintf(raw_buf,"default_head %s",print_header);

    return(ret_code);
}
