/*******************************************************************************
*	del_spursM	(see manual, Command Ref., Function Manager)	<fm>   *
*			Description:  Parses string parameter and checks       *
*			arguments for their presence and validity.             *
*			Parameters:  A string containing the function          *
*			name and its arguments.  The following values          *
*			are searched for:                                      *
*			arg1:  Maximum spur length to be deleted.              *
*                                                                              *
*			Returns zero upon normal end-of-job (EOJ).             *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
long del_spursM(parameters)
char *parameters;
{
	long length;
	char answer[STRLIST];

/************** check first parameter *************************/
	length = -1;
	if(*(trim(parameters)))
		sscanf(parameters,"%d",&length);

/************** get length from input or user *****************/
	if(!batch_mode)
	{	for(; length < 0;)
		{	message(prompt[30]);
			get_string(answer);
			sscanf(answer,"%d",&length);
		}
	}

/************** check length & process or abort ***************/
	if(length <= 0)
		return(0);
	if(!collecting_macro)
	{	if(del_spurs(length))
			return(0);
	}


/************** build string **********************************/
	sprintf(raw_buf,"del_spurs %d",length);
	
/************** return ****************************************/
	return(1);
}
