/*******************************************************************************
*	dem_viewM 	(see manual, Command Ref., Function Manager)	<fm>   *
*			Function manager for the dem_view  function.           *
*                                                                              *
*			Queries for all parameters not present.                *
*                                                                              *
*			Calls function or writes command to macro being built  *
*                 							       *
*			Returns zero upon normal end-of-job (EOJ).             *
*******************************************************************************/
 
#include <string.h>
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
long dem_viewM(parameters)
char *parameters;
{
	char parsed[20][STRLIST];
	char fname[256];

	long promptem;
	long no_params;
	long d;

		/************** initialize promptem flag and format type ******/
	promptem = 0;  /* set to 1 if & when prompting is necessary */

		/****** parse string for 2 parameters (0 = fname, 1=direction) */
	if(!batch_mode)
		no_params = parse(trim(parameters),delim_buf,parsed,3);

		/****** check for parameter 0, file name **********************/
	if(get_dirfname(parsed[0],fname,config.export_path,&promptem))
		return(0);

		/****** check for parameter 1, lighting direction *************/
	if(get_long(parsed[1],&d,&promptem,300,0,3))
		return(0);

		/****** call import program ***********************************/
	if(!collecting_macro)
	{	if(dem_view(fname,d))
			return(0);
	}

		/****** write command line ************************************/
	sprintf(raw_buf,"dem_view  %s  %d",fname,d);

		/****** return ************************************************/
	return(1);
}
