/*******************************************************************************
*	dict_printM	(see manual, Command Ref., Function Manager)	<fm>   *
*			Description:  Parses string parameter and check        *
*			arguments for their presence and validity.             *
*			Parameters:  A string containing the function name     *
*			and its arguments.  The following values are searched  *
*			for:                                                   *
*			arg1:  dictionary file name                            *
*			arg2:  device type                                     *
*                                                                              *
*			Returns zero upon normal end-of-job (EOJ).             *
*******************************************************************************/
/* Modified 6/92 by DBS@CWU for multi user support */
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
long dict_printM(parameters)
char *parameters;
{
	char parsed[2][STRLIST];
	char fname[256];
	char path[256];
	static char print_choice[3][STRLIST] = { "screen print", "hardcopy print"
				, "print to file" };

	long print_dev;
	long promptem;

		/************** initialize promptem ***************************/
	promptem = 0;

		/************** break up parameters ***************************/
	parse(lowerc(trim(parameters)),delim_buf,parsed,2);

		/************** check & get parameter 0, printer choice *******/
	print_dev = -1;
	if(*parsed[0])
		sscanf(parsed[0],"%ld",&print_dev);
		
	if((print_dev < 0)  ||  (print_dev > 1))
	{	if(batch_mode)
			return(0);
		print_dev = list_choice(print_choice[0],2,230);
	}

		/****** check for parameter 1, file name **********************/
	if(!parsed[1][0])
		sprintf(parsed[1],"%s",header.dictionary);

#ifdef MULTIUSER
	sprintf(path,"%s/.ltp/dictionaries",home_path);
	if(get_dirfname(parsed[1],fname,path,&promptem)) {
		sprintf(path,"%s/dictionaries",ltp_path);
		if(get_dirfname(parsed[1],fname,path,&promptem))
			return(0);
	}
#else
	sprintf(path,"%s/dictionaries",ltp_path);
	if(get_dirfname(parsed[1],fname,path,&promptem))
		return(0);
#endif

		/****** call print program *************************************/
	if(!collecting_macro)
	{	if(dict_print(print_dev,fname))
			return(0);
	}

		/****** write command line ************************************/
	sprintf(raw_buf,"dict_print  %d  %s",print_dev,fname);

		/****** return ************************************************/
	return(1);
}
