/*******************************************************************************
*	editM        (see manual, Command Ref., Function Manager)	<fm>   *
*			Description:  Parses string parameter and              *
*			checks arguments for their presence and validity.      *
*                                                                              *
*			Returns one  upon normal end-of-job (EOJ).             *
*        J.Dabritz  2/1/90                                                     *
*******************************************************************************/
/* Modified 4/92 by DBS@CWU for multiuser support */
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
long editM(parameters)
char *parameters;
{
	char list[1024][STRLIST];
	char fname[STRLIST];
	char path[256];
	char parsed[3][STRLIST];
	char no_params;
	char *ptr1, *ptr2;

	long i,n;
	long promptem;
	long hits;
#ifdef MULTIUSER
	char path2[512];
#endif

		/*********** parse parameter string  ************************/
	no_params = parse(parameters,delim_buf,parsed[0],3);
	promptem = 0;


		/*********** check for first parameter, file type ***********/
	n = 0;
	if(no_params)
	{		/** match by least unique string **/
		for(i=1,hits=0; i<17 ; i++)
		{	ptr1=parsed[0];
			ptr2=file_types[i];
			for(;*ptr2 && *ptr1==*ptr2; ptr1++, ptr2++);
			if(*ptr1 == (char) 0)
			{	n = i;
				hits++;
			}
		}
		if(hits > 1)
			n = 0;
	}

	if((n<1) || (n>16))
	{	if(batch_mode)
			return(0);
		n = list_choice(file_types[0],17,305);
		promptem = 1;
	}
	
	if((n<1) || (n>16))
		return(0);
	
		/*********** check for second parameter, file  name *********/
	if(promptem || no_params < 2)
	{	if(batch_mode)
			return(0);

		switch(n) {
		case 1: 	/* config */
		case 3:  /* default_head */
		case 4:  /* diary  */
		case 9:  /* header */
		case 16: /* tolerance */
			sprintf(fname,"");
			sprintf(path,"");
			break;
		case 2:  /*	"cursor_key", 			/*   2 */
			sprintf(path,"%s/cursor_keys",ltp_path);
#ifdef MULTIUSER
			sprintf(path2,"%s/.ltp/cursor_keys",home_path);
#endif
			break;
		case 5:	/* "dictionary", 			/*   5 */
			sprintf(path,"%s/dictionaries",ltp_path);
#ifdef MULTIUSER
			sprintf(path2,"%s/.ltp/dictionaries",home_path);
#endif
			break;
		case 6:  /* "digmenu  "                /*   6 */
			sprintf(path,"%s/digmenus",ltp_path);
#ifdef MULTIUSER
			sprintf(path2,"%s/.ltp/digmenus",home_path);
#endif
			break;
		case 7:	/* "digitizer",				/*   7 */
			sprintf(path,"%s/digitizers",ltp_path);
#ifdef MULTIUSER
			sprintf(path2,"%s/.ltp/digitizers",home_path);
#endif
			break;
		case 8:	/* "export", 				/*   8 */
			sprintf(path,"%s",config.export_path);
			break;
		case 10:	/* "import", 			/*  10 */
			sprintf(path,"%s",config.import_path);
			break;
		case 11:	/* "macro",			/*  11 */
			sprintf(path,"%s/macros",ltp_path);
#ifdef MULTIUSER
			sprintf(path2,"%s/.ltp/macros",home_path);
#endif
			break;
		case 12:	/* "map_list", 			/*  12 */
			sprintf(path,"%s/map_lists",ltp_path);
#ifdef MULTIUSER
			sprintf(path2,"%s/.ltp/map_lists",home_path);
#endif
			break;
		case 13:	/* "menu_set, 			/*  13 */
			sprintf(path,"%s/menus",ltp_path);
#ifdef MULTIUSER
			sprintf(path2,"%s/.ltp/menus",home_path);
#endif
			break;
		case 14:	/* "other", 			/*  14 */
			sprintf(path,"");
			break;
		case 15:	/* "pen  ", 			/*  15 */
			sprintf(path,"%s/pens",ltp_path);
#ifdef MULTIUSER
			sprintf(path2,"%s/.ltp/pens",home_path);
#endif
			break;
		}

		if(*path)
		{	makedir(path);
#ifdef MULTIUSER
			makedir(path2);
			sprintf(list[0]," - none - (next list) ");
			sprintf(list[1]," - enter new name from keyboard");
			i = dir_list(path2,list[2],1020);
			if(i >  0) { /* choose from .ltp list first */
				i = list_choice(list[0],i+2,306);
				if(i == 1) {
					message(prompt[307]);
					get_string(fname);
					trim(fname);
					if(!(*fname))
						return(0);
				}
				if (i > 1)
					sprintf(fname,"%s",list[i]);
			}
			if (i <= 0) { /* now choose from system list */
				sprintf(list[0]," - none - ");
				i = dir_list(path,list[2],1020);
				i = list_choice(list[0],i+2,306);
				if(i <= 0)
					return(0);
				else if (i == 1)
				{	message(prompt[307]);
					get_string(fname);
					trim(fname);
					if(!(*fname))
						return(0);
				}
				else
					sprintf(fname,"%s",list[i]);
			}
			if (i <= 0)  /* if i still <= 0 use keyboard */
			{	message(prompt[307]);
				get_string(fname);
				trim(fname);
				if(!(*fname))
					return(0);
			}
#else   /***** original code *****/
			i = dir_list(path,list[2],1020);
			if(i >  0)
			{	sprintf(list[0]," - none, get out - ");
				sprintf(list[1]," - enter new name from keyboard");
				i = list_choice(list[0],i+2,306);
				if(i <= 0)
					return(0);
				else if(i == 1)
				{	message(prompt[307]);
					get_string(fname);
					trim(fname);
					if(!(*fname))
						return(0);
				}
				else
					sprintf(fname,"%s",list[i]);
			}
			else
			{	message(prompt[307]);
				get_string(fname);
				trim(fname);
				if(!(*fname))
					return(0);
			}
#endif
		}
		else if(n == 14)
		{	message(prompt[307]);
			get_string(fname);
			trim(fname);
			if(!(*fname))
				return(0);
		}
	}
	else
		sprintf(fname,"%s",parsed[1]);

	/*********** call function ************************************/
	if(!collecting_macro)
	{	if(editf(n,fname))
		{	*raw_buf = 0;
			return(0);
		}
	}

	/*********** write command string *****************************/
	sprintf(raw_buf,"edit  %s  %s",file_types[n],fname);

	/*********** return *******************************************/
	return(1);
}
