/*******************************************************************************
*       erase_objM  (see manual, Command Ref., Function Manager)        <fm>   *
*                       Function manager for the erase_obj function.           *
*                                                                              *
*                       Queries for object type if not specified.              *
*                                                                              *
*                       Calls function or writes command to macro being built  *
*            Returns 1 upon successful completion,  0 on failure.              *
*            J.Dabritz   7/15/90                                               *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
long erase_objM(parameters)
char *parameters;
{
	long otype;
	char answer[STRLIST];

		/*** set input or default object type if possible. ***/
	trim(parameters);
	if(*parameters)
		sscanf(parameters,"%d",&otype);
	else
		otype = -1;

	if((otype < 0)  ||  (otype > 2))
	{	if(batch_mode)
			return(0);
		else
		{	message(prompt[53]);
			get_string(answer);
			trim(answer);
			if((*answer < '0')  ||  (*answer > '2'))
				return(0);
			otype = *answer - '0';
		}
	}

	if((otype < 0)  ||  (otype > 2))
		return(0);

		/*** execute command ***/
	if(!collecting_macro)
	{	if(erase_obj(otype))
			return(0);
	}

		/*** build command string ***/
	sprintf(raw_buf,"erase_obj %d",otype);

		/*** return ***/
	return(1);
}
