/*******************************************************************************
*	frame_mapM      (see manual, Command Ref., Function Manager)      <fm>     *
*                                                                              *
*           Will connect of disconnect the four map corners on the raster      *
*           display.  The display is framed as a raster or true geodetic.      *
*           Parameters:  String containing at most 2 parameters.               *
*           Globals Modified:                                                  *
*           Returns zero upon normal execution.                                *
*           C Jonson   12/14/89                                                *
*******************************************************************************/
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
#include <sys/stat.h>
 
long frame_mapM(parms)
char *parms;
{
	long	parse_num;
	long	draw_frame,
			geo_frame;
	long	get_action,
			get_type;
	char	parsed[2][STRLIST];

/***  Initialize variables ***/
	draw_frame = geo_frame = get_action = get_type = 0;

/***  Check for map  ***/
	if(!job_stats[0]  &&  !collecting_macro)
	{	append_msg("  Map not loaded.  Acquire map first.");
		return(1);
	}

/*** Check for 2 parameters in parms.  If not 2, see if parm is a   ***/
/*** 'd' or an 'e'.  If so, ask if user wants geo or raster frame.  ***/
/*** If not 'd' or 'e', prompt for both action and type.            ***/
	parse_num = parse( parms, delim_buf, parsed, 2L );

	if( parse_num >= 1 )		/* At least one parm to check */
	{	if( *parsed[0] == 'd' )
			draw_frame = TRUE;
		else if( *parsed[0] == 'e' )
			draw_frame = FALSE;
		else
			get_action = TRUE;

	/*** Check for geo or raster ***/
		if( *parsed[1] == 'g' )
			geo_frame = TRUE;
		else if( *parsed[1] == 'r' )
			geo_frame = FALSE;
		else
			get_type = TRUE;
	}
	else
		get_type = get_action = TRUE;

	if( get_action )
		for(;;)
		{	message(prompt[114]);
			trim(lowerc(get_string(parsed[0])));
			if( *parsed[0] == 'd' )
				draw_frame = TRUE;
			else if( *parsed[0] == 'e' )
				draw_frame = FALSE;
			else
			{	append_msg("  <--Invalid choice");
				continue;
			}
			break;
		}

	if( get_type )
		for(;;)
		{	message(prompt[115]);
			trim(lowerc(get_string(parsed[1])));
			if( *parsed[1] == 'g' )
				geo_frame = TRUE;
			else if( *parsed[1] == 'r' )
				geo_frame = FALSE;
			else
			{	append_msg("  <--Invalid choice");
				continue;
			}
			break;
		}

	if( frame_map( draw_frame, geo_frame ) )
		return(0);
	else
	{	sprintf(raw_buf, "frame_map %s %s", parsed[0], parsed[1]);
		return(1);
	}
}
