/*******************************************************************************
*       grow_spursM (see manual, Command Ref., Function Manager)     <fm>      *
*		 	Function manager for the grow spurs function           *
*                                                                              *
*			Queries for the number of pixels to grow spurs and     *
*			calls the grow_spurs function.                         *
*                                                                              *
*           No globals changed in function managers.                           *
*			Calls function or writes command to macro being built  *
*           J.Dabritz      6/29/89                                             *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
grow_spursM(parameters)
char *parameters;
{
	long length;
	char answer[STRLIST];

		/************** check first parameter *************************/
	length = -1;
	if(*(trim(parameters)))
		sscanf(parameters,"%d",&length);

		/************** get length from input or user *****************/
	if(!batch_mode)
	{	for(; length < 0;)
		{	message(prompt[31]);
			get_string(answer);
			sscanf(answer,"%d",&length);
		}
	}

		/************** check length & process or abort ***************/
	if(length <= 0)
		return(0);
	if(!collecting_macro)
	{	if(grow_spurs(length))
			return(0);
	}

		/************** build string **********************************/
	sprintf(raw_buf,"grow_spurs %d",length);
	
		/************** return ****************************************/
    return(1);
}
