/*******************************************************************************
*	helpM		(see manual, Command Ref., Function Manager)	<fm>   *
*			Description:  Parses string parameter and checks       *
*			arguments for their presence and validity.             *
*			Parameters:  A string containing the function          *
*			name and its arguments.  The following values          *
*			are searched for:                                      *
*			arg1:  name of macro, menu or function.                *
*			Globals Modified:  none                                *
*                                                                              *
*			Returns zero upon normal end-of-job (EOJ).             *
*			J. Dabritz        1989                                 *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
long helpM(parms)
	char *parms;
{
	long choice;
	long i, j;
	long qflag = 0;
	char tmp_array[300][STRLIST];

	if( batch_mode )
		return(1);
/***   Check to see if string is a function  ***/
	trim(lowerc(parms));		/** Change to lower case & clean up **/

/***   If nothing passed, use list_choice for entire uf_name array  ***/
	if( !strlen(parms) )
	{	for( j = 1, i = 0; strlen(uf_name[i]); j++, i++ )
			strcpy( tmp_array[j], uf_name[i] );
		strcpy(tmp_array[0], "- none -");
		choice = list_choice(tmp_array, (i - 1), 211);
		if( !choice )		/*** 'none' selected ***/
		{	append_msg(tmp_array[0]);
			return(0);
		}
		strcpy(parms, tmp_array[choice]);
	}

	if( isfunc(parms) >= 0 )
		help(parms);
		/*   check to see if string is menu, if so display that menu  */
	else if(ismenu(parms));
		/*   check to see if string is macro, if so execute           */
	else if(ismacro(parms, 1L));
		/*   check to see if it is a partial match to a function      */
	else if( findfunc(parms, &qflag) >= 0)
		help(parms);
		/*   check to see if it is a partial match to a macro         */
	else if(findmacro(parms, &qflag, 1L));
		/*   otherwise tell user that it couldn't be found.           */
	else 
	{	if( qflag == 1 )
			return(0);
		else
		{	append_msg("   ***  not a command, menu, or macro.");
			raw_buf[0] = 0;
			return (0);
		}
	}
 
	sprintf(raw_buf, "help %s", parms);
	return(1);
}
