/*******************************************************************************
*	level_clearM 		(see manual, Command Ref., Function Manager)	<fm>   *
*                                                                              *
*			Either calls the appropriate import function or        *
*			writes the import command to a macro file.             *
*                                                                              *
*           Parses the input string for necessary parameters.  queries         *
*           the user for necessary information.  calls the function            *
*           for the appropriate import file format type.                       *
*                                                                              *
*           Returns  1 on successful completion, 0 on abort/failure.           *
*                                                                              *
*           J.Dabritz   9/20/89                                                *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
long level_clearM(parameters)
char *parameters;
{
	char parsed[3][STRLIST];
	char string[256];

	long level1, level2;
	long no_params;
	long i;


		/************** parse input parameters ************************/
	no_params = parse(trim(parameters),delim_buf,parsed,2);

		/************** get begin level number ************************/
	level1 = -1;
	if(no_params >= 1)
	{	trim(parsed[0]);
		sscanf(parsed[0],"%d",&level1);
	}
	if((level1 < 0)  ||  (level1 > 95))
	{	no_params == 0;
		if(!batch_mode)
			level1 = choose_level(0,95,251);
		else
			return(0);
	}

		/************** get end   level number ************************/
	if(no_params == 1)
		level2 = level1;
	else
	{	level2 = -1;
		trim(parsed[1]);
		if(*parsed[1])
			sscanf(parsed[1],"%d",&level2);
		if((level2 < 0)  ||  (level2 > 95))
		{	if(!batch_mode)
				level2 = choose_level(0,95,252);
			else
				return(0);
		}
	}

		/****** be sure that level1 <= level2 *************************/
	if(level1 > level2)
	{	i = level1;
		level1 = level2;
		level2 = i;
	}

		/****** execute function **************************************/
	if(!collecting_macro)
	{	if(level_clear(level1,level2))
			return(0);
	}

		/****** write command line ************************************/
	sprintf(raw_buf,"level_clear  %d  %d",level1,level2);

		/****** return ************************************************/
    return(1);
}
