/*******************************************************************************
*	level_dupM   		(see manual, Command Ref., Function Manager)	<fm>   *
*                                                                              *
*			Either calls the appropriate import function or        *
*			writes the import command to a macro file.             *
*                                                                              *
*           Parses the input string for necessary parameters.  queries         *
*           the user for necessary information.  calls the function            *
*           for the appropriate import file format type.                       *
*                                                                              *
*           Returns  1 on successful completion, 0 on abort/failure.           *
*                                                                              *
*           J.Dabritz   9/20/89                                                *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
long level_dupM(parameters)
char *parameters;
{
	char parsed[20][STRLIST];
	static char list[6][STRLIST] = {
		"Excuse me, is this geology 102?  I think I'm in the wrong class (get out).",
		"Objects only (draw lines on the raster).",
		"Attributes only (find attributes for all objects from import level).",
		"Obj & Attributes (Draw lines, Assemble, Find Attributes from level).",
		"Copy Attributes from Points on Import Level to map segments.",
		"Copy Attributes from Points on Import Level to map polygons."   };

	long promptem;
	long no_params;
	long level;
	long itc;             /* information type code 1=obj, 2=attr, 3=both */


		/************** get format type     ***************************/
	no_params = parse(trim(parameters),delim_buf,parsed,2);

		/************** initialize promptem flag and format type ******/
	promptem = 0;  /* set to 1 if & when prompting is necessary */

		/************** get level number ******************************/

	level = 0;
	if(no_params > 0)
		sscanf(parsed[0],"%d",&level);
	if((level < 32)  ||  (level > 95))
	{	if(!batch_mode)
		{	level = choose_level(32,95,246);
			promptem = 1;
		}
		else
			return(0);
	}


		/****** check for paramerer 1, information type code **********/
	if(get_long_lst(parsed[1],&itc,&promptem,397,1,5,list[0],6))
		return(0);
	

		/****** execute function **************************************/
	if(!collecting_macro)
	{	if(level_dup(level,itc))
			return(0);
	}

		/****** write command line ************************************/
	sprintf(raw_buf,"level_dup  %d  %d",level,itc);

		/****** return ************************************************/
    return(1);
}
