/*******************************************************************************
*	level_snapM  		(see manual, Command Ref., Function Manager)	<fm>   *
*                                                                              *
*			Either calls the appropriate import function or        *
*			writes the import command to a macro file.             *
*                                                                              *
*           Parses the input string for necessary parameters.  queries         *
*           the user for necessary information.  calls the function            *
*           for the appropriate import file format type.                       *
*                                                                              *
*           Returns  1 on successful completion, 0 on abort/failure.           *
*                                                                              *
*           J.Dabritz   9/20/89                                                *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
long level_snapM(parameters)
char *parameters;
{
	char parsed[10][STRLIST];
	static char pchoices[6][STRLIST] = {
	/* 0 */ " -> I want out of this command!",
	/* 1 */ "snap to nearest line or vertex.",
	/* 2 */ "snap preferentially to a vertex, even if a line is closer.",
	/* 3 */ "snap to line or vertex & add vertices for an exact match.",
	/* 4 */ "snap ONLY to a node or segment endpoint." };



	long promptem;
	long no_params;
	long level1,level2;
	long s,c,p;

	double r;


		/************** parse parameter string ************************/
	no_params = parse(trim(parameters),delim_buf,parsed,7);

		/************** initialize promptem flag **********************/
	promptem = 0;  /* set to 1 if & when prompting is necessary */

		/************** get parameter 0, set number *******************/
	s = -1;
	if(no_params)
		sscanf(parsed[0],"%ld",&s);
	if(s < 0)
		s = list_choice(level_names[0],32,202);

		/************** get parameter 1, lower bound level number *****/
	level1 = 0;
	if(no_params > 0)
		sscanf(parsed[1],"%ld",&level1);
	if((level1 < 32)  ||  (level1 > 95))
	{	if(!batch_mode)
		{	level1 = choose_level(32,95,260);
			promptem = 1;
		}
		else
			return(0);
	}


		/************** get parameter 2, upper bound level number *****/
	level2 = 0;
	if(no_params > 1)
		sscanf(parsed[2],"%ld",&level2);
	if((level2 < 32)  ||  (level2 > 95))
	{	if(!batch_mode)
		{	level2 = choose_level(32,95,261);
			promptem = 1;
		}
		else
			return(0);
	}


		/************** get parameter 3, radius ***********************/
	if(get_double(parsed[3],&r,&promptem,207,(double) 0.0,(double)999999999.0))
		return(0);

		/************** get parameter 4, units code *******************/
	if(get_long(parsed[4],&c,&promptem,51,0,6))
		return(0);
	

		/************** get parameter 5, vertex preference code *******/
	if(no_params > 5)
		p = *parsed[5] - '0';
	else
		p = 0;

	if(promptem  ||  no_params < 6  || p<1  ||  p > 4)
		p = list_choice(pchoices[0],5,259);

	if(p<1  ||  p>4)
		return(0);



			

		/****** execute function **************************************/
	if(!collecting_macro)
	{	if(level_snap(s,level1,level2,r,c,p))
			return(0);
	}

		/****** write command line ************************************/
	sprintf(raw_buf,"level_snap  %d  %d  %d  %f  %d  %d",s,level1,level2,r,c,p);

		/****** return ************************************************/
    return(1);
}
