/*******************************************************************************
*	macro_beginM	(see manual, Command Ref., Function Manager)	<fm>   *
*			Description:  Parses string parameter and              *
*			checks arguments for their presence and validity.      *
*                                                                              *
*			Returns one  upon normal end-of-job (EOJ).             *
*        J.Dabritz  2/1/90                                                     *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
long macro_beginM(parameters)
char *parameters;
{
	long no_params;
	long promptem;
	char *ptr; 
	char parsed[4][STRLIST];
	char macro_name[STRLIST];
	char descrip[STRLIST];


		/*********** parse input string *******************************/
	no_params = parse(trim(parameters),delim_buf,parsed,2);
	promptem = 0;


		/*********** check for parameter 0, macro name ****************/
	macro_name[0] = (char) 0;
	if(no_params == 0)
	{	if(batch_mode)
			return(0);
		message(prompt[301]);
		get_string(macro_name);
		promptem = 1;
	}
	else
		sprintf(macro_name,"%s",parsed[0]);

	trim(macro_name);
	if(!(*macro_name))
		return(0);

		/*********** check for parameter 1, macro description *********/
	if((no_params > 1)  &&  !promptem)
	{	for(ptr = parameters; *ptr  &&  (*ptr <= ' ') ; ptr++)
		trim(ptr);
		sprintf(descrip,"%s",ptr);
	}
	else
	{	if(batch_mode)
			descrip[0] = (char) 0;
		else
		{	message(prompt[302]);
			get_string(descrip);
			trim(descrip);
		}
	}

		/*********** call function ************************************/
	if(!collecting_macro)
	{	if(macro_begin(macro_name,descrip))
		{	*raw_buf = 0;
			return(0);
		}
	}

		/*********** write command string *****************************/
	sprintf(raw_buf,"macro_begin %s %s",macro_name,descrip);

		/*********** return *******************************************/
	return(1);
}
