/*******************************************************************************
*      maskM            (see manual, Command Ref., Function Manager)    <fm>   *
*                                                                              *
*                  Either calls the appropriate function or writes the comand  *
*                  to the macro file.                                          *
*                                                                              *
*                  collects user input as needed.                              *
*                                                                              *
*                  Returns one  upon normal execution.                         *
*                  J.Dabritz   2/16/90                                         *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
#ifdef SV32
#include <limits.h>
#else
#include <values.h>
#endif
 
long maskM(parameters)
char *parameters;
{
	char parsed[3][STRLIST];

	long promptem;
	long s,u;

	double r;

		/************* break up parameters *****************************/
	parse(trim(parameters),delim_buf,parsed,3);

		/************** initialize promptem flag **********************/
	promptem = 0;  /* set to 1 if & when prompting is necessary */

		/************* check parameter 0 , set number  *******************/
	s = get_set(parsed[0],&promptem,0,31,316);

		/************* check parameter 1 , length units code *************/
	if(get_long(parsed[1],&u,&promptem,51,0,6))
		return(0);

		/************* check parameter 2 , mask radius *******************/
#ifdef SV32
	if(get_double(parsed[2],&r,&promptem,317,(double) 0.0,(double) DBL_MAX))
		return(0);
#else
	if(get_double(parsed[2],&r,&promptem,317,(double) 0.0,(double) MAXDOUBLE))
		return(0);
#endif

		/************* call function ***********************************/
	if(!collecting_macro)
	{	if(mask(s,u,r))
			return(0);
	}

		/************* write command line ******************************/
	sprintf(raw_buf,"mask  %d  %d  %f",s,u,r);

		/************* return ******************************************/
    return(1);
}
