/*******************************************************************************
*	menuset_getM	(see manual, Command Ref., Function Manager)	<fm>   *
*			Description:  Parses string parameter and checks       *
*			arguments for their presence and validity.             *
*			Parameters:  A string containing the function          *
*			arguments.  The following values are searched for:     *
*			arg1:  Name of the menuset.                            *
*                                                                              *
*                                                                              *
*                                                                              *
*                                                                              *
*                                                                              *
*                                                                              *
*			Returns zero upon normal end-of-job (EOJ).             *
*******************************************************************************/

#include "../../incl/globals.h"  /*  <stdio.h> & all LTP defines & globals  */
#include "../../incl/in.h"       /*  <in> function definitions        */
#include "../../incl/fc.h"       /*  <fc> function definitions        */

#define LCOUNT 256


long menuset_getM( paramaters )
	char paramaters[];
{
	char file[STRLIST];
	char menuset_list[LCOUNT][STRLIST];
	long no_items;
	long i, found;
	long file_no;

       	/*       parse out name of menuset from paramaters string          */
	parsen(paramaters, " \t", file, 0);
		/*       put in default return string   */
	sprintf(raw_buf, "menuset_get");
	

		/*      see if menuset named does, in fact exist.     */
	no_items = dir_list(menus_path, menuset_list[1], LCOUNT-1);
	if(no_items <= 0)
	{	message("cannot locate menus directory.  Aborting.");
		return(0);
	}
	found = list_find(menuset_list[1], file, no_items);


       	/*if file is not found, & prompting is allowed, ask user for filename */
	if(!found)
	{   if(batch_mode)
			return 0;
		sprintf(menuset_list[0]," - none - ");
		no_items++;
		file_no = list_choice(menuset_list[0], no_items, 84);
		if(file_no == 0)
			return(0);
			/* check again to see if file exists & load it           */
		if( strlen(menuset_list[file_no]))
		{	found = 1;
			strcpy(file,menuset_list[file_no]);
		}
	}

	if(found)
	{	if(!collecting_macro)
		{	if(menuset_get(file))
				return(0);
			else
			{	sprintf(raw_buf, "menuset_get %s",file);
				return(1);
			}
		}
		else
		{	sprintf(raw_buf, "menuset_get %s",file);
			return(1);
		}
	}
	else
		return(0);

}
