/*******************************************************************************
*	mlist_creatM    (see manual, Command Ref., Function Manager)	<fm>   *
*			Function manager for the mlist_create function.          *
*			Queries for user input if necessary.                   *
*                                                                              *
*			Calls function or writes command to macro being built  *
*******************************************************************************/
 
#include <string.h>
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
#define LISTLENGTH 512
 
long mlist_creatM(parameters)
char *parameters;
{
	char parsed[50][STRLIST];
	char fname[256];
	char list[LISTLENGTH][STRLIST];
	char name[256], *temp_name,*ptr; 
	long a, i, n;

	long promptem;
	long no_params;

		/************** parse parameters    ***************************/
	no_params = parse(trim(parameters),delim_buf,parsed,50);

		/************** initialize promptem flag **********************/
	promptem = 0;  /* set to 1 if & when prompting is necessary */

		/************** get file name *********************************/
	if(get_fname(parsed[0],fname,&promptem,95))
		return(0);

		/****** get map name(s) ***************************************/
		/* (already have them as parsed[] */
		/** check for any map names at all **/
	if((no_params < 2)  &&  (!batch_mode))
	{
			/***********   get list of all existing maps  */
		n = dir_list(maps_path,list[1],LISTLENGTH-1);
		if(n == 0)
		{	message("There are no maps from which to choose.");
			return(0);
		}
		if(n < 0)
		{	message("maps directory must be created and listed in the config/config file.");
	
			return(0);
		}
	
			/***********  remove current temp map name from list if present */
		if(*temp_map_path  &&  job_stats[0])
		{	strcpy(name,temp_map_path);            /*  find name of temp  */
			for(ptr = name; *ptr; ptr++)
			{	if(*ptr == '/')
					temp_name = ptr +1;
			}
			for(i=1; i<=n; i++)                    /*  find name on list */
			{	if(!strcmp(temp_name,list[i]))
					break;
			}
			if(i<=n)
			{	for(; i<n; i++)
					strcpy(list[i],list[i+1]);
				n = n-1;
			}
		}
	
			/***********  add choice 'done' to list of all existing maps  */
		strcpy(list[0]," - done -");
	
			/***********   have user make selection                        */
		for(a=1, i=1; (i<50) && (a>0); )
		{	a = list_choice(list[0],n+1,138);
			if(a>0)
			{	strcpy(parsed[i],list[a]);
				i++;
			}
		}
		if(i > 1)
			no_params = i;
		else
			no_params = 0;
	}

	if(no_params < 2)
		return(0);
	else
		sprintf(parsed[no_params],"");

		/************* call function *************************************/
	if(!collecting_macro)
	{	if(mlist_create(fname,parsed[1]))
			return(0);
	}

		/************* write command string ******************************/
	sprintf(raw_buf,"mlist_create %s",fname);
	for(i=1; i<no_params; i++)
	{	raw_buf[STRLIST] = (char) 0;
		ptr = raw_buf + strlen(raw_buf);
		sprintf(ptr," %s",parsed[i]);
	}
	raw_buf[STRLIST] = (char) 0;

		/************* return ********************************************/
	return(1);
}
