/*******************************************************************************
*	mlist_execM	(see manual, Command Ref., Function Manager)	<fm>   *
*			Function manager for the mlist_exec function.          *
*			Queries for user input if necessary.                   *
*                                                                              *
*			Calls function or writes command to macro being built  *
*******************************************************************************/
/* Modified 6/92 by DBS@CWU for multi user support */
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
#include <string.h>
 
 
long mlist_execM(parameters)
char *parameters;
{
	long no_params;
	long promptem;
	long i, n;
	long save_flag, next_param;

	char *ptr; 
	char parsed[4][STRLIST];
	char maplist_name[STRLIST];
	char action[STRLIST];
	char path[STRLIST];
	char list[512][STRLIST];


		/*********** parse input string *******************************/
	no_params = parse(trim(parameters),delim_buf,parsed,4);
	promptem = 0;
	next_param = 0;
	save_flag = 1;


		/*********** check for optional parameter 0, -s  ****************/
	if(no_params)
	{	if(!strcmp("-s",parsed[0]))
/*	{	if((parsed[0][0] == '-') && (parsed[0][1] = 's') && (parsed[0][2] = (char) 0)) */
		{	save_flag = 0;
			next_param = 1;
		}
	}
	else
	{	promptem = 1;
		if(!answerisyes(363,1))
			save_flag = 0;
	}

		/*********** check for parameter 0, maplist name ****************/
	maplist_name[0] = (char) 0;
	if(no_params <= next_param)
	{	if(batch_mode)
			return(0);
#ifdef MULTIUSER  /**** first try local, then system lists ****/
		sprintf(path,"%s/.ltp/map_lists",home_path);
		i = dir_list(path,list[1],510);
		if (i > 0) {  /* show local list */
			sprintf(list[0]," - none - (next list)");
			n = list_choice(list[0],i+1,308);
		}
		if (n == 0 || i <= 0) { /* now show system list */
			sprintf(list[0]," - none -");
			sprintf(path,"%s/map_lists",ltp_path);
			i = dir_list(path,list[1],510);
                	n = list_choice(list[0],i+1,308);
                	if(n <= 0)
                        	return(0);
                	sprintf(maplist_name,"%s",list[n]);
                	promptem = 1;
		}
		if (i == 0) {
			message("There are no map lists created.  You must edit or mlist_create first.");
			return(0);
		}

#else  /*** original code ***/
		sprintf(path,"%s/map_lists",ltp_path);
		i = dir_list(path,list[1],510);
		if(!i)
		{	message("There are no map lists created.  You must edit or mlist_create first.");
			return(0);
		}
		sprintf(list[0]," - none -");
		n = list_choice(list[0],i+1,308);
		if(n <= 0)
			return(0);
		sprintf(maplist_name,"%s",list[n]);
		promptem = 1;
#endif
	}
	else
		sprintf(maplist_name,"%s",parsed[next_param]);

	trim(maplist_name);
	if(!(*maplist_name))
		return(0);
	next_param++;

		/*********** check for parameter 1, action ***************/
	trim(parameters);
	if((no_params > next_param)  &&  !promptem)
	{	for(ptr=parameters;next_param;next_param--)
		{	trim(ptr);
			for(; *ptr > ' ' ; ptr++);
		}
		trim(ptr);
		sprintf(action,"%s",ptr);
	}
	else
	{	if(batch_mode)
			return(0);
		else
		{	message(prompt[309]);
			get_string(action);
			trim(action);
			if(!(*action))
				return(0);
		}
		promptem = 1;
	}

		/*********** call function ************************************/
	if(!collecting_macro)
	{	if(mlist_exec(save_flag,maplist_name,action))
		{	*raw_buf = 0;
			return(0);
		}
	}

		/*********** write command string *****************************/
	if(save_flag)
		sprintf(raw_buf,"mlist_exec %s %s",maplist_name,action);
	else
		sprintf(raw_buf,"mlist_exec -s %s %s",maplist_name,action);

		/*********** return *******************************************/
	return(1);
}
