/*******************************************************************************
*	p_createM     (See manual, Command Ref., Function Manager)	   <fm>        *
*       Creates a pen file to allow selective plotting of sets of objects      *
*       with a specified plotter pen.                                          *
*       Parameters:  string from fj()                                          *
*       Globals Modified:  none                                                *
*       Returns 1 upon successful execution, else returns 0.                   *
*       C. Jonson    2/13/90                                                   *
*******************************************************************************/
#include "../../incl/globals.h"
#include <string.h>
 
long p_createM(parms)
	char *parms;
{
	long   i;

	char   pen_set[64];
	char   parsed[2][STRLIST];

/*** See how many parameters are in parm string.  ***/
	parse( parms, delim_buf, parsed, 2L );

/*** Inspect the parm[0] name for '/'.  If found, get new name ***/
	if( !strlen(parsed[0]) )
	{	message(prompt[360]);
		get_string(parsed[0]);
	}

	for( ;; )
	{	if( strchr(parsed[0], '/') != (char *)NULL )
		{	message("The slash character is not allowed in a penfile name");
			if(!valid_string(parsed[0], "Enter filename. [q = QUIT]"))
			{	sprintf(raw_buf, "User terminated p_create. ");
				return(0);
			}
		}
		else
			break;
	}

/*** Initialize the pen numbers to zero ***/
	for( i = 0; i < 32; pen_set[i++] = '0' );
	pen_set[32] = CNULL;		/* NULL terminate the string */

/*** The second parm is simply taken as a string of digits  ***/
	if( !(strlen(parsed[1])) )
	{	message(prompt[353]);
		get_string(parsed[1]);
	}

	parsed[1][32] = (char) 0;
	sprintf(pen_set,"%s",parsed[1]);
				
		/*********** execute function *********************************/
	if(!collecting_macro)
	{	if(p_create(parsed[0], pen_set))
		{	*raw_buf = 0;
			return(0);
		}
	}

		/*********** generate command string **************************/
	sprintf(raw_buf, "p_create  %s  %s", parsed[0], pen_set);

		/*********** return *******************************************/
    return(1);
}
