/*******************************************************************************
*	pauseM    	        (see manual, Command Ref., Function Manager)	<fm>   *
*		 	Function manager for the pause function.                           *
*                                                                              *
*			Queries for the seconds and string parameter.          *
*                                                                              *
*			Calls function or writes command to macro being built  *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
#include <string.h>
 
 
pauseM(parameters)
char *parameters;
{
	char parsed[3][STRLIST];
	char string[STRLIST];
	char *ptr;

	long seconds;
	long promptem;
	long no_params;
	long i,n;

		/************** initialize promptem flag and format type ******/
	promptem = 0;  /* set to 1 if & when prompting is necessary */

		/************** break up parameters ***************************/
	no_params = parse(trim(parameters),delim_buf,parsed,2);
	for(i=0; i < no_params; i++)
		trim(parsed[i]);

		/************** check first parameter for number of seconds *****/
	if(get_long(parsed[0],&seconds,&promptem,257,-1,999999))
		return(0);
	if(seconds < 0)
		return(0);


		/************** check for string parameter ********************/
	string[0] = 0;
	if(no_params > 1)
	{	n = strlen(parsed[0]);
		trim(parameters);
		ptr = parameters + n; 
		trim(ptr);
		if(ptr[0] != 0)
			strcpy(string,ptr);
	}

	if(!batch_mode  &&  promptem)
	{	message(prompt[258]);
		get_string(string);
	}	


		/************** execute pause command  ************************/
	if(!collecting_macro)
	{	if(pause_ltp(seconds,string))
			return(0);
	}

		
		/************** build command string **************************/
	sprintf(raw_buf,"pause %d %s",seconds,string);


		/************** return ****************************************/
    return(1);
}
