/*******************************************************************************
*	plot_asciiM     (see manual, Command Ref., Function Manager)	<fm>   *
*                                                                              *
*			Reads the file named by the only parameter and         *
*			creates a plot of the file.                            *
*                                                                              *
*			Parameters:   char *  -  name of ascii file that       *
*			                         contains HP-GL instructions.  *
*			Globals Modified:   none                               *
*                                                                              *
*			Returns 1 upon normal execution, else returns 0.       *
*			    C. Jonson  9/22/89                                 *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include <sys/stat.h>
 
long plot_asciiM(parms)
	char *parms;
{
	long   parse_num;
	long   p_dev;
	char   fname[256];
	char   pstring[STRLIST];
	char   parsed[2][STRLIST];
	struct stat buf;

/*** See how many parameters are in parm string.                     ***/
	parse_num = parse( parms, delim_buf, parsed, 2L );

/*** If incorrect number of parms, null parsed strngs to force prompting ***/
	if( parse_num != 2 )
	{	if( batch_mode )
			return(0);
		parsed[0][0] = parsed[1][0] =  0;
	}

/*** Check the parms for validity.  The valid_long & valid_string are  ***/
/*** found in the source code of reportM.c                             ***/
	if( !valid_long(parsed[0], &p_dev, 1L, 2L,
		    "Enter plotter type. [1=plotter1, 2=plotter2, q=QUIT]"))
	{	message("User terminated plot_ascii. Bye.");
		return(0);
	}

 	if( !strlen(parsed[1]) )
	{	if(!valid_string(parsed[1], "Enter filename. [q = QUIT]"))
		{	message("User terminated plot_ascii.  Bye.");
			return(0);
		}
	}

/*** Use the default export path for a directory to park users info.      ***/
/*** P_tmpdir is defined in stdio.h!!!                                    ***/
	if( parsed[1][0] == '/' )
		strcpy( fname, parsed[1]);
	else 
		sprintf(fname, "%s%s", P_tmpdir, parsed[1]);

/*** See if the file exists.  If not, get another  ***/
	while( stat(fname, &buf) == -1 )
	{	sprintf(pstring, "%s does not exist.  Check for correct path.",
			fname );
		message(pstring);
		if(!valid_string(parsed[1], "Enter filename. [q = QUIT]"))
		{	message("User terminated plot_ascii.  Bye.");
			return(0);
		}
	}

/*** If no open plotter (fd_plot == -1) open device ***/
	if( fd_plot == -1 )
	{	if( plot_setup(p_dev) )
			return(0);
	}

/*** Pass all parms to plot_ltp and let it process, unless collecting macro ***/
	if( !collecting_macro )
		if(plot_ascii(fname))
		{	raw_buf[0] = '\0';       /* null out raw buf */
			return(0);
		}
	sprintf(raw_buf, "plot_ascii %d %s",  p_dev, fname);

/*** Set job_stats plot flag ***/
	job_stats[42] = job_stats[45] + 1;

	return(1);
}
