/*******************************************************************************
*	plus_plusM	(see manual, Command Ref., Function Manager)	<fm>   *
*			Function manager for the plus_plus function.           *
*                                                                              *
*			Queries for all parameters not present.                *
*                                                                              *
*			Calls function or writes command to macro being built  *
*                 							       *
*			Returns zero upon normal end-of-job (EOJ).             *
*******************************************************************************/
 
#include <string.h>
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
long plus_plusM(parameters)
char *parameters;
{
	char parsed[4][STRLIST];
	char *ptr;

	long n,l,i;
	long no_params;
	long promptem;


		/************* break up parameters *****************************/
	no_params = parse(trim(parameters),delim_buf,parsed,4);

		/************** initialize promptem flag **********************/
	promptem = 0;  /* set to 1 if & when prompting is necessary */

		/****** check for options **********************************/
	l= -1;
	n= -1;
	if(no_params == 0)       /** if no parameters, prompt for both **/
	{	sprintf(parsed[0],"n=");
		sprintf(parsed[1],"l=");
		no_params = 2;
	}

	for(i=0; i< no_params; i++)
	{	switch(parsed[i][0]) {
		case 'n':         /* plus plus number */
			if(parsed[i][1] == '=')
				ptr = parsed[i] + 2;
			else 
				ptr = parsed[i] + 1;
			n = 1;
			get_long(ptr,&n,&promptem,341,-1,2000000000);
			if(n == -1)
				return(0);
			break;
		case 'l':         /* plus plus number length */
		case 'w':         /* plus plus number length (width) */
			if(parsed[i][1] == '=')
				ptr = parsed[i] + 2;
			else 
				ptr = parsed[i] + 1;
			l = 5;
			get_long(ptr,&l,&promptem,346,-1,30);
			if(l == -1)
				return(0);
			break;
		}
	}

		/*** check for real input ***/
	if((n == -1)  && (l == -1))
		return(0);

		/*********** execute function *********************************/
	if(!collecting_macro)
	{	if(plus_plus_ltp(n,l))
		{	*raw_buf = 0;
			return(0);
		}
	}

		/*********** generate command string **************************/
	if(n>=0  &&  l>=0)
		sprintf(raw_buf,"plus_plus  n=%d  l=%d",n,l);
	else if(n>=0)
		sprintf(raw_buf,"plus_plus  n=%d",n);
	else if(l>=0)
		sprintf(raw_buf,"plus_plus  l=%d",l);
	else
		sprintf(raw_buf,"plus_plus");

		/*********** return *******************************************/
    return(1);
}
