/*******************************************************************************
*	queryM		(see manual, Command Ref., Function Manager)	<fm>   *
*			Function manager for the query function.               *
*                                                                              *
*			Queries for object type if not specified.              *
*                                                                              *
*			Calls function or writes command to macro being built  *
*           Returns 1 upon successful completion,  0 on failure.              *
*           J.Dabritz   8/13/89                                               *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
long queryM(parameters)
char *parameters;
{
	long i;
	long otype;
	long ot10;
	long level;
	char answer[STRLIST];

		/*** set input or default object type if possible. ***/
	trim(parameters);
	if(*parameters)
		sscanf(parameters,"%d",&otype);
	else
		otype = -1;       /** flag for multiple map type **/

		/*** check & query for object type if necessary ***/
	ot10 = otype % 10;
	if((otype < 0)  ||  (otype > 952) || (ot10 < 0) || (ot10 > 2))
	{	if(batch_mode)
			return(0);
		else
		{	message(prompt[53]);
			get_string(answer);
			trim(answer);
			if((*answer < '0')  ||  (*answer > '2'))
				return(0);
			otype = *answer - '0';
		}
			/*** check to see if user wants to query an import level ***/
		if(answerisyes(342,0))
		{	if(!batch_mode)
				level = choose_level(32,95,246);
			else
				return(0);
			otype += level * 10;
		}
	}
	ot10 = otype % 10;
	if((otype < 0)  ||  (otype > 952) || (ot10 < 0) || (ot10 > 2))
		return(0);

		/*** execute command ***/
	if(!collecting_macro)
	{	if(query(otype))
			return(0);
	}

		/*** build command string ***/
	sprintf(raw_buf,"query %d",otype);

		/*** return ***/
	return(1);
}
