/*******************************************************************************
*      reduce_resM      (see manual, Command Ref., Function Manager)    <fm>   *
*                                                                              *
*                  Either calls the appropriate function or writes the comand  *
*                  to the macro file.                                          *
*                                                                              *
*                  collects user input as needed.                              *
*                                                                              *
*                  Returns one  upon normal execution.                         *
*                  J.Dabritz   1/23/90                                         *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
long reduce_resM(parameters)
char *parameters;
{
	char parsed[3][STRLIST];

	long promptem;
	long no_params;
	long n,t;

	double x;

		/************* break up parameters *****************************/
	no_params = parse(trim(parameters),delim_buf,parsed,3);

		/************** initialize promptem flag **********************/
	promptem = 0;  /* set to 1 if & when prompting is necessary */

		/************* check parameter 0 , reduction factor ************/
	if(get_long(parsed[0],&n,&promptem,296,2,(long) (job_stats[1] + 1)))
		return(0);

		/************* check parameter 1 , threshold *******************/
	t = 0;
	if((no_params > 1)  ||  (promptem))     /*  prompt for threshold */
	{	if(get_long(parsed[1],&t,&promptem,297,0,n * n))
			return(0);
		if(!t)
		{	x = n * n * 0.4 + 0.5;
			t = x;
		}
	}
	else
	{	x = n * n * 0.4 + 0.5;
		t = x;
	}

		/************* call function ***********************************/
	if(!collecting_macro)
	{	if(reduce_res(n,t))
			return(0);
	}

		/************* write command line ******************************/
	sprintf(raw_buf,"reduce_res  %d  %d",n,t);

		/************* return ******************************************/
    return(1);
}
