/*******************************************************************************
*    reflectM         (see manual, Command Ref., Function Manager)    <fm>     *
*        Displays the job stats file of the current map to the user in an      *
*        informative manner.  No changes are made to the job stats file.       *
*        Parameters:  A string containing the function arguments.  The         *
*                     following values are searched for:                       *
*                     arg1:  Horizontal flag:  reflect raster on a horizontal  *
*                            plane.  Default is to reflect on a vertical plane.*
*        Globals Modified:  None.                                              *
*                                                                              *
*        Returns 1 upon normal end-of-job (EOJ), else returns 0.               *
*        C. Jonson   1/5/90                                                    *
*******************************************************************************/
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
long reflectM(parms)
	char *parms;
{
	long   horiz = 0;

/*** Ensure map exists first! ***/
	if( !job_stats[0] &&  !collecting_macro)
	{	message("ACQUIRE or CREATE a map before raster can be REFLECTED.");
		*raw_buf = CNULL;
		return(0);
	}

/*** Is the parameter a -h (indicating reflect on horizontal plane)?  ***/
	trim(parms);
	if( !strncmp(parms, "-h", 2) )
		horiz = TRUE;
	else
		horiz = FALSE;

/*** Pass the print flag to reflect, unless collecting macro ***/
	if( !collecting_macro )
		if(reflect(horiz))
		{	*raw_buf = CNULL;       /* null out raw buf */
			return(0);
		}

	if( horiz )
		strcpy(raw_buf, "reflect -h");
	else
		strcpy(raw_buf, "reflect");

	return(1);
}
