/*******************************************************************************
*	retrieveM	(see manual, Command Ref., Function Manager)	<fm>   *
*                                                                              *
*			Either calls the retrieve function or writes the       *
*			retrieve command to a macro file.                      *
*                                                                              *
*			The config.bkup_path is examined to ensure it exists and that      *
*			it begins with /dev.  If the -t argument is present, only a        *
*			listing of the archive device is created, else all files are       *
*			extracted.   'Tar' is the system command used.                     *
*                                                                              *
*			Returns zero upon normal execution.                    *
*			C Jonson     12/12/89                                  *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"

long retrieveM(parms)
	char *parms;
{
	char tmp_cmd[512];				/*** string passed to retrieve_ltp ***/


/***  Check config.bkup_path for its existance.  If empty, return ***/
	if( !strlen(config.bkup_path) )
	{	message("There is no device listed in config file under bkup_path.");
		return(0);
	}
	else if( strncmp(config.bkup_path, "/dev", 4) )
	{	message("The device named by bkup_path in the config file must start \
with \'/dev\'.");
		return(0);
	}
	
/***  Check for parameters.  If present, it should be a -t for listing.   ***/
/***  The current map (identified by global 'map_path') is back up to     ***/
/***  the device listed in config.bkup_path by the tar command.           ***/
	if( strlen(trim(parms)) )
		if( !strncmp(parms, "-t", 2) )
			sprintf(tmp_cmd, "tar tvf %s", config.bkup_path);
		else
			sprintf(tmp_cmd, "tar xvf %s", config.bkup_path);

	if( !collecting_macro )
		if( retrieve_ltp( tmp_cmd ) )
		{	message("Unable to retrieve map from backup. Bye.");
			return(0);
		}

	sprintf(raw_buf, "retrieve %s", parms);
	return(1);
}
