/*******************************************************************************
*	saveM		(see manual, Command Ref., Function Manager)	<fm>   *
*                                                                              *
*			Either calls the save function or writes the           *
*			save command to a macro file.                          *
*                                                                              *
*			Returns 1 if successful, 0 if not.                     *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
long saveM(parameters)
char *parameters;
{
	char fname[256];

        /******************** check to see if a map is acquired ***********/
	if(!job_stats[0] && !collecting_macro)
	{	append_msg("no current map to save.");
		return(0);
	}

        /******************** get fname parameter if present **************/
	trim(parameters);
	if(parameters[0])
		sprintf(fname,"%s",parameters);
	else
		fname[0] = (char) 0;

        /******************** store everything to temp & copy to map ******/
	if(!collecting_macro)
	{	if(!save(fname))
			return(0);
	}
	
        /******************** set command string **************************/
	sprintf(raw_buf,"save %s",fname);

        /******************** return **************************************/
    return(1);
}
