/*******************************************************************************
*	set_clearM   		(see manual, Command Ref., Function Manager)	<fm>   *
*                                                                              *
*			Either calls the appropriate import function or        *
*			writes the import command to a macro file.             *
*                                                                              *
*           Parses the input string for necessary parameters.  queries         *
*           the user for necessary information.  calls the function            *
*           for the appropriate import file format type.                       *
*                                                                              *
*           Returns  1 on successful completion, 0 on abort/failure.           *
*                                                                              *
*           J.Dabritz   1/24/90                                                *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
long set_clearM(parameters)
char *parameters;
{
	char parsed[3][STRLIST];
	char string[256];

	long set1, set2;
	long no_params;
	long i;


		/************** parse input parameters ************************/
	no_params = parse(trim(parameters),delim_buf,parsed,2);

		/************** get begin set number ************************/
	set1 = -1;
	if(no_params >= 1)
	{	trim(parsed[0]);
		sscanf(parsed[0],"%d",&set1);
	}
	if((set1 < 0)  ||  (set1 > 95))
	{	no_params == 0;
		if(!batch_mode)
			set1 = choose_level(0,95,251);
		else
			return(0);
	}

		/************** get end   set number ************************/
	if(no_params == 1)
		set2 = set1;
	else
	{	set2 = -1;
		trim(parsed[1]);
		if(*parsed[1])
			sscanf(parsed[1],"%d",&set2);
		if((set2 < 0)  ||  (set2 > 95))
		{	if(!batch_mode)
				set2 = choose_level(0,95,252);
			else
				return(0);
		}
	}

		/****** be sure that set1 <= set2 *************************/
	if(set1 > set2)
	{	i = set1;
		set1 = set2;
		set2 = i;
	}

		/****** execute function **************************************/
	if(!collecting_macro)
	{	if(level_clear(set1,set2))
			return(0);
	}

		/****** write command line ************************************/
	sprintf(raw_buf,"set_clear  %d  %d",set1,set2);

		/****** return ************************************************/
    return(1);
}
