/*******************************************************************************
*	set_digM  	(see manual, Command Ref., Function Manager)	<fm>   *
*                                                                              *
*			Either calls the crit_end function or writes the       *
*			crit_end command to a macro file.                      *
*                                                                              *
*			Parses parameters and gathers user input.  calls       *
*			the function.                                          *
*                                                                              *
*			Returns one  upon normal execution.                    *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
long set_digM(parameters)
char *parameters;
{
	char parsed[4][STRLIST];
	char descr[STRLIST];
	char *ptr;

	long s;
	long no_params;
	long promptem;
	long otype;


		/************* break up parameters *****************************/
	no_params = parse(trim(parameters),delim_buf,parsed,3);

		/************** initialize promptem flag **********************/
	promptem = 0;  /* set to 1 if & when prompting is necessary */

		/************* check parameter 0 , set number ******************/
	s = 0;
	if(no_params)
		sscanf(parsed[0],"%ld",&s);

	if(!s  ||  (s < -24)  ||  (s > 24))
	{	promptem = 1;
		s = get_set(" ",&promptem,1,24,344);
		if(answerisyes(345,0))
			s = -s;
	}
	if(!s  ||  (s < -24)  ||  (s > 24))
		return(0);

		/************* check parameter 1 , object type *****************/
	otype = -1;
	get_long(parsed[1],&otype,&promptem,53,-1,2);
	if((otype <0) || (otype > 2))
		return(0);

		/************* check parameter 2 , description *****************/
	if((no_params > 2)  &&  !promptem)
	{	for(ptr=parameters; *ptr > 32; ptr++);
		trim(ptr);
		for(ptr=parameters; *ptr > 32; ptr++);
		trim(ptr);
		strcpy(descr,ptr);
	}
	else if(!batch_mode)
	{	message(prompt[287]);
		get_string(descr);
	}
	else
		*descr = (char) 0;

	descr[60] = (char) 0;


		/************* call function ***********************************/
	if(!collecting_macro)
	{	if(set_dig(s,otype,descr))
			return(0);
	}

		/************* write command line ******************************/
	sprintf(raw_buf,"set_dig  %d  %d  %s",s,otype,descr);

		/************* return ******************************************/
    return(1);
}
