/*******************************************************************************
*	set_eraseM   		(see manual, Command Ref., Function Manager)	<fm>   *
*                                                                              *
*			Either calls the appropriate import function or        *
*			writes the import command to a macro file.             *
*                                                                              *
*           Parses the input string for necessary parameters.  queries         *
*           the user for necessary information.  calls the function            *
*           for the appropriate import file format type.                       *
*                                                                              *
*           Returns  1 on successful completion, 0 on abort/failure.           *
*                                                                              *
*           J.Dabritz   7/15/90                                                *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
#include <string.h>
 
 
long set_eraseM(parameters)
char *parameters;
{
	char parsed[3][STRLIST];

	long set;
	long no_params;
	long i;


		/************** parse input parameters ************************/
	no_params = parse(trim(parameters),delim_buf,parsed,2);

		/************** get begin set number ************************/
	set = -1;
	if(no_params >= 1)
	{	trim(parsed[0]);
		sscanf(parsed[0],"%d",&set);
	}
	if((set < 0)  ||  (set > 31))
	{	
		if(!batch_mode)
			set = choose_level(0,31,343);
		else
			return(0);
	}

		/****** execute function **************************************/
	if(!collecting_macro)
	{	if(set_erase(set))
			return(0);
	}

		/****** write command line ************************************/
	sprintf(raw_buf,"set_erase  %d",set);

		/****** return ************************************************/
    return(1);
}
