/*******************************************************************************
*      set_intrsecM     (see manual, Command Ref., Function Manager)    <fm>   *
*                                                                              *
*                  Either calls the appropriate function or writes the comand  *
*                  to the macro file.                                          *
*                                                                              *
*                  collects user input as needed.                              *
*                                                                              *
*                  Returns one  upon normal execution.                         *
*                  J.Dabritz   1/17/90                                         *
*******************************************************************************/
 
#include <string.h>
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"

 
long set_intrsecM(parameters)
char *parameters;
{
	char parsed[4][STRLIST];
	char set_descriptor[STRLIST];
	char *ptr;

	long promptem;
	long s0, s1, s2;
	long no_params;
	long i;

		/************* break up parameters *****************************/
	no_params = parse(trim(parameters),delim_buf,parsed,4);

		/************** initialize promptem flag **********************/
	promptem = 0;  /* set to 1 if & when prompting is necessary */

		/************* check parameter 0 , set to intersect    *********/
	s0 = get_set(parsed[0],&promptem,0,31,292);
	if(s0 < 0)
		return(0);

		/************* check parameter 1 , set to intersect    *********/
	s1 = get_set(parsed[1],&promptem,0,31,293);
	if(s1 < 0)
		return(0);

		/************* check parameter 2 , new set created     *********/
	s2 = get_set(parsed[2],&promptem,1,24,288);
	if(s2 < 0)
		return(0);

		/************* check parameter 3 , new set descriptor  *********/
	if((no_params == 4) && !promptem)
	{	trim(parameters);
		ptr = parameters;
		for(i=0; i<3; i++)
		{	for(; (*ptr > 32)  &&  (*ptr < 127) ; ptr++);
			trim(ptr);
		}
		strncpy(set_descriptor,ptr,94);
	}
	else
	{	if(batch_mode)
			return(0);
		message(prompt[287]);
		get_string(set_descriptor);
	}
	set_descriptor[60] = (char) 0;

		/************* call function ***********************************/
	if(!collecting_macro)
	{	if(set_intrsec(s0,s1,s2,set_descriptor))
			return(0);
	}

		/************* write command line ******************************/
	sprintf(raw_buf,"set_intrsec  %d  %d  %d  %s",s0,s1,s2,set_descriptor);

		/************* return ******************************************/
    return(1);
}
