/*******************************************************************************
*    statusM          (see manual, Command Ref., Function Manager)    <fm>     *
*        Displays the job stats file of the current map to the user in an      *
*        informative manner.  No changes are made to the job stats file.       *
*        Parameters:  A string containing the function arguments.  The         *
*                     following values are searched for:                       *
*                     arg1:  Print flag (-p: send to default printer)          *
*        Globals Modified:  None.                                              *
*                                                                              *
*        Returns 1 upon normal end-of-job (EOJ), else returns 0.               *
*******************************************************************************/
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
long statusM(parms)
	char *parms;
{
	long   print_it = 0;

/*** Ensure map exists first! ***/
	if( !job_stats[0]  &&  !collecting_macro)
	{	message("ACQUIRE or CREATE a map before STATUS can be displayed.");
		*raw_buf = CNULL;
		return(0);
	}

/*** Is the parameter a -p (indicating print the status) ?  ***/
	trim(parms);
	if( !strncmp(parms, "-p", 2) )
		print_it = TRUE;
	else
		print_it = FALSE;

/*** Pass the print flag to status_ltp, unless collecting macro ***/
	if( !collecting_macro )
	{	if(status_ltp(print_it))
		{	*raw_buf = CNULL;       /* null out raw buf */
			return(0);
		}
	}

	if( print_it )
		strcpy(raw_buf, "status -p");
	else
		strcpy(raw_buf, "status");

	return(1);
}
