/*******************************************************************************
*	stepM		(see manual, Command Ref., Function Manager)	<fm>   *
*			Checks input parameter and querries user if necessary. *
*                                                                              *
*			Either calls step() or writes step command             *
*			line to the macro being built.                         *
*                                                                              *
*			Returns zero upon normal end-of-job (EOJ).             *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
long stepM(parameters)
char *parameters;
{
	char answer[256];
	long direction;

		/******************* check for map loaded **********************/
	if(!job_stats[0] && !collecting_macro)
	{	*raw_buf = 0;
		return(0);
	}

		/*********** check parameter *********************************/
	direction = 0;
	lowerc(trim(parameters));
	switch((long) *parameters) {
	case (long) 'l':
	case (long) 'r':
	case (long) 'u':
	case (long) 'd':
		direction = (long) *parameters;
		break;
	default:
		if(!batch_mode)
		{	message(prompt[64]);
			get_string(answer);
			lowerc(trim(answer));
			switch((long) *answer) {
			case (long) 'l':
			case (long) 'r':
			case (long) 'u':
			case (long) 'd':
				direction = (long) *answer;
				break;
			}
		}
		break;
	}

		/*********** check input *****************/
	if(!direction)
		return(0);

		/*********** execute command *********************************/
	if(!collecting_macro)
	{	if(!step(direction))
		{	*raw_buf = 0;
			return(0);
		}
	}
	
		/*********** write command string ****************************/
	switch((long) *parameters) {
	case (long) 'l':
		sprintf(raw_buf,"step left");
		break;
	case (long) 'r':
		sprintf(raw_buf,"step right");
		break;
	case (long) 'u':
		sprintf(raw_buf,"step up");
		break;
	case (long) 'd':
		sprintf(raw_buf,"step down");
		break;
	}
		/*********** *************************************************/
 
    return(1);
}
