/*******************************************************************************
*	thin_linesM	(see manual, Command Ref., Function Manager)	<fm>   *
*			Description:  Parses string parameter and checks       *
*			arguments for their presence and validity.             *
*			Parameters:  A string containing the function          *
*			arguments.  The following values are searched for:     *
*			arg1:  Number of thinning passes. Default = 0.         *
*			arg2:  Thinning type code (0-2)                        *
*									       *
*			Returns one  upon normal end-of-job (EOJ).             *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
long thin_linesM(parameters)
char *parameters;
{
	char parsed[3][STRLIST];

	long no_params;
	long passes, thin_type;
	long promptem;

		/************** parse parameter string ************************/
	no_params = parse(trim(parameters),delim_buf,parsed,3);

		/************** initialize promptem flag **********************/
	promptem = 0;  /* set to 1 if & when prompting is necessary */


		/************** get parameter 1, thinning type ****************/
	thin_type = 0;
	if(get_long(parsed[0],&thin_type,&promptem,206,0,2))
		return(0);
	
		/************** check second parameter, number of passes ******/
	if(thin_type < 2)
		passes = 0;
	else
		passes = 1;
	if(promptem || (thin_type == 2) || (no_params >= 2))
	{	if(get_long(parsed[1],&passes,&promptem,205,0,999999999))
			return(0);
	}


		/************** execute command *******************************/
	if(!collecting_macro)
	{	if(thin_lines(passes, thin_type))
			return(0);
	}

		/************** build string **********************************/
	sprintf(raw_buf,"thin_lines %d %d",thin_type,passes);
	
		/************** return ****************************************/
    return(1);
}
