/*******************************************************************************
*	vertex_thinM	(see manual, Command Ref., Function Manager)	<fm>   *
*			Function manager for the vertex_thin function.         *
*			Queries for user input if necessary.                   *
*                                                                              *
*           Parses the input string for necessary parameters.  queries         *
*           the user for necessary information.  calls the function            *
*           for the appropriate import file format type.                       *
*                                                                              *
*           Returns  1 on successful completion, 0 on abort/failure.           *
*                                                                              *
*           J.Dabritz   7/31/90                                                *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
long vertex_thinM(parameters)
char *parameters;
{
	char parsed[10][STRLIST];

	long promptem;
	long no_params;
	long s,u,m;

	double r;


		/************** parse parameter string ************************/
	no_params = parse(trim(parameters),delim_buf,parsed,7);

		/************** initialize promptem flag **********************/
	promptem = 0;  /* set to 1 if & when prompting is necessary */

		/************** get parameter 0, set number *******************/
	s = -1;
	if(no_params)
		sscanf(parsed[0],"%ld",&s);
	if((s < 0)  ||  (s > 31))
		s = list_choice(level_names[0],32,202);


		/************** get parameter 1, units code *******************/
	if(get_long(parsed[1],&u,&promptem,51,0,6))
		return(0);
	
		/************** get parameter 2, radius ***********************/
	r = -1.0;
	if(get_double(parsed[2],&r,&promptem,208,(double) 0.0,(double)999999999.0))
		return(0);
	if((r == (double) 0.0) || (r < (double) 0.0))
		return(0);

		/************** get parameter 3, smoothing code ***************/
	m = 0;
	if(get_long(parsed[3],&m,&promptem,347,0,1))
		return(0);
			

		/****** execute function **************************************/
	if(!collecting_macro)
	{	if(vertex_thin(s,u,r,m))
			return(0);
	}

		/****** write command line ************************************/
	sprintf(raw_buf,"vertex_thin  %d  %d  %f  %d",s,u,r,m);

		/****** return ************************************************/
    return(1);
}
