/*******************************************************************************
*	viewM		(see manual, Command Ref., Function Manager)	<fm>   *
*			Checks input parameter (resolution) and queries user   *
*			if necessary.                                          *
*                                                                              *
*			Either calls view() or writes view command             *
*			line to the macro being built.                         *
*                                                                              *
*			Returns zero upon normal end-of-job (EOJ).             *
*******************************************************************************/
 
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include "../../incl/fc.h"
 
 
long viewM(parameters)
char *parameters;
{
	char parsed[3][STRLIST];
	char answer[STRLIST];

	long no_params;
	long view_code;
	long x,y;
	long no_xy;

		/******************* check for map loaded **********************/
	if(!job_stats[0])
	{	*raw_buf = 0;
		return(0);
	}

		/******************* clip parameters into separate strings *****/
	no_params = parse(trim(parameters),delim_buf,parsed,3);

		/******************* check for legal viewtype parameter ********/
	view_code = -1;     /*  default */
	if(no_params)
	{	switch(*parsed[0])  {
		case 'm':            /*  'map'  */
			view_code = 0;        
			break;
		case 'b':            /*  block  */
			view_code = 1;
			break;
		case 'f':            /*  full   */
			view_code = 2;
			break;
		case 'z':            /*  zoom   */
			view_code = 3;
			break;
		case 'l':            /*  last   */
			view_code = 4;
			break;
		}
	}
	if(view_code < 0)
	{	if(!batch_mode)
		{	message(prompt[209]);
			get_string(answer);
			view_code = 0;         /*  default  */
			if((*answer >= '0')   &&  (*answer <= '4'))
				view_code = (*answer) - '0';
		}
		else
		{	*raw_buf = 0;
			return(0);
		}
	}

		/******************* check for legal x & y *********************/
	x = 0;
	y = 0;
	if(no_params == 3)    /*   x and y value may be present  */
	{	if((!sscanf(parsed[1],"%d",&x))  ||  (!sscanf(parsed[2],"%d",&y)) )
			no_xy = 1;
		else
			no_xy = 0;
	}
	else
		no_xy = 1;

	if(no_xy  &&  !batch_mode && view_code)
	{	message("Enter view center position with cursor:");
		get_position(&x, &y);
	}

		/******************* set x & y on map **************************/
	x = (x < 0) ?  0 : x;
	x = (x > job_stats[1]) ?  job_stats[1] : x;
	y = (y < 0) ?  0 : y;
	y = (y > job_stats[2]) ?  job_stats[2] : y;

		/******************* execute view change ***********************/
	if(!collecting_macro)
	{	if(view_ltp(x,y,view_code))
		{	*raw_buf = 0;
			return(0);
		}
	}

		/******************* set raw_buf string ************************/
	switch(view_code)   {
	case 0:
		sprintf(raw_buf,"view map %d %d",x,y);
		break;
	case 1:
		sprintf(raw_buf,"view block %d %d",x,y);
		break;
	case 2:
		sprintf(raw_buf,"view full %d %d",x,y);
		break;
	case 3:
		sprintf(raw_buf,"view zoom %d %d",x,y);
		break;
	case 4:
		sprintf(raw_buf,"view last %d %d",x,y);
		break;
	}

		/******************* return ************************************/
    return(1);
}
