/*******************************************************************************
*     abort_cmd                                                                *
*         This program checks keyboard input for an escape (ascii 27) or a     *
*     delete (ascii 127).  If one of these is found, then a true (1) is        *
*     returned.   Otherwise a flase (0) is returned.                           *
*                                                                              *
*     parameters none                                                          *
*                                                                              *
*     globals modified  none here, but km.c modifies kb_buf                    *
*                                                                              *
*     Returned:      long   1   (if user has pressed an escape or delete)      *
*                           0   (if user has not pressed escape or delete)     *
*                                                                              *
*     J.Dabritz   9/9/89                                                       *
*******************************************************************************/

#include <string.h>
#include "../../incl/globals.h"

long abort_cmd()
{
	char escape = 27;
	char delete = 127;

	long i,j;

		/** check for graphics on **/
	if(batch_mode || !graphics_flag)
		return(0);

	
	i = km();
	j = kb_nxtwr;
	for(;j;)
	{	
		if(i)
		{	if((strchr(raw_buf,escape) != (char *) 0)  ||
			 (strchr(raw_buf,delete) != (char *) 0))
			{	message("abort command exection");
				return(1);
			}
		}
		else
		{	if((strchr(kb_buf,escape) != (char *) 0)  ||
			 (strchr(kb_buf,delete) != (char *) 0))
			{	message("abort command exection");
				return(1);
			}
		}
		i = km();
		if(j == kb_nxtwr)
			break;
		j = kb_nxtwr;
	}

	return(0);
}
