/*******************************************************************************
*    arr_rm_frame  (see manual, Command Ref., User Functions)    <fc>          *
*            This program duplicates the data from an import level onto the    *
*       map raster and/or attributes.  The import levels expected are 32,      *
*       33, or 34.                                                             *
*                                                                              *
*       files/globals changed:  all, if both are specified and the map is      *
*       assembled.                                                             *
*                                                                              *
*       values returned:  long 0= ok,  1=failure                               *
*                                                                              *
*       parameters:    long level  level number to be duplicated on the map    *
*                                  (32 - 34)                                   *
*                      long action Action to occur.  Zero indicates level is   *
*                                  to be erased, nonzero indicates level is to *
*                                  be drawn.                                   *
*                                                                              *
*            C. Jonson   12/19/89                                              *
*******************************************************************************/

#include "../../incl/globals.h"

long add_rm_frame(level,action)
	long level;
	long action;			/* 0 = erase, nonzero = draw */
{
	V_OBJECTS vobj;
	COORD_LIST vcoord;

	long i,v1,v2;
	long x1,y1,x2,y2;


		/************* check for map **********************************/
	if(!job_stats[0])
	{	message("You must CREATE or ACQUIRE a map before modifying raster.");
		return(1);
	}

	/************* duplicate objects onto raster **************/
	for(i=0; i < job_stats[17]; i++)
	{		/************* (search all v_objects, checking level & ****/
			/*************  drawing them onto the raster ) ************/
		if(get_vobjects(&vobj,i))
			return(1);
		if((vobj.type / 10) == level)
		{	if(vobj.v1 == vobj.v2)     /* node */
				continue;
			else			/** segment or polygon **/
			{	if(vobj.v1 < vobj.v2)
				{	v1 = vobj.v1;
					v2 = vobj.v2;
				}
				else                /** reverse order ***/
				{	v1 = vobj.v2;
					v2 = vobj.v1;
				}

				if(get_v_coord(&vcoord,v1))
					return(1);
				x1 = vcoord.x + 0.5;
				y1 = vcoord.y + 0.5;
				
				for(v1++; v1 <= v2; v1++)
				{	if(get_v_coord(&vcoord,v1))
						return(1);
					x2 = vcoord.x + 0.5;
					y2 = vcoord.y + 0.5;
					line_diag(x1,y1,x2,y2,action);

					x1 = x2;
					y1 = y2;
				}
			}
		}
	}

	return(0);
}
