/*******************************************************************************
*       answerisyes     (see manual, Internal Functions)                <in>   *
*           Display the specified prompt, gets an answer that can              *
*           be evaluated as yes or 1 or y or no or 0 or n.                     *
*                                                                              *
*           Parameters:  long prompt_no;      number of the prompt to display  *
*                        long default_answer; default answer: 0=N, 1=Y, 2=none *
*                                                                              *
*           Returns a 1 for yes and 0 for no.                                  *
*                       JPD 3/27/89                                            *
*******************************************************************************/

#include <string.h>
#include "../../incl/globals.h"


long answerisyes(prompt_no,default_answer)
	long int prompt_no;
	long default_answer;
{
	char string[STRLIST];
	long return_value;

		/*   check to see if grahpics are being used.  */
	if(batch_mode)
		return ((default_answer<1) ?  0:1);

		/*    check for legitimate input                */
	if(prompt_no < 0)
		return 0;

		/*   bug user until they answer with yes,y,1,no,n,or 0  */
	return_value = -1;
	for(; return_value < 0;)
	{ 	/*    display prompt                        */
		if( prompt_no )		/*** no msg if prompt 0 ***/
			message(prompt[prompt_no]);
			/*  display default, if any  */
		switch(default_answer)   {
		case 0:
			append_msg(" (dflt = NO)");
			break;
		case 1:
			append_msg(" (dflt = YES)");
			break;
		default:
			break;     /* no display if there is no default  */
		}
		
			/*  get answer  */
		trim(lowerc(get_string(string)));
		
			/*  evaluate for yes or no  */ 
		if(!strcmp("yes",string) || !strcmp("y",string) || !strcmp("1",string))
			return_value = 1;

		else if(!strcmp("no",string) || !strcmp("n",string) || !strcmp("0",string))
			return_value = 0;

		else if((default_answer==1)  ||  (default_answer == 0))
			return_value = default_answer;

		else
			append_msg("   you must answer 'y', 'yes', '1', 'n', 'no', or '0'");
	}
	
	return(return_value);
}
