/*******************************************************************************
*       arraytext       (see manual, Internal Functions)                <in>   *

     Purpose:	Places multiple lines of text on the screen
		from an array STRLIST bytes wide and lines long.
		Will only print that part of the text which falls on the
		screen.

     Arguments:	long row - starting text row (0 - 29) 
		long col - starting text column (0 - 79)
		long lines - number of lines in array
		char *ptr - pointer to beginning of text array.

     Returned Values: (long) 0

     Global Variables Modified:

*                      j.dabritz  3/7/89 - 5/8/89                              *
*******************************************************************************/


#include "../../incl/globals.h"
long disptext();      /*  (long row,col, char *string)               */


arraytext(row,col,lines,ptr)
long row;	/*  - starting text row (0 - 29)                          */
long col;	/*  - starting text column (0 - 79)                       */
long lines;	/*  - number of lines in array                            */
char *ptr;	/*  - pointer to beginning of text array.                 */
{
	long i;

	/* display each line of text    */
	for(i=0; (i<lines) ; i++)
		disptext(row+i,col,&ptr[i*STRLIST]);

	return  (long) 0;
}
