/*******************************************************************************
*       asgn_atrbt      (see manual, Internal Functions)                <in>   *
*    asigns an attribute to the input object number in the defined maner.      *
*    displays a message which includes the object number, serial & attribute.  *
*    Updates the vector display if attributed/non attributes vectors are       *
*    being displayed.                                                          *
*                                                                              *
*    Arguments:    long obj_no    object nubmer                                *
*                  long action:   0 = replace all previous attributes.         *
*                                 1 = replace first attribute                  *
*                                 2 = repalce second attribute                 *
*                                 3 = add new (additional) first attribute.    *
*                                 4 = prefix first exitsting attribute.        *
*                                 5 = suffix first exitsting attribute.        *
*                                 6 = add new (additional) last attribute.     *
*                                 7 = remove all attributes.                   *
*                                 8 = suffix second existing attribute         *
*                                 9 = suffix second existing attribute         *
*                  char *atstring   attribute string to assign.                *
*                                                                              *
*    Returned Values: (long) 0 = assigned attribute.                           *
*                            1 = didn't assign attribute                       *
*                                                                              *
*    Global Variables Modified:  none.                                         *
*                                                                              *
*                      j.dabritz  8/12/89                                      *
*******************************************************************************/

#include "../../incl/globals.h"
#include <string.h>


long asgn_atrbt(obj_no,action,atstring)
long obj_no, action;
char *atstring;
{
	OBJECTS object;
	ATTRIBUTES atr_rec;
	ATTRIBUTES attributes, atrbt2;

	long store_object;
	long rec2;
	long i,n;

	char dummy[STRLIST];
	char string[STRLIST];
	char string2[STRLIST];
	char plus_string[STRLIST];
	char *ptr;
	static char last_string[STRLIST];
							/** bit masks **/
	static unsigned long attribute =    (1 << 25);
	static unsigned long no_attribute = (1 << 26);
	static unsigned long attribute2 =   (1 << 27);
	static unsigned long no_attribute2 =(1 << 28);
	static unsigned long diff_atrbts =  (1 << 29);
	long flags;


		/********* make sure that there is a dummy rec in attributes rec 0 */
	if(job_stats[13] == 0)
	{	atr_rec.next = 0;
		atr_rec.string[0] = 0;
		if(put_atrbt(&atr_rec,job_stats[13]))
			return(1);
	}

		/********* assign attribute *************************************/
	if((obj_no >= 0)  && (obj_no < job_stats[10]))
	{		/**** get object record *****/
		if(get_objects(&object,obj_no))
			return(1);

			/********* convert $++ to incremental value, $serial, $record ***/
		if(action != 7)
		{	atstring[30] = (char) 0;
			strcpy(string,atstring);
				/************** check for $serial ****************************/
			for(;;)
			{	ptr = (char *) strstr(string,"$serial");
				if(ptr == (char *) 0)
					break;
				*ptr = (char) 0;
				ptr += 7;
				sprintf(string2,"%s%d%s",string,object.i12[1],ptr);
				strcpy(string,string2);
				string[30] = (char) 0;
			}

				/************** check for $record ****************************/
			for(;;)
			{	ptr = (char *) strstr(string,"$record");
				if(ptr == (char *) 0)
					break;
				*ptr = (char) 0;
				ptr += 7;
				sprintf(string2,"%s%d%s",string,obj_no,ptr);
				strcpy(string,string2);
				string[30] = (char) 0;
			}

				/************** check for $++ ********************************/
			for(i=0;;i++)
			{	ptr = (char *) strstr(string,"$++");
				if(ptr == (char *) 0)
					break;
				*ptr = (char) 0;
				ptr += 3;
				if(plus_plus < 0)
					plus_plus = 0;
				else if(plus_plus > 2000000000)
					plus_plus = 2000000000;
				if(plus_length > 30)
					plus_length = 30;
				sprintf(plus_string,"%30d",plus_plus);
				if(plus_length > 0)
				{	for(n=0; n<(30 - plus_length); n++)
						plus_string[n] = ' ';
					for(; (n<30) && (plus_string[n] == ' '); n++)
						plus_string[n] = '0';
				}
				trim(plus_string);
				sprintf(string2,"%s%s%s",string,plus_string,ptr);
				strcpy(string,string2);
				string[30] = (char) 0;
			}
				/************** if used, increment ++ ************************/
			if(i > 0)
				plus_plus++;

				/************** check for $mp ********************************/
			for(;;)
			{	ptr = (char *) strstr(string,"$mp");
				if(ptr == (char *) 0)
					break;
				*ptr = (char) 0;
				ptr += 3;

				sprintf(string2,"%s%5.2f%s",string,mile_post,ptr);
				ptr = string2 + strlen(string);
				for(; *ptr == (char) 32; ptr++)
					*ptr = '0';

				strcpy(string,string2);
				string[30] = (char) 0;
			}

			strcpy(last_string,string);
		}

			/**** get attribute record ****/
		if(object.i12[2])
		{	if(get_attr(&atr_rec,object.i12[2]))
				return(1);
			store_object = 0;
		}	
		else
		{	atr_rec.string[0] = 0;
			atr_rec.next = 0;
			store_object = 1;
		}
			/**** take action on attribute as indicated by parameter ****/
		switch(action)   {
		case 0:       /*** replace all ***/
			sprintf(atr_rec.string,"%s",string);
			atr_rec.next = 0;
			if(object.i12[2] == 0)
				object.i12[2] = job_stats[13];
			if(put_atrbt(&atr_rec,object.i12[2]))
				return(1);
			break;
		case 1:       /*** replace 1st ****/
			sprintf(atr_rec.string,"%s",string);
			if(object.i12[2] == 0)
				object.i12[2] = job_stats[13];
			if(put_atrbt(&atr_rec,object.i12[2]))
				return(1);
			break;
		case 2:       /*** replace 2nd ****/
			if(rec2 = atr_rec.next)     /** 2nd record exists, replace it **/
			{	if(get_attr(&atr_rec,rec2))
					return(1);
			}	
			else		/** new second record **/
			{	if(object.i12[2] == 0)       /* (no first attribute) */
				{		/*** store a dummy first attribute ***/
					sprintf(atr_rec.string,"dummy first attribute");
					object.i12[2] = job_stats[13];
					rec2 = atr_rec.next = job_stats[13] + 1;
					if(put_atrbt(&atr_rec,object.i12[2]))
						return(1);
				}
				else     /** there is a first attribute*/
				{		/** set new next ptr & re-store **/
					rec2 = atr_rec.next = job_stats[13];
					if(put_atrbt(&atr_rec,object.i12[2]))
						return(1);
				}
				atr_rec.next = 0;
			}
			sprintf(atr_rec.string,"%s",string);
			if(put_atrbt(&atr_rec,rec2))
				return(1);
			break;
		case 3:       /*** insert new first ****/
			sprintf(atr_rec.string,"%s",string);
			atr_rec.next = object.i12[2];
			object.i12[2] = job_stats[13];
			store_object = 1;
			if(put_atrbt(&atr_rec,object.i12[2]))
				return(1);
			break;
		case 4:       /*** prefix first ***/
			sprintf(dummy,"%s%s",string,atr_rec.string);
			dummy[30] = 0;
			sprintf(atr_rec.string,"%s",dummy);
			if(object.i12[2] == 0)
				object.i12[2] = job_stats[13];
			if(put_atrbt(&atr_rec,object.i12[2]))
				return(1);
			break;
		case 5:       /*** suffix first    ****/
			sprintf(dummy,"%s%s",atr_rec.string,string);
			dummy[30] = 0;
			sprintf(atr_rec.string,"%s",dummy);
			if(object.i12[2] == 0)
				object.i12[2] = job_stats[13];
			if(put_atrbt(&atr_rec,object.i12[2]))
				return(1);
			break;
		case 6:        /*** add new last attribute ***/
				/*** store new attribute record ***/
			sprintf(atr_rec.string,"%s",string);
			atr_rec.next = 0;
			if(put_atrbt(&atr_rec,job_stats[13]))
				return(1);
			  /******* store pointer to new attribute record ***/
			if(object.i12[2] == 0)               /** new attribute is first **/
			{	object.i12[2] = job_stats[13]-1;
				store_object = 1;
			}
			else                                 /* there are existing atrbts */
			{	atr_rec.next = object.i12[2];
				for(; atr_rec.next; )
				{	i = atr_rec.next;
					if(get_attr(&atr_rec,atr_rec.next))
						return(1);
				}
				atr_rec.next = job_stats[13]-1;
				if(put_atrbt(&atr_rec,i))
					return(1);

					/*** reset string for display **/
				sprintf(atr_rec.string,"%s",string);
			}
			break;
		case 7:       /*** remove all      ****/
			object.i12[2] = 0;
			store_object = 1;
			sprintf(atr_rec.string," - none -");
			break;
		case 8:       /*** prefix second ***/
		case 9:       /*** suffix second ***/
			if(rec2 = atr_rec.next)     /** 2nd record exists, prefix/suffix it **/
			{	if(get_attr(&atr_rec,rec2))
					return(1);
				if(action == 8)  /** prefix **/
					sprintf(dummy,"%s%s",string,atr_rec.string);
				else                   /** suffix **/
					sprintf(dummy,"%s%s",atr_rec.string,string);
				dummy[30] = 0;
				sprintf(atr_rec.string,"%s",dummy);
			}	
			else		/** new second record **/
			{	if(object.i12[2] == 0)       /* (no first attribute) */
				{		/*** store a dummy first attribute ***/
					sprintf(atr_rec.string,"dummy first attribute");
					object.i12[2] = job_stats[13];
					rec2 = atr_rec.next = job_stats[13] + 1;
					if(put_atrbt(&atr_rec,object.i12[2]))
						return(1);
				}
				else     /** there is a first attribute*/
				{		/** set new next ptr & re-store **/
					rec2 = atr_rec.next = job_stats[13];
					if(put_atrbt(&atr_rec,object.i12[2]))
						return(1);
				}
				atr_rec.next = 0;
				sprintf(atr_rec.string,"%s",string);
			}
			if(put_atrbt(&atr_rec,rec2))
				return(1);
			break;
		}

			/*** update object sets 25-29 ***/
			/******* set flags 25-29 according to criteria ******/
		flags = object.i12[4] & ~(63 << 25);

	
			/** next, set bit flag 25 or 26 according to first attribute **/
		if(object.i12[2])        /** object has attribute **/
		{		/** turn bit 25 on & 26 off **/
			flags |= attribute;
		}
		else
		{		/** turn bit 25 off & 26 on **/
			if(flags & 1)
				flags |= no_attribute;
		}
	
	
			/** set flag 29 'on' as a default **/
		if(flags & 1)
			flags |= diff_atrbts;
	
			/** next, set bit flag 27 or 28 according to second attribute **/
		if(object.i12[2])        /** object has attribute **/
		{	if(get_attr(&attributes,object.i12[2]))
				return(1);
			else if(attributes.next)
			{		/** turn bit 27 on & 28 off **/
				flags |= attribute2;
					/**** if it has 2 identical attributes turn flag 29 off ***/
				if(get_attr(&atrbt2,attributes.next))
					return(1);
				if(!strcmp(attributes.string,atrbt2.string))
					flags &= ~diff_atrbts;
			}
			else
			{		/** turn bit 27 off & 28 on **/
				if(flags & 1)
					flags |= no_attribute2;
			}
		}
		else
		{		/** turn bit 27 off & 28 on **/
			if(flags & 1)
				flags |= no_attribute2;
		}
	
			/*********** now, check this (flags) agaist object.i12[4] ***/
		if(flags != object.i12[4])   /* if true, then there have been changes */
		{	object.i12[4] = flags;
			store_object = 1;
		}
	
			/*** store object record if necessary **/
		if(store_object)
		{	if(put_objects(&object,obj_no))
				return(1);
		}
			/**** display message ***/
		sprintf(string,"  object no: %d,   serial: %d,    attribute:  %s",
		                   obj_no,object.i12[1],atr_rec.string);
		message(string);


			/********* update vector display ***/
		if((disp_normal | disp_hglight) & (31 << 25)) /* atrbt objs displayed */
		{	if(display_obj(1,obj_no))
				return(1);
		}
	}
	else
		return(1);

		/********* update attribute flag ********************************/
	if(job_stats[44] < job_stats[45])
	{	job_stats[45]++;
		job_stats[44] = job_stats[45];
	}

		/********* return ***********************************************/
	return(0);
}
