/*******************************************************************************
*       atrbt_xy        (see manual, Internal Functions)                <in>   *
*    Finds objects using the input x,y location & search radius.  Assigns      *
*    the input attribute string in the prescribed manner to that object.       *
*                                                                              *
*    Arguments:    float x,y,r:   raster coordinates and search radius.        *
*                                 (search radius used for segs & nodes)        *
*                  long otype:    0 = node,  1 = segment,  2 = polygon         *
*                  long action:   see lists.h include file.                    *
*                                                                              *
*    Returned Values: (long) 0 = found object & assigned attribute.            *
*                            1 = didn't assign attribute                       *
*                                                                              *
*    Global Variables Modified:  none.                                         *
*                                                                              *
*                      j.dabritz  8/9/89                                       *
*******************************************************************************/

#include "../../incl/globals.h"

long atrbt_xy(x,y,r,otype,action)
float x,y,r;
long otype, action;
{	
	long obj_no;

		/********* check for map ****************************************/
	if(!job_stats[0])
	{	message("no current map.");
		return(1);
	}


		/********* check for objects ************************************/
	if(!job_stats[10])
	{	message("Map has not been assembled.  There are no objects to assign attributes.");
		return(1);
	}

		/********* find object ******************************************/
	switch(otype)     {
	case 0:           /** nodes ***/
		obj_no = find_vnode(x,y,r,31);
		break;
	case 1:           /** segments  */
		obj_no = find_vseg(x,y,r,31);
		break;
	case 2:           /** polygons  */
		obj_no = find_vpoly(x,y,31);
		break;
	default:
		return(1);
	}

		/********* assign attribute *************************************/
	if(obj_no < 0)
		message("No object found.");
	else
		asgn_atrbt(obj_no,action,atrbt_string);

		/********* return ***********************************************/
	return(0);
}
