/* This function re-orders the bits in a byte.  It is used to put
   data into the format that the XCreateBitmap function requires.

   Bits are re-ordered by the following map:
    O      7  -->  0
    r      6  -->  1
    i      5  -->  2    N
    g      4  -->  3    e
    i      3  -->  4    w
    n      2  -->  5
    a      1  -->  6
    l      0  -->  7

DBS@CWU 6/92

*/

long bit_swap(ptr, length)
  char *ptr;
  long length;
{
  register int mask;
  register int c, t;

  while(length--) {
    mask = 0x01;
    c = 0;
    t = *ptr;

    c = c | ((t & mask) << 7);
    mask = mask << 1;
    c = c | ((t & mask) << 5);
    mask = mask << 1;
    c = c | ((t & mask) << 3);
    mask = mask << 1;
    c = c | ((t & mask) << 1);
    mask = mask << 1;
    c = c | ((t & mask) >> 1);
    mask = mask << 1;
    c = c | ((t & mask) >> 3);
    mask = mask << 1;
    c = c | ((t & mask) >> 5);
    mask = mask << 1;
    c = c | ((t & mask) >> 7);

    *ptr++ = (char) c;
  }
}
