/*******************************************************************************
*       bitmap          (see manual, Internal Functions)                <in>   *
		bitmap(byte_width,lines,from_incr,to_incr,from_ptr,to_ptr)

     Purpose:	Copies portions of rasters to other rasters.  Must start 
		and end on byte boundries.
		(Transfers multiple lines of byte_width bytes from from_ptr
		to ptr 2, incrementing pointers by from_incr and to_incr.)

     Arguments:	long byte_width - byte width of array portion to be copied
		long lines - number of lines in array portion to be copied
		long from_incr - increment value of 'from' array (byte width)
		long to_incr - increment value of 'to' array (byte width)
		char *from_ptr - pointer to 'from' array portion to be copied
		char *to_ptr - pointer to 'to' array portion to be targeted

     Returned Values: (long) 0

     Global Variables Modified:  - none -

*                      j.dabritz  3/7/89 - 5/8/89                              *
*******************************************************************************/

#include <string.h>
#include "../../incl/globals.h"


long bitmap(byte_width,lines,from_incr,to_incr,from_ptr,to_ptr)
long byte_width,lines,from_incr,to_incr;
char *from_ptr, *to_ptr;
{	
	if((lines <= 0) || (byte_width <= 0))
		return (long) 0;

	for(; lines > 0 ; lines--, from_ptr += from_incr, to_ptr += to_incr)
		memcpy(to_ptr,from_ptr,byte_width);


	return (long) 0;
}
