/*******************************************************************************
   bitmap4x 
	bitmap4x(width,height,src_x,src_y,src,dest_x,dest_y,dest)

     Purpose:	Copies portions of one X drawable to the destination
		drawable.

     Arguments:	long width - pixel width of drawable portion to be copied
		long height - pixwl hieght of drawable to be copied
		long src_x, src_y - x,y coordinates in source drawable
		Drawable src -  the source drawable
		long dest_x, dest_y - x,y coordinates in the destination
		Drawble dest - destination drawable

     Returned Values: (long) 0

     Global Variables Modified:  - none -

     DBS@CWU 5/92
*******************************************************************************/

#include "../../incl/globals.h"
#include "../../incl/x11.h"


long bitmap4x(width,height,src_x,src_y,src,dest_x,dest_y,dest)
long width, height, src_x, src_y, dest_x, dest_y;
Drawable src, dest;
{	
	if((height <= 0) || (width <= 0))
		return (long) 0;


	XCopyArea(xdisplay, src, dest, xgccopy, src_x, src_y, width, height, dest_x, dest_y);

	return (long) 0;
}
