/*******************************************************************************
*	changes     (see manual, Internal Functions)            	<in>   *
*	               Determines if changes have been made on the current map *
*               since the last save/load/create.                               *
*                                                                              *
*			Globals Modified:                                      *
*			        none                                           *
*                                                                              *
*			Returns  = 0 if no changes found                       *
*			           1 if changes have been made                 *
*******************************************************************************/
/* fixed typo "macro_bein" changed to "macro_begin" 5/92 DBS@CWU */

#include <string.h>
#include "../../incl/globals.h"

long changes()
{
	char string[256];
	long i,j;
	long begin, done, hit;
	long changed;

	static char *endfunction[] = {"acquire", "create", "save", ""};
	static char *ok_function[] = {"func_" , "menu" , "digmenu" , "stickup"
		, "ckeys" , "backup" , "catalog" , "purge" , "rename"
		, "retrieve" , "coord_type" , "ginput" , "graphics","set_dig"
		, "redisp_map" , "goto" , "step" , "view" , "edge_"
		, "query" , "b_edit" , "fix_map" , "mass_update", "level_icopy"
		, "mlist_create" , "next_step", "p_create" , "area_plot"
		, "pers_plot" , "plot" , "report", "erase_obj", "vertex_move"
		, "macro_begin" , "macro_hist" , "macro_end" , "wink"
		, "atrbt_contur", "atrbt_dig", "connect", "draw", "erase"
		, "erase_seg", "separate", "pause", "wait", "config", "default_head"
		, "recall", "crit_clear", "crit_type", "crit_slen", "crit_serial"
		, "crit_record", "crit_psides", "crit_newatr", "crit_length"
		, "crit_astrg", "crit_area", "crit_arange", "crit_adj"
		, "crit_subel", "crit_superel", "crit_report", "set_report" 
		, "shell",  "dem_view", "dict_edit", "dict_print", "macro_edit"
		, "seg_break", "bridge_gap", "atrbt_line", "plus_plus", "atrbt_copy"
		, "atrbt_list", "more", "mlist_exec", ""  };

	
		/*  check to see if a map is loaded  */
	if(!job_stats[0])
		return (0);

	/*  check history file back until a map file has been altered, or
				the map was saved, loaded, or created, or
				the history file is null, or
				the history file is exhausted.               */
	changed = 0;
	begin = (next_hist + 511) % 512;
	done = -1;
	for(i=begin; (done != 1) && !changed  ; i=(i+511)%512 )
	{		/* check for null or exhausted string */
		if(*(history[i]) == 0)
			done = 1;
		else if(i == begin) /* check for a complete loop          */
		{	done ++;
			if(done == 1)     /** assume changes on a full wrap **/
				changed = 1;
		}

			/* check for acquire, create, save  */
		history[i][STRLIST -1] = (char) 0;
		parse(history[i],delim_buf,string,1);

		if(done != 1)
		{	for(hit=0, j=0; !hit && *(endfunction[j]); j++)
			{	if(!strncmp(string,endfunction[j],strlen(endfunction[j])))
					done=1;
			}
		}

			/******* check for any function which changes the map file ****/
		if(done != 1)
		{		/****** ignore comments, lines that begins with '#' *****/
			if(*string != '#')
			{		/* check for an 'ok' function, one that does not change
						the map file.                                */
				for(hit=0, j=0; !hit && *(ok_function[j]); j++)
				{	if(!strncmp(string,ok_function[j],STRLIST))
						hit=1;
				}
					/* check for menu changes */
				for(j=0; !hit  &&  j<19; j++)
				{	if(!strncmp(string,menu_name[j],STRLIST))
						hit=1;
				}
				/* otherwise assume that a change has been made  */
				if(!hit)
					changed = 1;
			}
		}
	}

	return (changed);
}
