/*******************************************************************************
*       choose_level    (see manual, Internal Functions)                <in>   *
*           allow the user a choice of levels in the range specified.          *
*           returns the error number or -1 for error.                          *
*                                                                              *
*           Returns the item number of the answer,  or -1 for failure.         *
*                       JPD 3/27/89                                            *
*******************************************************************************/
/* Modified 5/92 by DBS@CWU for X11 support */

#include <string.h>
#include "../../incl/globals.h"
#ifdef LTP_X11
#include "../../incl/x11.h"
#endif

char *trim();  
#ifndef LTP_X11
long bitmap();
#else
long bitmap4x();
#endif
long bar_off();
long swplane();
long maxl();
char *get_string();
long disptext();
long message();

long choose_level(first_level,last_level,prompt_no)               
	long first_level,last_level;        /* range of levels to choose from */
	long int prompt_no;
{

	long i,begin,choice,end,next,max_length,items,fit;
	long col_incr,list_col,row,n,col;
	long save_dctype;
	long save_cmode;
	long save_cx, save_cy;

	char *list_ptr;
	char string[STRLIST], *ptr;


		/*   check to see if grahpics are being used.  */
	if(batch_mode)
		return 0;

		/*    check for legitimate input                */
	if((prompt_no < 0) ||  (first_level > last_level)  || (last_level < 0) || (first_level > 95))
		return -1;

		/*    save graphics for redisplay later & clear screen   */
	save_dctype = disp_coord_type;
	disp_coord_type = -1;         /*  no coord display  */
	save_cmode = cursor_mode;
	cursor_mode = 0;        /* cross hair  */
	save_cx = ginfo.scoord[0];
	save_cy = ginfo.scoord[1];
	cursor(-200, -200);            /*  take cursor off screen  */
	for(i=0; i<4; i++)
	{	swplane(i);
#ifndef LTP_X11
		bitmap(BITPLN_WIDTH,415,BITPLN_WIDTH,BITPLN_WIDTH,vga_plane,scratch_pad[i]);
#else
		bitmap4x(WIDTH, 415, 0, 0, xmainwin, 0, 0, xmainpix);
#endif
		bar_off(0,0,639,414);
	}
	cursor(save_cx,save_cy);       /*  place cursor back on screen  */

		/*    loop through list displays on screen  */
	list_ptr = level_names[0];
	for(begin=first_level, choice = -1;  choice == -1;  begin = end+1)
	{		/*  check & set begin          */
		if(begin > last_level)
			begin = first_level;

			/*    display prompt                        */
		message(prompt[prompt_no]);

			/*	find first/last item to display & rows   */
		max_length = 0;
		for(next = begin, fit=1;  fit ;  next++)
		{	if(next > last_level)
				fit = 0;
			else
			{ 	ptr = list_ptr + next*STRLIST;
				max_length = maxl(2, (long) strlen(ptr), max_length);
				items = next - begin + 1;
				if(items > 100)
					fit = 0;
				else if(items > 75)
				{	if(max_length > (20-7))
						fit = 0;
				}
				else if(items > 50)
				{	if(max_length > (26-7))
						fit = 0;
				}
				else if(items > 25)
				{	if(max_length > (40-7))
						fit = 0;
				}
			}

			if(!fit)
				end = next-1;
		}

			/*  erase old text                                     */
		swplane(3);
		bar_off(0,0,639,414);

			/*  display list                                       */
		items = end - begin + 1;
		if(items > 75)
			col_incr = 20;
		else if(items > 50)
			col_incr = 26;
		else if(items > 25)
			col_incr = 40;
		else 
			col_incr = 80;
		for(i=0 ; i<items ; i++)
		{	list_col = i/25;
			col = list_col * col_incr;
			row = i % 25;
			ptr = list_ptr + (begin+i)*STRLIST;
			sprintf(string,"%3d. %s", (begin+i) , ptr);
			disptext(row,col,string);
		}

		/*  display message below list to press return for more (if needed)*/
		if((begin != first_level) || (end != last_level))
			disptext(25,0,"Press [RETURN] to view the next portion of the list.");

			/*  get answer  */
		for(;;)
		{	if(km() > 0)                  /******* check for keyboard input */
			{	strcpy(string,raw_buf);
				trim(string);
				for(ptr = string, n=0; (*ptr >= '0') && (*ptr <= '9'); ptr++)
					n = n*10 + ((*ptr) - '0');
				if(ptr != string)
				{	if((n >= first_level) && (n <= last_level))
						choice = n;
				}
				break;
			}
			if(gr_dev)
			{	if(gi() >= 0)              /******* check for graphics input */
				{	if(*cursor_keys[ginfo.button])
					{	row = ginfo.scoord[1] / 16;
						if(row < 25)
						{	col = ginfo.scoord[0] / 8;
							col = col / col_incr;
							choice = begin + 25 * col + row;
							if((choice >= 0) && (choice <= end))
								break;
						}
						else
							break;
					}
				}
			}
		}
	}

		/*   reset screen     */
	for(i=0; i<4; i++)
	{	swplane(i);
#ifndef LTP_X11
		bitmap(BITPLN_WIDTH,415,BITPLN_WIDTH,BITPLN_WIDTH,scratch_pad[i],vga_plane);
#else
		bitmap4x(WIDTH, 415, 0, 0, xmainpix, 0, 0, xmainwin);
#endif
	}
	disp_coord_type = save_dctype;
	cursor_mode = save_cmode;
	cursor(ginfo.scoord[0], ginfo.scoord[1]);

		/*   return           */
	return choice;

}
