/*******************************************************************************
*       choose_map      (see manual, Internal Functions)                <in>   *
*           Display all current map names and prompt the user to               *
*           select 1.  (or none).                                              *
*                                                                              *
*           Returns the string containing the chosen map name (or null).       *
*                       JPD 3/27/89                                            *
*******************************************************************************/

#include "../../incl/globals.h"
#define LISTLENGTH 1024
long list_choice();


char *choose_map(map)
char *map;
{
	char list[LISTLENGTH][STRLIST];
	char name[256], *temp_name,*ptr; 
	long a, i, n;

		/***********   set default map name   */
	map[0] = 0;     /*  set to null */

		/***********   check for batch_mode   */
	if(batch_mode)
		return(map);

		/***********   get list of all existing maps  */
	n = dir_list(maps_path,list[1],LISTLENGTH-1);
	if(n == 0)
	{	append_msg("  << at least 1 map must be created first.");
		return(map);
	}
	if(n < 0)
	{	message("maps directory must be created and listed in the config/config file.");

		return(map);
	}


		/***********  remove current temp map name from list if present */
	if(*temp_map_path  &&  job_stats[0])
	{	strcpy(name,temp_map_path);            /*  find name of temp  */
		for(ptr = name; *ptr; ptr++)
		{	if(*ptr == '/')
				temp_name = ptr +1;
		}
		for(i=1; i<=n; i++)                    /*  find name on list */
		{	if(!strcmp(temp_name,list[i]))
				break;
		}
		if(i<=n)
		{	for(; i<n; i++)
				strcpy(list[i],list[i+1]);
			n = n-1;
		}
	}


		/***********  add choice 'none' to list of all existing maps  */
	strcpy(list[0]," - none -");

		/***********   have user make selection                        */
	a = list_choice(list[0],n+1,80);

		/***********   check selection   */
	if(a)
	{	append_msg("   ");
		strcpy(map,list[a]);
		append_msg(map);
	}
	else
		append_msg("   none chosen.");

	return(map);
}
