/*******************************************************************************
*	clipl         (see manual, Internal Functions)            	<in>   *
*	    		clips line segments to a window.                       *
*           This program clips longs, use clipf to clip floats.                *
*                                                                              *
*			Globals Modified:  none                                *
*                                                                              *
*			Returns 1 if segment is entirely outside window.       *
*			        0 if part or all of segment is in window       *
*              J.dabritz  7/10/89                                              *
*******************************************************************************/

#include "../../incl/globals.h" 

long clip_code();


long clipl(x1,y1,x2,y2,left,right,bottom,top)
long  *x1, *y1, *x2, *y2;        /* endpoints of segment to be clipped.  */
long left, right, bottom, top;   /* limits of window to clip at.         */
{
	float fx1,fy1,fx2,fy2;
	long return_val;

		/********* use clipf to do calculations ************/
		/********* switch input to floats ******************/
	fx1 = *x1;
	fy1 = *y1;
	fx2 = *x2;
	fy2 = *y2;

		/********* call cliplf to do calculations **********/
	return_val = clipf(&fx1, &fy1, &fx2, &fy2, left, right, bottom, top);

		/********* reset input values (add .5 to get rounding) **********/
	*x1 = 0.4999999 + fx1;
	*y1 = 0.4999999 + fy1;
	*x2 = 0.4999999 + fx2;
	*y2 = 0.4999999 + fy2;
	
		/********* return *********************************/
	return(return_val);
}
