/*******************************************************************************
*       cnvrt_bslash    (see manual, Internal Functions)                <in>   *
*                       This program reads the input string and converts       *
*                       backslash sequences as follows:                        *
*                         ( n represents a digit 0 through 9 )                 *
*                       \\    converts to \                                    *
*                       \nnn  converts to ascii decimal char  nnn (unsigned)   *
*                       \nn   converts to ascii decimal char  nn (unsigned)    *
*                       \n    converts to ascii decimal char  n (unsigned)     *
*                                                                              *
*                       No globals or files changed.                           *
*                                                                              *
*                       Returns the string passed.                             *
*                      j.dabritz  6/22/89                                      *
*******************************************************************************/

#include "../../incl/globals.h"  /*  <stdio.h> & all LTP defines & globals  */

char *cnvrt_bslash(string)
char *string;
{
	char *ptr, *ptr2;
	long n, digits;

		/*  convert \n & \nn & \nnn & \\ groups in string  */
	for(ptr=string; *ptr; ptr++)
	{	if(*ptr == 92)
		{		/*  convert '\\' groups to '\'   */
			if(*(ptr+1) == 92)     /*   '\\' found, reduce to '\'  */
			{	for(ptr2=ptr+1; *(ptr2) ; ptr2++)
					*ptr2 = *(ptr2 + 1);
			}
				/*  convert '\n' & '\nn' & '\nnn' to decimal ascii */
			else if((*(ptr+1) >= '0')  &&  (*(ptr+1) <= '9'))
			{	n = (*(ptr+1)) - '0';
				digits = 1;
				if((*(ptr+2) >= '0')  &&  (*(ptr+2) <= '9'))
				{	n = 10 * n + (*(ptr+2)) - '0';
					digits = 2;
					if((*(ptr+3) >= '0')  &&  (*(ptr+3) <= '9'))
					{	n = 10 * n + (*(ptr+3)) - '0';
						digits = 3;
					}
				}
				*ptr = (n % 256);
				for(ptr2=ptr+1; *(ptr2 - 1) ; ptr2++)
					*ptr2 = *(ptr2 + digits);
			}
		}
	}

	return(string);

}
