/************************************************************

		colorvga(index,color)

     Purpose:	Switches colors

     Arguments:	index - number (0-15) of color to change
		color - number of color to switch to in
			format RGBrgb

     Returned Values: (long) 0

     Global Variables Modified: - none -

************************************************************/
/* Modified 5/92 by DBS@CWU for X11 support */

#include "../../incl/globals.h"

#ifndef LTP_X11   /***** first the VGA code *****/

#ifndef SV32				/*  For XENIX 2.3 or later  */
#include "malloc.h"
#include <sys/ioctl.h>
#include <memory.h>
#endif

#ifdef SCO_UNIX
#include <sys/machdep.h>
#endif


long colorvga(index,color)
long index,color;
{
	struct port_io_arg pia;

		/*   check to see if grahpics are being used.  */
	if(batch_mode)
		return 0;

 	pia.args[0].dir = IN_ON_PORT;
	pia.args[0].port = 0x3da;
 	pia.args[1].dir = OUT_ON_PORT;
	pia.args[1].port = 0x3c0;
	pia.args[1].data = index;
 	pia.args[2].dir = OUT_ON_PORT;
	pia.args[2].port = 0x3c0;
	pia.args[2].data = color;
	pia.args[3].port = 0;
 	pia.args[3].dir = OUT_ON_PORT;
	pia.args[3].port = 0x3c0;
	pia.args[3].data = 32;
#ifdef SV32			/*  For AT&T System V 3.2 ver 2.1 or later  */
        ioctl(fdvga,EGAIO,&pia);
#else				/*  For XENIX 2.3 or later  */
        ioctl(fdvga,VGAIO,&pia);
#endif

	return(0);
}

#else     /***** now the X11 code *****/

#include "../../incl/x11.h"

#define GET_RED(x)   (65*((x & 0x20) != 0) + 185*((x & 0x04) != 0) - 0*((x & 0x24) != 0))
#define GET_GREEN(x) (65*((x & 0x10) != 0) + 185*((x & 0x02) != 0) - 0*((x & 0x12) != 0))
#define GET_BLUE(x)  (65*((x & 0x08) != 0) + 185*((x & 0x01) != 0) - 0*((x & 0x09) != 0))

long colorvga(index,color)
long index,color;
{
  XColor xcolor;

  /*   check to see if graphics are being used.  */
  if(batch_mode || !graphics_flag)
    return 0;
  
  xcolor.red = GET_RED(color)<<8;
  xcolor.green = GET_GREEN(color)<<8;
  xcolor.blue = GET_BLUE(color)<<8;
  xcolor.pixel = index;
  xcolor.flags = (DoRed | DoGreen | DoBlue);

  XStoreColor(xdisplay, xcolormap, &xcolor);

  return (0);
}

#endif   /***** end of VGA code *****/
