/*******************************************************************************
*   copy_dir       (see manual, Internal Functions)                <in>        *
*      This program copies a directory of files and checks the copy to be      *
*  sure that everything is there.                                              *
*                                                                              *
*  Parameters:     char *fromdir;    directory from which to copy              *
*                  char *todir;      NEW directory to which to copy            *
*                                                                              *
*  Values returned:   0 = copy complete & ok,  1=copy failed or incomplete.    *
*                                                                              *
*   J.Dabritz      3/14/90                                                     *
*******************************************************************************/
/* Modified 5/92 by DBS@CWU for ULTRIX support */

#include "../../incl/globals.h"


long copy_dir(fromdir,todir)
	char *fromdir, *todir;
{	
	char list1[100][STRLIST];
	char list2[100][STRLIST];
	char string[256];
	char error[256];

	long n1,n2;
	long i,j;


		/************* attempt to copy directory *********************/
/* #if ULTRIX */
	sprintf(string,"%s %s/* %s",COPY_CMD, fromdir,todir);

	if(system_ltp(string))
	{	sprintf(error,"copy command \"%s\" failed.",string);
		message(error);
		sprintf(string,"rm -r %s",todir);
		system_ltp(string);
		return(1);
	}

		/************* get list of from directory (1) ****************/
	n1 = dir_list(fromdir,list1[0],100);
	if(n1 < 0)
	{	sprintf(error,"cannot catalog directory %s, copy failed.",fromdir);
		message(error);
		sprintf(string,"rm -r %s",todir);
		system_ltp(string);
		return(1);
	}

		/************* get list of to directory (2) ******************/
	n2 = dir_list(todir,list2[0],100);
	if(n2 < 0)
	{	sprintf(error,"cannot catalog directory %s, copy failed.",todir);
		message(error);
		sprintf(string,"rm -r %s",todir);
		system_ltp(string);
		return(1);
	}

		/************* compair lists *********************************/
	if(n1 != n2)
	{	message("directories have unequal number of elements, copy failed.");
		sprintf(string,"rm -r %s",todir);
		system_ltp(string);
		return(1);
	}

	for(i=0; i<n1; i++)
	{	for(j=0; j<n2; j++)
		{	if(!strcmp(list1[i],list2[j]))
				break;
		}
		if(j >= n2)
		{	sprintf(error, "file %s did not copy, copy failed.",list1[i]);
			message(error);
			sprintf(string,"rm -r %s",todir);
			system_ltp(string);
			return(1);
		}
	}

		/************* return ****************************************/
	return(0);
}
