/*
 * This function copies a file from the original path to the new path.
 *     copy_file(orig_path, name, new_path)
 *        char *orig_path, *name, *new_path;
 *     Returns: 0 if it fails
 *
 * by David B. Satnik CWU GIS Lab
 */

#ifdef MULTIUSER

#include "../../incl/globals.h"

long copy_file(orig_path, name, new_path)
       char *orig_path, *name, *new_path;
{
  char command[1024];
  int ret;

  if (!file_exists(new_path,"")) { /* destination directory doesn't exist! */
    sprintf(command, "mkdir -p %s", new_path);
    ret = system_ltp(command);
  }

  sprintf(command, "cp %s/%s %s/%s", orig_path, name, new_path, name);
  ret = system_ltp(command);

  return (!ret);
}

#endif
