/*******************************************************************************
*       crlftext        (see manual, Internal Functions)                <in>   *

     Purpose:	Places multiple lines of text on the screen
		from a buffer with the different lines of
		text seperated by CRLF.  Only the portion of the text which
		falls on the screen will be printed.

     Arguments:	long row - starting row
		long col - starting column 
		char *ptr - pointer to text string

     Returned Values: (long) 0

     Global Variables Modified:   - none - 

*                      j.dabritz  3/7/89 - 5/8/89                              *
*******************************************************************************/

#include <string.h>
#include "../../incl/globals.h"


long disptext();     /* (long row,col,  char *ptr)          */
long maxl();


long crlftext(row,col,ptr)
long row,col;
char *ptr;
{	char *p0, *p, *pend;
	long lf, lastlf;
	long cr, lastcr;

		/* set pend pointer to null at end of string  */
	pend = ptr + strlen(ptr);

		/* look through string setting cr or lf to null & printing */
	lf = 0;
	lastlf = 0;
	cr = 0;
	lastcr = 0;
	for(p0=ptr, p=ptr; p<=pend; p++)
	{	if((*p == 10) || (*p == 13) || (*p == 0))
		{	if(*p == 10)      /*  count linefeeds  */
			{	lf++;
				if((lf - lastlf) > 1)
					row++;
			}
			if(*p == 13)      /*  count carriage returns  */
			{	cr++;
				if((cr - lastcr) > 1)
					row++;
			}
			*p = 0;     /* change cr or lf to null           */
			     /* if parsed string has length, print it    */
			if(p0 != p)
			{	disptext(row++,col,p0);
				lastlf = lf;	/*  reset lastlf counter */
				lastcr = cr;    /*  reset lastcr counter */
			}
			p0 = p +1; /* reset parsed string pointer to next char*/
		}
	}

	return (long) 0;
}
