/*******************************************************************************
*     dig_set         (see manual, Command Ref., User Functions)      <fc>     *
*                                                                              *
*         adds to or removes from a set by digitized entry.                    *
*                                                                              *
*         Parameters:    long x,y;     coords near object to be added.         *
*                                                                              *
*         globals changed:  objects file                                       *
*                                                                              *
*         Returns 0 upon normal execution, 1 otherwise                         *
*             J.Dabritz  7/17/90                                               *
*******************************************************************************/

#include "../../incl/globals.h"


long dig_set(x,y)
	long x,y;
{	
	OBJECTS object;

	long i;
	long mask;
	long obj_no;

	float fx,fy,r;


		/*********** check for map *************************************/
	if(!job_stats[0])
	{	message("You must Create or Acquire a map befor creating sets of objects.");
		return(1);
	}

		/*********** check entry level *********************************/
	if((!entry_level)  ||  (entry_level < -24)  ||  (entry_level > 24))
	{	message("Set number must be in range (+-) 1-24.");
		return(1);
	}

		/*********** set mask ******************************************/
	i = (entry_level > 0) ? entry_level : -entry_level;
	mask = 1 << i;

		/*********** find object ***************************************/
	fx = x;
	fy = y;
	r = (float) search_radius;
	switch(atrbt_otype)     {
	case 0:           /** nodes ***/
		obj_no = find_vnode(fx,fy,r,0);
		break;
	case 1:           /** segments  */
		obj_no = find_vseg(fx,fy,r,0);
		break;
	case 2:           /** polygons  */
		obj_no = find_vpoly(fx,fy,0);
		break;
	default:
		return(1);
	}

		/*********** add to, or delete from set ************************/
	if(obj_no >= 0)
	{		/********** get object *******************************/
		if(get_objects(&object,obj_no))
			return(1);

			/********** remove from display **********************/
		display_obj(0,obj_no);

			/********** change set *******************************/
		if(entry_level < 0)
			object.i12[4] &=  ~mask;
		else
			object.i12[4] |= mask;

			/********** put object *******************************/
		if(put_objects(&object,obj_no))
			return(1);

			/********** display object ***************************/
		display_obj(1,obj_no);
	}
	else
		message("No object found.");


		/*********** return ********************************************/
	return(0);
}
