/*******************************************************************************
*       disp_object     (see manual, Internal Functions)                <in>   *
*                                                                              *
*    Purpose:    Checks one map object vs the display globals disp_normal      *
*       and disp_hglight.  The returned variable is bit coded as to the        *
*       display type of the object (see below)                                 *
*                                                                              *
*    Arguments:    long object_no;                                             *
*                                                                              *
*    Returned Values: (long) display_code:  0 = none                           *
*                                           1 = normal only                    *
*                                           2 = highlight only                 *
*                                           3 = both highlight & normal        *
*                                                                              *
*    Global Variables Modified: none                                           *
*    Files modified           : none                                           *
*                                                                              *
*                      j.dabritz  8/14/89                                      *
*******************************************************************************/

#include "../../incl/globals.h"

long disp_object(obj_no)
long obj_no;
{
	OBJECTS object;
	long ret_val;


		/*********** check for map loaded ****************************/
	if(!job_stats[0])
		return(0);

		/*********** get object record ***************************/
	if(get_objects(&object,obj_no))
		return(0);


		/*********** now, check this (.i12[4]) against *************/
		/***  the disp_ globals **/
	if(disp_normal & object.i12[4])     /**	 include in normal vec. disp **/
		ret_val = 1;
	else
		ret_val = 0;

	if(disp_hglight & object.i12[4])   /** include in hglight vec. disp **/
		ret_val |= 2;    /** turn bit on **/


		/*********** if segment, check polygons on either side ***/
	if((object.i12[0] >= 8)  && (object.i12[0] < 14) && 
	 job_stats[7]  &&  (map_type & 4))
	{	if(object.i12[7])     /** add display attributes of rt poly */
			ret_val |=  disp_object(object.i12[7]);
		if(object.i12[8])     /** add display attributes of lt poly */
			ret_val |=  disp_object(object.i12[8]);
	}

		/******************* return ********************************/
	
	return(ret_val);
}
