/*******************************************************************************
*       disp_reg        (see manual, Internal Functions)                <in>   *
*           Displays the registration of the current map.                      *
*                                                                              *
*           Returns 0 upon successful eoj, else returns a 1.                   *
*                       CEJ 7/24/89                                            *
*******************************************************************************/
/* Modified 6/92 by DBS@CWU for X11 support */

#include <string.h>
#include "../../incl/globals.h"
#ifdef LTP_X11
#include "../../incl/x11.h"
#endif

#ifndef LTP_X11
long bitmap();
#else
long bitmap4x();
#endif
long bar_off();
long swplane();
char *get_string();
long disptext();

long disp_reg()
{
	long i, j;
	long save_dctype;
	long save_cmode;
	char tmp_line[STRLIST];

/*** Check to see if grahpics are being used.  ***/
	if(batch_mode)
		return(0);

/*** Save graphics for redisplay later & clear screen   ***/
	save_dctype = disp_coord_type;
	disp_coord_type = -1;         /*  no coord display  */
	save_cmode = cursor_mode;
	cursor_mode = 0;        /* cross hair  */
	cursor(-200, -200);            /*  take cursor off screen  */
	for(i=0; i<4; i++)
	{	swplane(i); 
#ifndef LTP_X11
		bitmap(BITPLN_WIDTH,415,BITPLN_WIDTH,BITPLN_WIDTH,
				vga_plane,scratch_pad[i]); 
#else
                bitmap4x(WIDTH,415,0,0,xmainwin,0,0,xmainpix);
#endif
		bar_off(0,0,639,414);
	}
/***  Load up the register information of current map  ***/
	sprintf(tmp_line, "REGISTER %s", map_path);
	disptext( 1, 1, tmp_line );
	sprintf(tmp_line, "                        SW               NW       \
        NE               SE");
	disptext( 2, 1, tmp_line );

	sprintf(tmp_line, "X Raster (Pix)  %+12.3f%+12.3f%+12.3f%+12.3f", 
	 corner[0][0][0], corner[0][1][0], corner[0][2][0], corner[0][3][0]);
	disptext( 3, 1, tmp_line);
	sprintf(tmp_line, "Y Raster (Pix)  %+12.3f%+12.3f%+12.3f%+12.3f", 
	 corner[0][0][1], corner[0][1][1], corner[0][2][1], corner[0][3][1]);
	disptext( 4, 1, tmp_line);
	
	sprintf(tmp_line, "West Longitude  %+12.3f%+12.3f%+12.3f%+12.3f", 
	 	-corner[1][0][0], -corner[1][1][0], 
		-corner[1][2][0], -corner[1][3][0]);
	disptext( 5, 1, tmp_line);
	sprintf(tmp_line, "North Latitude  %+12.3f%+12.3f%+12.3f%+12.3f", 
	 corner[1][0][1], corner[1][1][1], corner[1][2][1], corner[1][3][1]);
	disptext( 6, 1, tmp_line);

	sprintf(tmp_line, "E UTM (meters)  %+12.3f%+12.3f%+12.3f%+12.3f", 
	 corner[2][0][0], corner[2][1][0], corner[2][2][0], corner[2][3][0]);
	disptext( 7, 1, tmp_line);
	sprintf(tmp_line, "N UTM (meters)  %+12.3f%+12.3f%+12.3f%+12.3f", 
	 corner[2][0][1], corner[2][1][1], corner[2][2][1], corner[2][3][1]);
	disptext( 8, 1, tmp_line);

	sprintf(tmp_line, "E St Pln (feet) %+12.3f%+12.3f%+12.3f%+12.3f", 
	 corner[3][0][0], corner[3][1][0], corner[3][2][0], corner[3][3][0]);
	disptext( 9, 1, tmp_line);
	sprintf(tmp_line, "N St Pln (feet) %+12.3f%+12.3f%+12.3f%+12.3f", 
	 corner[3][0][1], corner[3][1][1], corner[3][2][1], corner[3][3][1]);
	disptext( 10, 1, tmp_line);

	sprintf(tmp_line, "X map (inches)  %+12.3f%+12.3f%+12.3f%+12.3f", 
	 corner[6][0][0], corner[6][1][0], corner[6][2][0], corner[6][3][0]);
	disptext( 11, 1, tmp_line);
	sprintf(tmp_line, "Y map (inches)  %+12.3f%+12.3f%+12.3f%+12.3f", 
	 corner[6][0][1], corner[6][1][1], corner[6][2][1], corner[6][3][1]);
	disptext( 12, 1, tmp_line);

	for( i = 10, j = 13; i < 14; i++, j += 2 )
	{
	sprintf(tmp_line, "UDU System %2d X %+12.3f%+12.3f%+12.3f%+12.3f", 
	 corner[i][0][0], corner[i][1][0], corner[i][2][0], corner[i][3][0]);
	disptext( j, 1, tmp_line);
	sprintf(tmp_line, "UDU System %2d Y %+12.3f%+12.3f%+12.3f%+12.3f", 
	 corner[i][0][1], corner[i][1][1], corner[i][2][1], corner[i][3][1]);
	disptext( j + 1, 1, tmp_line);
	}

	strcpy(tmp_line, "Press [RETURN] to continue with LTPlus");
	disptext( 25, 1, tmp_line);

/*** Wait for user to enter anything  ***/
	get_string(tmp_line);

		/***  erase old text              ***/
		swplane(3);
		bar_off(0,0,639,414);


		/*   reset screen     */
	for(i=0; i<4; i++)
	{	swplane(i);
#ifndef LTP_X11
		bitmap(BITPLN_WIDTH,415,BITPLN_WIDTH,BITPLN_WIDTH,
					scratch_pad[i],vga_plane);
#else
                bitmap4x(WIDTH,415,0,0,xmainpix,0,0,xmainwin);
#endif
	}
	disp_coord_type = save_dctype;
	cursor_mode = save_cmode;
	cursor(ginfo.scoord[0], ginfo.scoord[1]);

		/*   return           */
	return(0);

}
