/*******************************************************************************
*       dispchar        (see manual, Internal Functions)                <in>   *

     Purpose:	Puts text on screen at row and col.  Only that portion of the
		text which falls on the screen will be displayed.  Also will
		remove text that is already displayed (it actually reverses the 
		bit pattern over the letter pixels.)

     Arguments:	int row - starting row
		int col - starting column
		char c  - character to be displayed

     Returned Values: (long) 0

     Global Variables Modified: - none -

*                      j.dabritz  3/7/89 - 5/8/89                              *
*******************************************************************************/
/* Modified 5/92 by DBS@CWU for X11 support */

#include "../../incl/globals.h"

#ifndef LTP_X11         /***** First the VGA code *****/

#include "malloc.h"
#include <sys/ioctl.h>
#include <memory.h>

long dispchar(row,col,c) 
long row,col;
unsigned char c;
{	long j;
	char *p, *s;


		/*   check to see if grahpics are being used.  */
	if(batch_mode)
		return 0;


		/*  check row and col & reject those which aren't on scrn */
	if((row <0) || (row >29) || (col >79) || (col < 0))
		return (long) 0;


	if(batch_mode || !graphics_flag)
		printf("\ndispchar:  %d  %d  %d\n",row,col,c);

		/*   p is pointer to screen location at start of text     */
	p = vga_plane + (row * BITPLN_WIDTH * 16) + col;
		/*    s is pointer to binary pattern for text*/
	s = (char *)textchar + (c << 4);
		/*    copy each line of bit pattern to screen */
	for(j=0; j<16; j++, p += BITPLN_WIDTH, s++)
		*p = *s;

	return (long) 0;
}


#else        /***** now the X11 code *****/

#include "../../incl/x11.h"

long dispchar(row,col,c) 
     long row,col;
     unsigned char c;
{
  int x, y;
  char string[2];

  /*   check to see if grahpics are being used.  */
  if(batch_mode)
    return 0;

  /*  check row and col & reject those which aren't on scrn */
  if((row <0) || (row >29) || (row<0) || (col >79))
    return (long) 0;


  if(batch_mode || !graphics_flag)
    printf("\ndispchar:  %d  %d  %d\n",row,col,c);
  else {
    string[0] = c; string[1] = '\0';
    x = col * 8;
    y = row * 16 + 9;
    XFillRectangle(xdisplay,xmainwin,xgcclear, 
                    x, y-(xfont_info->ascent),
                    9, 17);
    XDrawString(xdisplay, xmainwin, xgccopy, x, y, string, 1);
  }
  return (long) 0;

}

#endif     /***** end of X11 code *****/

