/*******************************************************************************
*       displogo        (see manual, Internal Functions)                <in>   *
*		This program clears the grahpics window and displays   *
*		the "LINE TRACE PLUS" logo.                                    *
*                                                                              *
*       Parameters 	none                                                   *
*                                                                              *
*       Global variables changed:  none                                        *
*                                                                              *
*	value returned:	long 0;                                                *
*                      j.dabritz  6/15/89                                      *
*******************************************************************************/
/* Modified 5/92 by DBS@CWU for X11 support */

#include <string.h>
#include "../../incl/globals.h"
#include <malloc.h>

#ifndef LTP_X11   /* not using this for X11 */
long fattext();
#else    /* always use the disclaimer in X11 version */
#undef NODISCLAIM
#endif

long swplane();
long bar_off();
long disptext();


long displogo()
{
	long i;
	char string[STRLIST];

        /**************** check for batch mode ************************/
	if(batch_mode)
		return(0);

        /**************** clear graphics screen ***********************/
	for(i=0; i<4; i++)
	{	swplane(i);
		bar_off(windowxmin,windowymin,windowxmax,windowymax);
	}

        /**************** display logo ********************************/
#ifndef NODISCLAIM
	swplane(2);
	bar_on(224,0,623,399);
	swplane(3);
	bar_on(224,0,623,399);
  
	disptext(7,30, "       THE FEDERAL GOVERNMENT MAKES NO");
	disptext(8,30, "   WARRANTIES, EITHER EXPRESSED OR IMPLIED");
	disptext(9,30, "   WITH RESPECT TO THIS SOFTWARE, ITS");
	disptext(10,30,"   QUALITY, PERFORMANCE, MERCHANTABILITY OR");
	disptext(11,30,"   FITNESS FOR ANY PARTICULAR PURPOSE.");
	disptext(13,30,"       THE FEDERAL GOVERNMENT RESERVES THE");
	disptext(14,30,"   RIGHT TO MAKE IMPROVEMENTS IN THIS");
	disptext(15,30,"   SOFTWARE AT ANY TIME AND WITHOUT NOTICE.");

#else
  
	swplane(1);
	fattext(12,30,8,"LINE");
	fattext(16,33,8,"TRACE");
	swplane(3);
	fattext(16,33,8,"TRACE");
	swplane(0);
	fattext(12,30,8,"L");
	fattext(16,33,8,"T");
	fattext(21,40,8,"PLUS");
#endif

	sprintf(string,"Version %4.2f",ltp_version);
	disptext(20,50,string);
	swplane(1);
	disptext(23,43,"USDA - Forest Service");
	disptext(24,40,"& Soil Conservation Service");
	swplane(3);
#ifdef NODISCLAIM
/*	disptext(15,40," ..  .   ..     ..   ..  .   . ");  */
/*	disptext(16,40," ..  ..  ..     ..   ..  .     ");  */
/*	disptext(17,40," ..  .   ..     ..   ..     .  ");  */
/*	disptext(18,40," ..      ..     ..   ..      . ");  */
/*	disptext(19,40," ..      ..  ..  .   .   .   . ");  */

  
	disptext(15,40," H   O   W           D   O     ");
	disptext(16,40," Y   O   U                     ");
	disptext(17,40," FR      US     TR   AT     E  ");
	disptext(18,40," AN                            ");
	disptext(19,40," I       D       I   O   T   ? ");
	swplane(2);
	disptext(15,40," H   O   W           D   O     ");
	disptext(16,40," Y   O   U                     ");
	disptext(17,40," FR      US     TR   AT     E  ");
	disptext(18,40," AN                            ");
	disptext(19,40," I       D       I   O   T   ? ");
#endif

        /**************** set logo_on global **************************/
	logo_on = 1;


        /**************** return **************************************/
	return(0);
}


