/*******************************************************************************
*       dms           (see manual, Command Ref., User Functions)    <fc>       *
*          computes integer degrees, minutes, seconds and decimal seconds      *
*       from (abs value of) decimal degrees.                                   *
*                                                                              *
*       Parameters:  double dec_degrees   decimal degrees                      *
*                    long * deg           degrees                              *
*                    long * min           minutes                              *
*                    long * sec           seconds (rounded to nearest sec)     *
*                                                                              *
*       files/globals changed:  none                                           *
*                                                                              *
*       Returns (long)  0                                                      *
*       J.Dabritz  10/12/89                                                    *
*******************************************************************************/

#include <math.h>


long dms( dec_degrees, deg, min, sec)
    double dec_degrees;
    long *deg, *min, *sec;
{
	double m,s;

		/*** take absolute value of decimal degrees input ***/
	dec_degrees = fabs(dec_degrees);

		/*** calculate degrees **/
	*deg = dec_degrees;

		/*** caluclate minutes **/
	m = 60.0 * (dec_degrees - *deg);
	*min = m;

		/*** calculate seconds **/
	s = 0.5 + (3600.0 * (dec_degrees - *deg - *min / 60.0));
	*sec = s;

		/*** round seconds **/
	if(*sec > 59)
	{	*min = *min + 1;
		*sec = *sec - 60;
	}

		/*** round minutes **/
	if(*min > 59)
	{	*deg = *deg + 1;
		*min = *min - 60;
	}

		/**** return ***/
	return(0);
}
