/*******************************************************************************
*       dms2          (see manual, Command Ref., User Functions)    <fc>       *
*          computes integer degrees, minutes, seconds and decimal seconds      *
*       from (abs value of) decimal degrees.                                   *
*                                                                              *
*       Parameters:  double dec_degrees   decimal degrees                      *
*                    long * deg           degrees                              *
*                    long * min           minutes                              *
*                  double * sec           seconds                              *
*                                                                              *
*       files/globals changed:  none                                           *
*                                                                              *
*       Returns (long)  0                                                      *
*       J.Dabritz  10/12/89                                                    *
*******************************************************************************/

#include <math.h>


long dms2( dec_degrees, deg, min, sec)
    double dec_degrees;
    long *deg, *min;
    double *sec;
{
	double m;

		/*** take absolute value of decimal degrees input ***/
	dec_degrees = fabs(dec_degrees);

		/*** calculate degrees **/
	*deg = dec_degrees;

		/*** caluclate minutes **/
	m = 60.0 * (dec_degrees - *deg);
	*min = m;

		/*** calculate seconds **/
	*sec =  3600.0 * (dec_degrees - *deg - *min / 60.0);

		/**** return ***/
	return(0);
}
