/*******************************************************************************
*     edit_ltp          (see manual, Internal Functions)                <in>   *
*     	   This program puts the user in the config file specified editor     *
*     	   editing the input file.  Returns 0 when done.                      *
*    	                                                                         *
*     	   No globals changed, only the input file.                           *
*     	                                                                      *
*                      j.dabritz  8/12/89                                      *
*******************************************************************************/
/* Modified 5/92 by DBS@CWU for X11 support */

#include "../../incl/globals.h"

long graphics_on();
long kb_reset();
long graphics_off();
long kb_setup();

#ifndef LTP_X11          /*****  first the VGA code  *****/

long edit_ltp(fname)
	char fname[];
{	
	char string[256];

	/*  check for batch mode    */
	if(batch_mode)
		return(0);

	/*	turn graphics and keyboard trap off   */
	graphics_off();
	kb_reset();

	/*  load and exec the string (vi) by the operating system  */
	trim(config.edit1);
	trim(config.edit2);
	if(*(config.edit1))  /** an editor is specified in the config file. **/
		sprintf(string,"%s %s %s\n", config.edit1, fname, config.edit2);
	else     /** no editor is specified, default to  'vi' **/
		sprintf(string,"vi %s",fname);

	trim(string);
	if(system_ltp(string))
	{		/*  reset the graphics and keyboard trap  */
		graphics_on();
		kb_setup();
		message(string);
		message(" system() command (above) to edit file failed.  ");
		return(1);
	}

	sync();       /** make sure that all file storage is scheduled **/
	/*  reset the graphics and keyboard trap  */
	graphics_on();
	kb_setup();

	return 0;
}

#else       /***** now the X11 version *****/

#  include "../../incl/x11.h"

long edit_ltp(fname)
     char fname[];
{
  char string[256];

  /*  check for batch mode    */
  if(batch_mode)
    return(0);

  /*  load and exec the string (vi) by the operating system  */
  trim(config.edit1);
  trim(config.edit2);
  if(*(config.edit1))	/** an editor is specified in the config file. **/
    sprintf(string,"%s -e %s %s %s\n", XTERM_CMD, config.edit1, fname, config.edit2);
  else			/** no editor is specified, default to  'vi' **/
    sprintf(string,"%s -e vi %s",XTERM_CMD, fname);

  trim(string);
  if(system_ltp(string))
    {
      message(string);
      message(" system() command (above) to edit file failed.  ");
      return(1);
    }

  sync();		/** make sure that all file storage is scheduled **/

  return 0;
}

#endif  /*****  end of X11 code *****/
