/*******************************************************************************
*       fattext         (see manual, Internal Functions)                <in>   *

     Purpose:	Puts size-row high text on screen at row and col.  Only full 
		characters which fall on the screen will be displayed.

     Arguments:	int row - starting row (lowest normal row to be written on)
		int col - starting column (leftmost normal column written on)
		long size - expansion factor ( 1 or greater )
		char *string - pointer to string to be displayed

     Returned Values: (long) 0

     Global Variables Modified: - none -

*                      j.dabritz  3/7/89 - 5/8/89                              *
*******************************************************************************/

#include "malloc.h"
#include <sys/ioctl.h>
#include <memory.h>

#include "../../incl/globals.h"


long bar_on();


long fattext(row,col,size,string) 
long row,col,size;
unsigned char *string;
{	long x,y,x1,y1;
	long i,l;
	unsigned char *bitptr;

		/*  check row and col & reject those which aren't on scrn */
	if((row <3) || (row >29) || (col >75) || (size < 1))
		return (long) 0;


	for(;(*string != 0) && (col<BITPLN_WIDTH); string++, col += size)
	{	y = (row-size + 1) * 16;
		x = col * 8;
		bitptr = textchar + 16* (*string);

		/*  for each of the 16 pixel lines of a normal character   */
		for(l=0; l<16; l++)
		{	/*  for each of the 8 bits in a normal character row */
			for(i=7; i>=0; i--)
			{   	/*  if bit is on, turn the fat pixel on  */
				if((bitptr[l]) & (1<<i))
				{	x1 = x + size*(7-i);
					y1 = y + size*l;
					bar_on(x1,y1,x1+size-1,y1+size-1);
				}
			}
		}
	}
	
	return (long) 0;
}
