/*******************************************************************************
*     file_access       (see manual, Internal Functions)                <in>   *
*           Checks for specified access to the named file. Similar to          *
*           access(2), except this function checks permission at every         *
*           directory level.                                                   *
*           Globals Modified:   none.                                          *
*           Parameters:    path - string containg name of file.                *
*                          perms - permission to check for.  See access(2)     *
*                          disp  - message display flag.  TRUE = display       *
*                                                         FALSE = no display   *
*                                                                              *
*			Returns 0 if the return code is OK, else returns 1.                *
*           C. Jonson  12/16/89                                                *
*******************************************************************************/
#include "../../incl/globals.h"
#include <string.h>
#include <errno.h>

long file_access( path, perms, disp )	
	char *path;
	long perms;
	long disp;
{
	extern int errno;
	char *cptr;
	char cmd[STRLIST];
	char tpath[512];

/*** If path is empty, return with -1 ***/
	if( strlen(path) == 0 )
	{	if( disp )
			message("file_access:  no path provided"); 
		return(-1);
	}

/*** Copy path to tpath to preserve path name ***/
	strcpy(tpath, path);

/*** Check file access at every directory node.  47 is a '/'.  ***/
	for( ; (cptr = strrchr( tpath, 47 )) != (char *)CNULL; 
								tpath[cptr - tpath] = CNULL )
	{	if( access(tpath, perms) )
		{	if( errno == ENOENT )
				sprintf(cmd, "Sorry,  %s does NOT exist", tpath);
			else if( errno == EACCES )
				sprintf(cmd,"You do not have read/write permission for --> %s",
						tpath );
			else 
				sprintf(cmd, "Problem accessing %s.  UNIX errno is %d", 
						tpath, errno);
			if( disp )
				message(cmd);
			return(-1);
		}
	}

	return(0);
}
