/*
 * This function tries to open a file to see if it exists and is readable.
 *     file_exists(path, name)
 *        char *path, *name;
 *     Returns: 1 if the file exists and is readable.
 *              0 otherwise.
 *
 * by David B. Satnik CWU GIS Lab
 */

#ifdef MULTIUSER

#include "../../incl/globals.h"
#include <sys/stat.h>
#include <sys/types.h>

long file_exists(path, name)
     char *path, *name;
{
  char fullpath[512];
  struct stat buf;

  if (*name) 
    sprintf(fullpath, "%s/%s", path, name);
  else
    strcpy(fullpath, path);

  
  if(stat(fullpath, &buf)) { 
	 return(0);
  }

  return(1);
}

#endif
