/*******************************************************************************
*       find_node       (see manual, Internal Functions)                <in>   *
*                                                                              *
*    Returns a node record number given the x,y coordinates of the node.       *
*                                                                              *
*    Arguments:    long x,y;      node raster coordinates.                     *
*                                                                              *
*    Returned Values: (long) n = record number of node, or                     *
*                           -1 = no node found.                                *
*                                                                              *
*    Global Variables Modified:  none.                                         *
*                                                                              *
*                      j.dabritz  7/12/89                                      *
*******************************************************************************/

#include "../../incl/globals.h"

long find_node(x,y)
long x,y;
{	
	OBJECTS node;
	
	long n,hit;
	
	float fx,fy;


		/***************** check parameters **************************/
	if((x<0) || (x>job_stats[1]) || (y<0) || (y>job_stats[2]))
		return(-1);

		/***************** check for map present *********************/
	if(!job_stats[0])
		return(-1);

		/***************** check for node data ***********************/
	if(!job_stats[10])
		return(-1);

		/***************** set floats (fx,fy) for checking against ***/
	fx = (float) x;
	fy = (float) y;

		/***************** look for node using node_lookup array *****/
		/*** (find node if it is not an island node) ***/
	hit = 0;
	for(n = node_lookup[y];  (n >= 0) ; n--)
	{	get_objects(&node,n);
		if(node.f4[1] == fy)
		{	if(node.f4[0] == fx)
			{	hit = 1;
				break;
			}
		}
		else
			break;
	}

		/*** (find node if it is an island [2 branch] node) ***/
	if(!hit)
	{	for(n = job_stats[4]; n<job_stats[10]; n += 2)
		{	get_objects(&node,n);
			if(node.i12[0] == 5)            /* a simple island node */
			{	if(node.f4[1] == (float) y)
				{	if(node.f4[0] == (float) x)
					{	hit = 1;
						break;
					}
				}
			}
			else                            /* done with island nodes */
				break;
		}
	}

		/*********** return ***********************/
	if(hit)
		return(n);
	else
		return(-1);
}
