/*******************************************************************************
*    findfunc    (see manual, Internal Functions)                <in>          *
*                Determines if a string match the beginning of any LTP         *
*            function.  If there is exactly 1 match, it is returned, if there  *
*            are multiple matchs, then the user is given a choice.             *
*                                                                              *
*            Globals Modified:                                                 *
*                    none                                                      *
*                                                                              *
*            Returns >= 0 if a function match is found,                        *
*                       -1 if no match is found.                               *
*******************************************************************************/

#include <string.h>
#include "../../incl/fm.h"
#include "../../incl/globals.h"

long findfunc( function, qflag )
    char *function;
    long *qflag;
{
	long i,j,n;
	long parse_len;
	char choices[150][STRLIST];
	long index[150];

	parse_len = strlen(function);

	for( i = 0, j=1; uf_name[i][0] ; i++ )
	{	if( *function == uf_name[i][0] )
		{	if( !(strncmp( function, uf_name[i], parse_len )))
			{	strcpy(choices[j],uf_name[i]);
				index[j] = i;
				j++;
			}
		}
	}

	switch(j)   {
	case 1:        /* no hits                   */
		return (-1);
	case 2:        /* exactly 1 hit, return it  */
		strcpy(function,choices[1]);
	/***	message(function);	***/
		return (index[1]);
	default:       /* more than 1 hit, let the user decide  */
		strcpy(choices[0]," - none -");
		index[0] = -1;
		n = list_choice(&(choices[0][0]),(j),211);
		if(n)
		{	strcpy(function,choices[n]);
			message(choices[n]);
		}
		else
		{	append_msg(choices[n]);
			*qflag = 1;
		}
		return(index[n]);
	}

}
