/*******************************************************************************
*    findmacro   (see manual, Internal Functions)                <in>          *
*                Determines if a string match the beginning of any LTP         *
*            macro.  If there is exactly 1 match, it is executed, if there     *
*            are multiple matches, then the user is given a choice, and        *
*            the choice is executed (unless none is chosen)                    *
*                                                                              *
*            Parameters:    char*   name of macro to find                      *
*                           long*   flag to signal user quit!                  *
*            Globals Modified:  none                                           *
*                                                                              *
*            Returns =  1 if a macro match is found/chosen                     *
*                       0 if none is found.                                    *
*                       C. Jonson     1989                                     *
*******************************************************************************/
/* Last modified 5/3/92 by DBS@CWU for multiuser environment */

#include <string.h>
#include "../../incl/globals.h"


long findmacro( macro, qflag, help_flag )
    char *macro;
    long *qflag;
    long  help_flag;
{
	long i,j;
	long macro_len;
	long index[150];
	char choices[150][STRLIST];

	macro_len = strlen(macro);

/*** Search array of macro names for a hit, or for multiple hits  ***/
	for( i = 0, j=1; (macros[i][0]) && (i < MACSIZ) ; i++ )
	{	if( *macro == macros[i][0] )
        	{	if( !(strncmp( macro, macros[i], macro_len )))
			{	strcpy(choices[j],macros[i]);
				index[j] = i;
				j++;
			}
    		}
	}

#ifdef MULTIUSER
/*** Search array of my_macro names for a hit, or for multiple hits  ***/
	for( i = 0; (my_macros[i][0]) && (i < MACSIZ) ; i++ )
	{	if( *macro == my_macros[i][0] )
        	{	if( !(strncmp( macro, my_macros[i], macro_len )))
			{	strcpy(choices[j],my_macros[i]);
				index[j] = 300+i;
				j++;
			}
    		}
	}

#endif

/*** If multiple hits, display choices to user.  If no hits, return   ***/
	if(j == 1)
		return(0);		/* no hits  */

	if(j == 2)          /* exactly 1 hit */
	{	j = 1;
		strcpy(macro,choices[1]);
	}
	else          	 	/* multiple hits */
	{	strcpy(choices[0]," - none -");
		index[0] = -1;
		j = list_choice(choices[0],j,212);
		if(j == 0)     /*  none chosen  */
		{	append_msg(choices[j]);
			*qflag = 1;
			return(0);
		}
		else
			strcpy(macro,choices[j]);
	}

/***   use ismacro to execute macro  ***/
	message(choices[j]);
	return(ismacro(macro, help_flag));
}
