/*******************************************************************************
*       full_disp       (see manual, Internal Functions)                <in>   *
*           Will clear the entire screen (30 rows),  and execute a user        *
*           Parameters:   func_ptr - pointer to a function that returns long.  *
*                                    This is the user function to be executed. *
*           Globals Modified:  none                                            *
*                                                                              *
*           Returns 0 upon successful EOJ, else returns a -1.                  *
*           C. Jonson  11/20/89                                                *
*******************************************************************************/
/* Modified 6/92 by DBS@CWU for X11 support */

#include <string.h>
#include "../../incl/globals.h"
#ifdef LTP_X11
#include "../../incl/x11.h"
#endif

#ifndef LTP_X11
long bitmap();
#else
long bitmap4x();
#endif
long bar_off();
long swplane();
char *get_string();

long full_disp(recs, num_recs)
	char recs[][STRLIST];
	long num_recs;
{
	long i;
	long arr_indx, top, bottom;
	long save_dctype;
	long save_cmode;
	char resp[STRLIST];

/*** Check to see if graphics are being used.  ***/
	if(batch_mode)
		return(0);

/*** Save graphics for redisplay later & clear screen   ***/
	save_dctype = disp_coord_type;
	disp_coord_type = -1;         /*  no coord display  */
	save_cmode = cursor_mode;
	cursor_mode = 0;        /* cross hair  */
	cursor(-200, -200);            /*  take cursor off screen  */
	for(i=0; i<4; i++)
	{	swplane(i); 
#ifndef LTP_X11
		bitmap(BITPLN_WIDTH,416,BITPLN_WIDTH,BITPLN_WIDTH,
				vga_plane,scratch_pad[i]); 
#else
                bitmap4x(WIDTH,416,0,0,xmainwin,0,0,xmainpix);
#endif
		bar_off(0,0,639,414);
	}

/***  Display array and allow user to view more or to quit ***/
	arr_indx = 0;
	bottom = num_recs < 24 ? num_recs : 24; 
	/* loop until the user wants to quit */
	for( ;; bottom = num_recs - arr_indx < 24 ? num_recs - arr_indx : 24 )
	{	for( top = 1; top <= bottom; top++ )
			disptext( top, 1, recs[arr_indx++] );
		disptext(25,0,
			"Press [RETURN] to view the next portion of file [q to quit].");
		trim(get_string(resp));
		if( resp[0] == 'q' || resp[0] == 'Q' )
			break;		/* user wants out! */
		swplane(3);
		bar_off(0,0,639,414);		/* clear screen */
		arr_indx %= num_recs;		/* keep arr_indx within 0 - num_recs */
	}

/***  erase old text              ***/
	swplane(3);
	bar_off(0,0,639,414);

/*   reset screen     */
	for(i=0; i<4; i++)
	{	swplane(i);
#ifndef LTP_X11
		bitmap(BITPLN_WIDTH,416,BITPLN_WIDTH,BITPLN_WIDTH,
					scratch_pad[i],vga_plane);
#else
                bitmap4x(WIDTH,416,0,0,xmainpix,0,0,xmainwin);
#endif
	}
	disp_coord_type = save_dctype;
	cursor_mode = save_cmode;
	cursor(ginfo.scoord[0], ginfo.scoord[1]);

/*   return           */
	return(0);
}
