/*******************************************************************************
*       get_attr        (see manual, Internal Functions)                <in>   *
*                       This program reads the attribute  file and loads the   *
*                       information into the first parameter.                  *
*                                                                              *
*                       Globals Updated:  None                                 *
*                                                                              *
*                       Returns zero upon normal end-of-job (EOJ).             *
*                       returns 1 upon failure.                                *
*                      CEJ        3/7/89 - 5/8/89                              *
*******************************************************************************/

#include "../../incl/globals.h"  /*  <stdio.h> & all LTP defines & globals  */
#include <string.h>

int   closef();         /*  (int stream)                                    */

long get_attr(aptr, rec_no)
	ATTRIBUTES *aptr;
	long rec_no;
{
/***  Locals   ***/
	long offset; 
	char *from_ptr;

/***  Ensure parms are present and/or valid  ***/

	if( !aptr || rec_no < 0 || rec_no >= job_stats[13] )
	{	message("get_attr received bad parameter, rejecting.");
		return(1);
	}

/***  Calculate offset into attributes file    ***/
	offset = rec_no * attributesm.rec_size;

/***  Are attributes on malloced space?   ***/
	if( attributesm.malloc == 0 )		/** No, not malloced  **/
	{
		if( 0 > attributes_fd )
			return(1);
		if( 0 > movefp( attributes_fd, offset, 0 ) )
			return(1);
		if( attributesm.rec_size != readb((char *)aptr, 
				attributesm.rec_size, 1, attributes_fd ))
		{	message("get_attr, bad file pointer, rejecting.");
			return(1);
		}
	}
	else					/** Yes, is malloced  **/
	{
		if( (attributesm.rec0 + offset) >= attributesm.recn )
		{	message("get_attr, record indicated is beyond RAM data stored, rejecting");
			return(1);
		}

		from_ptr = attributesm.rec0 + offset;
		memcpy( (char *)aptr, from_ptr, attributesm.rec_size );
	}

		/**** ensure that attribute has 30 characters or less in string ***/
	(*aptr).string[30] = 0;

	return(0);
}
