/*******************************************************************************
*       get_ckeys       (see manual, Internal Functions)                <in>   *
*                       This program reads cursor keys file (ckeys) and        *
*                       loads the data into the ckeys global array.            *
*                                                                              *
*                       Only the ckeys global array is changed.                *
*                                                                              *
*                       Returns zero upon normal end-of-job (EOJ).             *
*                       returns 1 upon failure.                                *
*                      j.dabritz  6/21/89                                      *
*******************************************************************************/

#include "../../incl/globals.h"  /*  <stdio.h> & all LTP defines & globals  */
#include "../../incl/in.h"       /*  internal function declarations         */


long get_ckeys(path)
char *path;
{
char tstr[96];
	char parsed[2][32];
	unsigned char line[4096];
	char *ptr;

	int file; 
	int bytes;

	unsigned long i;

		/*    open the cursor key  file                               */
	file = openf(path, READ);
	if(!file)
		return((long) 1);

		/*    zero out cursor_keys data                               */
	for(i=0; i<256; i++)
		cursor_keys[i][0] = 0;

		/*    read the file 1 record at a time and        */
		/*    place in appropriate cursor_keys element           */
	bytes = 4094;
	line[4095] = 0;
	for(; reada(line, bytes, file) ;)
	{	trim(line);
		if(*line != '#')        /*  ignore comment lines ('#' is first char) */
	    {	cnvrt_bslash(line);     /*  convert all \ (backslash) sequences */
			if(*line)
			{	i = *line;
				ptr = (char *)(line + 1); 
				ptr[STRLIST - 2] = 0;    /*  make sure string isn't too long  */
				if(*ptr)
					strcpy(cursor_keys[i],ptr);
			}
		}
	}

		/*    close file                                         */
	closef(file);

	return(0);
}
