/*******************************************************************************
*       get_config      (see manual, Internal Functions)                <in>   *
*                       This program reads the config file and loads the       *
*                       information into the config.h common block.            *
*                                                                              *
*                       Only the config.h common block is changed.             *
*                                                                              *
*                       Returns zero upon normal end-of-job (EOJ).             *
*                      j.dabritz  3/7/89 - 5/8/89                              *
*******************************************************************************/
/* Last modified 5/3/92 by DBS@CWU for multi user support */

#include "../../incl/globals.h"  /*  <stdio.h> & all LTP defines & globals  */
#include <string.h>

int   closef();         /*  (int stream)                                      */
char *lowerc();         /*  (char *string)                                    */
int   openf();          /*  (char *filename, char *type)                      */
char *reada();          /*  ( char *string, int bytes, int stream )           */
char *strstr();         /*  (char *ref, char *test)                           */
char *trim();           /*  (char *string)                                    */


long get_config()
{
	char filename[256];
	char line[4096];
	char part1[256], part2[256];
	char *ptr;

	int  file; 
	int  bytes;
	int  old_color;

	long i,n;

#ifdef MULTIUSER
		/* set the file name to the config file, try home dir first */
	sprintf(filename, "%s/.ltp/config/config", home_path);
		/*    open the config file                               */
	if( (file = openf(filename, READ)) == -1 ) {
	        /* then try standard path */
 	    sprintf(filename, "%s/config/config", ltp_path);    
		/*    open the config file                               */
	    if( (file = openf(filename, READ)) == -1 )
	        return(1);
	}
#else
		/*    set the file name to the config file               */
	sprintf(filename, "%s/config/config", ltp_path);    

		/*    open the config file                               */
	if( (file = openf(filename, READ)) == -1 )
		return(1);
#endif

		/*    zero out the config global structure  */
	part2[0] = 0;    /*  set to null */
	strcpy(config.prtr_adr, part2);
	strcpy(config.prtr_type, part2);
	strcpy(config.crt_adr, part2);
	strcpy(config.crt_type, part2);
	strcpy(config.bkup11, part2);
	strcpy(config.bkup12, part2);
	strcpy(config.bkup21, part2);
	strcpy(config.bkup22, part2);
	strcpy(config.print1, part2);
	strcpy(config.print2, part2);
	strcpy(config.edit1, part2);
	strcpy(config.edit2, part2);
	strcpy(config.cursor_file, part2);
	strcpy(config.mouse_adr, part2);
	strcpy(config.mouse_type, part2);
	strcpy(config.dig1_adr, part2);
	strcpy(config.dig1_type, part2);
	strcpy(config.dig2_adr, part2);
	strcpy(config.dig2_type, part2);
	strcpy(config.plt1_adr, part2);
	strcpy(config.plt1_type, part2);
	strcpy(config.plt2_adr, part2);
	strcpy(config.plt2_type, part2);
	strcpy(config.maps_path, part2);
	strcpy(config.bkup_path, part2);
	strcpy(config.data3_path, part2);
	strcpy(config.data4_path, part2);
	strcpy(config.export_path, part2);
	strcpy(config.import_path, part2);
	strcpy(config.malloc, part2);
	strcpy(config.menuset, part2);
	strcpy(config.ginput, part2);
	strcpy(config.rasterh, part2);
	strcpy(config.rasterw, part2);
	strcpy(config.pen0, part2);
	strcpy(config.pen1, part2);
	strcpy(config.pen2, part2);
	strcpy(config.pen3, part2);
	strcpy(config.pen4, part2);
	strcpy(config.pen5, part2);
	strcpy(config.pen6, part2);
	strcpy(config.pen7, part2);
	strcpy(config.pen8, part2);
	strcpy(config.tile1, part2);
	strcpy(config.tile2, part2);
	strcpy(config.tile3, part2);
	strcpy(config.tile4, part2);
	strcpy(config.tile5, part2);
	strcpy(config.tile6, part2);
	strcpy(config.tile7, part2);
	strcpy(config.tile8, part2);
	strcpy(config.tile9, part2);
	strcpy(config.tile10, part2);
	strcpy(config.tile11, part2);

		/*    read the config file 1 record at a time and        */
		/*    place in appropirate config. element.              */
	bytes = 4095;
	for(; reada(line, bytes, file) ;)
	{
		trim(line);
		strsplit(line, '=', part1, part2);
		trim(lowerc(part1));
		trim(part2);
		if(strstr(line, "="))
		{
			if(!(strcmp(part1,"prtr_adr"))) 
				strcpy(config.prtr_adr, part2 );
			else if(!(strcmp(part1, "prtr_type")))
				strcpy(config.prtr_type, part2 );
			else if(!(strcmp(part1, "crt_adr")))
				strcpy(config.crt_adr, part2);
			else if(!(strcmp(part1, "crt_type")))
				strcpy(config.crt_type, part2 );
			else if(!(strcmp(part1, "bkup11")))
				strcpy(config.bkup11, part2);
			else if(!(strcmp(part1, "bkup12")))
				strcpy(config.bkup12, part2);
			else if(!(strcmp(part1, "bkup21")))
				strcpy(config.bkup21, part2);
			else if(!(strcmp(part1, "bkup22")))
				strcpy(config.bkup22, part2);
			else if(!(strcmp(part1, "print1")))
				strcpy(config.print1, part2);
			else if(!(strcmp(part1, "print2")))
				strcpy(config.print2, part2);
			else if(!(strcmp(part1, "edit1")))
				strcpy(config.edit1, part2);
			else if(!(strcmp(part1, "edit2")))
				strcpy(config.edit2, part2);
			else if(!(strcmp(part1, "cursor_file")))
				strcpy(config.cursor_file, part2 );
			else if(!(strcmp(part1, "mouse_adr")))
				strcpy(config.mouse_adr, part2 );
			else if(!(strcmp(part1, "mouse_type")))
				strcpy(config.mouse_type, part2 );
			else if(!(strcmp(part1, "dig1_adr")))
				strcpy(config.dig1_adr, part2 );
			else if(!(strcmp(part1, "dig1_type")))
				strcpy(config.dig1_type, part2 );
			else if(!(strcmp(part1, "dig2_adr")))
				strcpy(config.dig2_adr, part2 );
			else if(!(strcmp(part1, "dig2_type")))
				strcpy(config.dig2_type, part2 );
			else if(!(strcmp(part1, "plt1_adr")))
				strcpy(config.plt1_adr, part2 );
			else if(!(strcmp(part1, "plt1_type")))
				strcpy(config.plt1_type, part2 );
			else if(!(strcmp(part1, "plt2_adr")))
				strcpy(config.plt2_adr, part2 );
			else if(!(strcmp(part1, "plt2_type")))
				strcpy(config.plt2_type, part2 );
			else if(!(strcmp(part1, "maps_path")))
				strcpy(config.maps_path, part2 );
			else if(!(strcmp(part1, "bkup_path")))
				strcpy(config.bkup_path, part2 );
			else if(!(strcmp(part1, "data3_path")))
				strcpy(config.data3_path, part2 );
			else if(!(strcmp(part1, "data4_path")))
				strcpy(config.data4_path, part2 );
			else if(!(strcmp(part1, "export_path")))
				strcpy(config.export_path, part2 );
			else if(!(strcmp(part1, "import_path")))
				strcpy(config.import_path, part2 );
			else if(!(strcmp(part1, "malloc")))
				strcpy(config.malloc, part2 );
			else if(!(strcmp(part1, "menuset")))
				strcpy(config.menuset, part2 );
			else if(!(strcmp(part1, "ginput")))
				strcpy(config.ginput, part2 );
			else if(!(strcmp(part1, "rasterh")))
				strcpy(config.rasterh, part2 );
			else if(!(strcmp(part1, "rasterw")))
				strcpy(config.rasterw, part2 );
			else if(!(strcmp(part1, "pen0")))
				strcpy(config.pen0, part2 );
			else if(!(strcmp(part1, "pen1")))
				strcpy(config.pen1, part2 );
			else if(!(strcmp(part1, "pen2")))
				strcpy(config.pen2, part2 );
			else if(!(strcmp(part1, "pen3")))
				strcpy(config.pen3, part2 );
			else if(!(strcmp(part1, "pen4")))
				strcpy(config.pen4, part2 );
			else if(!(strcmp(part1, "pen5")))
				strcpy(config.pen5, part2 );
			else if(!(strcmp(part1, "pen6")))
				strcpy(config.pen6, part2 );
			else if(!(strcmp(part1, "pen7")))
				strcpy(config.pen7, part2 );
			else if(!(strcmp(part1, "pen8")))
				strcpy(config.pen8, part2 );
			else if(!(strcmp(part1, "tile1")))
				strcpy(config.tile1, part2 );
			else if(!(strcmp(part1, "tile2")))
				strcpy(config.tile2, part2 );
			else if(!(strcmp(part1, "tile3")))
				strcpy(config.tile3, part2 );
			else if(!(strcmp(part1, "tile4")))
				strcpy(config.tile4, part2 );
			else if(!(strcmp(part1, "tile5")))
				strcpy(config.tile5, part2 );
			else if(!(strcmp(part1, "tile6")))
				strcpy(config.tile6, part2 );
			else if(!(strcmp(part1, "tile7")))
				strcpy(config.tile7, part2 );
			else if(!(strcmp(part1, "tile8")))
				strcpy(config.tile8, part2 );
			else if(!(strcmp(part1, "tile9")))
				strcpy(config.tile9, part2 );
			else if(!(strcmp(part1, "tile10")))
				strcpy(config.tile10, part2 );
			else if(!(strcmp(part1, "tile11")))
				strcpy(config.tile11, part2 );
		}
	}

		/*    close file                                         */
	closef(file);

		/*    reset maps_path      */
	if((config.maps_path)[0])
		strcpy(maps_path,config.maps_path);
	else
#ifdef GRASS
		sprintf(maps_path,"%s/ltp_maps",grass_path); /* grass4.0 path */
#else
#  ifdef MULTIUSER
		sprintf(maps_path, "%s/.ltp/maps", home_path);
#  else
		sprintf(maps_path,"%s/maps",ltp_path);   /*   default   path  */
#  endif
#endif
	if(!file_exists(maps_path,"")) makedir(maps_path);

		/*     check print part1/part2     */
	if(!config.print1[0] && !config.print2[0])
		strcpy(config.print1,"lp");

		/*     check edit part1/part2     */
	if(!config.edit1[0] && !config.edit2[0])
		strcpy(config.edit1,"vi");

		/*     check/reset vga colors     */
	for(i=0; i<16; i++)
	{	switch(i) {
		case 0:                   /**** background                       */
			ptr = config.pen0;
			break;
                                  /**** cursor plus anything             */
		case 1: case 3: case 5: case 7: case 9: case 11: case 13: case 15:
			ptr = config.pen1;
			break;
		case 2:                   /**** raster                           */
			ptr = config.pen2;
			break;
		case 4:                   /**** vector (normal)                  */
			ptr = config.pen3;
			break;
		case 8:                   /**** text                             */
			ptr = config.pen4;
			break;
		case 10:                   /**** raster + text                    */
			ptr = config.pen5;
			break;
		case 12:                   /**** vector + text                    */
			ptr = config.pen6;
			break;
		case 6:                   /**** raster + vector                  */
			ptr = config.pen7;
			break;
		case 14:                   /**** raster + vector + text           */
			ptr = config.pen8;
			break;
		}

		if(*ptr)
		{
			trim(ptr);

			old_color = colors[i];

			if((*ptr >= '0')  &&  (*ptr <= '9'))
			{	sscanf(ptr,"%ld",&n);
				n &= 255;
				colors[i] = n;
			}
			else if(!(strcmp(ptr,"sickly_magenta"))) 
				colors[i] = 61;
			else if(!(strcmp(ptr,"ripe_magenta"))) 
				colors[i] = 5;
			else if(!(strcmp(ptr,"fishbelly_white"))) 
				colors[i] = 63;
			else if(!(strcmp(ptr,"dark_white"))) 
				colors[i] = 7;
			else if(!(strcmp(ptr,"cadaver_blue"))) 
				colors[i] = 1;
			else if(!(strcmp(ptr,"polar_blue"))) 
				colors[i] = 57;
			else if(!(strcmp(ptr,"glacier_cyan"))) 
				colors[i] = 3;
			else if(!(strcmp(ptr,"caribbean_cyan"))) 
				colors[i] = 59;
			else if(!(strcmp(ptr,"lumpy_brown"))) 
				colors[i] = 6;
			else if(!(strcmp(ptr,"infectious_yellow"))) 
				colors[i] = 62;
			else if(!(strcmp(ptr,"lides_green"))) 
				colors[i] = 58;
			else if(!(strcmp(ptr,"canpea_green"))) 
				colors[i] = 2;
			else if(!(strcmp(ptr,"bright_black"))) 
				colors[i] = 0;
			else if(!(strcmp(ptr,"seattle_gray"))) 
				colors[i] = 56;
			else if(!(strcmp(ptr,"vampire_red"))) 
				colors[i] = 4;
			else if(!(strcmp(ptr,"redtape_red"))) 
				colors[i] = 60;

			if((old_color != colors[i])  &&  (graphics_flag))
				colorvga(i,colors[i]);
			
		}
	}


	return(0);
}
