/*******************************************************************************
*       get_cont_int    (see manual, Internal Functions)                <in>   *
*    find the contour interval from the header file, or (if not found)         *
*    sets it to 40.                                                            *
*                                                                              *
*    Arguments:    none                                                        *
*                                                                              *
*    Returned Values: (long) 0 = ok,    1=failure                              *
*                                                                              *
*    Global Variables Modified:  contour_interval                              *
*                                                                              *
*    Files modified:    none                                                   *
*                                                                              *
*                      j.dabritz  9/3/89                                       *
*******************************************************************************/

#include "../../incl/globals.h"

long get_cont_int()
{
	char *ptr;
	
		/************ check & set contour_interval *********************/
	contour_interval = 0;
	ptr = (char *) trim(header.contour_interval);
	if(strlen(ptr))
	{	if((*ptr >= '0')  &&  (*ptr <= '9'))
			contour_interval = strtol(ptr, (char **)NULL, 10);
	}
	if(contour_interval <= 0)
	{	message("You have an illegal (or no) contour interval in you header file.");
		message("A contour interval of  40  will be used.  (or you can change your header");
		message("file & try again.");
		contour_interval = 40;
		sleep(5);
	}

	return(0);
}
