/*******************************************************************************
*       get_coordlst    (see manual, Internal Functions)                <in>   *
*                       This program fills the input structure with coord_list *
*                       information for the input coord_list record number.    *
*                                                                              *
*                       no global or file data is changed.                     *
*                                                                              *
*                       Returns zero upon normal end-of-job (EOJ).             *
*                       returns 1 upon failure.                                *
*                      j.dabritz  6/12/89                                      *
*******************************************************************************/

#include "../../incl/globals.h"  /*  <stdio.h> & all LTP defines & globals  */
#include <string.h>


long get_coordlst(ptr,record_number)
COORD_LIST *ptr;             /*  pointer to coord_list structure to be got    */
long record_number;          /*  record number for get.                   */
{
	char *from_ptr;
	long offset;

		/******************** check for legitimate parameters ***********/
	if(!ptr  ||  record_number < 0 || record_number >= job_stats[11])
	{	
		message("get_coordlst received bad parameter, rejecting.");
		return(1);
	}

		/******************** calculate offset **************************/
	offset = record_number * coord_listm.rec_size;

		/******************** see if current storage is on disc *********/
	if(coord_listm.malloc == 0)
	{		/******************** check for file pointer ********************/
		if(0 > coord_list_fd)
			return(1);
			/******************** position file write pointer ***************/
		if(0 > movefp(coord_list_fd,offset,0))
			return(1);
			/******************** read  record ******************************/
		if(0 > readb((char *)ptr, coord_listm.rec_size ,1 ,coord_list_fd))
		{	message("get_coordlst, bad file pointer, rejecting.");
			return(1);
		}
	}

	else	/******************** (file in ram) *****************************/
	{		/******************** check for enough existing malloc'd space **/
		if((coord_listm.rec0 + offset) >= coord_listm.recn)
		{	message("get_coordlst, record indicated is beyond RAM data stored, rejecting");
			return(1);
		}
		from_ptr = coord_listm.rec0 + offset;
		memcpy((char *) ptr,from_ptr,coord_listm.rec_size);
	}

		/******************** return ************************************/
	return(0);
}
