/*******************************************************************************
*       get_header      (see manual, Internal Functions)                <in>   *
*                       This program reads the dictionary file and loads       *
*                       information into the dictionary[][] global.            *
*                                                                              *
*       parameters: char* fname;   name of the file in the dictionaries dir.   *
*                                                                              *
*                       only the created dictionary array is changed.          *
*                                                                              *
*                       Returns pointer to dictionary character array.         *
*                      j.dabritz  1/16/90                                      *
*******************************************************************************/
/* Modified 6/92 by DBS@CWU for multi user support */

#include "../../incl/globals.h"  /*  <stdio.h> & all LTP defines & globals  */

char *calloc_ltp();
char *realloc_ltp();


char *get_dict( fname )
	char *fname;
{
	char string[96];
	char *dict;
	char *ptr, *ptr2;
	char path[256];

	long i;
	long size;

	int file;

		/****** malloc space for file **********/
	size = 100 ;
	dict = (char *) calloc_ltp(size*32,1);

		/*    open the file                               */
	trim(fname);
	if(! *fname)
		return(dict);

#ifdef MULTIUSER
	sprintf(path,"%s/.ltp/dictionaries/%s",home_path,fname);
	if((file = openf(path, READ)) == -1) {
		sprintf(path,"%s/dictionaries/%s",ltp_path,fname);
		if((file = openf(path, READ)) == -1)
			return(dict);
	}
#else
	sprintf(path,"%s/dictionaries/%s",ltp_path,fname);
	if((file = openf(path, READ)) == -1)
		return(dict);
#endif

		/*    read dictionary file   */
	ptr = (char *) dict;
	for(i=0 ; reada(string,96,file); )
	{
		if(*string > 32)
		{	string[30] = (char) 0;
			trim(string);
			sprintf(ptr,"%s",string);
			i++;
			ptr += 32;
			if(i >= size)
			{	size += 100;
				ptr2 = realloc_ltp(dict,size * 32);
				if(ptr2 == (char *) 0)
					break;
				dict = ptr2;
				ptr = dict + 32 * i;
			}
		}
	}

	*ptr = 0;

	closef(file);

	return(dict);
}
