/*******************************************************************************
*    get_dirfname                                                              *
*        This program allows the user to choose an existing file from a        *
*    a directory or to specify a string for an filename.                       *
*                                                                              *
*    Globals/files changed:  none                                              *
*                                                                              *
*    Parameters:  char string[]     default string to be used in non-null      *
*                 char fname[]      pointer to the filename string             *
*                 char path[]       directory from which to choose             *
*                 long *pf          prompt flag (if set, ignore string)        *
*                                   (set if filename not found from string)    *
*                                                                              *
*    Returned values:  (long)  0 = filename found & set & within range.        *
*                              1 = filename not found or not in range.         *
*                                                                              *
*    J.Dabritz  11/17/89                                                       *
*******************************************************************************/
/* Modified 7/92 by DBS@CWU for multi-user support */

#include <string.h>
#include "../../incl/globals.h"

long get_dirfname(string,fname,path,pf)
	char *string;
	char *fname;
	char *path;
	long *pf;
{
	char list[100][STRLIST];
	long i,n;


		/** check string and copy to fname **/
	trim(string);
	if(*string)
		strcpy(fname,string);
	else
	{	*fname = 0;
		*pf = 1;
	}

		/** test for batch mode **/
	if(batch_mode)
		return(0);


		/*** get list of all files in default import directory **/
	if(*pf)
	{	n = 0;
		if(*path) {
#ifdef MULTIUSER
			sprintf(list[0]," - none - (next list, if there is one)");
#else
			sprintf(list[0]," - none - ");
#endif
			sprintf(list[1],"enter name from keyboard");
			n = dir_list(path,list[2],98);
			if(n<0)
			{	message("Can not find path, choosing file name blind.");
				n=0;
			}
		}
	
			/*** select file from list ***/                           
		if(n)
		{	n += 2;
			i = list_choice(list[0],n,263);
			if(i == 0)
				return(1);
			if(i == 1)
				n = 0;
			else
			{	trim(list[i]);
				sprintf(fname,"%s",list[i]);
			}
		}
	
			/*** if 'other' selected, prompt for file name ***/
		if(n == 0)
		{	message(prompt[318]);
			get_string(fname);
			trim(fname);
		}
	}
	
		/*** return ***/
	if(! *fname)
		return(1);

	return(0);
}
