/*******************************************************************************
*    get_double                                                                *
*        This program trys to set a double value, fist by looking at the       *
*    string passed in, otherwise by prompting once for it (if not in batch     *
*    mode).  It checks the value to see if it is between the limits provided,  *
*    and returns a 0 if it is within the limits, 1 otherwise.                  *
*                                                                              *
*    Globals/files changed:  none                                              *
*                                                                              *
*    Parameters:  char string[]     string in which to look for number         *
*                 double *d         pointer to the double to be set            *
*                 long *pf          prompt flag (if set, ignore string)        *
*                                   (set if double not found from string)      *
*                 long pn           prompt number (used if prompt needed)      *
*                                   (prompt not used if value is < 0)          *
*                 double min,max    limits of acceptable values for double     *
*                                                                              *
*    Returned values:  (long)  0 = number found & set & within range.          *
*                              1 = number not found or not in range.           *
*                                                                              *
*    J.Dabritz  8/23/89                                                        *
*******************************************************************************/

#include "../../incl/globals.h"

long get_double(string,d,pf,pn,min,max)
	char *string;
	double *d;
	long *pf;
	long pn;
	double min,max;
{
	char answer[256];

		/****** check string for parameter ***/
	if(string)
	{	trim(string);
		if(!(*pf)  &&  *string)
		{	if(!sscanf(string,"%lf",d))
				*pf = 1;
			else
			{	if((*d < min)  ||  (*d  > max))
					*pf = 1;
			}
		}
		else
			*pf = 1;
	}
	else
		*pf = 1;
	

		/**** if prompting is needed, ask **/
	if(*pf)
	{	if(batch_mode || (pn < 0))
			return(1);
		message(prompt[pn]);
		get_string(answer);
		trim(answer);
		if(!sscanf(answer,"%lf",d))
			return(1);
	}

		/*** check input **/
	if((*d  < min)  ||  (*d  > max))
		return(1);

	return(0);
}
