/*******************************************************************************
*       get_errors      (see manual, Internal Functions)                <in>   *
*                       This program reads the  errors    file and loads the   *
*                       information into the first parameter.                  *
*                                                                              *
*                       Globals Updated:  None                                 *
*                                                                              *
*                       Returns zero upon normal end-of-job (EOJ).             *
*                       returns 1 upon failure.                                *
*                      CEJ        3/7/89 - 5/8/89                              *
*******************************************************************************/

#include "../../incl/globals.h"  /*  <stdio.h> & all LTP defines & globals  */
#include <string.h>

long readb();

long get_errors(eptr, rec_no)
	ERRORS *eptr;
	long rec_no;
{
/***  Locals   ***/
	long offset; 
	char *from_ptr;

/***  Ensure parms are present and/or valid  ***/

	if( !eptr || rec_no < 0 || rec_no >= job_stats[14] )
	{	message("get_errors received bad parameter, rejecting.");
		return(1);
	}

/***  Calculate offset into errors file    ***/
	offset = rec_no * errorsm.rec_size;

/***  Is errors on malloced space?   ***/
	if( errorsm.malloc == 0 )		/** No, not malloced  **/
	{
		if( 0 > errors_fd )
			return(1);
		if( 0 > movefp( errors_fd, offset, 0 ) )
			return(1);
		if( errorsm.rec_size != readb((char *)eptr, 
				errorsm.rec_size, 1, errors_fd ))
		{	message("get_errors, bad file pointer, rejecting.");
			return(1);
		}
	}
	else					/** Yes, is malloced  **/
	{
		if( (errorsm.rec0 + offset) >= errorsm.recn )
		{	message("get_errors, record indicated is beyond RAM data stored, rejecting");
			return(1);
		}
		from_ptr = errorsm.rec0 + offset;
		memcpy( (char *)eptr, from_ptr, errorsm.rec_size );
	}

	return(0);
}			/*** End of get_errors()  ***/
