/*******************************************************************************
*    get_fname                                                                 *
*        This program trys to set a filename string first by looking at the    *
*    string passed in, otherwise by prompting once for it (if not in batch     *
*    mode).                                                                    *
*                                                                              *
*    Globals/files changed:  none                                              *
*                                                                              *
*    Parameters:  char string[]     string in which to look for filename       *
*                 char fname[]      pointer to the filename string             *
*                 long *pf          prompt flag (if set, ignore string)        *
*                                   (set if filename not found from string)    *
*                 long pn           prompt number (used if prompt needed)      *
*                                   (prompt not used if value is < 0)          *
*                                                                              *
*    Returned values:  (long)  0 = filename found & set & within range.        *
*                              1 = filename not found or not in range.         *
*                                                                              *
*    J.Dabritz  8/23/89                                                        *
*******************************************************************************/

#include "../../incl/globals.h"

long get_fname(string,fname,pf,pn)
	char *string;
	char *fname;
	long *pf;
	long pn;
{

		/****** check for parameter 1, file name **********************/
	if(!(*pf)  &&  string)
	{	strcpy(fname,string);
		trim(fname);
		if(! *fname)
			*pf = 1;
	}

	if(*pf)
	{	if(batch_mode || (pn < 0))
			return(1);
		message(prompt[pn]);
		get_string(fname);
		trim(fname);
	}

	if(! *fname)
		return(1);

	return(0);
}
