/*******************************************************************************
*   get_fnm                                                                    *
*       Displays a list of files to choose, based upon the first parameter.    *
*       The users selection will be loaded into the fname parameter if         *
*       choice > 0.  Else no string is loaded and fname is nulled out.         *
*       Parameters:   dir_path - string containing name of directory to read.  *
*                     fname    - pointer to char array to hold selected name.  *
*       Globals Modified:  none                                                *
*       Returns the user choice, which will be non-negative long.              *
*       C. Jonson  6/89                                                        *
*******************************************************************************/
/* Modified 7/92 by DBS@CWU for multi-user support */

#include "../../incl/globals.h"
#include "../../incl/in.h"

long get_fnm( dir_path, fname )
	char *dir_path, *fname;
{
	char list[1024][STRLIST];
	long n_items, choice;

/*  Check entered dtype against valid types  */
#ifdef MULTIUSER
	strcpy( list[0], "- none - (next list, if there is one)" );
#else
	strcpy( list[0], "- none -" );
#endif
	n_items = dir_list( dir_path, list[1], 1023 );

/** One added to n_items as dir_list doesn't know about list[0]!  **/
	choice = list_choice( list, (n_items + 1), 265 );
	if( choice )
		strcpy( fname, list[choice] );
	else
		fname[0] = '\0';		/*  Null out fname  */

	return(choice);
}
