/*******************************************************************************
*    get_gefname                                                               *
*        This function will prompt the user to select the type of SCSGEF file  *
*    to import, then allows user to select the name of the file to import!     *
*                                                                              *
*    Globals/files changed:  none                                              *
*                                                                              *
*    Parameters:  char fname[]      char array for storing user-selected name  *
*                 char path[]       directory from which to choose             *
*                 long *ftype       type of scsgef file:                       *
*                                   0 = header 1 = line 2 = point 3 = feature  *
*                                                                              *
*    Returned values:  (long)  0 = filename found & set & within range.        *
*                             -1 = no file selected.                           *
*    C. Jonson 2/8/90                                                          *
*******************************************************************************/
#include <string.h>
#include "../../incl/globals.h"

long get_gefname(fname, path, ftype)
	char *fname;
	char *path;
	long *ftype;
{
	long i,n;
	static long pnum[4] = { 311, 312, 313, 314};		/* see prompts.h */

	char list[100][STRLIST];

/** Test for batch mode **/
	if(batch_mode)
		return(-1);

/*** Prompt user to select the type of scsgef file to import ***/
	for( ;; )
	{	sprintf(list[0], " - none - ");
		sprintf(list[1],
"Header  (NOT IMPLEMENTED! Contains descriptors of the map data and corners)");
		sprintf(list[2],
"Line    (Contains coordinates of boundaries and neatlines)");
		sprintf(list[3],
"Point   (Contains coordinates of special soil features)");
		sprintf(list[4],
"Feature (OPTIONAL file: Contains coordinates of special line features)");

		if( !(i = list_choice(list[0], 5, 310)) )
			return(-1);

		if( i == 1 )
			message("Cannot user HEADER at this time!  Make another choice.");
		else 
		{	*ftype = i;
			break;
		}
	}

/*** Now display the contents of the import dir so user may choose file ***/
	sprintf(list[0], " - none - ");
	sprintf(list[1],"enter name from keyboard");
	if( (n = dir_list(path,list[2],98)) == -1 )
	{	message("Can not find path, choosing file name blind.");
		n=0;
	}
	
/*** Select file from list ***/                           
	if(n)
	{	n += 2;				/* Account for additional two choices */
		if( (i = list_choice(list[0], n, pnum[*ftype - 1] )) == 0 )
			return(1);
		else if(i == 1)		/* Other chosen */
			n = 0;
		else
		{	trim(list[i]);
			sprintf(fname, "%s", list[i]);
		}
	}
	
/*** If 'other' selected, prompt for file name ***/
	if(n == 0)
	{	message(prompt[108]);
		get_string(fname);
		trim(fname);
	}
	
/*** Return ***/
	if(!*fname)
		return(-1);

	return(0);
}
