/*******************************************************************************
*       get_history     (see manual, Internal Functions)                <in>   *
*                       This program reads the history file and loads the      *
*                       information into the history.h common block.           *
*                                                                              *
*                       Only the history.h common block is changed.            *
*                                                                              *
*                       Returns zero upon normal end-of-job (EOJ).             *
*                       returns 1 upon failure.                                *
*                      j.dabritz  6/6/89                                       *
*******************************************************************************/

#include "../../incl/globals.h"  /*  <stdio.h> & all LTP defines & globals  */

int   closef();         /*  (int stream)                                    */
char *lowerc();         /*  (char *string)                                    */
int openf();          /*  (char *path, char *type)                      */
char *reada();          /*  ( char *string, int bytes, int stream )         */
char *strstr();         /*  (char *ref, char *test)                           */
char *trim();           /*  (char *string)                                    */


long get_history(path)
char *path;
{
	char line[STRLIST];
	int file;
	long bytes;
	long i;

		/*    open the history file                               */
	file = openf(path, READ);
	if(!file)
		return((long) 1);

		/*    blank out the history global array   */
	for(i=0; i<512; i++)
		history[i][0] = 0;    /*  set to null */

		/*    read the history file 1 line at a time and        */
		/*    place in the history global array                 */
	bytes = STRLIST-1;
	for(i=0; (i<512) && reada(line,bytes,file) ; )
	{	trim(line);
		line[STRLIST - 1] = 0;       /** clip at 95 characters **/
		if(*line)
			sprintf(history[i++],"%s",line);
	}

		/*    set the pointer to the history array  */
	next_hist = i % 512;

		/*    close file                                         */
	closef(file);

	return((long) 0);
}
