/*******************************************************************************
*    get_impfile                                                               *
*        This program trys to find a file under the fname input.               *
*        If fname contains ':', then it is considered to be a DOS filename.    *
*    In this case the dos file is copied into a temporary Unix/Xenix file      *
*    whose name is placed in the (char *) actual string.                       *
*        If the first character of fname is not '/' then it is assumed to      *
*    be a relative file or path name.  This relative path is appended to       *
*    the default input directory (from the config/config file) which is        *
*    the global variable config.import_adr.                                    *
*        If fname is a directory path, then /[mapname] is appended to it and   *
*    the result is placed in teh (char *) actual string.                       *
*        If fname is not a directory then it is just placed in the (char *)    *
*    actual string.                                                            *
*        The 'actual' string is check for a leading '/'.   If none is found    *
*    then the default import path is prefixed onto the actual string to form   *
*    a complete file path.                                                     *
*                                                                              *
*    Parameters:  char fname[]      user input file name                       *
*                 char actual[]     full path to import file                   *
*                                                                              *
*    Returned values:  (long)  0 = ok                                          *
*                              1 = failure                                     *
*                                                                              *
*    J.Dabritz  9/12/89                                                        *
*******************************************************************************/
/* Modified 7/92 by DBS@CWU for multi user support */

#include "../../incl/globals.h"
#include <string.h>
#include <sys/stat.h>
#include <errno.h>

long get_impfile(fname,actual)
	char fname[];
	char actual[];
{
	int fd;

	extern int  errno;
	struct stat buf;

	char tmp[L_tmpnam];
	char string[256];
	char wrk[256];


		/************** check input & output parameters *************/
	if((fname == (char *) 0) ||  (actual== (char *) 0))
		return(1);


		/************** check for map loaded ************************/
	if(!job_stats[0])
		return(1);


		/************** check for absolute or relative path *********/
		/************** & add default import path if necessary ******/
	trim(fname);
	strcpy(actual,fname);
	if((*actual != '/') && (actual[1] != ':'))      /** relative path **/
	{	trim(config.import_path);
		if(*config.import_path == (char) 0)
#ifdef MUTLIUSER
			sprintf(config.import_path,"%s/.ltp/import",home_path); /* default value */
#else
			sprintf(config.import_path,"%s/import",ltp_path); /* default value */
#endif

		sprintf(wrk,"%s/%s",config.import_path,actual);  /** unix path **/
		strcpy(actual,wrk);
	}

		/************** check file for ':' (DOS file) ***************/
		/************** & get a temp file name (absolute) ***********/
	if(actual[1] == ':')      /** dos file name **/
	{
#ifdef SV32
	message("You cannot copy from DOS partition into UNIX while in LTPlus on ATT systems.");
	return(1);
	}
}
#else
		message("copying dos file.");
		strcpy(wrk,actual);
		tmpnam(tmp);
		strcpy(actual,tmp);
		sprintf(string,"doscp -r %s %s",wrk,actual);
		if(system_ltp(string))
		{	message("DOSCP failed.");
			return(1);
		}
		return(0);
	}
	

		/************** check to see if it is a directory ***********/
		/************** & add map_name to end of directory path *****/
	if( stat(actual, &buf) )
	{	if(errno == ENOTDIR) /** a component of the path prefix is not a dir*/
		{	sprintf(string,"bad directory path:  %s",actual);
			message(string);
			return(1);
		}
	}

		/************** create file & load name into actual parameter  */
	fd = 0;
	fd = openf(actual,READ);
	if(fd <= 0)
	{	sprintf(wrk,"%s/%s",actual,map_name);
		strcpy(actual,wrk);
	}
	else
		closef(fd);
	

message(actual);
		/************** return **************************************/
	return(0);
}
#endif
