/*******************************************************************************
*       get_indexl      (see manual, Internal Functions)                <in>   *
*                       This program reads the index_list file and loads the   *
*                       information into the first parameter.                  *
*                                                                              *
*                       Globals Updated:  None                                 *
*                                                                              *
*                       Returns zero upon normal end-of-job (EOJ).             *
*                       returns 1 upon failure.                                *
*                      CEJ        3/7/89 - 5/8/89                              *
*******************************************************************************/

#include "../../incl/globals.h"  /*  <stdio.h> & all LTP defines & globals  */
#include <string.h>

long readb();

long get_indexl(ilptr, rec_no)
	INDEX_LIST *ilptr;
	long rec_no;
{
/***  Locals   ***/
	long offset; 
	char *from_ptr;

/***  Ensure parms are present and/or valid  ***/

	if( !ilptr || rec_no < 0 || rec_no >= job_stats[15] )
	{	message("get_indexl received bad parameter, rejecting.");
		return(1);
	}

/***  Calculate offset into index_list file    ***/
	offset = rec_no * index_listm.rec_size;

/***  Is index_list on malloced space?   ***/
	if( index_listm.malloc == 0 )		/** No, not malloced  **/
	{
		if( 0 > index_list_fd )
			return(1);
		if( 0 > movefp( index_list_fd, offset, 0 ) )
			return(1);
		if( index_listm.rec_size != readb((char *)ilptr, 
				index_listm.rec_size, 1, index_list_fd ))
		{	message("get_indexl, bad file pointer, rejecting.");
			return(1);
		}
	}
	else					/** Yes, is malloced  **/
	{
		if( (index_listm.rec0 + offset) >= index_listm.recn )
		{	message("get_indexl, record indicated is beyond RAM data stored, rejecting");
			return(1);
		}
		from_ptr = index_listm.rec0 + offset;
		memcpy( (char *)ilptr, from_ptr, index_listm.rec_size );
	}

	return(0);
}			/*** End of get_indexl()  ***/
