/*******************************************************************************
*       get_jobstats    (see manual, Internal Functions)                <in>   *
*                       This get the information stored in the job_stats file  *
*                       whos path is the parameter and puts it in the          *
*                       job_stats global.                                      *
*                                                                              *
*                       Only the job_stats global is changed.                  *
*                                                                              *
*                       Returns zero upon normal end-of-job (EOJ).             *
*                       returns 1 upon failure.                                *
*                      j.dabritz  6/12/89                                      *
*******************************************************************************/
/* Modified 6/92 by DBS@CWU for big endian support */

#include "../../incl/globals.h"  /*  <stdio.h> & all LTP defines & globals  */
#ifdef BIG_ENDIAN
#include "../../incl/big_end.h"
#endif


long get_jobstats(path)
char *path;
{
	int fd; 

		/*    open the job_stats fd                               */
	if(0 > (fd = openf(path, READ)))
		return(1);
	if(0 > readb((char *)job_stats,400,1,fd))
	{	closef(fd);
	 	return(1);
	}

#if (GENERIC_FILE && GENERIC_FILE)
	byte_swap((unsigned char *)job_stats, 400, SWAP_LONG);
#endif

		/*    close fd                                         */
	closef(fd);

	return(0);
}

