/*******************************************************************************
*       get_levelnms    (see manual, Internal Functions)                <in>   *
*                       This program reads the levelnms file and loads the     *
*                       information into the level_names global variable.      *
*                                                                              *
*                       Only the level_names global is changed.                *
*                                                                              *
*                       Returns zero upon normal end-of-job (EOJ).             *
*                       returns 1 upon failure.                                *
*                      j.dabritz  8/18/89                                      *
*******************************************************************************/

#include "../../incl/globals.h"  /*  <stdio.h> & all LTP defines & globals  */

int   closef();         /*  (int stream)                                    */
char *lowerc();         /*  (char *string)                                    */
int openf();          /*  (char *path, char *type)                      */
char *reada();          /*  ( char *string, int bytes, int stream )         */
char *strstr();         /*  (char *ref, char *test)                           */
char *trim();           /*  (char *string)                                    */


long get_levelnms(path)
char *path;
{
	char line[STRLIST];
	int file;
	long bytes;
	long i;

		/*    open the level_names file                               */
	file = openf(path, READ);
	if(!file)
		return((long) 1);

		/*    blank out the level_names global array   */
	for(i=0; i<96; i++)
		level_names[i][0] = 0;    /*  set to null */

		/*    read the level_names file 1 line at a time and        */
		/*    place in the level_names global array                 */
	bytes = STRLIST-1;
	for(i=0; (i<96) && (((char *) 0) != reada(line,bytes,file)) ; i++)
	{	trim(line);
		line[STRLIST - 1] = 0;       /** clip at 95 characters **/
		sprintf(level_names[i],"%s",line);
	}

		/*    close file                                         */
	closef(file);

	return((long) 0);
}
