/*******************************************************************************
*    get_long_lst                                                              *
*        This program trys to set a long value, fist by looking at the         *
*    string passed in, otherwise by letting the user choose it from a list.    *
*    It checks the value to see if it is between the limits provided,          *
*    and returns a 0 if it is within the limits, 1 otherwise.                  *
*                                                                              *
*    Globals/files changed:  none                                              *
*                                                                              *
*    Parameters:  char string[]     string in which to look for number         *
*                 long *l           pointer to the long to be set              *
*                 long *pf          prompt flag (if set, ignore string)        *
*                                   (set if long not found from string)        *
*                 long pn           prompt number (used if prompt needed)      *
*                                   (prompt not used if value is < 0)          *
*                 long min,max      limits of acceptable values for long       *
*                 char *list        pointer to 1st list value [STRLIST] long.  *
*                 long n            number of items in list                    *
*                                                                              *
*    Returned values:  (long)  0 = number found & set & within range.          *
*                              1 = number not found or not in range.           *
*                                                                              *
*    J.Dabritz  2/20/91                                                        *
*******************************************************************************/

#include "../../incl/globals.h"

long get_long_lst(string,l,pf,pn,min,max,list,n)
	char *string;
	long *l, *pf;
	long pn,min,max;
	char *list;
	long n;
{
		/****** check string for parameter ***/
	if(string)
	{	trim(string);
		if(!(*pf)  &&  *string)
		{	if(!sscanf(string,"%d",l))
				*pf = 1;
			else
			{	if((*l < min)  ||  (*l  > max))
					*pf = 1;
			}
		}
		else
			*pf = 1;
	}
	else
		*pf = 1;
	

		/**** if prompting is needed, ask **/
	if(*pf)
		*l = list_choice(list,n,pn);

		/*** check input **/
	if((*l  < min)  ||  (*l  > max))
		return(1);

	return(0);
}
