/*******************************************************************************
*       get_objects     (see manual, Internal Functions)                <in>   *
*                       This program fills the input structre with object      *
*                       information for the input object record number.        *
*                                                                              *
*                       no global or file data is changed.                     *
*                                                                              *
*                       Returns zero upon normal end-of-job (EOJ).             *
*                       returns 1 upon failure.                                *
*                      j.dabritz  6/12/89                                      *
*******************************************************************************/

#include "../../incl/globals.h"  /*  <stdio.h> & all LTP defines & globals  */
#include <string.h>


long get_objects(ptr,record_number)
OBJECTS *ptr;                /*  pointer to object structure to be got    */
long record_number;          /*  record number for get.                   */
{
	char *from_ptr;
	long offset;

		/******************** check for legitimate parameters ***********/
	if(!ptr  ||  record_number < 0 || record_number >= job_stats[10])
	{	message("get_objects received bad parameter, rejecting.");
		return(1);
	}

		/******************** calculate offset **************************/
	offset = record_number * objectsm.rec_size;

		/******************** see if current storage is on disc *********/
	if(objectsm.malloc == 0)
	{		/******************** check for file pointer ********************/
		if(0 > objects_fd)
		{	message("get_objects, bad file pointer, rejecting.");
			return(1);
		}
			/******************** position file write pointer ***************/
		if(0 > movefp(objects_fd,offset,0))
			return(1);
			/******************** read  record ******************************/
		if(0 > readb((char *)ptr, objectsm.rec_size ,1 ,objects_fd))
			return(1);
	}

	else	/******************** (file in ram) *****************************/
	{		/******************** check for enough existing malloc'd space **/
		if((objectsm.rec0 + offset) >= objectsm.recn)
		{	message("get_objects, record indicated is beyond RAM data stored, rejecting");

			return(1);
		}
		from_ptr = objectsm.rec0 + offset;
		memcpy((char *) ptr,from_ptr,objectsm.rec_size);
	}

		/******************** return ************************************/
	return(0);
}
