/*******************************************************************************
*       get_position    (see manual, Internal Functions)                <in>   *

     Purpose:	Sets input parameters to current raster position 
                when a curssor button has been pressed.

     Arguments:	&x, &y,                                                   

     Returned Values:  0 = normal return
                       1 = raster x & y not available.

     Global Variables Modified:	 cursinfo.rasterx & cursinfo.rastery
	
*                      j.dabritz  6/16/89                                      *
*******************************************************************************/
/* Modified 5/92 by DBS@CWU for X11 mouse support */


#include "../../incl/globals.h"


long get_position(x,y)
	long *x;
	long *y;
{

		/******************* check for batch mode  *********************/
	if(batch_mode)
		return(0);

		/******************* check for current map *********************/
	if(!job_stats[0])
		return(0);

		/******************* check graphics input type *****************/
	switch( gr_dev ) {
	case DIG1ABS:
	case DIG2ABS:
	case DIG1REL:	
	case DIG2REL:	
#ifndef LTP_X11        /***** only include these if not X11 *****/
	case LTSMSE:
	case MSSMSE:
#endif
		if(fd_ginput <= 0)
			return(1);
		break;
#ifdef LTP_X11
	case X11MSE:
#else
	case ATTBMSE:
#endif
		break;
	default:
		return(1);
	}

		/******************* check for &/or get raster coords **********/
	if((!ginfo.button)  ||  ginfo.tile_num)
		message("move the mouse/cursor onto the graphics tile & press any button.");
	for(; (!ginfo.button)  ||  ginfo.tile_num ; gi());

		/******************* set parameters returned *******************/
	*x = ginfo.tcoord[0];
	*y = ginfo.tcoord[1];

		/******************* snap if appropriate ***********************/
	if(snap_input)
		find_bit(x,y,search_radius);

		/******************* return ************************************/
	return(0);
}
