/*******************************************************************************
*       get_register    (see manual, Internal Functions)                <in>   *
*                       This program reads the register file and stores the    *
*                       information in the corner global.             *
*                                                                              *
*                       Only the corner global are changed.                    *
*                                                                              *
*                       Returns zero upon normal end-of-job (EOJ).             *
*                       returns 1 upon failure.                                *
*                      j.dabritz  6/12/89                                      *
*******************************************************************************/
/* Modified 7/92 by DBS@CWU for big endian support */

#include "../../incl/globals.h"  /*  <stdio.h> & all LTP defines & globals  */
#ifdef BIG_ENDIAN
#include "../../incl/big_end.h"
#endif


long get_register(path)
char *path;
{
	int fd; 

		/*    open the register file                             */
	if(0 > (fd = openf(path, READ)))
		return(1);

		/*   read corner array  */
	if(0 > readb((char *)corner[0][0], 8, (30 * 4 * 2) ,fd))
	{	closef(fd);
	 	return(1);
	}

#if (BIG_ENDIAN && GENERIC_FILE)
	byte_swap(corner[0][0], 8*30*4*2, SWAP_DOUBLE);
#endif

		/*    close fd                                         */
	closef(fd);

	return(0);
}

