/*******************************************************************************
*       get_seglist     (see manual, Internal Functions)                <in>   *
*                       This program reads the seg_list   file and loads the   *
*                       information into the first parameter.                  *
*                                                                              *
*                       Globals Updated:   None                                *
*                                                                              *
*                       Returns zero upon normal end-of-job (EOJ).             *
*                       returns 1 upon failure.                                *
*                      CEJ        3/7/89 - 5/8/89                              *
*******************************************************************************/

#include "../../incl/globals.h"  /*  <stdio.h> & all LTP defines & globals  */
#include <string.h>

long get_seglist(slptr, rec_no)
	long *slptr;
	long rec_no;
{
/***  Locals   ***/
	long offset; 
	char *from_ptr;

/***  Ensure parms are present and/or valid  ***/

	if( !slptr || rec_no < 0 || rec_no >= job_stats[12] )
	{	message("get_seglist received bad parameter, rejecting.");
		return(1);
	}

/***  Calculate offset into seg_list file    ***/
	offset = rec_no * seg_listm.rec_size;

/***  Is seg_list on malloced space?   ***/
	if( seg_listm.malloc == 0 )		/** No, not malloced  **/
	{
		if( 0 > seg_list_fd )
			return(1);
		if( 0 > movefp( seg_list_fd, offset, 0 ) )
			return(1);
		if( seg_listm.rec_size != readb((char *)slptr, 
				seg_listm.rec_size, 1, seg_list_fd ))
		{	message("get_seglist, bad file pointer, rejecting.");
			return(1);
		}
	}
	else					/** Yes, is malloced  **/
	{
		if( (seg_listm.rec0 + offset) >= seg_listm.recn )
		{	message("get_seglist, record indicated is beyond RAM data stored, rejecting");
			return(1);
		}
		from_ptr = seg_listm.rec0 + offset;
		memcpy( (char *)slptr, from_ptr, seg_listm.rec_size );
	}

	return(0);
}			/*** End of get_coordlist()  ***/
