/*******************************************************************************
*    get_set                                                                   *
*        This program trys to get a set number in the range specified.         *
*    if it is not in the string passed in, then it is promped for once (if     *
*    not in batch mode).  It checks the value to see if it is in the range and *
*    returns a the set number of -1 if not found.                              *
*                                                                              *
*    Globals/files changed:  none                                              *
*                                                                              *
*    Parameters:  char string[]     string in which to look for number         *
*                 long *pf          prompt flag (if set, ignore string)        *
*                                   (set if long not found from string)        *
*                 long s1           lower bound to check                       *
*                 long s2           upper bound to check                       *
*                 long prompt_num   prompt number to be used                   *
*                                                                              *
*                                                                              *
*                                                                              *
*    Returned values:  (long)  0-31 = set number found/entered.                *
*                              -1 = couldn't get a legitimate set number.      *
*                                                                              *
*    J.Dabritz  8/23/89                                                        *
*******************************************************************************/

#include "../../incl/globals.h"

long get_set(string,pf,s1,s2,prompt_num)
	char *string;
	long *pf,s1,s2,prompt_num;
{
	char list[45][STRLIST];

	long i;
	long  s;

		/****** check s1 and s2 ************/
	if(s1<0  ||  s1>31  ||  s2<0  ||  s2>31)
		return(-1);

		/****** check for set  *************/
	if(!*pf  &&  string != (char *) 0)
	{	trim(string);
		if(!*string)
			*pf = 1;
		else if(!sscanf(string,"%d",&s))
			*pf = 1;
		else
		{	if((s < s1)  ||  (s > s2))
				*pf = 1;
		}
	}

		/*** prompt for set if necessary ***/
	if(*pf)
	{	if(batch_mode)
			return((long) -1);

			/****** check s1 & s2  *************/
		if(s1 < 0  ||  s2 > 31  ||  s2 < s1)
			return((long) -1);

			/****** copy list of level names *****/
		for(i=0; i<=s2; i++)
		{	if(i<s1)
				sprintf(list[i]," - none, let me out -");
			else
				sprintf(list[i],"%s",level_names[i]);
		}
		s = list_choice(list[0],s2 + 1,prompt_num);
	}


	if((s < s1)  ||  (s > s2))
		return((long) -1);

	return(s);
}
