/*******************************************************************************
*       get_toler       (see manual, Internal Functions)                <in>   *
*                       This program reads the tolerance file and sets the     *
*                       tolerance global.                                      *
*                                                                              *
*                       Returns zero upon normal end-of-job (EOJ).             *
*                       returns 1 upon failure.                                *
*                       C. Jonson 8/16/89                                      *
*******************************************************************************/
/* Modified 6/92 by DBS@CWU for multi user support */

#include "../../incl/globals.h"  /*  <stdio.h> & all LTP defines & globals  */

int   closef();         /*  (int stream)                                    */
int   openf();          /*  (char *path, char *type)                      */
char *reada();          /*  ( char *string, int bytes, int stream )         */
char *trim();           /*  (char *string)                                    */
double strtod();	/*  convert strings to doubles if possible            */

long get_toler()
{
	char path[256];
	char line[80];
	int fd; 

/***  open the header file                               ***/
#ifdef MULTIUSER
	sprintf(path,"%s/.ltp/config/tolerance",home_path);
	if (!file_exists(path,""))
		sprintf(path,"%s/config/tolerance",ltp_path);
#else
	sprintf(path,"%s/config/tolerance",ltp_path);
#endif
	if((fd = openf(path, READ)) == -1)
		return(1);

/***  read the tolerance file and convert string to double value   ***/

	tolerance = 0.0;      /*  default **/
	if( reada(line, 80, fd) == (char *)0 )
		return(1);
	tolerance = strtod(trim(line), (char **)NULL);
	
/***  close file                                         ***/
	closef(fd);

	return(0);
}
