/*******************************************************************************
*       get_v_attr      (see manual, Internal Functions)                <in>   *
*                       This program reads the v_attribute file and loads the  *
*                       information into the first parameter.                  *
*                                                                              *
*                       Globals Updated:  None                                 *
*                                                                              *
*                       Returns zero upon normal end-of-job (EOJ).             *
*                       returns 1 upon failure.                                *
*                      CEJ        3/7/89 - 5/8/89                              *
*******************************************************************************/

#include "../../incl/globals.h"  /*  <stdio.h> & all LTP defines & globals  */
#include <string.h>

int   closef();         /*  (int stream)                                    */

long get_v_attr(vaptr, rec_no)
	ATTRIBUTES *vaptr;
	long rec_no;
{
/***  Locals   ***/
	long offset; 
	char *from_ptr;

/***  Ensure parms are present and/or valid  ***/

	if( !vaptr || rec_no < 0 || rec_no > job_stats[16] )
	{	message("get_v_attr received bad parameter, rejecting.");
		return(1);
	}

/***  Calculate offset into v_attributes file    ***/
	offset = rec_no * v_attributesm.rec_size;

/***  Are v_attributes on malloced space?   ***/
	if( v_attributesm.malloc == 0 )		/** No, not malloced  **/
	{
		if( 0 > v_attributes_fd )
			return(1);
		if( 0 > movefp( v_attributes_fd, offset, 0 ) )
			return(1);
		if( v_attributesm.rec_size != readb((char *)vaptr, 
				v_attributesm.rec_size, 1, v_attributes_fd ))
		{	message("get_v_attr, bad file pointer, rejecting.");
			return(1);
		}
	}
	else					/** Yes, is malloced  **/
	{
		if( (v_attributesm.rec0 + offset) >= v_attributesm.recn )
		{	message("get_v_attr, record indicated is beyond RAM data stored, rejecting");
			return(1);
		}
		from_ptr = v_attributesm.rec0 + offset;
		memcpy( (char *)vaptr, from_ptr, v_attributesm.rec_size );
	}

		/**** ensure that attribute has 30 characters or less in string ***/
	(*vaptr).string[30] = 0;

	return(0);
}
