/*******************************************************************************
*       get_v_coord       (see manual, Internal Functions)                <in> *
*                       This program reads the v_coord_list file and loads     *
*                       the information into the first parameter.              *
*                                                                              *
*                       Globals Updated:  None                                 *
*                                                                              *
*                       Returns zero upon normal end-of-job (EOJ).             *
*                       returns 1 upon failure.                                *
*                      CEJ        3/7/89 - 5/8/89                              *
*******************************************************************************/

#include "../../incl/globals.h"  /*  <stdio.h> & all LTP defines & globals  */
#include <string.h>

long readb();

long get_v_coord(vclptr, rec_no)
	COORD_LIST *vclptr;
	long rec_no;
{
/***  Locals   ***/
	long offset; 
	char *from_ptr;

/***  Ensure parms are present and/or valid  ***/

	if( !vclptr || rec_no < 0 || rec_no >= job_stats[18])
	{	message("get_v_coord received bad parameter, rejecting.");
		return(1);
	}

/***  Calculate offset into v_coord_list file    ***/
	offset = rec_no * v_coordlistm.rec_size;

/***  Is v_coord_list on malloced space?   ***/
	if( v_coordlistm.malloc == 0 )		/** No, not malloced  **/
	{
		if( 0 > v_coordlist_fd )
			return(1);
		if( 0 > movefp( v_coordlist_fd, offset, 0 ) )
			return(1);
		if( v_coordlistm.rec_size != readb((char *)vclptr, 
				v_coordlistm.rec_size, 1, v_coordlist_fd ))
		{	message("get_v_coord, bad file pointer, rejecting.");
			return(1);
		}
	}
	else					/** Yes, is malloced  **/
	{
		if( (v_coordlistm.rec0 + offset) >= v_coordlistm.recn )
		{	message("get_v_coord, record indicated is beyond RAM data stored, rejecting");
			return(1);
		}
		from_ptr = v_coordlistm.rec0 + offset;
		memcpy( (char *)vclptr, from_ptr, v_coordlistm.rec_size );
	}

	return(0);
}			/*** End of get_v_coord()  ***/
