/*******************************************************************************
*       get_vobjects    (see manual, Internal Functions)                <in>   *
*                       This program fills the input structure with vobject    *
*                       information for the input vobject record number.       *
*                                                                              *
*                       no global or file data is changed.                     *
*                                                                              *
*                       Returns zero upon normal end-of-job (EOJ).             *
*                       returns 1 upon failure.                                *
*                      j.dabritz  6/12/89                                      *
*******************************************************************************/

#include "../../incl/globals.h"  /*  <stdio.h> & all LTP defines & globals  */
#include <string.h>


long get_vobjects(ptr,rec)
V_OBJECTS *ptr;              /*  pointer to vobject structure to be got    */
long rec;          /*  record number for get.                   */
{
	char *from_ptr;
	long offset;

		/******************** check for legitimate parameters ***********/
	if(((char *) ptr == (char *) 0)  ||  rec < 0 || rec >= job_stats[17])
	{
		message("get_vobjects received a bad parameter, aborting.");
		return(1);
	}

		/******************** calculate offset **************************/
	offset = rec * v_objectsm.rec_size;

		/******************** see if current storage is on disc *********/
	if(v_objectsm.malloc == 0)
	{		/******************** check for file pointer ********************/
		if(0 > v_objects_fd)
		{	message("get_vobjects, bad file pointer, rejecting.");
			return(1);
		}
			/******************** position file write pointer ***************/
		if(0 > movefp(v_objects_fd,offset,0))
			return(1);
			/******************** read  record ******************************/
		if(0 > readb((char *)ptr, v_objectsm.rec_size ,1 ,v_objects_fd))
			return(1);
	}

	else	/******************** (file in ram) *****************************/
	{		/******************** check for enough existing malloc'd space **/
		if((v_objectsm.rec0 + offset) >= v_objectsm.recn)
		{	message("get_objects, record indicated is beyond RAM data stored, rejecting");

			return(1);
		}
		from_ptr = v_objectsm.rec0 + offset;
		memcpy((char *) ptr,from_ptr,v_objectsm.rec_size);
	}

		/******************** return ************************************/
	return(0);
}
