/*******************************************************************************
*	gi      	(see manual, Internal Functions)            	<in>   *
*	    		Graphics interface gets input from current graphics    *
*			input device.  Calls appropriate function to query     *
*			specified graphics device.  A return value greater     *
*			than zero from any of the called functions signals     *
*			a string has been formatted for fj().                  *
*                                                                              *
*			Globals Modified:                                      *
*			        none                                           *
*                                                                              *
*			Returns value greater than zero if input was read,     *
*			returns zero if no input was read, else -1 if error.   *
*******************************************************************************/
/* Modified 5/92 by DBS@CWU for X11 support */

#include "../../incl/globals.h" 
#include "../../incl/in.h" 

long gi()
{
/*  Automatics  */
	
	long ret_code;

/*  Determine which graphics device to interrogate  */

	switch( gr_dev )
	{
		case DIG1ABS:    /* digitizer #1 absolute mode input   */
		case DIG1REL:    /* digitizer #1 relative mode input   */
		case DIG2ABS:    /* digitizer #2 absolute mode input   */
		case DIG2REL:    /* digitizer #2 relative mode input   */
			ret_code = dig_input();
			break;
#ifndef LTP_X11
		case LTSMSE:     /* LogiTech serial mouse input        */
		case MSSMSE:     /* MicroSoft serial mouse input       */
		case ATTBMSE:    /* ATT buss mouse input               */
#else
		case X11MSE:     /* X11 mouse                          */
#endif
			ret_code = mse_input();
			break;
		default:
			ret_code = 0;
			break;
	}

	return(ret_code);
}
