/*******************************************************************************
*	ginput_reset   (see manual, Internal Functions)            	<in>   *
*	    		Closes the active graphics input (if any)              *
*                                                                              *
*	    		Globals Modified:                                      *
*	    		        fd_ginput                                           *
*                                                                              *
*			Returns 0;                                             *
*			J.Dabritz   6/20/89                                    *
*******************************************************************************/

#include "../../incl/globals.h"

long ginput_reset()
{
	char char_buf[STRLIST];
	long i;

			
		/****************** check fd_ginput *****************/
	if(0 >= fd_ginput)
		return(0);

	switch(gr_dev)   {
	case DIG1REL:
	case DIG1ABS:
	case DIG2REL:
	case DIG2ABS:
			/****************** send stop strings to digitizer **/
		for(i=0; i<10; i++)
		{	if(diginfo.stop[i][0])
			{	writea(diginfo.stop[i], fd_ginput);
				sleep_ltp((double) 0.2);
			}
			else
				break;
		}
		sleep_ltp((double) 0.2);
			/****************** close digitizer  & mouse file ************/
	case LTSMSE:
		char_buf[0] = '*';		/*  reset mouse baud rate to 1200 bps */
		char_buf[1] = 'n';		/*  reset mouse baud rate to 1200 bps */
		if( writeb( char_buf, 2, 1, fd_ginput ) == 0 )
		{	message("Cannot do write #1 to logitech serial mouse");
			return(1);
		}
		sleep_ltp((double) 0.2);
		closef(fd_ginput);
		break;
	case MSSMSE:
	case ATTBMSE:
#ifdef SV32 
		if( fd_ginput > -1)
			closef(fd_ginput);
#endif
			/*  do nothing  */
		break;
	}

		/***************** reset file device int ***************/
	fd_ginput = -1;

	return(0);
}
