/*******************************************************************************
*       graphics_off    (see manual, Internal Functions)                <in>   *

     Purpose:
	take the vga card out of mode 12 hex             

     Arguments:	- none -

     Returned Values: (long) 0=ok

     Global Variables Modified: - none - 

*                      j.dabritz  3/7/89 - 5/8/89                              *
*******************************************************************************/
/*  Modification history:
        Sept 1990 by Mandel
            Inserted #include statement to make function work in SCO UNIX.
*/
/* Modified 5/92 by DBS@CWU for X11 support */

#include "../../incl/globals.h"

#ifndef SV32				/*  For XENIX 2.3 or later  */
#include <sys/ioctl.h>
#endif

#ifdef SCO_UNIX
#include <sys/machdep.h>
#include <sys/vtkd.h>
#endif

#ifndef LTP_X11   /***** first the VGA code *****/

long bitmap();

long graphics_off()
{
	extern struct kd_memloc kdm;
	long i;
		/*   check to see if grahpics are being used.  */
	if(batch_mode)
		return 0;

		/*    sleep for a second to allow display to catch up    */
	sleep(1);

		/*    save graphics for redisplay later                  */
	for(i=0; i<4; i++)
	{	swplane(i);
		bitmap(BITPLN_WIDTH,479,BITPLN_WIDTH,BITPLN_WIDTH,vga_plane,scratch_pad[i]);
	}
		/******** erase everything from bit plane 3 to keep terminal 
		          font clean    ***********/
	swplane(3);
	bar_off(0,0,639,479);

	/* Clear screen by setting it back to 80x25 text mode */
#ifdef SV32 
	ioctl( fdvga, KDUNMAPDISP, &kdm);
#endif
	ioctl( fdvga, SW_ENHC80x25, 0);

#ifdef SV32
/*** New code as of 11/30/89 ***/
	ginput_reset();			/* Shut down any dititizer device to avoid crash */

/*** End of new code ***/

#ifndef VDC600
	enter_gmode();
	exit_gmode(); 
#endif

#endif

	/* Close the VGA file                     */
	close(fdvga);

#ifdef SV32
	/*** Free up vga plane.  Reallocate it in graphics_on ***/
	if( vga_plane != (char *)0 )
		free_ltp( vga_plane );
#endif

	/* set flag for graphics off */
	graphics_flag = 0;

	return(0);
}

#else   /***** now the X11 code *****/

#include "../../incl/x11.h"
long bitmap4x();

long graphics_off()
{
  int i;

  /*   check to see if grahpics are being used.  */
  if(batch_mode)
    return 0;

  /*    save graphics for redisplay later & clear screen   */
  for(i=0; i<4; i++) {
    swplane(i);
    bitmap4x(WIDTH,479,0,0,xmainwin,0,0,xmainpix);
  }
  XFlush(xdisplay);

  /* unmap window */
  XUnmapWindow(xdisplay, xmainwin);
  XFlush(xdisplay);

  /* set flag for graphics off */
  graphics_flag = 0;

  return(0);
}

#endif  /***** end of X11 code *****/
