/*******************************************************************************
*	im      	(see manual, Internal Functions)            	<in>   *
*	    		Toggles between gi() and km() until one of the two     *
*			functions produce a string for fj() to process.  If    *
*			no input has been read within 60 minutes of execution, *
*			the keyboard and display are reset and LTPlus exits.   *
*                                                                              *
*			Globals Modified:                                      *
*			        which_buf                                      *
*                                                                              *
*			Returns zero if input is available, else               *
*			returns -1  upon error.                                *
*******************************************************************************/
/* Modified 6/92 by DBS@CWU for X11 support (for exposure events) */

#include "../../incl/globals.h"
#ifdef LTP_X11
#include "../../incl/x11.h"
#endif

/*  Globals   */

void ltpquit();
char *trim();

long im()
{
/*  Automatics  */

	long ret_val = 0;
	long tmp = 0;

/*  Initialization  */
	/** set_alarm( 3600, ltpquit );	     /*  If no input for x seconds, exit */

/*  Mainline        */

	for( ;; )			/*  Infinite loop   */
	{
#ifdef LTP_X11    /***** added code to handle exposure events *****/
		if (XCheckMaskEvent(xdisplay, ExposureMask, &xevent)) {
			/* remove any other expose events from queue */
			while (XCheckMaskEvent(xdisplay, ExposureMask, &xevent));
			/* now redisplay the screen */
			x11redisplay();
		}
#endif

		if(( tmp = km() ) > 0 )
		{	which_buf = KB;
			ret_val = 0;
			break;
		}
		else if( tmp == 0 )	/*  No keyboard input  */
	 	{	if( gr_dev  &&  ( (tmp = gi()) > 0 ) )
			{	which_buf = gr_dev;
				ret_val = 0;
				break;
			}
		}

		if( tmp == -1 )
		{	ret_val = tmp;
			break;
		}
	}

	/** set_alarm(0, 0);		/*  Turn off alarm  */
	if(!ret_val)
		message(trim(raw_buf));
	return( ret_val );
}

void ltpquit()
{
	kb_reset();			/*  restore keybd stty vals     */
	ginput_reset();			/*  close mouse port            */
	graphics_off();			/*  restore video to text mode  */
	if(!batch_mode)
		message("exiting from ltp\n\7");
	exit(0);
}
