/*******************************************************************************
*    isfunc      (see manual, Internal Functions)                <in>          *
*                Determines if a string exactly matches the name of an LTP     *
*            function If true, the index into the function pointer array is    *
*            returned, otherwise -1 is returned.                               *
*                                                                              *
*            Parameters:   char*   string containing (possible) function name  *
*            Globals Modified:  none                                           *
*                                                                              *
*            Returns >= 0 if a function match is found,                        *
*            -1 if no match is found, and                                      *
*            J. Dabritz         1989                                           *
*******************************************************************************/

#include <string.h>
#include "../../incl/fm.h"
#include "../../incl/globals.h"

long isfunc( parse_tok )
    char * parse_tok;
{
    long i;

	trim(lowerc(parse_tok));

    for( i = 0; uf_name[i][0] ; i++ )
    {   if( *parse_tok == uf_name[i][0] )            /*   check first char  */
        {   if( !(strcmp( parse_tok, uf_name[i])))   /* check entire string */
                return(i);
        }
    }

    return (-1);    /* no hits  */
}
