/*******************************************************************************
*	kb_cook     (see manual, Internal Functions)            	<in>   *
*	    		Cooks the raw input buffer from stdin.  Keys are       *
*			mapped by using case statements and appropriate logic. *
*			If the carriage return (CR) was pressed, the CR        *
*			is overwritten with a null and the resulting string    *
*			is copied to raw_buf for use by fj().                  *
*                                                                              *
*                       Globals modified:                                      *
*                               kb_buf                                         *
*                               kb_nxtwr                                       *
*                               raw_buf                                        *
*                                                                              *
*			Returns 0 for normal EOJ unless CR is pressed,         *
*			then a 1 is returned.                                  *
*******************************************************************************/
/* Modified 5/92 by DBS@CWU for X11 support */

#include <stdio.h>
#include "../../incl/globals.h"
#define BKSPACE '\010'
#define CR '\015'
#define LF '\012'

long kb_cook()
{
/*  Automatics  */

	long ret_code = 0;

/*  Mainline  */

	switch( *(kb_buf + kb_nxtwr) )
	{
		case BKSPACE:
			if( &kb_buf[kb_nxtwr - 1] >= kb_buf )
			{
				swplane(0);
				*(kb_buf + --kb_nxtwr) = '\0';
				dispchar( 29, kb_nxtwr, 32 );
				dispchar( 29, kb_nxtwr + 1, 32 );
			}
			break;
		case CR:
		case LF:
			*(kb_buf + kb_nxtwr) = '\0';
			strcpy( raw_buf, kb_buf );
			kb_nxtwr = 0;
			ret_code = 1;
			break;
		default:
			if(kb_nxtwr < 79)
				kb_nxtwr++;		/*  Increment buffer ptr  */
			break;
	}

	return(ret_code);

}		/*  End of kbcook()  */
