/*******************************************************************************
*	kb_reset     (see manual, Internal Functions)            	<in>   *
*	    		Restores stdin's line attributes to original values.   *
*                                                                              *
*	    		Globals Modified:                                      *
*	    		        none                                           *
*                                                                              *
*			Returns zero upon normal end-of-job (EOJ) and          *
*			returns -1 upon abnormal end-of-job.                   *
*******************************************************************************/
/* Modified 5/92 by DBS@CWU for X11 support */

#ifndef LTP_X11   /***** first the code for the 386 PC *****/

#include <sys/ioctl.h>
#include <errno.h>
#include "../../incl/globals.h"

extern int errno; 

long kb_reset()
{
		/*  check for batch_mode   */
	if(batch_mode)
		return(0);

/*  Return stdin to its original flag values  */

	if( fcntl( 0, F_SETFL, kb_origflag ) )
	{
		perror("kb_reset:  error on fcntl");
		return(-1);
	}

/*  Restore line to its original attributes  */

	if( ioctl( 0, TCSETAF, &kb_tsave ) == (char *)-1 )
		return(-1);
	
	return(0);
}

#else   /***** now the X11 code *****/

long kb_reset()
{
  return (0);
}

#endif
