/*******************************************************************************
*	makedir		(see manual, Internal Functions)         	<in>   *
*			Creates a directory.  Path is the name of the          *
*			directory to create.                                   *
*			                                                       *
*			Returns zero upon normal end-of-job (EOJ), else        *
*			returns -1 upon error.                                 *
*******************************************************************************/
#include "../../incl/globals.h"
#include <sys/stat.h>
#include <errno.h>

long makedir( path )
	char *path;
{
	long ret;
	extern int errno;
	struct stat buf;
	char cmd[512];

/*  If directory exits, return with -1  */
	if( stat( path, &buf) == 0 )
		return(-1);
	else if( errno == EACCES )
	{	sprintf(cmd, "Permissions invalid for %s.", path);
		message(cmd);
		return(-1);
	}

/*  If directory is new, execute mkdir command  */
	sprintf(cmd, "mkdir %s", path );

	return(system_ltp(cmd));
}
