/*******************************************************************************
*       more            (see manual, Internal Functions)                <in>   *
*			Displays the contents of the specified file (fname), in*
*               	paged format, on the full screen tile.                 *
*                                                                              *
*			Returns zero upon normal end-of-job (EOJ).             *
*                      j.dabritz  3/7/89 - 5/8/89                              *
*******************************************************************************/
/* Modified 6/92 by DBS@CWU for X11 support */

#include "../../incl/globals.h"
#ifdef LTP_X11
#include "../../incl/x11.h"
#endif

long moref();

long more(fname)
	char fname[];
{
	return(moref(fname,80));
}
/*******************************************************************************
*             moref    (see manual, Command Ref., internal Functions)    <fc>  *
*                       Displays the contents of the specified file (fname), in*
*                       paged format, on the full screen tile.                 *
*                                                                              *
*            parameters:  char *fname;    file name to be displayed            *
*                         long columns;   number of screen columns to use(1-80)*
*                                                                              *
*                                                                              *
*                                                                              *
*                        Returns zero upon normal end-of-job (EOJ).            *
*                      j.dabritz  12/3/90                                      *
*******************************************************************************/

long moref(fname,columns)
	char fname[];
	long columns;
{
	long save_dctype;
	long save_cmode;
	long save_cx, save_cy;
	long c,i,j,n;
	long row,old_lines;
	long bytes, quit;
	long binary;
	long ignorelf;
	long promptem;
	long max_cols;
	long disp_array1, disp_array2;
	long eof, lines_read;

	int fd;

	char scrn_display[25][STRLIST];
	char string[STRLIST], *ptr;
	char *to_ptr;
	char *end_ptr, input_string[1024];

		/********* check for batch mode **************************/
	if(batch_mode)
		return(0);

		/********* check columns parameter ***********************/
	if((columns < 1) || (columns > 80))
		max_cols = 80;
	else
		max_cols = columns;

		/********* set screen_display values *********************/
	eof = 0;
	lines_read = 0;
	disp_array1 = 0;
	disp_array2 = 0;
	for(i=0; i< 25; i++)
	{	for(j=0; j<STRLIST; j++)
			scrn_display[i][j] = ' ';
	}

		/********* open file *************************************/
	fd = -1;
	fd = openf(fname,READ);
	if(fd < 0)
	{	sprintf(string,"More: Cannot open file  %s",fname);
		pause_ltp(5,string);
	}

		/********* copy graphics *********************************/
		/********* clear upper tiles *****************************/
	save_dctype = disp_coord_type;
	disp_coord_type = -1;         /*  no coord display  */
	save_cmode = cursor_mode;
	cursor_mode = 0;        /* cross hair  */
	save_cx = ginfo.scoord[0];
	save_cy = ginfo.scoord[1];
	cursor(-200, -200);            /*  take cursor off screen  */
	for(i=0; i<4; i++)
	{	swplane(i);
#ifndef LTP_X11
		bitmap(BITPLN_WIDTH,415,BITPLN_WIDTH,BITPLN_WIDTH,vga_plane,scratch_pad[i]);
#else
                bitmap4x(WIDTH,415,0,0,xmainwin,0,0,xmainpix);
#endif
		bar_off(0,0,639,414);
	}
	cursor(save_cx,save_cy);       /*  place cursor back on screen  */

		/********* read & display file ***************************/
	i=25;
	quit = 0;
	promptem = 0;
	ptr = input_string;
	end_ptr = input_string;
	binary = 0;
	for(;;)
	{		/*  display i lines of the file */
			/*  1) move display up i lines */
		swplane(3);
		if(i <= 0)
			i = 20;

		old_lines = 25 - i;
		if(old_lines > 0)
		{	n = 16 * old_lines - 1;
#ifndef LTP_X11
			to_ptr = vga_plane + 16 * i * BITPLN_WIDTH;
			bitmap(BITPLN_WIDTH,n,BITPLN_WIDTH,BITPLN_WIDTH,to_ptr,vga_plane);
#else
                	bitmap4x(WIDTH,n,0,16*i,xmainwin,0,0,xmainwin);
#endif
		}
			/*  2) clear bottom area       */
		if(old_lines > 0)
			n = old_lines * 16;
		else
			n = 0;
		bar_off(0,n,639,399);
			/**** clear line on display array ****/
		j=
		

			/*  3) add new lines           */
		ignorelf = 0;
		for(;(old_lines < 25) ;old_lines++, lines_read++)
		{		/*** increment scrn_display array ***/
			disp_array1 = (disp_array1 + 1) % 25;
			for(j=0; j<STRLIST; j++)
				scrn_display[disp_array1][j] = ' ';
			disp_array2 = -1;
			
				/*** read string ***/
			for(c=0;;)
			{	ptr++;
				if(ptr >= end_ptr)
				{	bytes = readb(input_string,1024,1,fd);
					if(bytes <= 0)
					{	quit = 1;
						eof = 1;
						break;
					}
					ptr = input_string;
					end_ptr = input_string + bytes;
				}
				c++;
				disp_array2++;
					/** check for tab, line feed, carriage return, form feed */
				if(((*ptr==9) || (*ptr==10) || (*ptr==13) || (*ptr==12)) && !binary)
				{	if(*ptr == 9)   /*** tab ***/
					{	c = c / 8;
						c = 8 * (c + 1);
						disp_array2 = disp_array2 / 8;
						disp_array2 = 8 * (disp_array2 + 1);
					}
					else            /*** possible conversion to line feed ***/
					{	c--;
						disp_array2--;
						if((*ptr == 10) || (*ptr == 12))
						{	if(ignorelf && !c)
								ignorelf = 0;
							else
							{	ignorelf = 0;
								break;
							}
						}
					}
				}
				else
				{	if(!binary)
					{	if((*ptr < 32) || (*ptr > 127))
						binary = 1;
					}

					if(((*ptr != 13) || binary) && (old_lines >= 0))
						dispchar(old_lines,c-1,(unsigned char) *ptr);

					if((*ptr != 13) || binary)
						scrn_display[disp_array1][disp_array2] = (char) *ptr;

					if(c >= max_cols)
					{	ignorelf = 1;
						break;
					}
				}
			}
			if(quit)
				break;
		}

			/*    check for end of file displayed **/
		if(eof && (lines_read >= 25))
		{		/*** display last 25 rows ***/
			j = (disp_array1 + 1) % 25;
			for(i=0; ; j = (j + 1) % 25, i++)
			{	for(c=0;c < max_cols;c++)
					dispchar(i,c,(unsigned char) scrn_display[j][c]);
						
				if(j == disp_array1)
					break;
			}
		}

			/*    display prompt                        */
		if(!promptem)
		{	disptext(25,0,"Cursor Selection: move ahead (lines) +1,  +5, +10, +15, +20, +25,+100, quit ");
			bar_on(0,400,639,400);
			message("Enter number of rows to advance (default = 20, q=quit) and press  [RETURN]");
			promptem = 1;
		}

			/*  get answer  */
		for(;!quit;)
		{	if(km() > 0)                  /******* check for keyboard input */
			{	strcpy(string,raw_buf);
				trim(lowerc(string));
				if(*string == 'q')
					quit = 2;
				else
				{	i = 20;    /* default */
					sscanf(string,"%ld",&i);
				}
/*				message("Enter number of rows to advance (defalut = 20, q=quit) and press  [RETURN]");   */
				break;
			}

			if(gr_dev)
			{	if(gi() >= 0)              /******* check for graphics input */
				{	if(*cursor_keys[ginfo.button])
					{	row = ginfo.scoord[1] / 16;
						if(row == 25)
						{	i = ginfo.scoord[0] / 8;
							i = (i - 35) / 5;
							i = i * 5;
							if(i <= 0)
								i = 1;
							if(i > 25)
							{	if(i > 30)
									quit = 2;
								else
									i=100;
							}
						}
						else
							i = 20;
						break;
					}
				}
			}
		}
		if(quit)
			break;
	}

		/********* prompt for return to LTPlus *******************/
	if((quit<2) && (!batch_mode))
	{	message("******* File complete.  Press [RETURN] or any cursor button to continue. *******");
		swplane(3);
		bar_off(0,401,639,414);
		disptext(25,0,"******* File complete.  Press [RETURN] or any cursor button to continue. *******");
		
		for(;;)
		{	if(km() > 0)                  /******* check for keyboard input */
				break;
			if(gr_dev)
			{	if(gi() >= 0)              /******* check for graphics input */
				{	if(*cursor_keys[ginfo.button])
						break;
				}
			}
		}
	}

		/********* close file ************************************/
	closef(fd);
	fd = -1;

		/********* replace graphics ******************************/
	for(i=0; i<4; i++)
	{	swplane(i);
#ifndef LTP_X11
		bitmap(BITPLN_WIDTH,415,BITPLN_WIDTH,BITPLN_WIDTH,scratch_pad[i],vga_plane);
#else
                bitmap4x(WIDTH,415,0,0,xmainpix,0,0,xmainwin);
#endif
	}
	disp_coord_type = save_dctype;
	cursor_mode = save_cmode;
	cursor(ginfo.scoord[0], ginfo.scoord[1]);


		/********* return ****************************************/
	return(0);
}
