/** NOTE: this program is not currently used in LTPlus **/
/*******************************************************************************
*    move_vectors                                                              *
*         This program moves all verticies by a translation, rotation, change  *
*    of scale specified by the parameters already loaded into the transform4   *
*    programs, and an optional reflection specified by the input parameter.    *
*    In addition, all vector data is re-indexed, and a new sized index array   *
*    is build & stored.                                                        *
*                                                                              *
*    Parameters:    long invert;    1=reflect, 0= no reflection                *
*                   double r;       reduction factor                           *
*                                                                              *
*    Value returned:  long 0=ok, 1=error.                                      *
*                                                                              *
*******************************************************************************/

#include "../../incl/globals.h"


move_vectors(invert,r)
long invert;
double r;
{
	ERRORS error;
	OBJECTS object;
	COORD_LIST coordlst;
	V_OBJECTS vobjects;

   char string[STRLIST];

	double cmat[4][2];
	double x,y;
	double r2;

   long i;
	long row, row_max;
	long col, col_max;


		/*********** set index_list recs to 0 **************************/
	job_stats[15] = 0;

		/*********** save job_stats ************************************/
	sprintf(string,"%s/job_stats",temp_map_path);
	put_jobstats(string);

		/*********** 0 out index array *********************************/
	row_max = job_stats[2] >> 5;
	col_max = job_stats[1] >> 5;
	for(row=0; row<=row_max; row++)
	{	for(col=0; col<=col_max; col++)
			index_array[row][col] = 0;
	}
return(0);

		/*********** convert all vector data . . . *******************/
		/*********** convert raster registration *********************/
	for(i=0; i<4; i++)
	{	cmat[i][0] = corner[0][i][0];
		cmat[i][1] = corner[0][i][1];
		transform4(&cmat[i][0],&cmat[i][1],invert);
	}
	register_ltp(0,0,cmat[0],4,(char) ' ');

		/*********** convert coord_list file *************************/
	for(i=0; i<job_stats[11]; i++)
	{		/******** inform user *************/
		if(!(i % 1000))
		{	sprintf(string,"Updating coordinates in the Coord_list file, rec %d (of %d)",i,job_stats[11]);
			message(string);
		}
			/******** get record **************/
		if(get_coordlst(&coordlst,i))
			return(1);
			/******** transform4 coords *******/
		transform4f(&coordlst.x,&coordlst.y,invert);
			/******** put record **************/
		if(put_coordlst(&coordlst,i))
			return(1);
	}

		/*********** convert errors file *****************************/
	for(i=0; i<job_stats[14]; i++)
	{		/******** inform user *************/
		if(!(i % 500))
		{	sprintf(string,"Updating coordinates in the Errors file, rec %d",i);
			message(string);
		}
			/******** get record **************/
		if(get_errors(&error,i))
			return(1);
			/******** transform4 coords *******/
		transform4f(&error.x,&error.y,invert);
			/******** put record **************/
		if(put_errors(&error,i))
			return(1);
	}

		/*********** convert v_objects *******************************/
	for(i=0; i<job_stats[17]; i++)
	{		/******** inform user *************/
		if(!(i % 250))
		{	sprintf(string,"Updating coordinates in the V_objects file, rec %d",i);
			message(string);
		}
			/******** get record **************/
		if(get_vobjects(&vobjects,i))
			return(1);
			/******** check for map node data ********/
		if(vobjects.type == 00)
		{	x = vobjects.v1;
			y = vobjects.v2;
				/******** transform4 coords *******/
			transform4(&x,&y,invert);
			vobjects.v1 = x + 0.5;
			vobjects.v2 = y + 0.5;
				/******** put record **************/
			if(put_vobjects(&vobjects,i))
				return(1);
		}
	}

		/*********** convert v_coordlist *****************************/
	for(i=0; i<job_stats[18]; i++)
	{		/******** inform user *************/
		if(!(i % 5000))
		{	sprintf(string,"Updating coordinates in the V_coordlist file, rec %d",i);
			message(string);
		}
			/******** get record **************/
		if(get_v_coord(&coordlst,i))
			return(1);
			/******** transform4 coords *******/
		transform4f(&coordlst.x,&coordlst.y,invert);
			/******** put record **************/
		if(put_v_coord(&coordlst,i))
			return(1);
	}

		/*********** convert objects file ****************************/
		/******( includes length & perimeter ) ***********************/
	if(r > 0.0)
	{	r2 = r * r;
		for(i=0; i<job_stats[10]; i++)
		{		/******** inform user *************/
		if(!(i % 250))
		{	sprintf(string,"Updating coordinates in the Objects file, rec %d",i);
			message(string);
		}
				/******** get record **************/
			if(get_objects(&object,i))
				return(1);
				/******** transform4 coords *******/
			transform4f(&(object.f4[0]),&(object.f4[1]),invert); /** centroid **/
			object.f4[2] = object.f4[2] / r;                  /** length ****/
			object.f4[3] = object.f4[3] / r2;                 /** area  *****/
	
				/******** put record **************/
			if(put_objects(&object,i))
				return(1);
		}
	}
	
		/*********** re-index map objects ****************************/
	if(job_stats[10])
	{	if(index_map())
			return(1);
	}

		/*********** re-index vector objects *************************/
	if(job_stats[17])
	{	if(index_vobj(1))
			return(1);
	}

   	/*** All done.  Return ***/
   return(0);
}
