/*******************************************************************************
*   obj_count  (see manual, Internal Functions)                         <in>   *
*        Will calculate the number of nodes, segments, interior polygons, and  *
*        'other' objects in a maps objects file.                               *
*        Parameters:  A pointer to a structure of type OBJ_CNT.                *
*        Globals Modified:  None.                                              *
*                                                                              *
*        Returns 0 if all OK, else returns -1.                                 *
*        C. Jonson    1/2/90                                                   *
*******************************************************************************/
#include "../../incl/globals.h"

long obj_count( otally )
	OBJ_CNT *otally;
{
	long       end_orec;
	long       i;
	OBJECTS    orec;

/*** Ensure there is a current map ***
	if( !job_stats[0] )
		return(-1);

/*** Calculate number of object records ***/
	end_orec = job_stats[10];        

/*** Zero out tallys in structure ***/
	otally->nodes = otally->segments = otally->int_polys = otally->others = 0;

/*** Read objects file until EOF and format plotter commands ***/
	for(i = 0; i < end_orec; i++ )
	{	if( get_objects( &orec, i ))
		{	message("OBJ_COUNT:  Cannot read objects file");
			return(-1);
		}

		switch(orec.i12[0])
		{	case 3:				/* Node with 0 branches */
			case 4:				/* Node with 1 branch   */
			case 5:				/* Node with 2 branches */
			case 6:				/* Node with 3 branches */
			case 7:				/* Node with 4 branches */
				otally->nodes++;
				break;
			case 8:				/* Seg with 2 free ends */
			case 9:				/* Seg with 1 free end  */
			case 10:			/* Seg with 0 free ends */
				otally->segments++;
				break;
			case 14:			/* Interior Polygons */
				otally->int_polys++;
				break;
			default:
				otally->others++;
				break;
		}
	}

	return(0);
}
