/*******************************************************************************
*       pack_atrbts                                                            *
*           this program packs the map attributes file.                        *
*                                                                              *
*       Globals/files changed:  job_stats[13] & the objects file & attributes  *
*                               file.                                          *
*                                                                              *
*       Parameters:  none                                                      *
*                                                                              *
*       Returned:    long 0 = pack successful                                  *
*                         1 = failed                                           *
*                                                                              *
*       j.Dabritz  8/5/89                                                      *
*******************************************************************************/

#include "../../incl/globals.h"

int natrbts_fd;


long pack_atrbts()
{
	long put_new_at();
	char *malloc_ltp();

	OBJECTS object;
	ATTRIBUTES attributes;

	char string[256];
	char string2[256];
	char path[256];

	long obj;
	long new_attributes;
	long next;
	long size;


		/************** check for map present **************************/
	if(!job_stats[0])
	{	message("abort, pack_atrbts, location 1");
		return(1);
	}

		/************** create new (blank) attributes file *************/
	sprintf(string,"%s/natrbts",temp_map_path);
	purgef(string);

	sprintf(path, "%s/natrbts", temp_map_path );
	if(creatf(path) < 0)
	{	message("cannot create new attributes file for packing, aborting.");
		return(1);
	}
		/*    open file        */
	sprintf(path,"%s/natrbts",temp_map_path);
	natrbts_fd = openf(path,RDWR);
	if(0 > natrbts_fd)
	{	message("  <<  cannot open natrbts map file.");
		return(1);
	}

		/************** read through objects, copying attribute linked lists */
	new_attributes = 0;
		/** write a dummy first attribute. **/
	if(put_new_at(&attributes,new_attributes++))
	{	message("abort, pack_atrbts, location 3");
		return(1);
	}

		/** ( can't reference record 0 if 0 is used as a flag.) **/
	for(obj = 0;  obj < job_stats[10]; obj++)
	{		/*** read object record **/
		if(get_objects(&object,obj))
		{	message("abort, pack_atrbts, location 4");
			return(1);
		}
			/*** copy linked list of attributes **/
		if(object.i12[2])
		{	next = object.i12[2];
			object.i12[2] = new_attributes;
			for(; next; )
			{		/*** read next attribute record **/
				if(get_attr(&attributes,next))
				{	message("abort, pack_atrbts, location 5");
					return(1);
				}
					/*** save next old & set next new **/
				next = attributes.next;
				if(next)
					attributes.next = new_attributes + 1;
				  /*** store record in packed file. **/
				if(put_new_at(&attributes,new_attributes++))
				{	message("abort, pack_atrbts, location 6");
					return(1);
				}
			}
				/*** store object record with new attribute pointer **/
			if(put_objects(&object,obj))
			{	message("abort, pack_atrbts, location 7");
				return(1);
			}
		}
	}

		/************** close & free old attributes file ***************/
	if(attributes_fd >= 0)
	{	closef(attributes_fd);
		attributes_fd = -1;
	}
	if(attributesm.malloc)
	{	free_ltp(attributesm.malloc);
		attributesm.malloc = (char *) 0;            
	}
 
 
		/************** purge old file *********************************/
	sprintf(string,"%s/attributes",temp_map_path);
	purgef(string);

		/************** move new file into old files place *************/
		/** close new file **/
	closef(natrbts_fd);
		/** move to new file **/
	sprintf(string,"%s/natrbts",temp_map_path);
	sprintf(string2,"%s/attributes",temp_map_path);
	if(move_file(string,string2))
	{	message("Cannot move new attributes file.  Aborting.");
		return(1);
	}


		/************** reset job_stats counter for attributes recs ****/
	job_stats[13] = new_attributes;


		/************** open & malloc attributes file ******************/
		/*    open file        */
	sprintf(path,"%s/attributes",temp_map_path);
	attributes_fd = openf(path,RDWR);
	if(0 > attributes_fd)
	{	message("  <<  cannot open attributes map file.");
		return(1);
	}
		/*  calculate size to malloc */
	size = attributesm.rec_size * job_stats[13];
		/*  malloc space & set pointer or leave file (stream) pointer  */
	if(size)
	{	if(ramfree(size + RAMSPACE))
		{	if(attributesm.malloc = (malloc_ltp(size)))
			{   attributesm.rec0 = attributesm.malloc;
				attributesm.recn = attributesm.rec0 + size;
				if(!readb(attributesm.rec0,size,1,attributes_fd))
				{	message("  <<  cannot read attributes map file.");
					return(1);
				}
			}
		}
	}


		/************** return *****************************************/
	return(0);
}


/*******************************************************************************
*      put_new_at                                                              *
*                       This program stores the input structure into the       *
*                       record indicated in the natrbts file pointer.          *
*                                                                              *
*                       only the file written is changed.                      *
*                                                                              *
*                       Returns zero upon normal end-of-job (EOJ).             *
*                       returns 1 upon failure.                                *
*                      j.dabritz  8/5/89                                       *
*******************************************************************************/


long put_new_at(ptr,record_number)
ATTRIBUTES *ptr;                /*  pointer to object structure to be put    */
long record_number;          /*  record number for put.                   */
{
	long offset;

		/******************** calculate offset **************************/
	offset = record_number * attributesm.rec_size;

		/******************** position file write pointer ***************/
	if(0 > movefp(natrbts_fd,offset,0))
	{	message(" cannot position read/write pointer in natrbts file.  aborting.");
		return(1);
	}
		/******************** read  record ******************************/
	if(0 > writeb((char *)ptr, attributesm.rec_size ,1 ,natrbts_fd))
	{	message(" cannot write in new natrbts file.  aborting.");
		return(1);
	}

		/******************** return ************************************/
	return(0);
}
