/*******************************************************************************
*       parse           (see manual, Internal Functions)                <in>   *
*			Parses buffer passed by using specified delimiters     *
*			and loads each parsed element into an array.  Each     *
*			parsed element will be a null terminated string.       *
*                                                                              *
*                       Returns number of parsed elements found.               *
*                      j.dabritz  3/7/89 - 5/8/89                              *
*******************************************************************************/

#include <string.h> 
#include "../../incl/globals.h"

long parse( raw, delimiters, parsed, max_elements )
	char *raw;
	char *delimiters;
	char *parsed;
	long max_elements;
{
	long i,j,k;
	char *parsep;

		/*  initialize parsed array to null     */
	for(i=0; i<max_elements ; i++) 
		parsed[i * STRLIST] = (char) NULL;

		/*   initialize the return value (j)    */
	j = 0;

		/*   check for null pointer             */
	if(!raw)
		return( j );

		/*   check for null string              */
	if(!raw[0])
		return( j );

		/*   parse string                               */
		/*   i = character counter in raw string        */
		/*   j = parsed element counter                 */
		/*   k = character counter for parsed element   */
		/*   parsep = element of string array (parsed)   */
	parsep = parsed;
	for (i=0, j=0, k=0;  (raw[i]) && (j < max_elements);  i++) 
	{	if(strchr(delimiters,raw[i]))   /*   is the chr a delimiter?  */
		{	if(k)                       /*   does it end a non-delim string? */
			{	parsep[k] = 0;          /*   append a NULL to end of prev str*/
				parsep = parsed + (++j * STRLIST);  /* incrmnt parsep pointer*/
				k = 0;                  /*   reset parse chr ptr to first elem*/
			}
		}
		else                            /*   char is not a delimiter     */
		{	if(k < (STRLIST-1))
				parsep[k++] = raw[i];   /*   add it to the non-delim string */
		}
	}

		/*   add 0 to end of last string & add to parse count               */
	if(k > 0)
	{	parsep[k] = 0;
		j++;
	}

		/*   return parsed count                        */
	return( j );
}
