/*******************************************************************************
*       parsen          (see manual, Internal Functions)                <in>   *
*			Will parse the nth token from the passed string and    *
*			returns the length of the parsed token.  Returns zero  *
*			upon error.                                            *
*                      j.dabritz  3/7/89 - 5/8/89                              *
*******************************************************************************/

#include <string.h> 

#include "../../incl/globals.h"


long parsen( raw, delimiters, parsed, tok_num )
	char *raw;
	char *delimiters;
	char *parsed;
	long tok_num;
{
	long i,j,k;

		/*  initialize parsed value to null     */
	if(parsed)
		parsed[0] = (char) NULL;

		/*  check for null pointers             */
	if(!raw || !parsed || !delimiters || (tok_num < 0))
		return 0;

		/*   parse string                               */
		/*   i = character counter in raw string        */
		/*   j = parsed element counter                 */
		/*   k = character counter for parsed element   */
		/*   parsed = output string                      */
	for (i=0, j=0, k=0;  (raw[i]) && (j <= tok_num);  i++) 
	{	if(strchr(delimiters,raw[i]))   /*   is the chr a delimiter?  */
		{	if(k)                       /*   does it end a non-delim string? */
			{	j++;                    /*   increment parsed element counter*/
				k=0;                  /*   reset parsed character counter to 0*/
			}
		}
		else                            /*   char is not a delimiter     */
		{	if(j == tok_num)            /*  if it is the right token     */
			{	if(k < (STRLIST-1))         /*  if it is in the range STRLIST */
				{	parsed[k++] = raw[i];   /* add it to the non-delim string */
					parsed[k] = (char) NULL;
				}
			}
			else
				k++;
		}
	}

		/*   return parsed count                        */
	return strlen(parsed);
}
