/*******************************************************************************
*	purgef		(see manual, Internal Functions)          	<in>   *
*			Purges any file or removes directories.                *
*			Needs the compiler -DSV32 flag.                        *
*			                                                       *
*			Returns zero upon normal end-of-job (EOJ), else        *
*			returns -1 upon error.                                 *
*			Craig Jonson 8/9/89      *
*******************************************************************************/
#include "../../incl/globals.h"
#include <sys/stat.h>
#define LISTSIZ 200

int purgef( fname )	
	char *fname;
{
	extern int  errno;
	long        i;
	long        num_list;
	char        file_name[256];
	char        name_list[LISTSIZ][STRLIST];
	char        tmp_msg[STRLIST];
	struct stat buf;

	if( stat(fname, &buf) )
	{	if(errno == 2)      /** file is already gone ***/
			return(0);
		sprintf(tmp_msg, "purgef, note:  file  %s  nonexistant.", fname);
		message(tmp_msg);
		return(-1);
	}
	if( buf.st_mode & 040000 )
	{	while( num_list = dir_list(fname, name_list, LISTSIZ) )
		{	for(i = 0; i < num_list; i++)
			{	sprintf(file_name, "%s/%s", fname,name_list[i]);
				if( purgef(file_name) == -1)
					return(-1);
			}
		}
/* #if (SV32 || ULTRIX || SUNOS) */
#ifndef SCO_UNIX
		if( rmdir( fname) == -1)
		{	sprintf(tmp_msg, "Cannot unlink %s.  Errno is %d", fname, errno );
			message(tmp_msg);
			return(-1);
		}
#else
		sleep(1);  /** hesitate & remove the directory. **/
		sprintf(tmp_msg, "rmdir %s", fname);
		for(i=0; system_ltp(tmp_msg) && (i<20); sleep(1), i++);
		if(i == 20)
		{	sprintf(tmp_msg, "Cannot remove %s.", fname);
			message(tmp_msg);
			return(-1);
		}
		sleep(1); /** hesitate again **/
			/*** ensure its deleted ***/
		for(i=0; (i<20) && !stat(fname, &buf); sleep(1), i++ );
		if(i == 20)
		{	sprintf(tmp_msg, "Cannot remove %s (we tried).", fname);
			message(tmp_msg);
			return(-1);
		}
#endif
	}
	else if( unlink(fname) == -1)
	{	sprintf(tmp_msg, "Cannot unlink %s.  Errno is %d", fname, errno );
		message(tmp_msg);
		return(-1);
	}
	return(0);
}
