/*******************************************************************************
*       put_atrbt       (see manual, Internal Functions)                <in>   *
*                       This program stores the information in one attributes  *
*                       structure in either malloc space or the temp file.     *
*                       (whichever is being used as data storage)              *
*                                                                              *
*                       The malloc space/file is changed.                      *
*                       The malloc struct may be changed.                      *
*                       The job_stats[13] entry is updated.                    *
*                                                                              *
*                       Returns zero upon normal end-of-job (EOJ).             *
*                       returns 1 upon failure.                                *
*                      j.dabritz  6/12/89                                      *
*******************************************************************************/

#include "../../incl/globals.h"  /*  <stdio.h> & all LTP defines & globals  */
#include <string.h>
#include <malloc.h>


long put_atrbt(ptr,rec_no)
ATTRIBUTES *ptr;                /*  pointer to structure to be saved  */
long rec_no;          /*  one greater than record number for save    */
{
	char *new_ptr;
	char path[512];
	char *to_ptr;

	long offset;
	long put_on_disc;
	long size;

		/******************** check for legitimate parameters ***********/
	if(!ptr  ||  rec_no < 0 || (rec_no > job_stats[13]))
	{	message("put_atrbt, bad parameters received, rejected.");
		return(1);
	}

		/******************** trim string to 30 char or less ************/
	(*ptr).string[30] = 0;
	
		/******************** calculate offset **************************/
	offset = rec_no * attributesm.rec_size;

		/******************** see if current storage is in RAM  *********/
	put_on_disc = 0;    /** default **/
	if(attributesm.malloc != (char *) 0)       
	{		/******************** check for enough existing malloc'd space **/
		if((attributesm.rec0 + offset + attributesm.rec_size) > attributesm.recn)
		{		/******************** reallocate enough space ***************/
			size = attributesm.recn - attributesm.rec0;
			size += 2000 * attributesm.rec_size;     /*** add 2000 records ***/
				/*   try to realloc space  */
			new_ptr = (char *) realloc_ltp(attributesm.malloc,size);
			if(new_ptr != (char *) 0)
			{	attributesm.malloc = new_ptr;
				attributesm.rec0 = new_ptr;
				attributesm.recn = new_ptr + size;
					/*   check for a meg free    */
				if(!ramfree(1000000))
					put_on_disc = 1;
			}
			else
				put_on_disc = 1;

			if(put_on_disc)         /*  dump file to disc   */
			{	sprintf(path,"%s/attributes",temp_map_path);
				if(0 > (attributes_fd = openf(path,RDWR)))
					return(1);
				if(0 > writeb(attributesm.rec0,attributesm.rec_size,job_stats[13],attributes_fd))
					return(1);
				free_ltp(attributesm.malloc);
				attributesm.malloc = (char *) 0;
				attributesm.rec0 = (char *) 0;
				attributesm.recn = (char *) 0;
			}
		}
			/******************** store in ram ******************************/
		if(!put_on_disc)
		{	to_ptr = attributesm.rec0 + offset;
			memcpy(to_ptr,(char *)ptr,attributesm.rec_size);
		}
	}

	if(attributesm.malloc == 0)
	{		/******************** check for file pointer ********************/
		if(0 > attributes_fd)
		{	message("put_atrbt, there is no file pointer, rejecting.");
			return(1);
		}
			/******************** position file write pointer ***************/
		if(0 > movefp(attributes_fd,offset,0))
			return(1);
			/******************** write record ******************************/
		if(0 > writeb((char *)ptr, attributesm.rec_size ,1 ,attributes_fd))
			return(1);
	}

		/******************** update job_stats file *********************/
	job_stats[13] = (rec_no < job_stats[13]) ? job_stats[13] : (rec_no + 1);

		/******************** return ************************************/
	return(0);
}
