/*******************************************************************************
*       put_config      (see manual, Internal Functions)                <in>   *
*                       This program stores the information in the config.h    *
*                       global into a file whose path is the parameter.        *
*                                                                              *
*       parameters:  none                                                      *
*                                                                              *
*                       Only the file written is changed.                      *
*                                                                              *
*                       Returns zero upon normal end-of-job (EOJ).             *
*                       returns 1 upon failure.                                *
*                      j.dabritz  6/9/89                                       *
*******************************************************************************/
/* Modified 6/92 by DBS@CWU for multi user support */

#include "../../incl/globals.h"  /*  <stdio.h> & all LTP defines & globals  */

int   closef();         /*  (int stream)                                    */
char *lowerc();         /*  (char *string)                                    */
int openf();          /*  (char *path, char *type)                      */
char *reada();          /*  ( char *string, int bytes, int stream )         */
char *strstr();         /*  (char *ref, char *test)                           */
char *trim();           /*  (char *string)                                    */


long put_config()
{
	char line[4096];
	char path[256];
	int file; 

		/*    open the config file                               */
#ifdef MULTIUSER
	sprintf(path,"%s/.ltp/config/config",home_path);
#else
	sprintf(path,"%s/config/config",ltp_path);
#endif
	if(creatf(path) < 0)
		return(1);
	file = openf(path, WRITE);
	if(0 > file)
		return((long) 1);

		/*    go through the header global writting 1 line       */
		/*    in the file for each element.                      */
	sprintf(line,"prtr_adr = %s\n",trim(config.prtr_adr));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"prtr_type = %s\n",trim(config.prtr_type));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"crt_adr = %s\n",trim(config.crt_adr));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"crt_type = %s\n",trim(config.crt_type));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"bkup11 = %s\n",trim(config.bkup11));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"bkup12 = %s\n",trim(config.bkup12));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"bkup21 = %s\n",trim(config.bkup21));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"bkup22 = %s\n",trim(config.bkup22));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"print1 = %s\n",trim(config.print1));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"print2 = %s\n",trim(config.print2));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"edit1 = %s\n",trim(config.edit1));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"edit2 = %s\n",trim(config.edit2));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"cursor_file = %s\n",trim(config.cursor_file));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"mouse_adr = %s\n",trim(config.mouse_adr));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"mouse_type = %s\n",trim(config.mouse_type));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"dig1_adr = %s\n",trim(config.dig1_adr));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"dig1_type = %s\n",trim(config.dig1_type));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"dig2_adr = %s\n",trim(config.dig2_adr));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"dig2_type = %s\n",trim(config.dig2_type));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"plt1_adr = %s\n",trim(config.plt1_adr));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"plt1_type = %s\n",trim(config.plt1_type));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"plt2_adr = %s\n",trim(config.plt2_adr));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"plt2_type = %s\n",trim(config.plt2_type));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"maps_path = %s\n",trim(config.maps_path));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"bkup_path = %s\n",trim(config.bkup_path));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"data3_path = %s\n",trim(config.data3_path));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"data4_path = %s\n",trim(config.data4_path));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"export_path = %s\n",trim(config.export_path));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"import_path = %s\n",trim(config.import_path));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"malloc = %s\n",trim(config.malloc));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"menuset = %s\n",trim(config.menuset));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"ginput = %s\n",trim(config.ginput));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"rasterh = %s\n",trim(config.rasterh));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"rasterw = %s\n",trim(config.rasterw));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"pen0 = %s\n",trim(config.pen0));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"pen1 = %s\n",trim(config.pen1));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"pen2 = %s\n",trim(config.pen2));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"pen3 = %s\n",trim(config.pen3));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"pen4 = %s\n",trim(config.pen4));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"pen5 = %s\n",trim(config.pen5));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"pen6 = %s\n",trim(config.pen6));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"pen7 = %s\n",trim(config.pen7));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"pen8 = %s\n",trim(config.pen8));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"tile1 = %s\n",trim(config.tile1));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"tile2 = %s\n",trim(config.tile2));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"tile3 = %s\n",trim(config.tile3));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"tile4 = %s\n",trim(config.tile4));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"tile5 = %s\n",trim(config.tile5));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"tile6 = %s\n",trim(config.tile6));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"tile7 = %s\n",trim(config.tile7));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"tile8 = %s\n",trim(config.tile8));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"tile9 = %s\n",trim(config.tile9));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"tile10 = %s\n",trim(config.tile10));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"tile11 = %s\n",trim(config.tile11));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}

		/*    close file                                         */
	closef(file);

	return(0);
}
