/*******************************************************************************
*       put_coordlst    (see manual, Internal Functions)                <in>   *
*                       This program stores the information in one coord_list  *
*                       structure in either malloc space or the temp file.     *
*                       (whichever is being used as data storage)              *
*                                                                              *
*                       The malloc space/file is changed.                      *
*                       The malloc struct may be changed.                      *
*                       The job_stats[11] entry is updated.                    *
*                                                                              *
*                       Returns zero upon normal end-of-job (EOJ).             *
*                       returns 1 upon failure.                                *
*                      j.dabritz  6/12/89                                      *
*******************************************************************************/

#include "../../incl/globals.h"  /*  <stdio.h> & all LTP defines & globals  */
#include <string.h>
#include <malloc.h>


long put_coordlst(ptr,rec_no)
COORD_LIST *ptr;         /*  pointer to coord_list structure to be saved  */
long rec_no;          /*  record number of item to save              */
{
	char *new_ptr;
	char path[512];
	char *to_ptr;

	long offset;
	long put_on_disc;
	long size;

		/******************** check for legitimate parameters ***********/
	if(!ptr  ||  rec_no < 0 || (rec_no > job_stats[11]))
	{	message("put_coordlst, bad parameters received, rejected.");
		return(1);
	}

		/******************** calculate offset **************************/
	offset = rec_no * coord_listm.rec_size;

		/******************** see if current storage is in RAM  *********/
	put_on_disc = 0;    /** default **/
	if(coord_listm.malloc != (char *) 0)       
	{		/******************** check for enough existing malloc'd space **/
		if((coord_listm.rec0 + offset + coord_listm.rec_size) > coord_listm.recn)
		{		/******************** reallocate enough space ***************/
			size = coord_listm.recn - coord_listm.rec0;
			size += 2000 * coord_listm.rec_size;     /*** add 2000 records ***/
				/*   try to realloc space  */
			new_ptr = (char *) realloc_ltp(coord_listm.malloc,size);
			if(new_ptr != (char *) 0)
			{	coord_listm.malloc = new_ptr;
				coord_listm.rec0 = new_ptr;
				coord_listm.recn = new_ptr + size;
					/*   check for a meg free    */
				if(!ramfree(1000000))
					put_on_disc = 1;
			}
			else
				put_on_disc = 1;

			if(put_on_disc)         /*  dump file to disc   */
			{	sprintf(path,"%s/coord_list",temp_map_path);
				if(0 > (coord_list_fd = openf(path,RDWR)))
					return(1);
				if(0 > writeb(coord_listm.rec0,coord_listm.rec_size,job_stats[11],coord_list_fd))
					return(1);
				free_ltp(coord_listm.malloc);
				coord_listm.malloc = (char *) 0;
				coord_listm.rec0 = (char *) 0;
				coord_listm.recn = (char *) 0;
			}
		}
			/******************** store in ram ******************************/
		if(!put_on_disc)
		{	to_ptr = coord_listm.rec0 + offset;
			memcpy(to_ptr,(char *)ptr,coord_listm.rec_size);
		}
	}

	if(coord_listm.malloc == 0)
	{		/******************** check for file pointer ********************/
		if(0 > coord_list_fd)
		{	message("put_coordlst, there is no file pointer, rejecting.");
			return(1);
		}
			/******************** position file write pointer ***************/
		if(0 > movefp(coord_list_fd,offset,0))
			return(1);
			/******************** write record ******************************/
		if(0 > writeb((char *)ptr, coord_listm.rec_size ,1 ,coord_list_fd))
			return(1);
	}

		/******************** update job_stats file *********************/
	job_stats[11] = (rec_no < job_stats[11]) ? job_stats[11] : (rec_no + 1);

		/******************** return ************************************/
	return(0);
}
