/*******************************************************************************
*       put_diary       (see manual, Internal Functions)                <in>   *
*                       This program appends the diary with who/what/when      *
*                       and the input string.                                  *
*                                                                              *
*                       The diary file is changed.                             *
*                                                                              *
*                       Returns zero upon normal end-of-job (EOJ).             *
*                       returns 1 upon failure.                                *
*                      j.dabritz  8/11/89                                      *
*******************************************************************************/

#include "../../incl/globals.h"  /*  <stdio.h> & all LTP defines & globals  */
#include <string.h>
#include <time.h>

long put_diary(diary_entry)
char *diary_entry;
{
	int fp;
	char string[256];
	char filepath[256];
	char *std_header();

		/************** check for map loaded ***************************/
	if(!job_stats[0])
	{	message("cannot make diary entry unless a map is loaded.");
		return(1);
	}

		/************** check & trim diary entry parameter *************/
	trim(diary_entry);
	if(!*diary_entry)
	{	message("diary entry is blank, nothing written.");
		return(1);
	}
	
		/************** open diary file ********************************/
	sprintf(filepath, "%s/%s", temp_map_path, "diary" );
	if( (fp = openf( filepath, APPEND)) == -1 )
		return(1);

		/************** write info_data string *************************/
	if( 0 > writea( std_header(string), fp) )
		return(1);

		/************** write input diary_entry string *****************/
	sprintf(string,"  > %s\n\n",diary_entry);
	if( 0 > writea( string, fp) )
		return(1);

		/************** close file *************************************/
	closef( fp );

		/************** return *****************************************/
	return(0);
}
