/*******************************************************************************
*       put_header      (see manual, Internal Functions)                <in>   *
*                       This program stores the information in the header.h    *
*                       global into a file whose path is the parameter.        *
*                                                                              *
*       parameters:  char *path;    complete file path                         *
*                    HEADER *head;  pointer to HEADER structure to be written  *
*                                                                              *
*                       Only the file written is changed.                      *
*                                                                              *
*                       Returns zero upon normal end-of-job (EOJ).             *
*                       returns 1 upon failure.                                *
*                      j.dabritz  6/9/89                                       *
*******************************************************************************/

#include "../../incl/globals.h"  /*  <stdio.h> & all LTP defines & globals  */

int   closef();         /*  (int stream)                                    */
char *lowerc();         /*  (char *string)                                    */
int openf();          /*  (char *path, char *type)                      */
char *reada();          /*  ( char *string, int bytes, int stream )         */
char *strstr();         /*  (char *ref, char *test)                           */
char *trim();           /*  (char *string)                                    */


long put_header(path,head)
char *path;
HEADER *head;
{
	char line[4096];
	int file; 

		/*    open the header file                               */
	if(creatf(path) < 0)
		return(1);
	file = openf(path, WRITE );
	if(0 > file)
		return((long) 1);

		/*    go through the header global writting 1 line       */
		/*    in the file for each element.                      */
	sprintf(line,"comments = %s\n",trim(head->comments));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"compress = %s\n",trim(head->compress));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"contour_interval = %s\n",trim(head->contour_interval));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"datum = %s\n",trim(head->datum));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"dictionary = %s\n",trim(head->dictionary));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"edgematch = %s\n",trim(head->edgematch));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"edge_e = %s\n",trim(head->edge_e));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"edge_n = %s\n",trim(head->edge_n));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"edge_s = %s\n",trim(head->edge_s));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"edge_w = %s\n",trim(head->edge_w));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"head1 = %s\n",trim(head->head1));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"head2 = %s\n",trim(head->head2));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"layer_name = %s\n",trim(head->layer_name));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"map_ht = %s\n",trim(head->map_ht));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"map_wd = %s\n",trim(head->map_wd));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"maptype = %s\n",trim(head->maptype));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"menu_set = %s\n",trim(head->menu_set));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"org = %s\n",trim(head->org));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"quad_unit = %s\n",trim(head->quad_unit));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"revision_yr = %s\n",trim(head->revision_yr));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"scale = %s\n",trim(head->scale));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"search_rad = %s\n",trim(head->search_rad));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"source_yr = %s\n",trim(head->source_yr));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"state = %s\n",trim(head->state));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"stplzn = %s\n",trim(head->stplzn));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"template1 = %s\n",trim(head->template1));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"template2 = %s\n",trim(head->template2));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"template3 = %s\n",trim(head->template3));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"udrn = %s\n",trim(head->udrn));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"utmln = %s\n",trim(head->utmln));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}
	sprintf(line,"utmlt = %s\n",trim(head->utmlt));
	if (0 > writea(line,file))
	{	closef(file);
		return(1);
	}

		/*    close file                                         */
	closef(file);

	return(0);
}
