/*******************************************************************************
*       put_history     (see manual, Internal Functions)                <in>   *
*                       This program stores the information in the history     *
*                       global into a file whose path is the parameter.        *
*                                                                              *
*                       Only the file written is changed.                      *
*                                                                              *
*                       Returns zero upon normal end-of-job (EOJ).             *
*                       returns 1 upon failure.                                *
*                      j.dabritz  6/12/89                                      *
*******************************************************************************/

#include "../../incl/globals.h"  /*  <stdio.h> & all LTP defines & globals  */

int openf();          /*  (char *path, char *type)                      */
char *trim();


long put_history(path)
char *path;
{
	char line[512];
	int file; 
	long i;
	long newest_hist;

		/*    open the history file                               */
	file = openf(path, O_TRUNC | O_WRONLY | O_CREAT);
	if(0 > file)
		return(1);

		/*    go through the history global from oldest to newest */
		/*    writing 1 line for each element.                   */
	newest_hist = (next_hist + 511) % 512;
	for( i=next_hist; ; i= (i+1) % 512)
	{	trim((char *) (history[i] + 2));
		if(*(history[i]))
		{	history[i][STRLIST - 2] = 0;
			sprintf(line,"%s\n",history[i]);
			if(writea(line,file))
			{	close(file);
				return(1);
			}
		}
		if(i == newest_hist)
			break;
	}

		/*    close file                                         */
	closef(file);

	return(0);
}
