/*******************************************************************************
*       put_raster      (see manual, Internal Functions)                <in>   *
*                       This program stores the information in the raster      *
*                       global into a file whose path is the parameter.        *
*                                                                              *
*                       Only the file written is changed.                      *
*                                                                              *
*                       Returns zero upon normal end-of-job (EOJ).             *
*                       returns 1 upon failure.                                *
*                      j.dabritz  6/12/89                                      *
*******************************************************************************/

#include "../../incl/globals.h"  /*  <stdio.h> & all LTP defines & globals  */


long put_raster(path)
char *path;
{
	int fd; 
	long size;
	long bytes;
	char temp[256];

		/*    open the raster file                             */
	if(0 > (fd = openf(path, WRITE)))
	{	append_msg("  Error on raster file open.");
		return(1);
	}

		/*   write raster array  */
	size = (job_stats[1]+1) * (job_stats[2]+1)  / 8;
	if(( bytes = writeb((char *)rasterm.rec0, size, 1, fd)) != size)
	{	sprintf(temp, "wrote %d bytes", bytes);
		append_msg(temp);
		closef(fd);
	 	return(1);
	}

		/*    close fd                                         */
	closef(fd);

	return(0);
}

