/*******************************************************************************
*       put_register    (see manual, Internal Functions)                <in>   *
*                       This program stores the information in the register    *
*                       global into a file whose path is the parameter.        *
*                                                                              *
*                       Only the file written is changed.                      *
*                                                                              *
*                       Returns zero upon normal end-of-job (EOJ).             *
*                       returns 1 upon failure.                                *
*                      j.dabritz  6/12/89                                      *
*******************************************************************************/
/* Modified 7/92 by DBS@CWU for big endian support */

#include "../../incl/globals.h"  /*  <stdio.h> & all LTP defines & globals  */
#ifdef BIG_ENDIAN
#include "../../incl/big_end.h"
#endif


long put_register(path)
char *path;
{
	int fd; 

		/*    open the register file                             */
	if(0 > (fd = openf(path, WRITE)))
		return(1);

#ifdef BIGENDIAN
	byte_swap(corner[0][0], 8*30*4*2, SWAP_DOUBLE);
#endif

		/*   write corner array  */
	if(0 > writeb((char *)corner[0][0], 8, (30 * 4 * 2) ,fd))
	{	closef(fd);
	 	return(1);
	}

#ifdef BIGENDIAN
	byte_swap(corner[0][0], 8*30*4*2, SWAP_DOUBLE);
#endif

		/*    close fd                                         */
	closef(fd);

	return(0);
}

