/*******************************************************************************
*       put_seg_list    (see manual, Internal Functions)                <in>   *
*                       This program stores the information in a long          *
*                       in either malloc space or the temp file.               *
*                       (whichever is being used as data storage)              *
*                                                                              *
*                       The malloc space/file is changed.                      *
*                       The malloc struct may be changed.                      *
*                       The job_stats[12] entry is updated.                    *
*                                                                              *
*                       Returns zero upon normal end-of-job (EOJ).             *
*                       returns 1 upon failure.                                *
*                      j.dabritz  6/12/89                                      *
*******************************************************************************/

#include "../../incl/globals.h"  /*  <stdio.h> & all LTP defines & globals  */
#include <string.h>
#include <malloc.h>


long put_seg_list(ptr,rec_no)
long *ptr;                /*  pointer to segment number to be saved    */
long rec_no;          /*  record number to save long in              */
{
	char *new_ptr;
	char path[512];
	char *to_ptr;

	long offset;
	long put_on_disc;
	long size;

		/******************** check for legitimate parameters ***********/
	if(!ptr  ||  rec_no < 0 || (rec_no > job_stats[12]))
	{	message("put_seg_list, bad parameters received, rejected.");
		return(1);
	}

		/******************** calculate offset **************************/
	offset = rec_no * seg_listm.rec_size;

		/******************** see if current storage is in RAM  *********/
	put_on_disc = 0;    /** default **/
	if(seg_listm.malloc != (char *) 0)       
	{		/******************** check for enough existing malloc'd space **/
		if((seg_listm.rec0 + offset + seg_listm.rec_size) > seg_listm.recn)
		{		/******************** reallocate enough space ***************/
			size = seg_listm.recn - seg_listm.rec0;
			size += 2000 * seg_listm.rec_size;     /*** add 2000 records ***/
				/*   try to realloc space  */
			new_ptr = (char *) realloc_ltp(seg_listm.malloc,size);
			if(new_ptr != (char *) 0)
			{	seg_listm.malloc = new_ptr;
				seg_listm.rec0 = new_ptr;
				seg_listm.recn = new_ptr + size;
					/*   check for a meg free    */
				if(!ramfree(1000000))
					put_on_disc = 1;
			}
			else
				put_on_disc = 1;

			if(put_on_disc)         /*  dump file to disc   */
			{	sprintf(path,"%s/seg_list",temp_map_path);
				if(0 > (seg_list_fd = openf(path,RDWR)))
					return(1);
				if(0 > writeb(seg_listm.rec0,seg_listm.rec_size,job_stats[12],seg_list_fd))
					return(1);
				free_ltp(seg_listm.malloc);
				seg_listm.malloc = (char *) 0;
				seg_listm.rec0 = (char *) 0;
				seg_listm.recn = (char *) 0;
			}
		}
			/******************** store in ram ******************************/
		if(!put_on_disc)
		{	to_ptr = seg_listm.rec0 + offset;
			memcpy(to_ptr,(char *)ptr,seg_listm.rec_size);
		}
	}

	if(seg_listm.malloc == 0)
	{		/******************** check for file pointer ********************/
		if(0 > seg_list_fd)
		{	message("put_seg_list, there is no file pointer, rejecting.");
			return(1);
		}
			/******************** position file write pointer ***************/
		if(0 > movefp(seg_list_fd,offset,0))
			return(1);
			/******************** write record ******************************/
		if(0 > writeb((char *)ptr, seg_listm.rec_size ,1 ,seg_list_fd))
			return(1);
	}

		/******************** update job_stats file *********************/
	job_stats[12] = (rec_no < job_stats[12]) ? job_stats[12] : (rec_no + 1);

		/******************** return ************************************/
	return(0);
}
