/*******************************************************************************
*	reacquire2(see manual, Command Ref., Internal Functions)	<in>   *
*	         	reacquires the temp map file using the acquire function.        *
*			      (different from reacquire, which does not use the acquire       *
*               function, but is faster).                       *
*			Returns 1 if successful, 0 if not.                     *
*			j.dabritz, 1/25/91                                     *
*******************************************************************************/

#include <string.h>
#include "../../incl/globals.h"
#include "../../incl/in.h"
#include <malloc.h>
#include <sys/stat.h>
#include <errno.h>

long reacquire2( )
{	
	
	char hold_map_name[256];
	char hold_map_path[256];
	char new_path[256];
	char string[512];

	extern int errno;
	struct stat buf;

	long i;

		/************* update temp map **************/
	if(update_temp())
		return(1);

		/************* copy map name, path ***/
	sprintf(hold_map_name,"%s",map_name);
	sprintf(hold_map_path,"%s",map_path);

		/************* rename temp path *************/
		/*  copy map file to temp directory                                */
	i=0;
	for(;i<100;i++) /* make temporary directory */
	{	sprintf(new_path,"%s/temp%d",maps_path,i);
			/*  If directory doesn't exit, break out       */
		if( !stat( new_path, &buf) == 0 )
			break;
	}
	if(i >= 100)
		return(1);

	sprintf(string,"mv %s %s",temp_map_path,new_path);
	if(system_ltp(string))
		return(1);

		/************* acquire renamed temp map *********/
	if(!acquire(new_path))
		return(1);

		/************* reset map name, path ***/
	sprintf(map_name,"%s",hold_map_name);
	sprintf(map_path,"%s",hold_map_path);

		/************* display correct name    **************/
		/*   display map name in upper left block, line 2 */
	strcpy(string,map_name);
	string[14] = 0;
	for(i=2; i<4; i++)
	{	swplane(i);
		if(windowxmin)
		{	bar_off(0,16,111,31);
			disptext(1,0,string);
		}
		else
		{	bar_off(528,416,639,431);
			disptext(26,66,string);
		}
	}

		/************* purge renamed temp map  **************/
	purgef(new_path);

		/************* return                  **************/
	return(0);
}
