/*******************************************************************************
*   reflect_indx    (see manual, Command Ref., Internal Functions)  <fc>       *
*           Description:  Fills a 256 byte unsigned character array with       *
*			the reverse value of each character (byte) number.                 *
*                                                                              *
*			Parameters:  unsigned char *index;        (256 bytes minimum)      *
*                                                                              *
*           Globals/files changed:  none                                       *
*                                                                              *
*           Returns zero upon normal end-of-job (EOJ).                         *
*                   J.Dabritz,   1/3/89                                        *
*******************************************************************************/


long reflect_indx(index)
	unsigned char *index;
{
	long b,i;

		/************* for each byte *********/
	for(i=0; i < 256; i++)
	{	index[i] = 0;         /** initialize to 0 ***/
		for(b = 0; b<8; b++)  /** reverse bit order */
			index[i] = (unsigned char) ((index[i] << 1) | ((i >> b) & 1));
	}

	return(0);
}
