/*******************************************************************************
*       registered      (see manual, Internal Functions)                <in>   *
*                       checks a given coordinate system to see if it is       *
*                       registered.                                            *
*                                                                              *
*                       If any 2 corners match exactly, the system is not      *
*                       completely registered and a 0 is returned.             *
*                                                                              *
*                       Returns (long) 1 if it IS REGISTERED                   *
*                                      0 if it is NOT registered               *
*                       J.Dabritz 8/9/89                                       *
*******************************************************************************/

#include "../../incl/globals.h"

long registered(c)
	long c;    /** register file number of coordinate system to be checked*/
{
	long i,j;

	for(i=0; i<3; i++)
	{	for(j=i+1; j<4; j++)
		{	if((corner[c][i][0] == corner[c][j][0]) &&
			   (corner[c][i][1] == corner[c][j][1]))
				return(0);
		}
	}

		/*** check for 0.0, 0.0 cords for a single corner for ground reg. ***/
	if((c > 0) && (c < 4))    /** geodetic, utm, or state plane **/
	{	for(i=0; i<4; i++)
		{	if((corner[c][i][0] == (double) 0.0)  &&  
			   (corner[c][i][1] == (double) 0.0))
				return(0);
		}
	}

	return(1);
}
