/*******************************************************************************
*       remove_temp     (see manual, Internal Functions)                <in>   *
*           Closes all open file paths to temp map file.                       *
*			Removes the temporary map file from disc.              *
*           frees all malloc'ed space in ram.                                  *
*           sets the temp_map_path to null.                                    *
*           sets job_stats[0] = 0  (file version & flag for map loaded)        *
*           make sure that gr_dev is not in DIG1ABS or DIG2ABS mode.           *
*           displays the LINE TRACE PLUS logo.                                 *
*                                                                              *
*           changes no other files or globals.                                 *
*                                                                              *
*			Returns zero upon normal end-of-job, 1 for failure.    *
*                      j.dabritz  6/6/89                                       *
*******************************************************************************/

#include "../../incl/globals.h"


long remove_temp()
{	
/*** Free up storage and close out files  ***/
	close_files();
	free_malloc();

	purgef(temp_map_path);

	temp_map_path[0] = 0;    /*    set to null */
	displogo();

	job_stats[0] = 0;

		/*  take out of abs mode input  */
	switch(gr_dev)  {
	case DIG1ABS:
		gr_dev = DIG1REL;
		break;
	case DIG2ABS:
		gr_dev = DIG2REL;
		break;
	}

	return(0);
}
