/*******************************************************************************
*     report_1set     (see manual, Command Ref., Internal Functions)   <in>    *
*                                                                              *
*         Generates a one line report on the screen about the input set number *
*                                                                              *
*         Parameters:                                                          *
*            long set_num  number of set to be reported on                     *
*                                                                              *
*         Returns 0 upon normal execution, else                                *
*         returns -1 upon error.                                               *
*             J.Dabritz  9/22/90                                               *
*******************************************************************************/

#include "../../incl/globals.h"

long report_1set( set_num)
	long set_num;
{
	OBJECTS object;
	char string[256];

	long i;
	long element_count;

	float length, area;


		/***** initialize element_count, length, area   ********/
	element_count = 0;
	length = 0.0;
	area = 0.0;

		/***** count the number of elements in each set ********/
	for(i=0; i<job_stats[10]; i++)
	{		/***** get object record ***************************/
		if(get_objects(&object,i))
			return(1);

			/***** add to set *********************************/
		if(object.i12[4])
		{	if(object.i12[4] & (1 << set_num))
			{	element_count++;
				length += object.f4[2];
				area += object.f4[3];
			}
		}
	}

		/***** convert to mi/acres *******/
	get_units();
	if((unit_factor[3][0] != (float) 0.0)  &&  (unit_factor[2][1] != (float) 0.0))
	{	length *= unit_factor[3][0];
		area *= unit_factor[2][1];
	}
	
		/***** write a message line for user ***************************/
	sprintf(string,"set %d  has %d objects, length/perim = %.2f mi, area = %.2f acres",set_num,element_count,length,area);
	message(string);

		/***** return **************************************************/
	return(0);
}
