/*******************************************************************************
*	reset_fkeys	(see manual, Internal Functions)         	<in>   *
*			Restores the string mapping table to its original      *
*			values.  This is run only on the AT&T machines.        *
*			Note that System V needs to have the "base" function   *
*			keys remapped, whereas XENIX does not.                 *
*			                                                       *
*			Globals Modified:  none                                *
*			                                                       *
*			Returns zero upon normal end-of-job (EOJ), else        *
*			returns -1 upon error.                                 *
*			CEJ 11/30/89     	                               *
*******************************************************************************/
/* Modified 6/92 by DBS@CWU for X11 support */

#include "../../incl/globals.h"
#include <errno.h>

long reset_fkeys()
{
/***** X11 functions keys don't need to be remapped *****/
#ifndef LTP_X11

/*** As XENIX doesn't need fkeys remapped, this is AT&T only code ***/
#ifdef SV32
	int fd;

/***  Open the console device  ***/
	if( (fd = openf("/dev/console", O_RDWR ))  == -1 )
	{	perror("reset_fkeys():  after open");
		return(-1);
	}

/***  Restore the string mapping table  ***/
	if(ioctl( fd, PIO_STRMAP, orig_fkeys) == (char *)-1)
	{	perror("reset_fkeys():  after ioctl");
		return(-1);
	}

/*** Close up shop and go home ***/
	closef(fd);
#endif
#endif /***** LTP_X11 undefined *****/
	return(0);
}
