/*******************************************************************************
*	set_alarm	(see manual, Internal Functions)            	<in>   *
*	    		Sets the alarm for secs seconds.  To turn off alarm,   *
*			call with null value secs.                             *
*                                                                              *
*			Globals Modified:                                      *
*			        none                                           *
*                                                                              *
*			Returns zero upon normal end-of-job (EOJ).             *
*******************************************************************************/

#include <signal.h>
#include <stdio.h>
#include "../../incl/define.h"

long set_alarm( secs, func_ptr )
	int secs;
	long (*func_ptr)();
{
	if( secs )				/*  Turn alarm on  */
	{
		alarm( secs );
		signal(SIGALRM, func_ptr );
	}
	else					/*  Turn alarm off  */
		signal(SIGALRM, SIG_IGN);
	
	return(0);
}						/*  End of set_alarm  */
