/*******************************************************************************
*       set_undo        (see manual, Internal Functions)                <in>   *
*                                                                              *
*            This function sets 1 element of the undo array which tracks       *
*       interactive raster changes, and atrbt_contur  entries.                 *
*                                                                              *
*        parameters:  long mode;     current input mode                        *
*                     long x2,y2;    oldest coordinate pair, raster coords     *
*                     long x1,y1;    old coordinate pair, raster coords        *
*                     long x,y;      newest coordinate pair, raster coords     *
*                                                                              *
*       globals/files changed:  (globals) undo_array, undo_index               *
*                                                                              *
*       returns:   (long) 0 = successful,  1 = failure                         *
*                                                                              *
*                      j.dabritz  1/9/90                                       *
*******************************************************************************/

#include "../../incl/globals.h"



long set_undo(mode,x2,y2,x1,y1,x,y)
	long mode,x2,y2,x1,y1,x,y;
{
	undo_index = (undo_index + 1) & 31;
	undo_array[undo_index].mode = mode;
	undo_array[undo_index].x2   = x2;
	undo_array[undo_index].y2   = y2;
	undo_array[undo_index].x1   = x1;
	undo_array[undo_index].y1   = y1;
	undo_array[undo_index].x    = x ;
	undo_array[undo_index].y    = y ;

	return(0);
}
