/*******************************************************************************
*       strsplit        (see manual, Internal Functions)                <in>   *
*                 This program splits a string into 2 parts divided at         *
*                 the first occurrance of a single delimiter character.        *
*                 Only the passed parameters are affected.                     *
*                                                                              *
*                 It returns a 0 if no delimiter is found, 1 if the delimiter  *
*                 is found on one end of the string, and 2 if it is found      *
*                 somewhere in the middle of the string.                       *
*                      j.dabritz  3/7/89 - 5/8/89                              *
*******************************************************************************/
#include <string.h>
#include <stdio.h>

long strsplit(ref,delim,part1,part2)
	char ref[];
	char delim;
	char part1[];
	char part2[];
{
	char *delimptr;
	long rtn;

		/*   initialize return value                   */
	rtn = 0;

		/*   check for legitimate parameters           */
	if(!ref || !part1 || !part2 || !delim)
		return(rtn);

		/*   initialize returned strings               */
	*part1 = 0;                /*  set to null  */
	*part2 = 0;                /*  set to null  */
	strcpy(part1, ref);

		/*   get pointer to delimeter                  */
	delimptr = strchr(part1, delim);

		/*   check to see if delim found               */
	if(delimptr)
	{		/*   split string                              */
		delimptr[0] = (char) NULL;
		delimptr++;
		strcpy(part2, delimptr);
	
			/*   check to see if both parts have non=zero length  */
		if(strlen(part1) && strlen(part2))
			rtn = 2;
		else
			rtn = 1;
	}
	
		/*  return                                      */
	return(rtn);

}
