/************************************************************

		swplane(planenum)

     Purpose:	Switches bit planes

     Arguments:	planenum - bit plane to switch to

     Returned Values: (long) 0=ok,    -1=failure.

     Global Variables Modified:

************************************************************/

/*  Modification history:
        Sept 1990 by Mandel
            Inserted include statement to make code compile under SCO UNIX.
*/
/* Modified 5/4/92 by DBS@CWU for X11 support */

#include "../../incl/globals.h"

#ifdef SCO_UNIX
#include <sys/machdep.h>
#endif

#ifndef SV32				/*  For XENIX 2.3 or later  */
#include <malloc.h>
#include <sys/ioctl.h>
#include <memory.h>
#endif

#ifndef LTP_X11  /***** first the VGA code *****/

long swplane(planenum)
    long planenum;
{
        struct port_io_arg pia;

		/*   check to see if grahpics are being used.  */
	if(batch_mode)
		return(0);

	/* Check if bit plane number is valid */

	if ((planenum < 0) || (planenum > 3))
		return(-1);

	/* Switch bit planes */

	/* read plane */

 	pia.args[0].dir = OUT_ON_PORT;
	pia.args[0].port = 0x3ce;
	pia.args[0].data = 4;
 	pia.args[1].dir = OUT_ON_PORT;
	pia.args[1].port = 0x3cf;
	pia.args[1].data = planenum;

	/* write plane */

 	pia.args[2].dir = OUT_ON_PORT;
	pia.args[2].port = 0x3c4;
	pia.args[2].data = 2;
 	pia.args[3].dir = OUT_ON_PORT;
	pia.args[3].port = 0x3c5;
	pia.args[3].data = 1 << planenum;

# ifdef SV32			/*  For AT&T System V 3.2 ver 2.1 or later  */
        ioctl(fdvga,EGAIO,&pia);
# else				/*  For XENIX 2.3 or later  */
        ioctl(fdvga,VGAIO,&pia);
# endif

	return(0);
}

#else  /***** now the X11 code *****/

#include "../../incl/x11.h"

long swplane(planenum)
     long planenum;
{
  unsigned long planemask = 1;

  /*   check to see if graphics are being used.  */
  if(batch_mode || !graphics_flag)
    return(0);

  /* Check if bit plane number is valid */

  if ((planenum < 0) || (planenum > 3))
    return(-1);

  /* Switch bit planes 
  planemask = planemask << planenum; */
  XSetPlaneMask(xdisplay, xgcclear, xplanemasks[planenum]);
  XSetPlaneMask(xdisplay, xgcxor, xplanemasks[planenum]);
  XSetPlaneMask(xdisplay, xgcor, xplanemasks[planenum]);
  XSetPlaneMask(xdisplay, xgccopy, xplanemasks[planenum]);

  return(0);
}

#endif /***** end of X11 code *****/
