/*******************************************************************************
*	sync_file	(see manual, Internal Functions)         	<in>   *
*			Will open a file for syncronized writes.  Will not     *
*			return until writing is physically done.   See         *
*			../../incl/define.h file for type choices.             *
*			It is assumed that the file named in fpath has data.   *
*			Compile using the -DSV32 compiler command line flag.   *
*			                                                       *
*			Returns  -1  upon abnormal end-of-job (EOJ), else      *
*			returns  0.                                            *
*			C. Jonson 8/8/89		       *
*******************************************************************************/
#include "../../incl/define.h"

long sync_file( fpath )	
	char *fpath;
{
	int        fpath_fd;
	extern int errno;
	char       frec[4];
	char       tmp_msg[STRLIST];

	if( (fpath_fd = openf(fpath, RDWR | SYNC)) == -1 )
	{	sprintf(tmp_msg, "Cannot open %s.  Errno is %d", fpath, errno);
		message(tmp_msg);
		return(-1);
	}

/***  Reposition file pointer to end of file  ***/
	if( movefp(fpath_fd, 0L, 2) == -1)
	{	sprintf(tmp_msg, "Cannot move %s file pointer.  Errno is %d", 
			fpath, errno);
		message(tmp_msg);
		return(-1);
	}

	if( readb(frec, 1, 1, fpath_fd) == -1)
	{	sprintf(tmp_msg, "Cannot read %s.  Errno is %d", fpath, errno);
		message(tmp_msg);
		return(-1);
	}

/***  Reposition file pointer to end of file for write  ***/
	if( movefp(fpath_fd, 0L, 2) == -1)
	{	sprintf(tmp_msg, "Cannot move %s file pointer.  Errno is %d", 
			fpath, errno);
		message(tmp_msg);
		return(-1);
	}
	if( writeb(frec, 1, 1, fpath_fd) == -1)
	{	sprintf(tmp_msg, "Cannot write %s.  Errno is %d", fpath, errno);
		message(tmp_msg);
		return(-1);
	}

	if(closef(fpath_fd) == -1)
	{	sprintf(tmp_msg, "Cannot close %s.  Errno is %d", fpath, errno);
		message(tmp_msg);
		return(-1);
	}

	return(0);
}
