/*******************************************************************************
*	system_ltp  ( see manual, Internal Functions)                   <in>       *
*			a string has been formatted for fj().                  *
*                                                                              *
*           Parameters:   buf - string containing system call to execute       *
*           Globals Modified:   none                               *
*                                                                              *
*           Returns value greater than zero if input was read,                 *
*           returns zero if no input was read, else -1 if error.               *
*******************************************************************************/
#include <stdio.h>
#include "../../incl/define.h"
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>

system_ltp(buf)
	char *buf;
{
	static long first_time = 1;
	static int qid;
	MSG_ST  mrcv, msnd;
	char *ptr;
	static char envname[] = LTPQID;
	char *getenv();
	
/*** get msg queue ID.  Do this one time only ***/
	if( first_time )
	{	first_time = 0;
		if( (ptr = getenv(envname)) == NULL )
		{	message("SYSTEM_LTP: No LTPQID environment variable.");
			return(-1);
		}
		qid = (int)strtol(ptr, (char **)0, 10);
		if( qid < 0 )
		{	printf("SYSTEM_LTP: Invalid qid found.");
			return(-1);
		}
	}

/*** Write the buf to the fifo ***/

	strcpy(msnd.mtext, buf);
	msnd.mtype = TODAEMON;
	if( msgsnd(qid, &msnd, MTEXT_SZ, 0) == -1 )
	{	message("SYSTEM_LTP:  Cannot send message.");
		return(-1);
	}

/*** See if user wants to quit.  ***/
	if( !strncmp(msnd.mtext, "LTP_EXIT", 8) )
		return(0);

/*** Block on message receive from daemon ***/
	mrcv.mtype = FROMDAEMON;
	if( msgrcv(qid, &mrcv, MTEXT_SZ, FROMDAEMON, 0) == -1)
	{	message("SYSTEM_LTP:  Cannot receive message.");
		return(-1);
	}
	
	if( mrcv.mtext[0] == 0 )
		return(-1);				/* system call failed */
	else 
		return(0);				/* system call succeeded */
}
