/*******************************************************************************
*       time_ltp        (see manual, Internal Functions)                <in>   *
*        Sets a double to the time in fractional seconds.                      *
*                                                                              *
*        parameters:  double *time    pointer to double to be set.             *
*                                                                              *
*        Returns zero upon normal end-of-job (EOJ).                            *
*                      j.dabritz  7/30/90                                      *
*******************************************************************************/

#ifdef SV32
long time_ltp(time)
	double *time;
{	
	return(0);
}
#else

#include <sys/types.h>
#include <sys/timeb.h>

long time_ltp(time)
	double *time;
{	
	struct timeb tstruct;


	ftime(&tstruct);

	*time = tstruct.time + tstruct.millitm / 1000.0;
	
	return(0);
}
#endif
