/*******************************************************************************
*	trim    	(see manual, Internal Functions)            	<in>   *
*	      		Trims off leading and trailing white space             *
*			and control and extension characters from character    *
*                       string.                                                *
*                                                                              *
*			Returns the trimmed string.                            *
*                       JPD 3/13/89                                            *
*******************************************************************************/

#include <string.h>
#include <stdio.h>

char *trim( str )
	char *str;
{
	long i, j, k, length;

	if(str == (char *) 0)
		return(str);

	length = strlen(str);

	/*    identify the first printable character (i)                      */
	for(i=0; (i<length)  &&  ((str[i]<33) || (str[i]>126)); i++);

	/*    identify the last printable character  (j)          	      */
	for(j=length; (j>0)  &&  ((str[j]<33) || (str[j]>126)); j--);

	/*    compute length of trimmed string       (length)                 */
	if(length>0) 
		length = j-i+1;

	/*    move printable characters to beginning of string                */
	if(length > 0) 
		for(k=0; k<length  ;k++)     
			str[k]=str[i+k];
	else                
		length = 0;

	/* 	append a NULL (0) to the end of the trimmed string characters */
	str[length] = (char) NULL;

	/*	return the trimmed string				      */
	return(str);
}
