/*******************************************************************************
*       update_temp     (see manual, Internal Functions)                <in>   *
*                       This program stores all global and malloc'd map        *
*                       data into the temp map file so that it is current      *
*                       and complete.                                          *
*                                                                              *
*                       Only the file written is changed.                      *
*                                                                              *
*                       Returns zero upon normal end-of-job (EOJ).             *
*                       returns 1 upon failure.                                *
*                      j.dabritz  5/12/89                                      *
*******************************************************************************/

#include "../../incl/globals.h"  /*  <stdio.h> & all LTP defines & globals  */


long update_temp()
{
	int fd;
	long h,w,size;
	char path[512];


		/***** write objects to temp ******/
	if(job_stats[10] && objectsm.malloc) /*  if there are objects malloc'd  */
	{		/*  open file   */
		sprintf(path,"%s/objects",temp_map_path);
		if((fd = openf(path,WRITE)) <= 0)
		{	message("Cannot open objects temp file.  Aborting.");
			return(1);
		}
			/*  write all records  */
		if(0 > writeb(objectsm.rec0,objectsm.rec_size,job_stats[10],fd))
		{	message("Cannot write all objects recs to temp file.  Aborting.");
			closef(fd);
			return(1);
		}
			/*  close file  */
		closef(fd);
	}

		/***** write coord_list to temp ******/
	if(job_stats[11] && coord_listm.malloc) /*  coord_list is malloc'd  */
	{		/*  open file   */
		sprintf(path,"%s/coord_list",temp_map_path);
		if((fd = openf(path,WRITE)) <= 0)
		{	message("Cannot open coord_list temp file.  Aborting.");
			return(1);
		}
			/*  write all records  */
		if(0 > writeb(coord_listm.rec0,coord_listm.rec_size,job_stats[11],fd))
		{	message("Cannot write all coord_list recs to temp file.  Aborting.");
			closef(fd);
			return(1);
		}
			/*  close file  */
		closef(fd);
	}

		/***** write seg_list to temp ******/
	if(job_stats[12] && seg_listm.malloc) /*  seg_list is malloc'd  */
	{		/*  open file   */
		sprintf(path,"%s/seg_list",temp_map_path);
		if((fd = openf(path,WRITE)) <= 0)
		{	message("Cannot open seg_list temp file.  Aborting.");
			return(1);
		}
			/*  write all records  */
		if(0 > writeb(seg_listm.rec0,seg_listm.rec_size,job_stats[12],fd))
		{	message("Cannot write all seg_list recs to temp file.  Aborting.");
			closef(fd);
			return(1);
		}
			/*  close file  */
		closef(fd);
	}

		/***** write attributes to temp ******/
	if(job_stats[13] && attributesm.malloc) /*  attributes is malloc'd  */
	{		/*  open file   */
		sprintf(path,"%s/attributes",temp_map_path);
		if((fd = openf(path,WRITE)) <= 0)
		{	message("Cannot open attributes temp file.  Aborting.");
			return(1);
		}
			/*  write all records  */
		if(0 > writeb(attributesm.rec0,attributesm.rec_size,job_stats[13],fd))
		{	message("Cannot write all attributes recs to temp file.  Aborting.");
			closef(fd);
			return(1);
		}
			/*  close file  */
		closef(fd);
	}

		/***** write errors to temp ******/
	if(job_stats[14] && errorsm.malloc) /*  errors is malloc'd  */
	{		/*  open file   */
		sprintf(path,"%s/errors",temp_map_path);
		if((fd = openf(path,WRITE)) <= 0)
		{	message("Cannot open errors temp file.  Aborting.");
			return(1);
		}
			/*  write all records  */
		if(0 > writeb(errorsm.rec0,errorsm.rec_size,job_stats[14],fd))
		{	message("Cannot write all errors recs to temp file.  Aborting.");
			closef(fd);
			return(1);
		}
			/*  close file  */
		closef(fd);
	}

		/***** write index_list to temp ******/
	if(job_stats[15] && index_listm.malloc) /*  index_list is malloc'd  */
	{		/*  open file   */
		sprintf(path,"%s/index_list",temp_map_path);
		if((fd = openf(path,WRITE)) <= 0)
		{	message("Cannot open index_list temp file.  Aborting.");
			return(1);
		}
			/*  write all records  */
		if(0 > writeb(index_listm.rec0,index_listm.rec_size,job_stats[15],fd))
		{	message("Cannot write all index_list recs to temp file.  Aborting.");
			closef(fd);
			return(1);
		}
			/*  close file  */
		closef(fd);
	}

		/***** write v_attributes to temp ******/
	if(job_stats[16] && v_attributesm.malloc) /*  v_attributes is malloc'd  */
	{		/*  open file   */
		sprintf(path,"%s/v_attributes",temp_map_path);
		if((fd = openf(path,WRITE)) <= 0)
		{	message("Cannot open v_attributes temp file.  Aborting.");
			return(1);
		}
			/*  write all records  */
		if(0 > writeb(v_attributesm.rec0,v_attributesm.rec_size,job_stats[16],fd))
		{	message("Cannot write all v_attributes recs to temp file.  Aborting.");
			closef(fd);
			return(1);
		}
			/*  close file  */
		closef(fd);
	}

		/***** write v_objects to temp ******/
	if(job_stats[17] && v_objectsm.malloc) /*  v_objects is malloc'd  */
	{		/*  open file   */
		sprintf(path,"%s/v_objects",temp_map_path);
		if((fd = openf(path,WRITE)) <= 0)
		{	message("Cannot open v_objects temp file.  Aborting.");
			return(1);
		}
			/*  write all records  */
		if(0 > writeb(v_objectsm.rec0,v_objectsm.rec_size,job_stats[17],fd))
		{	message("Cannot write all v_objects recs to temp file.  Aborting.");
			closef(fd);
			return(1);
		}
			/*  close file  */
		closef(fd);
	}

		/***** write v_coord_list to temp ******/
	if(job_stats[18] && v_coordlistm.malloc) /*  v_coordlist is malloc'd  */
	{		/*  open file   */
		sprintf(path,"%s/v_coordlist",temp_map_path);
		if((fd = openf(path,WRITE)) <= 0)
		{	message("Cannot open v_coordlist temp file.  Aborting.");
			return(1);
		}
			/*  write all records  */
		if(0 > writeb(v_coordlistm.rec0,v_coordlistm.rec_size,job_stats[18],fd))
		{	message("Cannot write all v_coordlist recs to temp file.  Aborting.");
			closef(fd);
			return(1);
		}
			/*  close file  */
		closef(fd);
	}

	
		/**** check disprstr_get VIEW ONLY flag *****/
	if(job_stats[78] == 0)
   {     /******************** write raster & index arrays to temp *********/
			/*******   write raster to temp file  *****/
			/*  open file   */
		sprintf(path,"%s/raster",temp_map_path);
		if((fd = openf(path,WRITE)) <= 0)
		{	message("Cannot open raster temp file.  Aborting.");
			return(1);
		}
			/*  write all records  */
		size = (job_stats[1]+1)  *  (job_stats[2]+1)  /  8;
		if(0 > writeb(rasterm.rec0, size , 1, fd))
		{	message("Cannot write all raster recs to temp file.  Aborting.");
			closef(fd);
			return(1);
		}
			/*  close file  */
		closef(fd);

			/*******   write mini_raster to temp file  *****/
			/*  open file   */
		sprintf(path,"%s/mini_raster",temp_map_path);
		if((fd = openf(path,WRITE)) <= 0)
		{	message("Cannot open mini_raster temp file.  Aborting.");
			return(1);
		}
			/*  write all records  */
		size = 400 * 50;
		if(0 > writeb(mini_raster[0], size , 1, fd))
		{	message("Cannot write all mini_raster recs to temp file.  Aborting.");
			closef(fd);
			return(1);
		}
			/*  close file  */
		closef(fd);
	}

		/***** write index_array to temp ******/
	if(index_arraym.malloc) /*  index_array is malloc'd  */
	{		/*  open file   */
		sprintf(path,"%s/index_array",temp_map_path);
		if((fd = openf(path,WRITE)) <= 0)
		{	message("Cannot open index_array temp file.  Aborting.");
			return(1);
		}
			/*  write all records  */
		h = job_stats[2] / 32 + 1;
		w = job_stats[1] / 32 + 1;
		size = 4 * h * w;
		if(0 > writeb(index_arraym.rec0, size, 1, fd))
		{	message("Cannot write all index_array recs to temp file.  Aborting.");
			closef(fd);
			return(1);
		}
			/*  close file  */
		closef(fd);
	}


        /******************** write global map files to temp **************/
	sprintf(path,"%s/header",temp_map_path);
	if(put_header(path,&header))
		{	message("Cannot write header to temp file.  Aborting.");
			return(1);
		}
	sprintf(path,"%s/history",temp_map_path);
	if(put_history(path))
		{	message("Cannot write history to temp file.  Aborting.");
			return(1);
		}
	sprintf(path,"%s/level_names",temp_map_path);
	if(put_levelnms(path))
		{	message("Cannot write level_names to temp file.  Aborting.");
			return(1);
		}
	sprintf(path,"%s/job_stats",temp_map_path);
	if(put_jobstats(path))
		{	message("Cannot write job_stats to temp file.  Aborting.");
			return(1);
		}
	sprintf(path,"%s/register",temp_map_path);
	if(put_register(path))
		{	message("Cannot write registration data to temp file.  Aborting.");
			return(1);
		}

		/*** make sure that all writes are scheduled **/
	sync();

	return(0);
}

