/*******************************************************************************
*       utm_zone        (see manual, Internal Functions)                <in>   *
*                        returns the utm zone number of the current map.       *
*                        no parameters                                         *
*                                                                              *
*                        Returns zero if no data found                         *
*                      j.dabritz  11/7/90                                      *
*******************************************************************************/

#include "../../incl/globals.h"
char *trim();

long utm_zone()
{	
	long zone;
	long i;

	double ln;

	
		/******** try to get zone from utmln in header file ********/
	trim(header.utmln);
	ln = 0.0;
   sscanf(header.utmln,"%lf",&ln);
	ln = (ln < 0.0) ?  -ln : ln;
	zone = 31 - (ln / 6.0);

		/******** no legal zone from utmln in header, average map corners ***/
	if((zone > 20) || (zone < 1))
	{	ln = 0.0;
		for(i=0, ln=0.0; i<4; i++)
			ln += (corner[1][i][0] / 4.0);
		ln = (ln < 0.0) ?  -ln : ln;
		zone = 31 - (ln / 6.0);
	}

	return(zone);
}
