/*******************************************************************************
*	mssmse_input   (see manual, Internal Functions)            	<in>   *
*	    		Checks for microsoft serial mouse input.  the raw      *
*			input is put into the ginfo global data structure.     *
*			button presses are de-bounced.                         *
*                                                                              *
*			Globals Modified:                                      *
*			        ginfo.button                                   *
*			        ginfo.rawcoord[0]                              *
*			        ginfo.rawcoord[1]                              *
*                                                                              *
*			Returns 0 if input is read, 1 if none there.           *
*			DBS@CWU 5/92                                           *
*******************************************************************************/

#ifdef LTP_X11    /***** don't compile any of this if we aren't using X11 *****/

#include <stdio.h>
#include "../../incl/globals.h"
#include "../../incl/x11.h"

long x11mse_input()
{
  Bool first = True;

  /*  Mainline  */

  /************** read until a byte is read with bit #6 set. ******/
  ginfo.button = 0;
/*  ginfo.rawcoord[0] = 0;
  ginfo.rawcoord[1] = 0;
*/
  while (XCheckMaskEvent(xdisplay, ButtonPressMask | PointerMotionMask, &xevent)) {
    first = False;
    if (xevent.type == ButtonPress) break;
  }
  if (first) return(1);

  /************** build ginfo button press ********************/
  if (xevent.type == ButtonPress) {
    if(xevent.xbutton.button == Button1) {
      ginfo.button = 'L';
    }
    else if(xevent.xbutton.button == Button2) {
      ginfo.button = 'M';
    }
    else if(xevent.xbutton.button == Button3) {
      ginfo.button = 'R';
    }
    /* build ginfo x & y movement */
    ginfo.rawcoord[0] = xevent.xbutton.x;
    ginfo.rawcoord[1] = xevent.xbutton.y;
  }
  else if (xevent.type == MotionNotify) {
    /* build ginfo x & y movement */
    ginfo.rawcoord[0] = xevent.xmotion.x;
    ginfo.rawcoord[1] = xevent.xmotion.y;
  }
  else /* unexpected event */
    return(1);

  return(0);
}

#endif  /***** end of X11 code *****/
