/*******************************************************************************
*       x11redisplay                                                           *
*                      derived from the graphics() function by J. Dabritz      *
*                      Attempts to regenerate the window display after an      *
*		       Expose event.                                           *
*                                                                              *
*			Returns zero upon normal end-of-job (EOJ).             *
*           DBS@CWU 6/92                                                       *
*******************************************************************************/

#include "../../incl/globals.h"
#include "../../incl/in.h"
#include <string.h>


long x11redisplay()
{
	long raster_disp, normal_v, normal_i1, normal_i2, highlight_v,
	     highlight_i1, highlight_i2, centroid_disp, full_width;
	long x,y;
	long i;
	char string[256];

		/************* set global display control variables *********/
	raster_disp = disp_raster ;
	normal_v = disp_normal;
	normal_i1 = disp_i1normal;
	normal_i2 = disp_i2normal;
	highlight_v = disp_hglight;
	highlight_i1 = disp_i1hglight;
	highlight_i2 = disp_i2hglight;
	centroid_disp = disp_centroid;

	full_width = full_width_disp;
	if(full_width) {
		windowxmin = 0;
		scrn_display();

		/*   display map name *****************************/
		strcpy(string,map_name);
		string[14] = 0;
		for(i=2; i<4; i++)
		{	swplane(i);
			bar_off(528,416,639,431);
			disptext(26,66,string);
		}

		/****** display menu name *********************/
		for(i = 2;  i < 4;  i++)
		{	swplane(i);
			bar_off(528,432,639,447);
			disptext(27,66,menu_name[current_menu]);
		}

		/*** display input mode ****/
		for(i = 2;  i < 4;  i++)
		{	swplane(i);
			bar_off(528,448,639,463);
			disptext(28,66,input_modes[input_mode]);
		}

		/***************** display snap on/off ***********************/
		for(i=1; i<4; i++)
		{	swplane(i);
			bar_off(528,464,639,479);
		}
		if(snap_input)
		{	for(i = 2;  i < 4;  i++)
			{	swplane(i);
				disptext(29,66,"** SNAP ON **");
			}
		}
		else
		{	swplane(1);
			disptext(29,66,"  snap off");
		}
	}
	else 
	{	windowxmin = 224;
		scrn_display();
		/*** erase map/menu/mode/snap in lower right corner **/
		for(i=1; i<4; i++)
		{	swplane(i);
			bar_off(528,416,639,479);
		}
			
		i = current_menu;
		disp_menuset();
		disp_menu(i);
		/*** redisp input mode ****/
		for(i = 2;  i < 4;  i++)
		{	swplane(i);
			bar_off(0,47,111,32);
			disptext(2,0,input_modes[input_mode]);
		}

		/*** redisp snap mode ***/
		/***************** display snap on/off ***********************/
		for(i=1; i<4; i++)
		{	swplane(i);
			bar_off(0,62,111,48);
		}
		if(snap_input)
		{	for(i = 2;  i < 4;  i++)
			{	swplane(i);
				disptext(3,0,"** SNAP ON **");
			}
		}
		else
		{	swplane(1);
			disptext(3,0,"  snap off");
		}

		/*** redisp map name ****/
		/*   display map name in upper left block, line 2 */
		strcpy(string,map_name);
		string[14] = 0;
		swplane(2);
		bar_off(0,16,111,31);
		disptext(1,0,string);
		swplane(3);
		bar_off(0,16,111,31);
		disptext(1,0,string);
	}

	/************* call dispgraphics to re-display data *********/
	x = (rwindowxmin + rwindowxmax) / 2;
	y = (rwindowymin + rwindowymax) / 2;
	if(dispgraphics(x,y,resolution_code))
		return(1);

		/************* return ***************************************/
	return(0);
}
