/*******************************************************************************
*     fork_execvp       (see manual, Internal Functions)                <in>   *
*           Calls the UNIX/XENIX 'system' function call. This function used    *
*           to fork() and execvp(), but the redirection symbols didn't work.   *
*           Globals Modified:   none.                                          *
*           Parameters:    command - string containing command to exec.        *
*                                                                              *
*			Returns 0 if the return code is OK, else returns -1.               *
*           C. Jonson  12/19/89                                                *
*******************************************************************************/
#include "../../incl/define.h"
#include <string.h>
#include <errno.h>
#include <signal.h>
#include <stdio.h>

long fork_execvp( command )	
	char *command;
{
/*** If command is empty, return with -1 ***/
	if( strlen(command) == 0 )
		return(-1);

/*** Call a new shell using 'system' ***/
#if (XENIX || SCO_UNIX)
	if( system(command) < 0 )
#else
	if( do_system(command) < 0 )
#endif
		return(-1);
	else 
		return(0);
}


#if !(XENIX || SCO_UNIX)
do_system (command)
    char *command;
{
    int status, pid, w;
    int fd;
    int (*sigint)(), (*sigquit)() ;

    sigint  = signal (SIGINT,  SIG_IGN);
    sigquit = signal (SIGQUIT, SIG_IGN);

    fflush (stdout);
    fflush (stderr);

    if ( (pid = fork()) == 0)
    {
        signal (SIGINT,  SIG_DFL);
        signal (SIGQUIT, SIG_DFL);

	
	fd = open ("/dev/null", 1);
	dup2 (fd, 2);	/* stderr */
	dup2 (fd, 1);	/* stdout */

        execl ("/bin/sh", "sh", "-c", command, 0);
        _exit(127);
    }

    if (pid < 0)
    {
        fprintf (stderr, "WARNING: can not create a new process\n");
        status = -1;
    }
    else
    {
        while ( (w = wait (&status)) != pid && w != -1)
            ;

        if (w == -1)
            status = -1;
    }

    signal (SIGINT,  sigint);
    signal (SIGQUIT, sigquit);

    return (status);
}
#endif
