/*******************************************************************************
*            This program checks 2 binary (or ascii) files to see if they are  *
*       identical.                                                             *
*                                                                              *
*            J.Dabritz   1/14/91                                               *
*******************************************************************************/

#include <fcntl.h>
#include <stdio.h>
#include <string.h>

long main(argc,argv)
int argc;
char *argv[];
{
	unsigned char string1[1028],string2[1028];
	unsigned char *ptr1, *ptr2;

	long c,n1,n2;
	long done;

	int fd1,fd2;

	
		/************* check for parameters *****************************/
	if(argc < 3)
	{	printf("usage:  bindiff  file1  file2\n");
		printf("reports the first difference between two binary (or ascii) files.\n");
		return(1);
	}

		/************* open files ***************************************/
	printf("\n------------------- bindiff -----------------------\n");
	printf("Checking for differences between files (first byte is 0):\n");
	printf("  file1:  %s\n",argv[1]);
	printf("  file2:  %s\n",argv[2]);

	fd1 = open(argv[1],O_RDONLY);
	if(fd1 <= 0)
	{	printf("Cannot open file  %s  , aborting\n",argv[1]);
		return(1);
	}
	fd2 = open(argv[2],O_RDONLY);
	if(fd2 <= 0)
	{	printf("Cannot open file  %s  , aborting\n",argv[2]);
		return(1);
	}

		/************* read & check files ******************************/
	c = 0;
	done = 0;
	for(; ;)
	{	n1 = read(fd1,string1,1024);
		string1[n1] = (char) 0;
		n2 = read(fd2,string2,1024);
		string2[n2] = (char) 0;

		if(n1 != n2)
		{	printf("Note:  files have different lengths.\n");
			if(n1 > n2)
				printf("file1 has %d bytes or more, file2 has %d.\n",c+n1,c+n2);
			else
				printf("file2 has %d bytes or more, file1 has %d.\n",c+n2,c+n1);
		}
		else if(n1 == 0)
			break;

		for(ptr1=string1, ptr2 = string2;n1 && n2;c++, n1--, n2--, ptr1++, ptr2++)
		{	if(*ptr1 != *ptr2)
			{	printf("files first differ at byte %d.  file1 has (byte value) %d, file2 has %d\n",c,*ptr1,*ptr2);
				done=1;
				break;
			}
		}

		if(done || n1 || n2)
			break;

	}

	if(!done)
		printf("%d bytes read.  Files are identical.\n",c);
	printf("--------------------- end -------------------------\n\n");

	close(fd1);
	close(fd2);

	return(0);
}
