#include <grp.h>
#include <pwd.h>
#include <stdio.h>

int change_grp( grp_name )
	char *grp_name;
{
	struct group *grp, *getgrnam();
	FILE *fp, *fpn;
	char *cptr1, *cptr2, *tptr;
	long count = 0; 
	long no_match = 0; 
	long i = 0; 
	char new_rec[256];
	char gid_str[8];
	char pw_rec[256];
	char *strtok();

/*** Backup the passwd file for safety's sake!  ***/
	if( system("cp /etc/passwd /etc/passwd.orig") )
	{	printf("ltpinst:change_grp:system call \'cp\' failed.\n\7");
		return(-1);
	}

/*** Get ltplus group record ***/
	if( (grp = getgrnam(grp_name) ) == (struct group*)NULL )
	{	printf("ltpinst:change_grp:getgrnam fail\n\7");
		return(-1);
	}

/*** Open the passwd file ***/
	if( (fp = fopen("/etc/passwd", "r")) == (FILE *)NULL )
	{	printf("ltpinst:change_grp:open on passwd fail\n\7");
		return(-1);
	}

/*** Open the new passwd file ***/
	if( (fpn = fopen("/etc/passwd.new", "w")) == (FILE *)NULL )
	{	printf("ltpinst:change_grp:open on passwd fail\n\7");
		return(-1);
	}

/*** Read passwd file until login found.  If found, change grp to 'ltplus' ***/
	while( fgets(pw_rec, (sizeof(pw_rec) - 1), fp) )
	{	for( count = i = 0; grp->gr_mem[i]; i++ )
		{	if( !strncmp(pw_rec, grp->gr_mem[i], sizeof(grp->gr_mem[i]) ))
			{		/* parse string based on :  */
				strcpy( new_rec, strtok(pw_rec, ":") );
				count++;
				while( tptr = strtok((char*)NULL, ":") )
				{	strcat(new_rec, ":");
					if( count == 3 )
					{	sprintf(gid_str, "%d", grp->gr_gid);
						strcat(new_rec, gid_str);
					}
					else
						strcat(new_rec, tptr);
					count++;
				}
				/*** Write updated record to passwd file ***/
				if( fputs(new_rec, fpn) == -1 )
				{	printf("ltpinst:change_grp:fputs fail\n\7");
					return(-1);
				}
				no_match = 0;
				break;		/** Get next passwd record!  **/
			}
			else
				no_match = 1;
		}
		if( no_match )
		{	/*** Write unchanged record to passwd file ***/
			if( fputs(pw_rec, fpn) == -1 )
			{	printf("ltpinst:change_grp:fputs fail\n\7");
				return(-1);
			}
			no_match = 0;
		}
	}
	fclose(fp);
	fclose(fpn);

/*** Overlay the /etc/passwd file with the new version!  ***/
	if( system("mv /etc/passwd.new /etc/passwd") )
	{	printf("ltpinst:change_grp:system call \'mv\' failed.\n\7");
		return(-1);
	}

	return(0);
}
