/*****************************************************************************
*    change_uid                                                              *
*        This program changes the real and effective user and group ID's     *
*        to that of the user selected by the person running ltpinstl.        *
*                                                                            *
*        C. Jonson   10/89                                                   *
*****************************************************************************/
#include <stdio.h>
#include <grp.h>
#include <pwd.h>
#include <sys/types.h>
#include <sys/stat.h>

static char  grp_mem[32];
static char  grp_name[32];

int  change_uid()
{
	extern int errno;
	long lognum, i;
	struct passwd *pw;
	struct group *gp, *getgrnam();
	char name_list[64][32];

/***  Have user select the login to use for file ownership ***/
	user_list(name_list);
	printf("\nSelect one of the following user logins to be the owner\
 of the LTPlus files.\n\
If GRASS is run from this machine, you should select the login that\n\
owns grass.\n");

	for( i = 0; name_list[i][0]; i++ )
		printf("\n\t%d.  %s", i, name_list[i]);
	printf("\n\n\t\tEnter the number of a login \7(0 - %d)--> ", i - 1 );
	for( ;; )
	{	scanf("%d", &lognum);
		if( lognum >= 0 && lognum < i )
			break;
		printf("\n\7\t\tYour choice is invalid.  Chose again --> ");
	}

/***  Read passwd file again and get gid of selected user ***/
	pw = (struct passwd *)getpwnam(name_list[lognum]);
	gp = (struct group *)getgrgid(pw->pw_gid);
	strcpy(grp_name, gp->gr_name);
	strcpy(grp_mem, name_list[lognum]);

/***  Set the effective and real user and group ID to name selected above ***/
	if( setuid(pw->pw_uid) == -1 )
	{	printf("Cannot set User ID to %s.  UNIX errno is %d", 
					grp_mem, errno);
		return(-1);
	}

	return(0);
}
