/*******************************************************************************
*     copyrlc                                                                  *
*        This program alows the user to copy from a dos directory all files    *
*     ending in .RLC into a chosen Xenix directory.  After copying (if         *
*     successful) the dos .rlc file(s) are deleted.                            *
*                                                                              *
*     8/30/90   J.Dabritz                                                      *
*                                                                              *
*******************************************************************************/

#include <stdio.h>
#include <string.h>
#include <fcntl.h>

main(argc,argv)
int argc;
char *argv[];
{
	char string[256];
	char dosdir[256], xendir[256];
	char rlcname[256];
	char *ptr;

	int fd;

	long i;
	long brd;
	

		/************** check/prompt for dos directory ****************/
	dosdir[0] = (char) 0;
	if(argc > 1)
	{		/*** copy input parameter to variable 'dosdir' ****/
		sprintf(dosdir,"%s",argv[1]);
			/*** check for colon *****/
		if(strchr(dosdir,':') == (char *) 0)
			dosdir[0] = (char) 0;
	}
		/**** prompt for directory if not there ***/
	if(!dosdir[0])
	{	printf("\n\nEnter the DOS pathname of the DIRECTORY where the .RLC file are now\n------------>");
		scanf("%s",dosdir);
	}

		/*** convert backslash '\' to slash '/' ****/
	for(ptr=dosdir; *ptr; ptr++)
	{	if(*ptr == (char) 92)
			*ptr = (char) 47;
	}

		/************** check/prompt for the xenix directory **********/
		/************** check/prompt for dos directory ****************/
	xendir[0] = (char) 0;
	if(argc > 2)
	{		/*** copy input parameter to variable 'xendir' ****/
		sprintf(xendir,"%s",argv[2]);
			/*** check for colon *****/
		if(strchr(xendir,':') != (char *) 0)
			xendir[0] = (char) 0;
	}
		/**** prompt for directory if not there ***/
	if(!xendir[0])
	{	printf("\n\nEnter XENIX pathname of the DIRECTORY where the .RLC files are to be copied.\n------------>");
		scanf("%s",xendir);
	}

		/************** remove temp file if present *******************/
	printf(">rm ./temp.junk\n");
	system("rm ./temp.junk");

		/************** dosls the dos directory > temp file ***********/
	sprintf(string,"dosls %s > ./temp.junk",dosdir);
	printf(">%s\n",string);
	system(string);

		/************** open temp file ********************************/
	fd = open("./temp.junk",O_RDONLY);

		/************** read temp file, on line at a time *************/
	for(;;)
	{		/** read one line **/
		rlcname[0] = (char) 0;
		for(i=0; ; i++ )
		{	brd = read(fd, (rlcname + i), 1);
			if( brd < 1 )
				break;
			if( *(rlcname + i) == '\n' )
				break;
			if(i > 14)
				break;
		}
		if(!(*rlcname))
			break;
		*(rlcname + i) = '\0';	/* null term string  */

			/************** check name for *.RLC ***********************/
		for(ptr = rlcname; *ptr  &&  *ptr!='.'; ptr++);
		if(*ptr == '.')
		{	ptr++;
			if(*ptr == 'R')
			{	ptr++;
				if(*ptr == 'L')
				{	ptr++;
					if(*ptr == 'C'); 
					{		/*** copy file from dos to xenix *************/	
						ptr++;
						*ptr = (char) 0;
						sprintf(string,"doscp -r %s/%s %s/%s",dosdir,rlcname,xendir,rlcname);
						printf(">%s\n",string);
						if(system(string) == 0)
						{		/** if doscp is successful, remove dos file **/
							sprintf(string,"dosrm %s/%s",dosdir,rlcname);
							printf(">%s\n",string);
							system(string);
						}
					}
				}
			}
		}
	}

		/************** close temp file *******************************/
	close(fd);

		/************** delete temp file ******************************/
	printf(">rm ./temp.junk\n");
	system("rm ./temp.junk");

		/************** end program ***********************************/
	return(0);
}
