/*****************************************************************************
*    create_dirs                                                             *
*        This program makes empty directories for the ltp directory.         *
*        Since many directories are not generated by cpio since they         *
*        are empty, this program simply makes a directory file for           *
*        those empty directories.                                            *
*                                                                            *
*        C. Jonson   10/89                                                   *
*****************************************************************************/
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>

long create_dirs( path )
	char *path;
{
	long i, num_dirs;
	long makedir();
	char dir_path[256];
	static char empty_dirs[][16] = {"map_lists", "maps", "pens", 
		"dictionary", "digmenus", "import", "export"};

/*** Create all empty directories  ***/
	num_dirs = sizeof(empty_dirs) / 16;
	for( i = 0; i < num_dirs; i++ )
	{	sprintf(dir_path, "%s/ltp/%s", path, empty_dirs[i]);
		switch( makedir( dir_path ) )
		{	case 1:
				printf("Directory %s already exists.\n", dir_path);
				break;
			case -1:
				printf("Directory %s not created.  UNIX errno is %d\n",
								dir_path, errno);
				break;
			case 0:
				printf("Directory %s created.\n", dir_path);
				break;
			default:
				printf("Bizarre return value from \'makedir()\'.\n");
				break;
		}
	}

	return(0);
}

long makedir( path )
	char *path;
{
	extern int errno;
	struct stat buf;
	char cmd[512];

/*  If directory exits, return with  1  */
	if( stat( path, &buf) == 0 )
		return(1);
	else if( errno == EACCES )
	{	sprintf(cmd, "Permissions invalid for %s.", path);
		printf("%s\n", cmd);
		return(-1);
	}

/*  If directory is new, execute mkdir command  */
	sprintf(cmd, "mkdir %s", path );

	return( system(cmd) );
}
