/*******************************************************************************
*  insert_line                                                                 *
*       This program will insert a line of your choosing at the top of a file  *
*       that may be source code.                                               *
*       Parameters:  path  -  directory containing files to be modified.       *
*                    suffix - OPTIONAL string containing a suffix.  Only files *
*                             with this suffix will be modified.  '.c' default *
*******************************************************************************/
#include <stdio.h>
#include <fcntl.h>
#include <malloc.h>

#define ARRSZ 96

main(argc, argv)
	int argc;
	char *argv[];
{
	extern int errno;
	int  fd;
	long bytes_rd;
	long i;
	long len, len1;
	long num_files;
	long offset;
	char *cptr, *tptr;
	char file[256];
	char list[500][ARRSZ];
	char path[256];
	char suffix[32];
	char tmp[32];
	static char line2insert[] = "/***   %M%  %I%  %H%    ***/\n";

/*** Check the number of arguments ***/
	if( argc > 3 || argc < 2 )
	{	printf("\nUsage:  insert_line   directory  [suffix]\n\7");
		return(0);
	}

/*** Store off the path and see if a suffix is present ***/
	strcpy(path, argv[1]);
	if( argc == 3 )
	{	if( strlen(argv[2]) )
			strcpy(suffix, argv[2]);
	}
	else
		strcpy(suffix, ".c");

/*** Get list of directory elements ***/
	if( (num_files = dir_list(path, list, 500)) == 0 )
	{	printf("directory %s is empty.  insert_line terminating.\n\7");
		return(0);
	}

/*** Malloc space for manipulating files in memory ***/
	if( (cptr = (char *)calloc((unsigned)1, (unsigned)500000)) == (char *)NULL)
	{	printf("Cannot calloc 500000 bytes.  insert_line terminating\n");
		return(-1);
	}

/*** Go through list and edit members that end in 'suffix' ***/
	for( i = 0; i < num_files; i++ )
	{	len = strlen(list[i]);
		len1 = strlen(suffix);
		offset = len - len1;
		strcpy( tmp, (list[i] + offset) );
		if( strncmp( tmp, suffix, strlen(suffix) ) )
			continue;

		sprintf(file, "%s/%s", path, list[i]);
		if( (fd = open(file, O_RDWR)) == -1)
		{	printf("Cannot open %s.  insert_line terminating\n", file);
			return(-1);
		}
	
		/*** Insert line at top of file and read rest into calloced space ***/
		tptr = cptr;
		strcpy( tptr, line2insert );
		tptr += strlen(line2insert);

		for(;(bytes_rd = read(fd, tptr, (unsigned)512)) > 0; tptr += bytes_rd);

	/*** Now, reposition file pointer and write file back to itself ***/
		if( lseek(fd, 0L, 0) == -1 )
		{	printf("Cannot position file pointer to top of file. \n\7");
			return(-1);
		}

		if( write( fd, cptr, (unsigned)(tptr - cptr)) == -1)
		{	printf("Cannot write to %s.   Errno is %d", file, errno);
			return(-1);
		}
	}

/*** Free up calloc'ed space ***/
	free(cptr);

/*** Inform user all is done and return ***/
	printf("All files in %s ending in %s have been updated.\n\7", file,
			suffix);

	return(0);
}
