/*****************************************************************************
*    install_ltp                                                             *
*        This program loads the ltplus system on UNIX/XENIX systems.         *
*        It ensures the required software is loaded, loads the software      *
*        from either tape or disk, and changes permissions to 775 and        *
*        sets all ltp files to the user-selected owner and group.            *
*                                                                            *
*        C. Jonson   3/2/90                                                  *
*****************************************************************************/
#include <sys/utsname.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <ctype.h>
#include <stdio.h>

unsigned sleep();

install_ltp( unix_sys )
	long unix_sys;
{
	long dir_choice;
	char cmd[256];
	char user_dir[256];
	static char unix_dirs[2][8] = {"/usr", "/usr2"};
	static char xenix_dirs[2][8] = {"/u", "/u2"};
	struct stat buf;

/*** Clue the user in as to what is going to happen ***/
	printf("\n\nYou have selected the Initial Installation. The \
following tasks are performed:\n\n");

	printf("\t1.  Loads the LTPlus software from its distribution medium.\n\
\t2.  Changes LTPlus file permission and ownership based on your choice.\n\
\t3.  Links /dev/vio to /dev/vga if you are on an AT&T machine with GRASS.\n\n\
To properly run this package, you must be signed in as root, and you\n\
must be in the root directory.  Enjoy using LTPlus.\n\n\
Press RETURN to continue, or DELETE to quit.");

	fflush(stdin);
	getchar();

/*** Ask user what directory (file sys) they want LTPlus to reside in ***/
	if( unix_sys )
	{	printf("\n\nSelect the directory you want LTPlus to reside in\n\
\t0.  %s\n\
\t1.  %s\n\
\t2.  I want to select a different directory\n\
\t\tEnter the item number and press RETURN --> ", unix_dirs[0], unix_dirs[1] );
	}
	else
	{	printf("\n\nSelect the directory you want LTPlus to reside in\n\
\t0.  %s\n\
\t1.  %s\n\
\t2.  I want to select a different directory\n\
\t\tEnter the item number and press RETURN --> ", xenix_dirs[0], xenix_dirs[1]);
	}

	for( ;; )
	{	fflush(stdin);
		scanf("%d", &dir_choice);
		if( dir_choice >= 0 && dir_choice <= 2 )
			break;
		else
			printf("\n\t\tValid choices are 0, 1, or 2.  Select again --> ");
	}

	if( dir_choice == 2 )
	{	printf("\n\nEnter the name of the directory and press return --> ");
		scanf("%s", user_dir );
	}
	else if( unix_sys )
		strcpy(user_dir, unix_dirs[dir_choice]);
	else
		strcpy(user_dir, xenix_dirs[dir_choice]);

/*** Ensure the chosen directory exists! If not, tell them to create it ***/
	if( stat(user_dir, &buf) )
	{	printf("\nA \'%s\' directory is not detected.  Make %s\
before installing LTPlus.\n  It is advisable to place LTPlus on a \
filesystem other that root.  Installation terminated.\n\7", user_dir, user_dir);
		return(-1);
	}
	
/*** Begin the download of the actual software.  User interface is req'd ***/
	if( load_ltp(user_dir, unix_sys) )
	{	printf("Unable to load LTPlus.  The ltpinstl is terminating.\n\7");
		sprintf(cmd, "rm -r %/ltp", user_dir);
		system(cmd);
		return(-1);
	}

/*** Create required directories for LTPlus ***/
	if( create_dirs(user_dir) )
	{	printf("Unable to create \'empty\' directories for LTPlus. \n\
Notify your LTPlus support person.  LTPlus installation will continue.\7\n\n");
		sleep(3);
	}

/*** Change the permissions of the extracted files ***/
	if( change_perms(user_dir, "") )
	{	printf("Unable to modify the file permissions.  The LTPlus\
 install is terminated.\n\7");
		return(-1);
	}

/*** Set values for the config and header files! ***/
	if( set_configs(user_dir, unix_sys) )
	{	printf("Problem with modifying the files in %s/ltp/config\n\n", 
				user_dir);
		sleep(3);
	}
	
/*** Link Carlson's old driver to the new driver if under UNIX ***/
	if( unix_sys )
	{	if( link("/dev/vio", "/dev/vga") )
		{	perror("ltpinstl:link /dev/vio to /dev/vga ");
			printf("Unable to link old driver to new.  Contact your LTPlus\
 support person.\n");
			sleep(3);
		}
	}

	return(0);
}
