/*******************************************************************************
*	keyvalue      (see manual, Internal Functions)            	<in>   *
*	    		Will echo to the screen the octal value or the         *
*			control sequence of whatever key was pressed.  To      *
*			exit, press the return key.                            *
*                                                                              *
*******************************************************************************/

#include <sys/termio.h>
#include <sys/ioctl.h>
#include <stdio.h>

/*  Globals  */
struct termio termsave;
int orig_flag;
char buf[BUFSIZ];
char *orig_buf;
long kbsetraw(),
	kbread(),
	kbreset();

main()
{
/*  Initialization.  Stdin is placed in a raw input mode.    */

	orig_buf = buf;

	printf("Press RETURN to exit from keyvalue\n");
	fflush(stdin);
	fflush(stdout);
	if( kbsetraw() )
	{	printf("ERROR after kbsetraw\n");
		exit(0);
	}
	
/*  Mainline.  Read keystrokes as they occur.  */

	if( kbread( buf ) )
	{
		printf("ERROR\n");
		exit(0);
	}

/*  Reset terminal.    */

	if( kbreset() )
	{
		printf("ERROR after kbread\n");
		exit(0);
	}

}

long kbsetraw()
{
	struct termio tinfo;

/*  Get current line attributes for stdin  */

	if( ioctl(0, TCGETA, &tinfo) == -1 )
	{
		printf("RAWMODE:  error after ioctl\n");
		return(-1);
	}
	
	termsave = tinfo;

/*  Set line to raw input mode  */

	tinfo.c_iflag &= ~(INLCR | ICRNL | IUCLC | ISTRIP | IXON | BRKINT);
	tinfo.c_oflag &= ~OPOST;
	tinfo.c_lflag &= ~(ICANON | ISIG | ECHO);
	tinfo.c_cc[4] = 1;		/*  Minimum number of chars to read  */
	tinfo.c_cc[5] = 30;		/*  Tenths of a second  */
	
/*  Alter line with flags as set above  */

	if( ioctl(0, TCSETAF, &tinfo) == -1 )
	{
		printf("RAWMODE:  error after ioctl\n");
		return(-1);
	}
	
	return(0);
}


long kbread( kb_rawbuf )
	char *kb_rawbuf;
{
	int i = 0;
	int total = 0;

	for( ;; )
	{
		i = read( 0, (kb_rawbuf + total), 1 );
		if( *(kb_rawbuf + total) == 015 )
			break;
		printf("Character read is octal %3o  decimal %3d\n\r", 
				*(kb_rawbuf + total), *(kb_rawbuf + total) );
		total += i;
	}

	return(0);
}

long kbreset()
{
/*  Restore line to its original attributes  */

	if( ioctl(0, TCSETAF, &termsave) == -1 )
		return(-1);
	
	return(0);
}
