/*******************************************************************************
*        lowerc         (see manual, Internal Functions)                <in>   *
*                 This program changes all occurances of upper case letters    *
*                 in a string to lower case letters.  All other characters     *
*                 are unaffected.                                              *
*                                                                              *
*                 Only the string passed is changed.                           *
*                                                                              *
*                 On completion, the string pointer is returned.               *
*                                                                              *
*******************************************************************************/
#include <stdio.h>
#include <string.h>

char *lowerc(string) 
	char *string;
{
	long i;

		/*    test for null pointer          */
	if(!string) return(string);

		/*    convert string to lower case   */
	for(i=0; string[i] != 0 ; i++)
		if((string[i] >= 65) && (string[i] <= 90))
			string[i] = string[i] + 32;

		/*    return string                   */
	return(string);
}
/*******************************************************************************
*	closef		(see manual, Internal Functions)         	<in>   *
*			Close an open file.                                    *
*			Returns zero upon normal end-of-job (EOJ).             *
*			HLM&JPD030789					       *
*******************************************************************************/


int closef( stream )
	FILE *stream;
{
	return( fclose( stream ) );
}
/*******************************************************************************
*	reada		(see manual, Internal Functions)            	<in>   *
*			Reads an ascii file.                                   *
*			Returns zero upon abnormal end-of-job (EOJ).           *
*			HLM&JPD030789					       *
*******************************************************************************/

char *reada( string, bytes, stream  )
	char *string;	
	int bytes;
	FILE *stream;
{
	return( fgets( string, bytes, stream ) );
}
/*******************************************************************************
*	openf		(see manual, Internal Functions)         	<in>   *
*			Open a file.                                           *
*			The type may be one of the following values:           *
*			  "r" "r+" "w" "w+" "a" "a+"                           *
*			  and for DOS only  "t" for text files                 *
*			                    "b" for binary files.              *
*			Returns zero upon abnormal end-of-job (EOJ).           *
*			HLM&JPD030789					       *
*******************************************************************************/


FILE *openf( fname, type )	
	char *fname;
	char *type;
{
	return( fopen( fname, type ) );
}
/*******************************************************************************
*	writea		(see manual, Internal Functions)         	<in>   *
*			Writes an ascii file.                                  *
*			Returns zero upon normal end-of-job (EOJ).             *
*			HLM&JPD030789					       *
*******************************************************************************/

int writea( string, stream  )
	char *string;	
	FILE *stream;
{
	return( fputs( string, stream ) );
}
/*******************************************************************************
*	main	This is the entry point for LTPlus.                            *
*		Checks (or sets) the working directory.                        *
*		Checks for (and completes if necessary) the Config file.       *
*		Sets up all include files/common blocks                        *
*		Sets up the tiles etc.                                         *
*		Processes optional parameters which are macro names.           *
*		Starts user input.                                             *
*		Pops back to the previous directory upon exit.                 *
*		Returns zero upon normal end-of-job (EOJ).                     *
*******************************************************************************/

int main(argc, argv)
	int argc;  
	char *argv[];
/*	int argc	The number of parameters passed to main.  All 
			parameters passed (beyond 1 [main]) are assumed
			to be macro names.  These macros (if any) are 
			executed before beginning user input.  
	char *argv[]	These are all assumed to be macro names.             */

{	FILE *infile, *outfile;
	char line[96];

	if(argc!=3)
		printf("need exactly two entries, input file and an output file.  no action taken.\n");
	else
	{	infile = openf(argv[1],"r");
		outfile = openf(argv[2],"w+");

		while(reada(line,96,infile))
		{	lowerc(line);
			writea(line,outfile);
		}
	
		close(infile);
		close(outfile);
	}

	return(0);
}
