/*****************************************************************************
*    load_ltp                                                                *
*        This program loads the files from the distribution medium.  The     *
*        actual utility used is cpio, as it will prompt for additional       *
*        medium when needed, whereas tar will not.                           *
*                                                                            *
*        C. Jonson   10/89                                                   *
*****************************************************************************/
#include <stdio.h>
#include <ctype.h>

int load_ltp( path, unix_sys )
	char *path;
	long unix_sys;
{
	long dev_num;
	long disk_sz;
	extern int errno;
	int  resp;
	char media;
	char device[96];
	char arch_cmd[96];
	char filepath[96];
	
/*** Inform user that load is about to take place ***/
	printf("\nNow ready to load in the LTPlus files from the \
distribution media.\n");
	
	for( ;; )
	{	printf("\nEnter the distribution media (tape, disk, or file)--> \7");
		scanf("%s", device);
		media = (char) tolower((int)device[0]);
		if((media == 't') || (media == 'd') || (media == 'f'))
			break;
		printf("\nSelect media by entering the word \'tape\', \'disk\', or \'file\'.\7");
	}

/*** Change directory to path  ***/
	if( chdir(path) )
	{	printf("ltpinst:load_ltp: chdir to %s failed.  UNIX errno is %d\n",
					path, errno );
		return(-1);
	}

/*** Begin loading procedures for disk.  See which drive and size. ***/
	if( media == 'd' )
	{	for( ;; )
		{	printf("\nSelect the floppy drive to use:\n\
\tEnter 0 for drive0 or 1 for drive1 --> \7");
			scanf("%d", &dev_num);
			if( dev_num == 0 || dev_num == 1 )
				break;
			else
				printf("\nSelections are either 1 or 2.");
		}

		/*** Ask for size of floppy disk ***/
		for( ;; )
		{	printf("\nSelect the floppy disk size:\n\
\tEnter 0 for 3.5\" disks   or   1 for 5.25\" disks --> \7");
			scanf("%d", &disk_sz);
			if( disk_sz == 0 )
			{	if( unix_sys )
					sprintf(arch_cmd,"cpio -iacBdkuV -I /dev/rdsk/f%d3h",dev_num);
				else
					sprintf(arch_cmd,"tar xvf /dev/rfd%d135ds18",dev_num);
				break;
			}
			else if( disk_sz == 1 )
			{	if( unix_sys )
					sprintf(arch_cmd,"cpio -iacBdkuV -I /dev/rdsk/f%d",dev_num);
				else
					sprintf(arch_cmd,"tar xvf /dev/rfd%d",dev_num);
				break;
			}
			else
				printf("\nSelections are either 1 or 2.");
		}
		printf("\nInsert first diskette into floppy drive %d and press \
RETURN to start\n\7", dev_num);
		fflush(stdin);
		getchar();
	}
	else if( media == 't' )
	{	printf("\nInsert the cartridge tape into the tape drive and press\
 RETURN.");
		if( unix_sys )
			strcpy(arch_cmd,"cpio -iacBdkuV -I /dev/rmt/c0s0");
		else
			strcpy(arch_cmd,"tar xvf /dev/rct0");
		fflush(stdin);
		getchar();
	}
	else            /*** media == file ***/
	{		/*** get name of file ****/
		printf("\nEnter the complete path/filename of the installation file\n --> \7");
		scanf("%s", filepath);
		sprintf(arch_cmd,"tar xvf %s",filepath);
	}

	if( unix_sys )
	{	if( system(arch_cmd) )
		{	printf("Problem with reading medium.\nThe ltpinstl will \
terminate.  Please try again\n\n");
			return(-1);
		}
	}
	else if( media == 'd')
	{	for(;;)			/*** Ask user if all has been loaded yet ***/
		{	system(arch_cmd);
			printf("\nAre there more disks to load [y/n]\7? --> ");
			fflush(stdin);
			resp = getchar();
			if( resp == 'y' || resp == 'Y')
			{	printf("\nInsert next diskette into the drive and press RETURN.");
				fflush(stdin);
				getchar();
				continue;
			}
			else
			{	printf("\n\tAre you SURE there are no \
more disks to load [y/n]? --> ");
				fflush(stdin);
				resp = getchar();
				if( resp == 'y' || resp == 'Y')
					break;
			}
		}
	}
	else if( system(arch_cmd) )
	{	printf("Problem with archive command. ltpinstl aborting.\n\n");
		return(-1);
	}
				
	printf("\nLTPlus files have been extracted.\n");
	if(media != 'f')
		printf("You may remove the medium from its drive when the light is out.\n");

	return(0);
}
