/*****************************************************************************
*    loadltp                                                                 *
*        This program loads the files from the distribution medium.  The     *
*        actual utility used is cpio, as it will prompt for additional       *
*        medium when needed, whereas tar will not.                           *
*                                                                            *
*        C. Jonson   10/89                                                   *
*****************************************************************************/
#include <stdio.h>
#include <ctype.h>

int loadltp()
{
	long dev_num;
	long disk_sz;
	extern long unix_sys;
	int  resp;
	char media;
	char device[96];
	char arch_cmd[96];
	char cmd[96];
	
/*** Inform user that load is about to take place ***/
	printf("\nNow ready to load in the LTPlus file(s) from the \
distribution media.\n");
	
	for( ;; )
	{	printf("\nEnter the distribution media (tape OR disk)--> \7");
		scanf("%s", device);
		media = (char)( tolower((int)device[0]) == 't' ? 't':
					tolower((int)device[0]) == 'd' ? 'd' : (char)NULL );
		if( media == 't' || media == 'd' )
			break;
		else
			printf("\nSelect either tape or disk by entering the\
 word \'tape\' or \'disk\' --> \7");
	}

/*** Change directory to /u[sr] ***/
	if( unix_sys )
	{	if( chdir("/usr") )
		{	perror("ltpinst:loadltp: chdir to /usr ");
			return(-1);
		}
	}
	else
	{	if( chdir("/u") )
		{	perror("ltpinst:loadltp: chdir to /u ");
			return(-1);
		}
	}

/*** Begin loading procedures for disk ***/
	if( media == 'd' )
	{	for( ;; )
		{	printf("\nSelect the floppy drive to use:\n\
\tEnter 0 for drive0 or 1 for drive1 --> \7");
			scanf("%d", &dev_num);
			if( dev_num == 0 || dev_num == 1 )
			{	if( unix_sys )
					sprintf(arch_cmd,"cpio -iacBdkuV -I /dev/rdsk/f%d",dev_num);
				else
					sprintf(arch_cmd,"tar xvf /dev/rfd%d",dev_num);
				break;
			}
			else
				printf("\nSelections are either 1 or 2.");
		}

		printf("\nInsert first diskette into floppy drive %d and press \
RETURN to start\n\7", dev_num);
	}
	else
	{	printf("\nInsert the cartridge tape into the tape drive and press\
 RETURN.");
		if( unix_sys )
			strcpy(arch_cmd,"cpio -iacBdkuV -I /dev/rmt/c0s0");
		else
			strcpy(arch_cmd,"tar xvf /dev/rct0");
	}
	
	fflush(stdin);
	getchar();

	if( unix_sys )
	{	if( system(arch_cmd) )
		{	printf("Problem with reading medium.\nThe llplus install will \
terminate.  Please try again\n\n");
			return(-1);
		}
	}
	else if( media == 'd')
	{	for(;;)			/*** Ask user if all has been loaded yet ***/
		{	system(arch_cmd);
			printf("\nAre there more disks to load [y/n]\7? --> ");
			fflush(stdin);
			resp = getchar();
			if( resp == 'y' || resp == 'Y')
			{	printf("\nInsert next diskette into the drive and press RETURN.");
				fflush(stdin);
				getchar();
				continue;
			}
			else
			{	printf("\n\tAre you SURE there are no \
more disks to load [y/n]? --> ");
				fflush(stdin);
				resp = getchar();
				if( resp = 'y' || resp == 'Y')
					break;
			}
		}
	}
	else if( system(arch_cmd) )
	{	printf("Problem with archive command. LTPINSTL aborting.\n\n");
		sprintf(cmd, "rm -r ltp");
		system(cmd);
		return(-1);
	}
				
	printf("\nLTPlus file(s) have been extracted.\n");
	printf("You may remove the medium from its drive when the light is out.\n");

	return(0);
}
