/*******************************************************************************
*  batch                                                                       *
*     This program controls the batch production of assembled LTPlus maps and  *
*  DEMs using LTPlus in batch mode overnight as follows:                       *
*     1.  execute    ltpgo -b start_b2       which uses ltplus to process all  *
*         maps listed in the batch2f_maps and batch2m_maps maplists into DEMs. *
*     2.  catalog the /u2/ltdata/import directory into a temporary file.       *
*     3.  read the temp. file and for each scan file found:                    *
*         a.  create a map name & put in on a map_list called batch1_maps.     *
*         b.  executes   ltpgo -b start_b1    which creates the map, imports   *
*             the scan, reverses it if necessary, does batch editing,          *
*             assembles the map, reduces the amount of data, reduces the       *
*             resolution by a factor of 2, and saves the map (ready for        *
*             registration & contour labeling)                                 *
*     4.  does the dishes.                                                     *
*            J.Dabritz   4/18/91                                               *
*******************************************************************************/

#include <fcntl.h>
#include <stdio.h>
#include <string.h>

main()
{
	int fd_temp, fd;
	
	long n;

	char *ptr,string[256];


		/********* 1. execute    ltpgo -b start_b2    ********************/
printf("/u/ltp/bin/ltpgo -b start_b2\n");
	system("/u/ltp/bin/ltpgo -b start_b2");

		/********* 2. catalog import directory into temp file ************/
printf("cd\n");                            /** cd to users personal dir  ***/
	system("cd");                            /** cd to users personal dir  ***/
printf("rm -r junk\n");                    /** delete temporary file **/
	system("rm -r junk");                    /** delete temporary file **/
printf("ls /u2/ltdata/import > junk\n");   /** dump catalog into temp file **/
	system("ls /u2/ltdata/import > junk");   /** dump catalog into temp file **/

		/********* open the temp file ************************************/
	fd_temp = open("junk", O_RDONLY);
printf("fd_temp = %d\n",fd_temp);
	if(fd_temp < 0)
	{	printf("BATCH ERROR:  CANNOT OPEN file \"junk\".\n");
		printf("********** NO SCANS WILL BE IMPORTED. ***************\n");
		wait(10);
	}

		/********* loop for all lines in file ****************************/
	for(;fd_temp >= 0;)
	{		/********* read line ******************************************/
		ptr = string;
		*ptr = (char) 0;
		for(n=0;;n++,ptr++)
		{	if(0 >= read(fd_temp,ptr,(unsigned) 1))
			{	n = 0;
				break;
			}
			if(*ptr == (char) 10)
			{	*ptr = (char) 0;
				break;
			}
		}
	
		if(!n)      /*** check for end of file ****/
			break;
printf("line:  %s\n",string);

			/********* check for .opt or .opr ending on filename **********/
		ptr = ptr - 4;
		if((ptr > string) && (!strcmp(ptr,".opt")  ||  !strcmp(ptr,".opr")))
		{		/********* open /u/ltp/map_lists/batch1_maps file **********/
			fd = open("/u/ltp/map_lists/batch1_maps", O_RDWR | O_CREAT | O_TRUNC);

				/********* write line **************************************/
			sprintf(ptr,"\n");
			n = strlen(string);
			write(fd,string,(unsigned) n);
printf(" as written:  %s",string);

				/********* close file **************************************/
			close(fd);

				/********* execute ltplus **********************************/
printf("ltpgo -b start_b1\n\n");
			system("ltpgo -b start_b1");
		}
	}

		/********* close temp file ***************************************/
	close(fd_temp);

		/********* return ************************************************/
	return(0);
}
