/****************************************************************************
*   ltpdist                                                                 *
*         This program creates a distribution package for LTPlus sites.     *
*         The package may be either binary only or binary and source code.  *
*         Too, the package may create an update package or a new install-   *
*         ation package.  The user will be prompted for several items,      *
*         and once all information is collected, a system command is        *
*         executed to generate the package.  Tape or disks may be used as   *
*         medium.  (Don't forget, many tape drives are incompatable.        *
*         XENIX systems will use tar while UNIX systems use cpio.           *
*                                                                           *
*         C. Jonson    11/20/89                                             *
****************************************************************************/
#include <stdio.h>
#include <string.h>
#include <errno.h>

long osnum;			/* operating system choice 1 = UNIX   2 = XENIX */

main()
{
	extern int errno;
	long bin_only = 0;	/* switch for source_bin resp */ 
	long choice;
	long dev_num = 0;	/* Device selection */
	long disk_sz = 0;   /* Size in kbytes of floppy disk choice */
	long logo;
	long make_ltplus();
	long vganum;
	char ltp_path[96];
	char tmp_fname[96];
	char resp[96];
	char dev_name[96];
	char arch_cmd[96];
	static char ltp_dirs[4][8] = {"/usr", "/usr2", "/u", "/u2"};
	
/***  Ask for operating system type ***/
	system("clear");

	printf("\n\n   LINE TRACE PLUS DISTRIBUTION PACKAGE CREATION TOOL\n\n");
	printf("This tool allows you to create a software distribution package \
suitable\nfor UNIX or XENIX environments.  As this tool will dump data onto \
some\nmedium, please have formatted diskettes handy for use.  Do not format\n\
cartridge tapes. Ensure that the desired medium is NOT write protected!\n\n");

	printf("Do you wish to make a LTPlus distribution for:\n\
\t1. UNIX System V Release 3.2.2.1 or later (default)\n\
\t2. XENIX Release 2.3.1 or later\n\t\t\
Enter the number [1/2] --> ");
	for(;;)
	{	fflush(stdin);
		osnum = getchar();
		osnum -= 48;		/** convert to decimal **/
		if( osnum < 0 )     /** true if only return pressed **/
		{	osnum = 1;		/** Select UNIX by default **/
			break;
		}
		else if( osnum == 1 || osnum == 2 )
			break;
		else 
			printf("\n\t\tChoices are 1 or 2!.  \7Enter choice --> ");
	}

/*** Select either source and binary package or just binary ***/
	printf("\n\nDo you wish to include the source code in this distribution?\n\
\t\tEnter \'yes\' or \'no\' (default) --> ");
	fflush(stdin);
	gets(resp);
	if( tolower((int)resp[0]) == 'y' )
		bin_only = 0;
	else 
		bin_only = 1;
		
/*** Select the medium to use ***/
	printf("\n\nWhich of the following devices do you wish to use?\n\t\
1.  Floppy disk drive 0\n\t2.  Floppy disk drive 1\n\t3.  Cartridge tape\
\n\t\tEnter the number [1/2/3] --> ");
	for(;;)
	{	fflush(stdin);
		dev_num = getchar();
		dev_num -= 48;			/* cheesy way to convert char to int */
		if( dev_num == 1 || dev_num == 2 || dev_num == 3)
			break;
		else
			printf("\n\t\tChoices are 1 or 2 or 3!.  \7Enter choice --> ");
	}

/*** If its a floppy, find out what size and density it is (XENIX only)  ***/
	if( dev_num == 1 || dev_num == 2 )
	{	printf("\n\nWhat is the capacity of the floppy disk in kbytes?\n\t\
1.  1200  (5.25 inch High Density floppy)\n\t\
2.  1400  (3.5  inch High Density floppy)\n\t\tEnter your choice [1/2] --> ");
		for(;;)
		{	fflush(stdin);
			disk_sz = getchar();
			disk_sz -= 48;			/* cheesy way to convert char to int */
			if(disk_sz == 1)
			{	disk_sz = 1200;
				break;
			}
			else if(disk_sz == 2)
			{	disk_sz = 1400;
				break;
			}
			else
				printf("\n\t\tChoices are 1 or 2.  \7Enter choice --> ");
		}
	}

/*** Ask user where the ltp directory to use is located ***/
	printf("\nSelect the directory that contains the \'ltp\' directory:\n\
\t1.  %s\n\
\t2.  %s\n\
\t3.  %s\n\
\t4.  %s\n\
\t5.  I want to specify the directory\n\
\t\tEnter the number [1/2/3/4/5] --> ", ltp_dirs[0], ltp_dirs[1], 
			ltp_dirs[2], ltp_dirs[3] );
	for(;;)
	{	fflush(stdin);
		choice = getchar();
		choice -= 48;			/* cheesy way to convert char to int */
		if( choice < 1 || choice > 5 )
			printf("\n\t\tChoices are from 1 to 5. \7Enter choice --> ");
		else
			break;
	}

	if( choice == 5 )
	{	printf("\nEnter the name of the directory --> ");
		scanf("%s", ltp_path);
	}
	else
		strcpy(ltp_path, ltp_dirs[choice - 1] );

/*** If UNIX, see if VDC600 or Orchid card is used ***/
	if( osnum == 1 )
	{	printf("\nSelect the VGA card the end user has:\n\
\t1.  ORCHID Designed 800 VGA\n\
\t2.  AT&T VDC600 Super VGA\n\
\t\tEnter the number [1/2] --> ");

		for(;;)
		{	fflush(stdin);
			vganum = getchar();
			vganum -= 48;		           /** convert to decimal **/
			if( vganum == 1 || vganum == 2 )
				break;
			else 
				printf("\n\t\tChoices are 1 or 2!.  \7Enter choice --> ");
		}
	}

/*** Ask user if they want a disclaimer or USDA logo version ***/
	printf("\nSelect the logo that will be displayed on the screen:\n\
\t1.  Regular \"LTPlus\" logo for USDA and other government agencies\n\
\t2.  Disclaimer logo for third party users (ie non-government use)\n\
\t\tEnter the number [1/2] --> ");

	for(;;)
	{	fflush(stdin);
		logo = getchar();
		logo -= 48;		           /** convert to decimal **/
		if( logo == 1 || logo == 2 )
			break;
		else 
			printf("\n\t\tChoices are 1 or 2!.  \7Enter choice --> ");
	}

/*** Invoke a new compile for ltplus based on disclaimer and vga card type ***/
	printf("\nPlease wait while a new 'ltplus' is generated...\n");
	if( make_ltplus(osnum, vganum, logo, ltp_path) )
	{	printf("\nCannot generate a new 'ltplus' module.  You must have the\
 source directory\nto generate a new distribution.\n\n");
		return(-1);
	}

/*** Generate the list of files to archive.             ***/
	printf("\nThe list of files for the distribution is being produced.\n");
	sprintf(tmp_fname, "%s%s", P_tmpdir, "ltplist");
	if( mk_list( ltp_path, tmp_fname, bin_only ) )
	{	printf("Unable to generate list of ltp files.  ltpdist terminated.\n");
		exit(-1);
	}
	
/*** Generate the cpio string to create the new distribution pkg. ***/
	if( dev_num == 3 )                    /* for ctape */
	{	if( osnum == 1 )
			strcpy(dev_name, "\/dev\/rmt\/c0s0");
		else
			strcpy(dev_name, "\/dev\/rct0");
	}
	else if( dev_num == 1 )               /* for drive 0 */
	{	if( osnum == 1 )
		{	if( disk_sz == 1400 )
				strcpy(dev_name, "\/dev\/rdsk/f03h");
			else
				strcpy(dev_name, "\/dev\/rfd0");
		}
		else
		{	if( disk_sz == 1400 )
				strcpy(dev_name, "\/dev\/rfd0135ds18");
			else
				strcpy(dev_name, "\/dev\/rfd0");
		}
	}
	else                                  /* lets suppose drive 1! */
	{	if( osnum == 1 )
		{	if( disk_sz == 1400 )
				strcpy(dev_name, "\/dev\/rdsk/f13h");
			else
				strcpy(dev_name, "\/dev\/rfd1");
		}
		else
		{	if( disk_sz == 1400 )
				strcpy(dev_name, "\/dev\/rfd1135ds18");
			else
				strcpy(dev_name, "\/dev\/rfd1");
		}
	}

/*** Use cpio for UNIX, use tar for XENIX ***/
	if( osnum == 1 )
		sprintf(arch_cmd, "cat %s | cpio -ocv -C 51200 -O  %s", 
						tmp_fname, dev_name );
	else if( dev_num == 3 )
		sprintf(arch_cmd, "tar cvfFb  %s  %s  20", dev_name, tmp_fname);
	else
		sprintf(arch_cmd,"tar cvefkFb  %s  %ld  %s  20",
							dev_name, disk_sz, tmp_fname);

	printf("\nTo create the distribution package: \n\
\t1.  Change directory to  %s  \n\
\t2.  Insert the disk or tape\n\
\t3.  Type in the following command at the prompt:\n\n\
\t\t%s\n\n", ltp_path, arch_cmd);

	printf("\nOnce all files have been dumped to disk or tape, the \n\
distribution package is finished.\n\n");

	return(0);
}

/****************************************************************************
*   make_ltplus                                                             *
*         This function will generate a new ltplus executable based on the  *
*         parameters it receives.                                           *
*         Parameters:  osnum   - 1 if UNIX, 2 if XENIX                      *
*                      vganum  - 1 if ORCHID, 2 if VDC600                   *
*                      logo    - 1 if standard logo, 2 if disclaimer        *
*                      dir     - path of ltp directories                    *
*         Returns 0 if all goes well, else returns -1                       *
****************************************************************************/
long make_ltplus(osnum, vganum, logo, dir)
	long osnum, 
         vganum,
         logo;
    char *dir;
{
	extern int errno;
	char cmd[256];

/*** Change directory to .../ltp/bin ***/
	sprintf(cmd, "%s/ltp/bin", dir);
	if( chdir(cmd) == -1)
	{	printf("\nCannot chdir to %s\n", cmd);
		return(-1);
	}

/*** Compile the graphics_off program to accomodate whatever card ***/
	if( osnum == 1 )
	{	if( vganum == 1 )
			sprintf(cmd, "cc -c -DSV32 -O %s/ltp/source/in/graphics_off.c",dir);
		else
			sprintf(cmd, "cc -c -DSV32 -DVDC600 -O %s/ltp/source/in/graphics_off.c",dir);
		printf("\nCompiling graphics_off.c\n");
		if( system(cmd) == -1 )
		{	printf("Cannot do %s\n", cmd);
			return(-1);
		}
	}

/*** Compile the displogo program to set the logo displayed ***/
	if( osnum == 1 )
	{	if( logo == 1 )
			sprintf(cmd, "cc -c -DSV32 -O %s/ltp/source/in/displogo.c", dir);
		else	
			sprintf(cmd, "cc -c -DSV32 -DDISCLAIM -O %s/ltp/source/in/displogo.c", dir);
	}
	else
	{	if( logo == 1 )
			sprintf(cmd, "cc -c -O %s/ltp/source/in/displogo.c", dir);
		else	
			sprintf(cmd, "cc -c -DDISCLAIM -O %s/ltp/source/in/displogo.c",dir);
	}
	printf("\nCompiling displogo.c\n");
	if( system(cmd) == -1 )
	{	printf("Cannot do %s\n", cmd);
		return(-1);
	}

/*** Link up a new ltplus ***/
	if( osnum == 1 )
	{	if( vganum == 1 )
			sprintf(cmd, "cc -o %s/ltp/bin/ltplus -DSV32 -O  -s \
%s/ltp/bin/*.o -lltp -lvga -lmalloc -lm", dir, dir);
		else
			sprintf(cmd, "cc -o %s/ltp/bin/ltplus -DSV32 -DVDC600 -O -s \
%s/ltp/bin/*.o -lltp -lvga -lmalloc -lm", dir, dir);
	}
	else
		sprintf(cmd, "cc -o %s/ltp/bin/ltplus -O %s/ltp/bin/*.o -lltp -lmalloc -lm", dir, dir);
		
	printf("\nLinking the new ltplus\n");
	if( system(cmd) == -1 )
	{	printf("Cannot do %s\n", cmd);
		return(-1);
	}

/*** Remove the newly compiled object modules ***/
	if( osnum == 1 )
	{	sprintf(cmd, "%s/ltp/bin/graphics_off.o", dir);
		if( unlink(cmd) == -1 )
			if( errno != ENOENT )
				printf("Cannot remove %s\n", cmd);
	}

	sprintf(cmd, "%s/ltp/bin/displogo.o", dir);
	if( unlink(cmd) == -1 )
		if( errno != ENOENT )
			printf("Cannot remove %s\n", cmd);

	return(0);
}
