/*****************************************************************************
*    ltpinstl                                                                *
*        This program loads the ltplus system on UNIX/XENIX systems.         *
*        It ensures the required software is loaded, loads the software      *
*        from either tape or disk, and changes permissions to 775 and        *
*        sets all ltp files to the user-selected owner and group.            *
*        This program works under UNIX and XENIX without any modifications.  *
*                                                                            *
*        C. Jonson   10/89                                                   *
*****************************************************************************/
#include <sys/utsname.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <ctype.h>
#include <stdio.h>

unsigned sleep();

main()
{
	long choice;
	long unix_sys = 0;

/***  Clear the screen ***/
	system("clear");

/***  Is the user on a UNIX or a XENIX system  ***/
	printf("\n                      LTPLUS INSTALLATION TOOL\n\n\
Select the operating system running on this machine:\n\n\
\t0.  ATT UNIX Release 3.2 Version 2.1 or later\n\
\t1.  SCO UNIX or XENIX Release 2.3.1 or later\n\
\t2.  Some other operating system\n\
\t3.  Exit from this program\n\t\t\
Enter the item number and press RETURN --> ");

	for( ;; )
	{	fflush(stdin);
		scanf("%d", &choice);
		if( choice >= 0 && choice <= 3 )
			break;
		else
			printf("\n\t\tValid choices are 0, 1, 2 or 3.  Select again --> ");
	}

/*** Check for choice of 2 or 3.  If true, say bye-bye ***/
	if( choice == 2 )          /*** User has non-supported system ***/
	{	printf("\n\nSorry, LTPlus can function only with\
 UNIX or XENIX.  Installation terminated.\n\7");
		sleep(2);
		system("clear");
		return(1);
	}
	else if( choice == 3 )       /*** Use wants to exit ***/
	{	printf("\nLTPlus will be terminated per your request.  Bye.\n");
		sleep(2);
		system("clear");
		return(1);
	}

	if( choice == 0 )
		unix_sys = 1;
	
/***  Give the user a clue about running this package ***/
	printf("\nYou may use ltpinstl to make an initial installation of the \n\
LTPlus software or to update the LTPlus software currently loaded \n\
on your computer.  Select an action from the following menu:\n\n\
\t0.  Install LTPlus for the first time\n\
\t1.  Update existing LTPlus software\n\
\t2.  Exit from this program\n\
\t\tEnter number of your choice  --> ");

	for( ;; )
	{	fflush(stdin);
		scanf("%d", &choice);
		if( choice >= 0 && choice <= 2 )
			break;
		else
			printf("\n\tValid choices are 0, 1, or 2.  Select again --> ");
	}

	switch(choice)
	{	
	case 0:
		if( install_ltp(unix_sys) )
		{	printf("LTPlus installation terminating\n\n");
			sleep(2);
			system("clear");
			return(-1);
		}
		
		printf("\n\nLTPlus is now installed and ready to run.\n\n");
		
		break;
	case 1:
		if( update_ltp(unix_sys) )
			printf("\n\nProblems were encountered while updating LTPlus.\n");
		else
			printf("\n\nLTPlus is now updated and ready to run.\n\n");
		break;

	case 2:
		printf("\n\nYou have selected to terminate the LTPlus installation\
 program.  Bye.");
		sleep(2);
		system("clear");
		break;

	default:
		printf("\n\nHow you arrived here is a mystery to me.  So...Bye!\n");
		sleep(2);
		system("clear");
		break;
	}
	
	return(0);
}
