#include <stdio.h>
#include <string.h>
#include <ftw.h>

FILE *fp;

int  main( argc, argv )
	int  argc;
	char *argv[];
{
	long bin_only;
	int mk_bin(), mk_src_bin();
	char path[256];
	char fname[256];

/*** If args are present, use them.  Else prompt user for them ***/
	if( argc == 4 )
	{	strcpy(path, argv[1]);
		strcpy(fname, argv[2]);
		bin_only = strtol(argv[3], (char **)NULL);
	}
	else
	{    /*** Prompt user to enter path and name of file to create ***/
		printf("Welcome to the make_list function.\nThis function will\
 create a list of all files within a given path.\nSimply enter the path\
 you would like a listing of and a name of a file\nto be created that \
 will contain the list.\n\n");

		printf("Enter the pathname --> ");
		scanf("%s", path);
		printf("\nEnter a name for the file to create --> ");
		scanf("%s", fname);
		printf("\nEnter 1 for list of files for binary only release,\
 or 0 for all ltp files --> ");
		scanf("%d", &bin_only);
	}

/***  Open the file  ***/
	umask(0);
	if( (fp = fopen(fname, "w")) == (FILE *)NULL)
	{	printf("make_list:fopen failed.  make_list terminated.\n");
		exit(-1);
	}

/***  Create listing of file tree  ***/
	if( bin_only )
	{	if( ftw(path, mk_bin, 14) == -1 )
		{	printf("\nProblem with ftw().   make_list terminated.\n\n");
			exit(-1);
		}
	}
	else
	if( ftw(path, mk_src_bin, 14) == -1 )
	{	printf("\nProblem with ftw().   make_list terminated.\n\n");
		exit(-1);
	}

	printf("\nThe file %s has been created and contains the listing.\n", fname);
	return(0);
}

int mk_src_bin(fname, buf, flag)
	char *fname;
	struct stat *buf;
	int flag;
{
	char fnm[256];

	sprintf(fnm, "%s\n", fname);
	fputs(fnm, fp);
	
	printf(".");
	fflush(stdout);

	return(0);
}

int mk_bin(fname, buf, flag)
	char *fname;
	struct stat *buf;
	int flag;
{
	long i;
	char fnm[256];
	char *cptr, *fptr;
	static char excl_dirs[][32] = { "lib", "source", "obj", "incl" };

	for( i = 0 ; i < 4; i++ )
	{	fptr = fname;
		for( cptr = (char *)0; cptr = strchr(fptr, '/'); fptr = cptr + 1) 
		{	if( !strncmp(fptr, excl_dirs[i], strlen(excl_dirs[i])) ) 
				return(0);		/* get next file name */
		}
	}

	sprintf(fnm, "%s\n", fname);
	fputs(fnm, fp);
	
	printf(".");
	fflush(stdout);

	return(0);
}
