/**************************************************************************
*  reset_fkeys                                                            *
*     This program will remap the base and shift function key values      *
*     that were altered by the earlier releases of LTPlus ver 1.04 and    *
*     earlier.   This restores the aforementioned keys to their default   *
*     values as defined in the AT&T Users/Systems Admin Reference Manual  *
*     section Keyboard(7).                                                *
*     If you are running XENIX, do NOT run this program.  LTPlus never    *
*     remapped function keys under XENIX.                                 *
*                                                                         *
*     C. Jonson 11/2/89                                                   *
**************************************************************************/
#include <sys/types.h>
#include <sys/at_ansi.h>
#include <sys/kd.h> 
#include <stdio.h>
#include <errno.h>
#include <fcntl.h>

main()
{
	long i, j;
	int fd;
	strmap_t fbuf;			/*  Holds function strings  */
	unsigned char *cptr;
	struct fkeyarg fkey;
	char *ioctl();

/*  Open the console device  */

	if( (fd = open("/dev/console", O_RDWR ))  == -1 )
	{	perror("get_fkeys():  after open");
		return(-1);
	}

/*  Read in the string mapping table  */

	if(ioctl( fd, GIO_STRMAP, fbuf) == (char *)-1)
	{	perror("get_fkeys():  after ioctl");
		return(-1);
	}

/*  Alter the first 24 function key values for AT & T  */
/*  Check to see if the string keys have been updated before  */

	fkey.keynum = 1;		/*  get base F1 definition  */
	if(ioctl( fd, GETFKEY, &fkey) == (char *)-1)
	{	perror("get_fkeys():  after ioctl");
		return(-1);
	}
	
	if( !strncmp(fkey.keydef, "\033OB", fkey.flen) )
	{
	/*  Restore the base function keys  */
		for ( i = 0, cptr = fbuf; i < 12; cptr++)
		{	if( (*cptr == ('B' + i)) && (*cptr != 'M') )
			{	*cptr = ('P' + i);
				i++;
			}
			else if( *cptr == 'M' )
			{	*cptr = 'A';
				i++;
			}
		}
	
	/*  Alter the base + shift function keys  */
		for ( i = 0; i < 12; cptr++)
		{	if( *cptr == ( 'b' + i) && (*cptr != 'm') )
			{	*cptr = ('p' + i);
				i++;
			}
			else if( *cptr == 'm' )
			{	*cptr = 'a';
				i++;
			}
		}

	/*  Load string mapping table into memory */
		if(ioctl( fd, PIO_STRMAP, fbuf) == (char *)-1)
		{	perror("get_fkeys():  after ioctl");
			return(-1);
		}
		printf("\nThe BASE and SHIFT function keys have been reset to\
 default values. See keyboard(7).\n\n");
	}		/*  end of string key alterations  */
	else
		printf("\nYour BASE and SHIFT function keys were not set by \
LTPlus.  No action taken.\n");

/*  Close the console driver  */

	close(fd);
	return(0);
}
